# UnicodePlots

[![Docs stable](https://img.shields.io/badge/docs-stable-blue.svg)](
  https://juliaplots.org/UnicodePlots.jl/stable/
)
[![Docs dev](https://img.shields.io/badge/docs-dev-blue.svg)](
  https://juliaplots.org/UnicodePlots.jl/dev/
)
[![License](https://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat)](
  LICENSE.md
)
<br>
[![CI](https://github.com/JuliaPlots/UnicodePlots.jl/actions/workflows/ci.yml/badge.svg)](
  https://github.com/JuliaPlots/UnicodePlots.jl/actions/workflows/ci.yml
)
[![Coverage Status](https://codecov.io/gh/JuliaPlots/UnicodePlots.jl/branch/master/graphs/badge.svg?branch=master)](
  https://app.codecov.io/gh/JuliaPlots/UnicodePlots.jl
)
[![PkgEval](https://juliaci.github.io/NanosoldierReports/pkgeval_badges/U/UnicodePlots.named.svg)](
  https://juliaci.github.io/NanosoldierReports/pkgeval_badges/U/UnicodePlots.html
)
<br>
[![JuliaHub deps](https://juliahub.com/docs/UnicodePlots/deps.svg)](
  https://juliahub.com/ui/Packages/UnicodePlots/Ctj9q?t=2
)
[![Downloads](https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Fmonthly_downloads%2FUnicodePlots&query=total_requests&suffix=%2Fmonth&label=Downloads)](
  https://juliapkgstats.com/pkg/UnicodePlots
)

Advanced [`Unicode`](https://en.wikipedia.org/wiki/Unicode) plotting library designed for use in `Julia`'s `REPL`.

<img src="https://github.com/JuliaPlots/UnicodePlots.jl/raw/unicodeplots-docs/3.x/banner.jpg" width="900">

## Documentation
The [`Documenter`](https://github.com/JuliaDocs/Documenter.jl) based documentation is available [HERE](https://juliaplots.org/UnicodePlots.jl/dev/).

The (older) [`Markdown`](https://en.wikipedia.org/wiki/Markdown) based documentation is available [HERE](https://github.com/JuliaPlots/UnicodePlots.jl/blob/main/README-old.md).

## License
This code is free to use under the terms of the MIT license.

## Acknowledgement
Inspired by [TextPlots.jl](https://github.com/sunetos/TextPlots.jl), which in turn was inspired by [Drawille](https://github.com/asciimoo/drawille).

@testset "aspect ratio" begin
    @test spy(rand(2, 2)).graphics.grid |> size == (2, 5)
    @test spy(rand(4, 4)).graphics.grid |> size == (2, 5)
    @test spy(rand(8, 4)).graphics.grid |> size == (2, 5)
    @test spy(rand(12, 4)).graphics.grid |> size == (3, 5)
    @test spy(rand(8, 8)).graphics.grid |> size == (2, 5)
    @test spy(rand(8, 12)).graphics.grid |> size == (2, 6)
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 80, 80, 0.15), fix_ar = true)
    test_ref("spy/fix_aspect_ratio_80x80_.txt", @show_col(p, :displaysize => T_SZ))
end

@testset "sizing" begin
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 0, 0, 0.1))
    test_ref("spy/default_0x0.txt", @show_col(p, :displaysize => T_SZ))
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 10, 10, 0.15))
    @test p isa Plot
    test_ref("spy/default_10x10.txt", @show_col(p, :displaysize => T_SZ))
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 10, 15, 0.15))
    test_ref("spy/default_10x15.txt", @show_col(p, :displaysize => T_SZ))
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 15, 10, 0.15))
    test_ref("spy/default_15x10.txt", @show_col(p, :displaysize => T_SZ))
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 2_000, 200, 0.0001))
    test_ref("spy/default_2000x200.txt", @show_col(p, :displaysize => T_SZ))
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 200, 2_000, 0.0001))
    test_ref("spy/default_200x2000.txt", @show_col(p, :displaysize => T_SZ))
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 200, 200, 0.001))
    test_ref("spy/default_200x200_normal.txt", @show_col(p, :displaysize => T_SZ))
    test_ref("spy/default_200x200_normal_nocolor.txt", @show_nocol(p, :displaysize => T_SZ))
    seed!(RNG, 1_337)
    p = @binf spy(Matrix(_stable_sprand(RNG, 200, 200, 0.001)))
    test_ref("spy/default_200x200_normal.txt", @show_col(p, :displaysize => T_SZ))
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 200, 200, 0.001), width = 10)
    test_ref("spy/default_200x200_normal_small.txt", @show_col(p, :displaysize => T_SZ))
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 200, 200, 0.001), height = 5)
    test_ref("spy/default_200x200_normal_small.txt", @show_col(p, :displaysize => T_SZ))
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 200, 200, 0.001), height = 5, width = 20)
    test_ref("spy/default_200x200_normal_misshaped.txt", @show_col(p, :displaysize => T_SZ))
end

@testset "parameters" begin
    seed!(RNG, 1_337)
    p = @binf spy(_stable_sprand(RNG, 200, 200, 0.001), color = :green)
    test_ref("spy/parameters_200x200_green.txt", @show_col(p, :displaysize => T_SZ))
    test_ref(
        "spy/parameters_200x200_green_nocolor.txt",
        @show_nocol(p, :displaysize => T_SZ)
    )
    seed!(RNG, 1_337)
    p = spy(
        _stable_sprand(RNG, 200, 200, 0.001),
        title = "Custom Title",
        canvas = DotCanvas,
        border = :ascii,
    )
    test_ref("spy/parameters_200x200_dotcanvas.txt", @show_col(p, :displaysize => T_SZ))
    seed!(RNG, 1_337)
    p = spy(_stable_sprand(RNG, 200, 200, 0.99), show_zeros = true, compact_labels = true)
    test_ref("spy/parameters_200x200_zeros.txt", @show_col(p, :displaysize => T_SZ))
end

@testset "flip" begin
    I = [1, 4, 3, 5]
    J = [4, 7, 18, 9]
    V = [1, 2, -5, 3]
    A = sparse(I, J, V)
    for xflip in (true, false), yflip in (true, false)
        test_ref(
            "spy/flip_xflip-$(xflip)_yflip-$(yflip).txt",
            @show_col(spy(A; xflip, yflip), :displaysize => T_SZ)
        )
    end
end

"""
    BarplotGraphics

Structure to hold bar based graphics.
"""
struct BarplotGraphics{R <: Number, F <: Function, XS <: Function} <: GraphicsArea
    bars::Vector{R}
    colors::Vector{ColorType}
    char_width::Int
    visible::Bool
    maximum::Float64
    max_val::RefValue{Float64}
    max_len::RefValue{Int}
    symbols::Vector{Char}
    formatter::F
    xscale::XS

    function BarplotGraphics(
            bars::AbstractVector{R},
            char_width::Int;
            symbols::Union{AbstractVector, Tuple} = KEYWORDS.symbols,
            color::Union{UserColorType, AbstractVector} = :green,
            maximum::Union{Number, Nothing} = nothing,
            formatter::Function = default_formatter((;)),
            visible::Bool = KEYWORDS.visible,
            xscale = KEYWORDS.xscale,
        ) where {R <: Number}
        for s in symbols
            length(s) == 1 ||
                throw(ArgumentError("symbol has to be a single character, got \"$s\""))
        end
        xscale = scale_callback(xscale)
        char_width = max(10, char_width, length(string(bars[argmax(xscale.(bars))])) + 7)
        colors = if color isa AbstractVector
            ansi_color.(color)
        else
            fill(ansi_color(color), length(bars))
        end
        return new{R, typeof(formatter), typeof(xscale)}(
            bars,
            colors,
            char_width,
            visible,
            Float64(something(maximum, -Inf)),
            Ref(-Inf),
            Ref(0),
            collect(map(s -> first(s), symbols)),
            formatter,
            xscale,
        )
    end
end

@inline nrows(c::BarplotGraphics) = length(c.bars)
@inline ncols(c::BarplotGraphics) = c.char_width

function addrow!(
        c::BarplotGraphics{R},
        bars::AbstractVector{R},
        color::Union{UserColorType, AbstractVector} = nothing,
    ) where {R <: Number}
    append!(c.bars, bars)
    colors = if color isa AbstractVector
        ansi_color.(color)
    else
        fill(suitable_color(c, color), length(bars))
    end
    append!(c.colors, colors)
    return c
end

function addrow!(
        c::BarplotGraphics{R},
        bar::Number,
        color::UserColorType = nothing,
    ) where {R <: Number}
    push!(c.bars, R(bar))
    push!(c.colors, suitable_color(c, color))
    return c
end

function preprocess!(::IO, c::BarplotGraphics)
    max_val, i = findmax(c.xscale.(c.bars))
    c.max_val[] = max(max_val, c.maximum)
    c.max_len[] = length(c.formatter(c.bars[i]))
    return c -> (c.max_val[] = -Inf; c.max_len[] = 0)
end

function print_row(io::IO, print_nocol, print_color, c::BarplotGraphics, row::Integer)
    1 ≤ row ≤ nrows(c) || throw(ArgumentError("`row` out of bounds: $row"))
    val = (bar = c.bars[row]) |> c.xscale
    nsyms = length(c.symbols)
    frac = c.max_val[] > 0 ? max(val, zero(val)) / c.max_val[] : 0.0
    max_bar_width = max(c.char_width - 2 - c.max_len[], 1)
    bar_head = round(Int, frac * max_bar_width, nsyms > 1 ? RoundDown : RoundNearestTiesUp)
    print_color(io, c.colors[row], c.symbols[nsyms]^bar_head)
    if nsyms > 1
        rem = (frac * max_bar_width - bar_head) * (nsyms - 2)
        print_color(io, c.colors[row], rem > 0 ? c.symbols[1 + round(Int, rem)] : ' ')
        bar_head += 1  # padding, we printed one more char
    end
    len = if bar ≥ 0
        bar_lbl = c.formatter(bar)
        print_color(io, nothing, ' ', bar_lbl)
        length(bar_lbl)
    else
        -1
    end
    pad_len = max(max_bar_width + 1 + c.max_len[] - bar_head - len, 0)
    print_nocol(io, ' '^round(Int, pad_len))
    return nothing
end

using Pkg; Pkg.instantiate()
using UnicodePlots
using Markdown
using Term
import Markdown: MD, Paragraph, plain


(@main) = begin
  warn = "WARNING: this file has been automatically generated, please update UnicodePlots/docs/gen_docs.jl instead"
  docs_url = "https://github.com/JuliaPlots/UnicodePlots.jl/raw/unicodeplots-docs"
  ver = "3.x"

  exs = (
    lineplot1 = ("Basic Canvas", """
      using UnicodePlots
      lineplot([-1, 2, 3, 7], [-1, 2, 9, 4], title="Example", name="my line", xlabel="x", ylabel="y")
      """),
    lineplot2 = ("Basic Canvas", """
      plt = lineplot([-1, 2, 3, 7], [-1, 2, 9, 4], title="Example", name="my line",
                     xlabel="x", ylabel="y", canvas=DotCanvas, border=:ascii)
      """),
    lineplot3 = ("Basic Canvas", "lineplot!(plt, [0, 4, 8], [10, 1, 10], color=:cyan, name=\"other line\")"),
    lineplot4 = ("Basic Canvas", """
      p = Plot(; xlim=(-1, 3), ylim=(-1, 3))
      lineplot!(p, 1:2)
      """),
    lineplot5 = ("Lineplot", "lineplot([1, 2, 7], [9, -6, 8], title=\"My Lineplot\")"),
    lineplot6 = ("Lineplot", "plt = lineplot(-π/2, 2π, [cos, sin])"),
    lineplot7 = ("Lineplot", "lineplot!(plt, -.5, .2, name=\"line\")"),
    lineplot8 = ("Lineplot", "lineplot(1:10, [0:9 3:12 reverse(5:14) fill(4, 10)], color=[:green :red :yellow :cyan])"),
    lineplot9 = ("Lineplot", """
      using Unitful
      a, t = 1u"m/s^2", (0:100) * u"s"
      lineplot(a / 2 * t .^ 2, a * t, xlabel="position", ylabel="speed", height=10)
      """),
    lineplot10 = ("Lineplot", """
      using IntervalSets
      lineplot(-1..3, x -> x^5 - 5x^4 + 5x^3 + 5x^2 - 6x - 1; name="quintic")
      """),
    lineplot11 = ("Lineplot", "lineplot(1:10, 1:10, head_tail=:head, head_tail_frac=.1, height=4)"),
    lineplot12 = ("Lineplot", """
      p = Plot([NaN], [NaN]; xlim=(0, 8), ylim=(0, 8))
      vline!(p, [2, 6], [2, 6], color=:red)
      hline!(p, [2, 6], [2, 6], color=:white)
      hline!(p, 7, color=:cyan)
      vline!(p, 1, color=:yellow)
      """),
    scatterplot1 = ("Scatterplot", "scatterplot(randn(50), randn(50), title=\"My Scatterplot\")"),
    scatterplot2 = ("Scatterplot", "scatterplot(1:10, 1:10, xscale=:log10, yscale=:log10)"),
    scatterplot3 = ("Scatterplot", "scatterplot(1:4, 1:4, xscale=:log10, yscale=:ln, unicode_exponent=false, height=6)"),
    scatterplot4 = ("Scatterplot", """
      scatterplot([1, 2, 3], [3, 4, 1], marker=[:circle, '', "∫"],
                  color=[:cyan, nothing, :yellow], height=2)
      """),
    stairs1 = ("Staircase", """
      stairs([1, 2, 4, 7, 8], [1, 3, 4, 2, 7],
             color=:yellow, style=:post, height=6, title="Staircase")
      """),
    barplot1 = ("Barplot", """
      barplot(["Paris", "New York", "Madrid"], [2.244, 8.406, 3.165], title="Population")
      """),
    histogram1 = ("Histogram", "histogram(randn(1_000) .* .1, nbins=15, closed=:left)"),
    histogram2 = ("Histogram", "histogram(randn(1_000) .* .1, nbins=15, closed=:right, xscale=:log10)"),
    histogram3 = ("Histogram", "histogram(randn(100_000) .* .1, nbins=60, vertical=true, height=10)"),
    boxplot1 = ("Boxplot", "boxplot([1, 3, 3, 4, 6, 10])"),
    boxplot2 = ("Boxplot", """
      boxplot(["one", "two"],
              [[1, 2, 3, 4, 5], [2, 3, 4, 5, 6, 7, 8, 9]],
              title="Grouped Boxplot", xlabel="x")
      """),
    spy1 = ("Spy", "using SparseArrays\nspy(sprandn(50, 120, .05))"),
    spy2 = ("Spy", "using SparseArrays\nspy(sprandn(50, 120, .9), show_zeros=true)"),
    densityplot1 = ("Densityplot", """
      plt = densityplot(randn(10_000), randn(10_000))
      densityplot!(plt, randn(10_000) .+ 2, randn(10_000) .+ 2)
      """),
    densityplot2 = ("Densityplot", """
      x = randn(10_000); x[1_000:6_000] .= 2
      densityplot(x, randn(10_000); dscale=x -> log(1 + x))
      """),
    contourplot1 = ("Contourplot", "contourplot(-3:.01:3, -7:.01:3, (x, y) -> exp(-(x / 2)^2 - ((y + 2) / 4)^2))"),
    polarplot1 = ("Polarplot", "polarplot(range(0, 2π, length=20), range(0, 2, length=20))"),
    heatmap1 = ("Heatmap", "heatmap(repeat(collect(0:10)', outer=(11, 1)), zlabel=\"z\")"),
    heatmap2 = ("Heatmap", "heatmap(collect(0:30) * collect(0:30)', xfact=.1, yfact=.1, xoffset=-1.5, colormap=:inferno)"),
    imageplot1 = ("ImagePlot", """
      import ImageInTerminal  # mandatory (triggers glue code loading)
      using TestImages
      imageplot(testimage("monarch_color_256"), title="monarch")
      """),
    surfaceplot1 = ("Surfaceplot", """
      sombrero(x, y) = 15sinc(√(x^2 + y^2) / π)
      surfaceplot(-8:.5:8, -8:.5:8, sombrero, colormap=:jet)
      """),
    surfaceplot2 = ("Surfaceplot", """
      surfaceplot(
        -2:2, -2:2, (x, y) -> 15sinc(√(x^2 + y^2) / π),
        zscale=z -> 0, lines=true, colormap=:jet
      )
      """),
    isosurface = ("Isosurface", """
      torus(x, y, z, r=0.2, R=0.5) = (√(x^2 + y^2) - R)^2 + z^2 - r^2
      isosurface(-1:.1:1, -1:.1:1, -1:.1:1, torus, cull=true, zoom=2, elevation=50)
      """),
    width = ("Width", "lineplot(1:.5:20, sin, width=60)"),
    height = ("Height", "lineplot(1:.5:20, sin, height=18)"),
    labels = ("Labels", "lineplot(1:.5:20, sin, labels=false)"),
    border_dashed = ("Border", "lineplot([-1., 2, 3, 7], [1.,2, 9, 4], canvas=DotCanvas, border=:dashed)"),
    border_ascii = ("Border", "lineplot([-1., 2, 3, 7], [1.,2, 9, 4], canvas=DotCanvas, border=:ascii)"),
    border_bold = ("Border", "lineplot([-1., 2, 3, 7], [1.,2, 9, 4], canvas=DotCanvas, border=:bold)"),
    border_dotted = ("Border", "lineplot([-1., 2, 3, 7], [1.,2, 9, 4], border=:dotted)"),
    border_none = ("Border", "lineplot([-1., 2, 3, 7], [1.,2, 9, 4], border=:none)"),
    decorate = ("Decorate", """
      x = y = collect(1:10)
      plt = lineplot(x, y, canvas=DotCanvas, height=10, width=30)
      lineplot!(plt, x, reverse(y))
      title!(plt, "Plot Title")
      for loc in (:tl, :t, :tr, :bl, :b, :br)
        label!(plt, loc, string(':', loc))
      end
      label!(plt, :l, ":l")
      label!(plt, :r, ":r")
      for i in 1:10
        label!(plt, :l, i, string(i))
        label!(plt, :r, i, string(i))
      end
      plt
      """),
    canvas = ("Canvas", """
      import UnicodePlots: lines!, points!, pixel!
      canvas = BrailleCanvas(15, 40,                    # number of rows and columns (characters)
                             origin_y=0., origin_x=0.,  # position in virtual space
                             height=1., width=1.)       # size of the virtual space
      lines!(canvas, 0., 0., 1., 1.; color=:cyan)       # virtual space
      points!(canvas, rand(50), rand(50); color=:red)   # virtual space
      lines!(canvas, 0., 1., .5, 0.; color=:yellow)     # virtual space
      pixel!(canvas, 5, 8; color=:red)                  # pixel space
      Plot(canvas)
      """),
    blending = ("Blending", """
      import UnicodePlots: lines!
      canvas = BrailleCanvas(15, 40; origin_y=0., origin_x=0., height=1., width=1.)
      lines!(canvas, 0., 0., 1., 1.; color=:cyan)
      lines!(canvas, .25, 1., .5, 0.; color=:yellow)
      lines!(canvas, .2, .8, 1., 0.; color=:red)
      Plot(canvas)
      """),
    buffer_convention = ("Axes", """
      p = Plot([NaN], [NaN]; xlim=(1, 10), ylim=(1, 10), title="internal buffer conventions")

      # plot axes
      vline!(p, 1, head_tail=:head, color=:green, name="y-axis (rows)")
      hline!(p, 1, head_tail=:head, color=:red, name="x-axis (cols)")

      # square
      vline!(p, 2, [2, 9], color=:cyan, name="buf[y, x] - buf[row, col]")
      vline!(p, [2, 9], [2, 9], color=:cyan)
      hline!(p, [2, 9], [2, 9], color=:cyan)

      # internal axes
      vline!(p, 3, range(3, 8; length=20), head_tail=:tail, color=:light_green, name="y-buffer (rows)")
      hline!(p, 8, range(3, 8; length=20), head_tail=:head, color=:light_red, name="x-buffer (cols)")

      # mem layout
      vline!(p, 4, [4, 7]; color=:yellow, name="memory layout")
      vline!(p, 7, [4, 7]; color=:yellow)
      hline!(p, [4, 7], [4, 7]; color=:yellow)
      hline!(p, [4.5, 5, 5.5, 6], [4.5, 6.5]; color=:yellow)
      """),
  )

  plain_md_par(x) = x |> Paragraph |> MD |> plain

  indent(x, n=1, tab=' '^2) = tab^n * join(x isa AbstractVector ? x : split(x, '\n'), '\n' * tab^n)

  examples = NamedTuple{keys(exs)}(
    (plain_md_par("```julia\n$(rstrip(e[2]))\n```\n<img src=\"$docs_url/$ver/$k.png\" width=\"450\"><br>") for (k, e) ∈ pairs(exs))
  )

  desc_ex(k, d, n=2) = (
    if k ≡ :border
      join((
        d,
        indent(examples.border_dashed, n),
        indent(examples.border_ascii, n),
        indent(examples.border_bold, n),
        indent(examples.border_dotted, n),
        indent(examples.border_none, n),
      ), '\n')
    elseif k ∈ (:width, :height, :labels)
      join((d, indent(getindex(examples, k), n)), '\n')
    else
      d
    end
  )

  anchor(name) = replace(lowercase(name), ' ' => '-')
  summary(name::AbstractString) = "<summary><a name=$(anchor(name))></a><b>$(name)</b></summary><br>"  # named anchor + formatting
  summary(::Nothing) = "<summary></a><b>...</b></summary><br>"  # named anchor + formatting

  methods = plain_md_par("""
Non-exhaustive methods description:

  - `title!(plot::Plot, title::String)`

    - `title` the string to write in the top center of the plot window. If the title is empty the whole line of the title will not be drawn

  - `xlabel!(plot::Plot, xlabel::String)`

    - `xlabel` the string to display on the bottom of the plot window. If the title is empty the whole line of the label will not be drawn

  - `ylabel!(plot::Plot, xlabel::String)`

    - `ylabel` the string to display on the far left of the plot window.

The method `label!` is responsible for the setting all the textual decorations of a plot. It has two functions:

  - `label!(plot::Plot, where::Symbol, value::String)`

    - `where` can be any of: `:tl` (top-left), `:t` (top-center), `:tr` (top-right), `:bl` (bottom-left), `:b` (bottom-center), `:br` (bottom-right), `:l` (left), `:r` (right)

  - `label!(plot::Plot, where::Symbol, row::Int, value::String)`

    - `where` can be any of: `:l` (left), `:r` (right)

    - `row` can be between 1 and the number of character rows of the canvas
$(plain_md_par(indent(examples.decorate)))

  - `annotate!(plot::Plot, x::Number, y::Number, text::AbstractString; kw...)`
    - `text` arbitrary annotation at position (x, y)
  """)

  low_level_interface = plain_md_par("""
The primary structures that do all the heavy lifting behind the curtain are subtypes of `Canvas`. A canvas is a graphics object for rasterized plotting. Basically, it uses Unicode characters to represent pixel.

Here is a simple example:

$(indent(examples.canvas, 0))

You can access the height and width of the canvas (in characters) with `nrows(canvas)` and `ncols(canvas)` respectively. You can use those functions in combination with `print_row` to embed the canvas anywhere you wish. For example, `print_row(STDOUT, canvas, 3)` writes the third character row of the canvas to the standard output.

As you can see, one issue that arises when multiple pixel are represented by one character is that it is hard to assign color. That is because each of the "pixel" of a character could belong to a different color group (each character can only have a single color). This package deals with this using a color-blend for the whole group. You can disable canvas color blending / mixing by passing `blend=false` to any function.

$(indent(examples.blending, 0))

The following types of `Canvas` are implemented:

- **BrailleCanvas**:
  This type of canvas is probably the one with the highest resolution for `Unicode` plotting. It essentially uses the Unicode characters of the [Braille](https://en.wikipedia.org/wiki/Braille) symbols as pixels. This effectively turns every character into eight pixels that can individually be manipulated using binary operations.

- **BlockCanvas**:
  This canvas is also `Unicode` based. It has half the resolution of the BrailleCanvas. In contrast to `BrailleCanvas`, the pixels don't have visible spacing between them. This canvas effectively turns every character into four pixels that can individually be manipulated using binary operations.

- **HeatmapCanvas**:
  This canvas is also `Unicode` based. It has half the resolution of the `BlockCanvas`. This canvas effectively turns every character into two color pixels, using the foreground and background terminal colors. As such, the number of rows of the canvas is half the number of `y` coordinates being displayed.

- **AsciiCanvas** and **DotCanvas**:
  These two canvas utilizes only standard `ASCII` character for drawing. Naturally, it doesn't look quite as nice as the Unicode-based ones. However, in some situations it might yield better results. Printing plots to a file is one of those situations.

- **DensityCanvas**:
  Unlike the `BrailleCanvas`, the density canvas does not simply mark a "pixel" as set. Instead it increments a counter per character that keeps track of the frequency of pixels drawn in that character. Together with a variable that keeps track of the maximum frequency, the canvas can thus draw the density of data-points.

- **BarplotGraphics**:
  This graphics area is special in that it does not support any pixel manipulation. It is essentially the barplot without decorations but the numbers. It does only support one method `addrow!` which allows the user to add additional bars to the graphics object.
  """)

  kw_description = plain_md_par("""
  All plots support the set (or a subset) of the following named parameters:

  $(join(
    (
      "- `$(UnicodePlots.default_with_type(k))`: $(desc_ex(k, d * '.'))"
      for (k, d) ∈ pairs(UnicodePlots.DESCRIPTION) if k ∈ keys(UnicodePlots.KEYWORDS)
    ), '\n'
  ))

  _Note_: If you want to print the plot into a file but have monospace issues with your font, you should probably try setting `border=:ascii` and `canvas=AsciiCanvas` (or `canvas=DotCanvas` for scatterplots).
  """)

  installation = plain_md_par("""
  To install UnicodePlots, start up `Julia` and type the following code snippet into the `REPL` (makes use of the native `Julia` package manager `Pkg`):
  ```julia
  julia> using Pkg
  julia> Pkg.add("UnicodePlots")
  ```
  """)

  doc_update = plain_md_par("""
  The following snippet:
  ```bash
  \$ cd docs
  \$ julia gen_docs.jl
  \$ (cd imgs; julia gen_imgs.jl)
  ```
  will regenerate `README.md` and the example images with root (prefix) url $(docs_url).
  """)

  invalidations = plain_md_par("""
  Run the following snippet to analyze invalidations:
  ```julia
  using SnoopCompileCore

  invalidations = @snoopr using UnicodePlots
  tinf = @snoopi_deep UnicodePlots.precompile_workload()

  using SnoopCompile, AbstractTrees, PrettyTables  # must occur after `invalidations`

  print_tree(tinf; maxdepth = typemax(Int))

  trees = invalidation_trees(invalidations)
  trees = filtermod(UnicodePlots, trees; recursive = true)

  @show length(uinvalidated(invalidations))  # all invalidations

  # only from `UnicodePlots`
  @show length(staleinstances(tinf))
  @show length(trees)

  SnoopCompile.report_invalidations(;
     invalidations,
     process_filename = x -> last(split(x, ".julia/packages/")),
     n_rows = 0,
  )
  ```
  """)

  readme = plain_md_par("""
# UnicodePlots

[![License](http://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat)](LICENSE.md)
[![PkgEval](https://juliaci.github.io/NanosoldierReports/pkgeval_badges/U/UnicodePlots.named.svg)](https://juliaci.github.io/NanosoldierReports/pkgeval_badges/U/UnicodePlots.html)
[![CI](https://github.com/JuliaPlots/UnicodePlots.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaPlots/UnicodePlots.jl/actions/workflows/ci.yml)
[![Coverage Status](https://codecov.io/gh/JuliaPlots/UnicodePlots.jl/branch/master/graphs/badge.svg?branch=master)](https://app.codecov.io/gh/JuliaPlots/UnicodePlots.jl)
[![JuliaHub deps](https://juliahub.com/docs/UnicodePlots/deps.svg)](https://juliahub.com/ui/Packages/UnicodePlots/Ctj9q?t=2)
[![UnicodePlots Downloads](https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Fmonthly_downloads%2FUnicodePlots&query=total_requests&suffix=%2Fmonth&label=Downloads)](https://juliapkgstats.com/pkg/UnicodePlots)

Advanced [`Unicode`](https://en.wikipedia.org/wiki/Unicode) plotting library designed for use in `Julia`'s `REPL`.

<img src="$docs_url/$ver/banner.jpg" width="900">

## High-level Interface

Here is a list of the main high-level functions for common scenarios:

  - [`lineplot`](https://github.com/JuliaPlots/UnicodePlots.jl#lineplot) (Line Plot)
  - [`scatterplot`](https://github.com/JuliaPlots/UnicodePlots.jl#scatterplot) (Scatter Plot)
  - [`stairs`](https://github.com/JuliaPlots/UnicodePlots.jl#staircase-plot) (Staircase Plot)
  - [`barplot`](https://github.com/JuliaPlots/UnicodePlots.jl#barplot) (Bar Plot - horizontal)
  - [`histogram`](https://github.com/JuliaPlots/UnicodePlots.jl#histogram) (Histogram - horizontal / vertical)
  - [`boxplot`](https://github.com/JuliaPlots/UnicodePlots.jl#boxplot) (Box Plot - horizontal)
  - [`spy`](https://github.com/JuliaPlots/UnicodePlots.jl#sparsity-pattern) (Sparsity Pattern)
  - [`densityplot`](https://github.com/JuliaPlots/UnicodePlots.jl#density-plot) (Density Plot)
  - [`contourplot`](https://github.com/JuliaPlots/UnicodePlots.jl#contour-plot) (Contour Plot)
  - [`polarplot`](https://github.com/JuliaPlots/UnicodePlots.jl#polar-plot) (Polar Plot)
  - [`heatmap`](https://github.com/JuliaPlots/UnicodePlots.jl#heatmap-plot) (Heatmap Plot)
  - [`imageplot`](https://github.com/JuliaPlots/UnicodePlots.jl#image-plot) (Image Plot)
  - [`surfaceplot`](https://github.com/JuliaPlots/UnicodePlots.jl#surface-plot) (Surface Plot - 3D)
  - [`isosurface`](https://github.com/JuliaPlots/UnicodePlots.jl#isosurface-plot) (Isosurface Plot - 3D)

<details open>
  $(summary("Introduction"))

  Here is a quick hello world example of a typical use-case:

$(indent(examples.lineplot1))

  There are other types of `Canvas` available (see section [Low-level Interface](https://github.com/JuliaPlots/UnicodePlots.jl#low-level-interface)).

  In some situations, such as printing to a file, using `AsciiCanvas`, `DotCanvas` or `BlockCanvas` might lead to better results:

$(indent(examples.lineplot2))

  Some plot methods have a mutating variant that ends with an exclamation mark:

$(indent(examples.lineplot3))

  These mutating methods cannot update the limits of the axes as plots are drawn onto a fixed canvas. The limits must be set beforehand by the plotting function that creates the figure or by creating an empty `Plot`:

$(indent(examples.lineplot4))

  One can adjust the plot `height` and `width` to the current terminal size by using `height=:auto` and/or `width=:auto`.
  When using `width=:auto`, it is advised to use the `compact=true` keyword in order to maximize the plot size.

  You can reverse/flip the `Plot` axes by setting `xflip=true` and/or `yflip=true` on plot creation.

</details>

<details open>
  $(summary("Lineplot"))

$(indent(examples.lineplot5))

  It's also possible to specify a function and a range:

$(indent(examples.lineplot6))

  You can also plot lines by specifying an intercept and slope:

$(indent(examples.lineplot7))

  Plotting multiple series is supported by providing a `Matrix` (`<: AbstractMatrix`) for the `y` argument, with the individual series corresponding to its columns. Auto-labeling is by default, but you can also label each series by providing a `Vector` or a `1xn` `Matrix` such as `["series 1" "series2" ...]`:

$(indent(examples.lineplot8))

  Physical quantities of [`Unitful.jl`](https://github.com/PainterQubits/Unitful.jl) are supported through [package extensions - weak dependencies](https://pkgdocs.julialang.org/dev/creating-packages/#Conditional-loading-of-code-in-packages-(Extensions)):

$(indent(examples.lineplot9))

  Intervals from [`IntervalSets.jl`](https://github.com/JuliaMath/IntervalSets.jl) are supported:

$(indent(examples.lineplot10))

  Use `head_tail` to mimic plotting arrows (`:head`, `:tail` or `:both`) where the length of the "arrow" head or tail is controlled using `head_tail_frac` where e.g. giving a value of `0.1` means `10%` of the segment length:

$(indent(examples.lineplot11))

  `UnicodePlots` exports `hline!` and `vline!` for drawing vertical and horizontal lines on a plot:

$(indent(examples.lineplot12))

</details>

<details open>
  $(summary("Scatterplot"))

$(indent(examples.scatterplot1))

  Axis scaling (`xscale` and/or `yscale`) is supported: choose from (`:identity`, `:ln`, `:log2`, `:log10`) or use an arbitrary scale function:

$(indent(examples.scatterplot2))

  For the axis scale exponent, one can revert to using `ASCII` characters instead of `Unicode` ones using the keyword `unicode_exponent=false`:

$(indent(examples.scatterplot3))

  Using a `marker` is supported, choose a `Char`, a unit length `String` or a symbol name such as `:circle` (more from `keys(UnicodePlots.MARKERS)`).
  One can also provide a vector of `marker`s and/or `color`s as in the following example:

$(indent(examples.scatterplot4))

  As with `lineplot`, `scatterplot` supports plotting physical `Unitful` quantities, or plotting multiple series (`Matrix` argument).
</details>

<details open>
  $(summary("Staircase plot"))

$(indent(examples.stairs1))
</details>

<details open>
  $(summary("Barplot"))

$(indent(examples.barplot1))

  _Note_: You can use the keyword argument `symbols` to specify the characters that should be used to plot the bars (e.g. `symbols=['#']`).
</details>

<details open>
  $(summary("Histogram"))

$(indent(examples.histogram1))

  The `histogram` function also supports axis scaling using the parameter `xscale`:

$(indent(examples.histogram2))

  Vertical histograms are supported:

$(indent(examples.histogram3))
</details>

<details open>
  $(summary("Boxplot"))

$(indent(examples.boxplot1))

$(indent(examples.boxplot2))
</details>

<details open>
  $(summary("Sparsity Pattern"))

$(indent(examples.spy1))

  Plotting the zeros pattern is also possible using `show_zeros=true`:

$(indent(examples.spy2))
</details>

<details open>
  $(summary("Density Plot"))

$(indent(examples.densityplot1))

  Using a scale function (e.g. damping peaks) is supported using the `dscale` keyword:

$(indent(examples.densityplot2))
</details>

<details open>
  $(summary("Contour Plot"))

$(indent(examples.contourplot1))

  The keyword `levels` controls the number of contour levels. One can also choose a `colormap` as with `heatmap`, and disable the colorbar using `colorbar=false`.
</details>

<details open>
  $(summary("Polar Plot"))

  Plots data in polar coordinates with `θ` the angles in radians.

$(indent(examples.polarplot1))

</details>

<details open>
  $(summary("Heatmap Plot"))

$(indent(examples.heatmap1))

  The `heatmap` function also supports axis scaling using the parameters `xfact`, `yfact` and axis offsets after scaling using `xoffset` and `yoffset`.

  The `colormap` parameter may be used to specify a named or custom colormap. See the `heatmap` function documentation for more details.

  In addition, the `colorbar` and `colorbar_border` options may be used to toggle the colorbar and configure its border.

  The `zlabel` option and `zlabel!` method may be used to set the `z` axis (colorbar) label.

  Use the `array` keyword in order to display the matrix in the array convention (as in the repl).

$(indent(examples.heatmap2))
</details>

<details open>
  $(summary("Image Plot"))

  Draws an image, surround it with decorations. `Sixel` are supported (experimental) under a compatible terminal through [`ImageInTerminal`](https://github.com/JuliaImages/ImageInTerminal.jl) (which must be imported before `UnicodePlots`).

$(indent(examples.imageplot1))
</details>

<details open>
  $(summary("Surface Plot"))

  Plots a colored surface using height values `z` above a `x-y` plane, in three dimensions (masking values using `NaN`s is supported).

$(indent(examples.surfaceplot1))

  Use `lines=true` to increase the density (underlying call to `lineplot` instead of `scatterplot`, with color interpolation).
  By default, `surfaceplot` scales heights to adjust aspect wrt the remaining axes with `zscale=:aspect`.
  To plot a slice in 3D, use an anonymous function which maps to a constant value: `zscale=z -> a_constant`:

$(indent(examples.surfaceplot2))
</details>

<details open>
  $(summary("Isosurface Plot"))

  Uses [`MarchingCubes.jl`](https://github.com/JuliaGeometry/MarchingCubes.jl) to extract an isosurface, where `isovalue` controls the surface isovalue.
  Using `centroid` enables plotting the triangulation centroids instead of the triangle vertices (better for small plots).
  Back face culling (hide not visible facets) can be activated using `cull=true`.
  One can use the legacy 'Marching Cubes' algorithm using `legacy=true`.

$(indent(examples.isosurface))
</details>

## Documentation

##### Installation
<details>
  $(summary(nothing))

  $(installation)
</details>

##### Saving figures
<details>
  $(summary(nothing))

  Saving plots as `png` or `txt` files using the `savefig` command is supported (saving as `png` is experimental and requires `import FreeType, FileIO` before loading `UnicodePlots`).

  To recover the plot as a string with ansi color codes use `string(p; color=true)`.
</details>

##### Color mode
<details>
  $(summary(nothing))

  When the `COLORTERM` environment variable is set to either `24bit` or `truecolor`, `UnicodePlots` will use [24bit colors](https://en.wikipedia.org/wiki/ANSI_escape_code#24-bit) as opposed to [8bit colors](https://en.wikipedia.org/wiki/ANSI_escape_code#8-bit) or even [4bit colors](https://en.wikipedia.org/wiki/ANSI_escape_code#3-bit_and_4-bit) for named colors.

  One can force a specific colormode using either `UnicodePlots.truecolors!()` or `UnicodePlots.colors256!()`.

  Named colors such as `:red` or `:light_red` will use `256` color values (rendering will be terminal dependent). In order to force named colors to use true colors instead, use `UnicodePlots.USE_LUT[]=true`.

  The default color cycle can be changed to bright (high intensity) colors using `UnicodePlots.brightcolors!()` instead of the default `UnicodePlots.faintcolors!()`.
</details>

##### 3D plots
<details>
  $(summary(nothing))

  3d plots use a so-called "Model-View-Projection" transformation matrix `MVP` on input data to project 3D plots to a 2D screen.

  Use keywords`elevation`, `azimuth`, `up` or `zoom` to control the view matrix, a.k.a. camera.

  The `projection` type for `MVP` can be set to either `:persp(ective)` or `:ortho(graphic)`.

  Displaying the `x`, `y`, and `z` axes can be controlled using the `axes3d` keyword.

  For enhanced resolution, use a wider and/or taller `Plot` (this can be achieved using `default_size!(width=60)` for all future plots).
</details>

##### Layout
<details>
  $(summary(nothing))

  `UnicodePlots` is integrated in [`Plots`](https://github.com/JuliaPlots/Plots.jl) as a backend, with support for [basic layout](https://docs.juliaplots.org/stable/gallery/unicodeplots/generated/unicodeplots-ref17).

  For a more complex layout, use the `gridplot` function (requires loading [`Term`](https://github.com/FedeClaudi/Term.jl) as extension).
  ```julia
  using UnicodePlots, Term

  (
    UnicodePlots.panel(lineplot(1:2)) *
    UnicodePlots.panel(scatterplot(rand(100)))
  ) / (
    UnicodePlots.panel(lineplot(2:-1:1)) * 
    UnicodePlots.panel(densityplot(randn(1_000), randn(1_000)))
  ) |> display

  gridplot(map(i -> lineplot(-i:i), 1:5); show_placeholder=true) |> display
  gridplot(map(i -> lineplot(-i:i), 1:3); layout=(2, nothing)) |> display
  gridplot(map(i -> lineplot(-i:i), 1:3); layout=(nothing, 1)) |> display
  ```
</details>

##### Known issues
<details>
  $(summary(nothing))

  Using a non `true monospace font` can lead to visual problems on a `BrailleCanvas` (border versus canvas).

  Either change the font to e.g. [JuliaMono](https://juliamono.netlify.app/) or use `border=:dotted` keyword argument in the plots.

  For a `Jupyter` notebook with the `IJulia` kernel see [here](https://juliamono.netlify.app/faq/#can_i_use_this_font_in_a_jupyter_notebook_and_how_do_i_do_it).

  (Experimental) Terminals seem to respect a standard aspect ratio of `4:3`, hence a square matrix does not often look square in the terminal.

  You can pass the experimental keyword `fix_ar=true` to `spy` or `heatmap` in order to recover a unit aspect ratio.
</details>

##### Methods (API)
<details>
  $(summary(nothing))

$(methods)
</details>

##### Keywords description (API)
<details>
  $(summary(nothing))

$(indent(kw_description))
</details>

##### Low-level interface
<details>
  $(summary(nothing))

$(indent(low_level_interface))
</details>

##### Developer notes
<details>
  $(summary(nothing))

  Because Julia uses column-major indexing order for an array type, and because displaying data on a terminal is row based, we need an internal buffer compatible with efficient columns based iteration. We solve this by using the transpose of a (`width`, `height`) array for indexing into an internal buffer like `buf[row, col]` or `buf[y, x]`.
  Common users of UnicodePlots don't need to be aware of this axis difference if sticking to public interface.

$(indent(examples.buffer_convention))
</details>

##### Invalidations check
<details>
  $(summary(nothing))

$(indent(invalidations))
</details>


##### Documentation update
<details>
  $(summary(nothing))

$(indent(doc_update))
</details>

## License

This code is free to use under the terms of the MIT license.

## Acknowledgement

Inspired by [TextPlots.jl](https://github.com/sunetos/TextPlots.jl), which in turn was inspired by [Drawille](https://github.com/asciimoo/drawille).
""")

  joinpath(@__DIR__, "imgs", ver) |> mkpath

  fix_rand(c) = replace(c, r"\bsprandn\b\(" => "_stable_sprand(rng, ", r"\brandn\b\(" => "randn(rng, ", r"\brand\b\(" => "rand(rng, ")

  open(joinpath(@__DIR__, "imgs", "gen_imgs.jl"), "w") do io
    banner = """
    banner() = begin
      rng = StableRNG(1337)
      default_size!(height=10)

      panel(x; kw...) = begin
        xs = if x isa Plot
          # x.margin[] = p.padding[] = 0  # make plots more compact
          # x.compact_labels[] = x.compact[] = true
          string(x, color=true)
        else
          x
        end
        Panel(xs; fit=true, style="(180, 180, 180)", kw...)
      end

      panels = (
        line = panel(lineplot(t -> exp(-.15t) * sinpi(.5t), xlabel="t", ylabel="y(t)", name = "decay"); title="lineplot"),
        scat = panel(scatterplot(1:6, 1:6, xscale=:log10, yscale=:ln); title="scatterplot"),
        cont = panel(contourplot(-3:.01:3, -7:.01:3, (x, y) -> exp(-(x / 2)^2 - ((y + 2) / 4)^2)); title="contourplot"),
        surf = panel(surfaceplot(-8:.5:8, -8:.5:8, (x, y) -> 15sinc(√(x^2 + y^2) / π)); title="surfaceplot"),
        iso = panel(isosurface(-1:.1:1, -1:.1:1, -1:.1:1, (x, y, z) -> (√(x^2 + y^2) - 0.5)^2 + z^2 - 0.2^2, cull=true, zoom=2, elevation=50); title="isosurface"),
        vhist = panel(histogram(randn(1_000_000), nbins=150, vertical=true, compact_labels=true); title="histogram (vertical)"),
        hhist = panel(histogram(randn(1_000) .* 0.1, nbins=15); title="histogram (horizontal)"),
        dens = panel(densityplot(randn(1_000), randn(1_000); xlabel="x label", ylabel="y label", compact_labels=true); title="densityplot"),
        hmap = panel(heatmap(collect(0:20) * collect(0:20)', xfact=.1, yfact=.1, title="a matrix"); title="heatmap"),
        bar = panel(barplot(["Paris", "New York", "Madrid", "Berlin", "Amsterdam"], [2.244, 8.406, 3.165, 4.645, 0.821]); title="barplot"),
        polar = panel(polarplot(range(0, 2π, length=20), range(0, 2, length = 20)); title="polarplot"),
        box = panel(boxplot(["one", "two"], [collect(1:5), collect(3:6)]); title="boxplot"),
        stair = panel(stairs([1, 2, 4, 7, 8], [1, 3, 4, 2, 2]); title="stairs"),
        img = panel(imageplot(testimage("monarch_color_256")); title="imageplot"),
        spy = panel(spy(sprandn(20, 50, .05); compact_labels=true); title="spy"),
      )
      g = grid(panels, layout=:(
        (line * scat * polar * stair) / (dens * cont * surf * iso) / (hhist * (box / spy) * hmap * img) / (vhist * bar)
      ))

      if true
        cursor_hide(stdout)
        run(`clear`)
        println(stdout, g)
        win = if "WINDOWID" ∈ keys(ENV)
          ENV["WINDOWID"]
        else
          readchomp(`xdotool getactivewindow`)
        end
        tmp = tempname()
        sleep(1)
        # XX%x100% => remove the right scrollbar (run in a big terminal window)
        run(`import -window \$win -gravity West -crop 70%x100%+0+0 -trim -quality 100 \$tmp.miff`)
        # FIXME: export to `jpg` format, since we have an issue with rendering this `png` on github
        run(`convert -bordercolor '#2e3336' -border 4 -quality 100 \$tmp.miff $ver/banner.jpg`)
        cursor_show(stdout)
      else
        print(stdout, g)
        open("$ver/banner.txt", "w") do io
          print(io, g)
        end
      end
    end
    """

    println(io, """
      # $warn
      using ImageInTerminal, TestImages, FreeType, FileIO, Unitful, IntervalSets
      using UnicodePlots, StableRNGs, SparseArrays, Term
      import UnicodePlots: lines!, points!, pixel!

      # UnicodePlots.brightcolors!()

      include(joinpath(dirname(pathof(UnicodePlots)), "..", "test", "fixes.jl"))

      cursor_hide(io::IO) = print(io, "\e[?25l")
      cursor_show(io::IO) = print(io, "\e[?25h")

      $(fix_rand(banner))

      main() = begin
        rng = StableRNG(1337)

        bb = Base.get_bool_env("BB", false) ? 9 : nothing
        bb_glyph = Base.get_bool_env("BB_GL", false) ? 8 : nothing

        banner()
      """
    )
    for (i, (k, e)) ∈ enumerate(pairs(exs))
      println(io, "  # $k")
      code = fix_rand.(filter(x -> length(x) != 0 && !startswith(lstrip(x), r"using|import"), [lstrip(c) for c ∈ split(e[2], '\n')]))
      println(io, """
          println("ex n°$i - $k")
          default_size!()
          plt = begin
        """ * indent(code, 2) * '\n' * """
          end
          display(plt)
          savefig(plt, "$ver/$k.png"; transparent=false, bounding_box=bb, bounding_box_glyph=bb_glyph, pixelsize=32)
          # savefig(plt, "$ver/$k.txt"; color=true)
        """
      )
    end
    println(io, "  return\nend\nmain()")
  end

  write(stdout, readme)
  open(joinpath(@__DIR__, "..", "README.md"), "w") do io
    write(io, "<!-- $warn, and run \$ julia gen_docs.jl to render README.md !! -->\n")
    write(io, readme)
  end
  return
end

#=
open("imgs/gen_all.sh", "w") do io
  write(io, """
    #!/usr/bin/env bash
    # $warn

    echo '== julia =='
    \${JULIA-julia} gen_imgs.jl

    txt2png() {
      html=\${1%.txt}.html
      cat \$1 | \${ANSI2HTML-ansi2html} --input-encoding=utf-8 --output-encoding=utf-8 >\$html
      sed -i "s,background-color: #000000,background-color: #282828," \$html
      \${WKHTMLTOIMAGE-wkhtmltoimage} --quiet --quality 85 \$html \${html%.html}.png
    }
    echo '== txt2png =='
    for f in $ver/*.txt; do
      txt2png \$f & pids+=(\$!)
    done
    wait \${pids[@]}
    rm $ver/*.txt
    rm $ver/*.html
    """
  )
end
=#

@testset "reported issues" begin
    @testset "barplot nl in text (#102)" begin
        p = barplot(
            ["I need a\nbreak", "I don't but could", :Hello, :Again],
            [30, 40, 20, 10],
        )
        test_ref("issues/barplot_nl.txt", @show_col(p))
    end

    @testset "plot hang (tan → ∞) (#129)" begin
        p = lineplot(-π / 2, 2π, [cos, sin, tan])
        test_ref("issues/cos_sin_tan.txt", @show_col(p))
    end

    @testset "integer edges (#139)" begin
        p_int = horizontal_histogram(fit(Histogram, rand(10), 0:3))
        p_float = horizontal_histogram(fit(Histogram, rand(10), 0.0:1.0:3.0))
        @test @print_col(p_int) == @print_col(p_float)
    end

    @testset "isolated colorbar (#169)" begin
        p = Plot(
            [0],
            [0],
            colorbar = true,
            colormap = :cividis,
            width = -1,
            margin = 0,
            padding = 0,
        )
        test_ref("issues/isolated_colorbar.txt", @show_col(p))
    end

    @testset "steps (#211)" begin
        x = 1:5
        y = [1.0, 2.0, 3.0, 2.0, 1.0]
        p = scatterplot(x, y, marker = :circle)
        x = [1.0, 1.0, 2.0, 2.0, 3.0, 3.0, 4.0, 4.0, 5.0]
        y = [1.0, 2.0, 2.0, 3.0, 3.0, 2.0, 2.0, 1.0, 1.0]
        p = lineplot!(p, x, y)
        test_ref("issues/steps.txt", @show_col(p))
    end

    @testset "signed zero (#229)" begin
        p = histogram([-1.0, -0.0, 1.0])
        test_ref("issues/signed_zero.txt", @show_col(p))
    end

    @testset "grid log scale (#265)" begin
        @test lineplot(0.01:10, 0.01:10, xscale = :log10, yscale = :log10) isa Plot
    end

    @testset "float input (#277)" begin
        for FX in (Float16, Float32, Float64), FY in (Float16, Float32, Float64)
            @test lineplot(FX[-1, 2], FY[-1, 9]) isa Plot
        end
        @test barplot(["Paris", "Madrid"], Float32[2.2, 8.4]; maximum = 10.0f0) isa Plot
    end

    @testset "invalid data (#297)" begin
        @test_logs (:warn, "Invalid plotting range") match_mode = :any lineplot(
            [
                nextfloat(-Inf),
                prevfloat(+Inf),
            ]
        ) isa Plot
        @test lineplot([nextfloat(-Inf32), prevfloat(+Inf32)]) isa Plot
        @test lineplot([nextfloat(-Inf16), prevfloat(+Inf16)]) isa Plot
    end

    @testset "NaNs in heatmap (#321)" begin
        A = Array(1.0 * I, 5, 5)
        A[begin, begin] = A[end, end] = NaN
        p = heatmap(A; colorbar = true)
        test_ref("issues/heatmap_nans.txt", @show_col(p))

        p = heatmap(fill(NaN, 5, 5); colorbar = true)
        test_ref("issues/heatmap_all_nans.txt", @show_col(p))

        # while resolving #321, a bug in printing the last row was observed
        A = Array(1.0 * I, 4, 4)
        p = heatmap(A; array = true)
        test_ref("issues/heatmap_identity_array.txt", @show_col(p))

        p = heatmap(A)
        test_ref("issues/heatmap_identity.txt", @show_col(p))
    end

    @testset "Unitful mix units, lims (#321)" begin
        x = 1:3
        y = @. 2x * u"s"
        ylim = (0u"s", 8u"s")

        @test lineplot(x, y; ylim) isa Plot
        @test scatterplot(x, y; ylim) isa Plot
    end

    @testset "Unitful dispatch (#383)" begin
        @test lineplot(rand(1), rand(1) * u"m") isa Plot
        @test lineplot(rand(1) * u"m", rand(1)) isa Plot

        @test scatterplot(rand(1), rand(1) * u"m") isa Plot
        @test scatterplot(rand(1) * u"m", rand(1)) isa Plot
    end

    @testset "Heatmap ±Inf (#378)" begin
        @test heatmap([1 2; 3 -Inf]) isa Plot
        @test heatmap([-Inf]') isa Plot
        @test heatmap([1 2; 3 Inf]) isa Plot
    end

    @testset "width=:auto (#404)" begin
        @test lineplot(
            -1:1,
            width = :auto,
            ylim = (-0.456789, 0.456789),
            compact = true,
            ylabel = "a label",
        ) isa Plot
        @test lineplot(
            -1:1,
            width = :auto,
            ylim = (-0.456789, 0.456789),
            margin = 0,
            padding = 0,
            ylabel = "a label",
            compact = true,
        ) isa Plot
        @test lineplot(
            -1:1,
            width = :auto,
            ylim = (-0.456789, 0.456789),
            compact = true,
        ) isa Plot
    end
end

# NOTE: use `axes3d = false` on stability of \ issues w.r.t azimuth and elevation

@testset "sphere" begin
    x = y = z = -3:0.2:3
    p = isosurface(
        x,
        y,
        z,
        (x, y, z) -> x^2 + y^2 + z^2 - 2;
        centroid = false,
        cull = true,
        zoom = 2,
    )
    test_ref("isosurface/sphere.txt", @show_col(p))
end

@testset "torus" begin
    torus(x, y, z, r = 0.2, R = 0.5) = (√(x^2 + y^2) - R)^2 + z^2 - r^2
    x = y = z = -1:0.1:1
    p = isosurface(x, y, z, torus; cull = true, zoom = 2)
    test_ref("isosurface/torus.txt", @show_col(p))
end

@testset "hyperboloid" begin
    x = y = z = -3:0.8:3
    p = isosurface(x, y, z, (x, y, z) -> x^2 + y^2 - z^2 - 1)
    test_ref("isosurface/hyperboloid.txt", @show_col(p))
end

@testset "legacy" begin
    x = y = z = -3:0.25:3
    p = isosurface(x, y, z, (x, y, z) -> x * exp(-x^2 - y^2 - z^2) - 1.0e-4; legacy = true)
    test_ref("isosurface/legacy.txt", @show_col(p))
end

module UnitfulExt

import UnicodePlots: UnicodePlots, KEYWORDS, Plot, Canvas, unitless
import Unitful: Unitful, AbstractQuantity, ustrip, unit

# compat for Unitful < 1.6
const RealOrRealQuantity = if isdefined(Unitful, :RealOrRealQuantity)
    Unitful.RealOrRealQuantity
else
    Union{Real, AbstractQuantity{<:Real}}
end

function unit_str(x, fancy)
    io = IOContext(PipeBuffer(), :fancy_exponent => fancy)
    show(io, unit(x))
    return read(io, String)
end

unit_label(label::AbstractString, unit::AbstractString) =
    (lab_strip = rstrip(label)) |> isempty ? unit : "$lab_strip ($unit)"
unit_label(label::AbstractString, unit::Nothing) = rstrip(label)

number_unit(x::Union{AbstractVector, Number}, args...) = x, nothing
number_unit(x::AbstractVector{<:AbstractQuantity}, fancy = true) =
    ustrip.(x), unit_str(first(x), fancy)
number_unit(x::AbstractQuantity, fancy = true) = ustrip(x), unit_str(x, fancy)

unitless(x::AbstractQuantity) = ustrip(x)  # NOTE: keep in sync with src/common.jl

# ---------------------------------------------------------------------------- #
# lineplot
function UnicodePlots.lineplot(
        x::AbstractVector{<:RealOrRealQuantity},
        y::AbstractVector{<:RealOrRealQuantity};
        unicode_exponent::Bool = KEYWORDS.unicode_exponent,
        canvas::Type = KEYWORDS.canvas,
        xlabel = KEYWORDS.xlabel,
        ylabel = KEYWORDS.ylabel,
        kw...,
    )
    pkw, okw = UnicodePlots.split_plot_kw(kw)
    x, ux = number_unit(x, unicode_exponent)
    y, uy = number_unit(y, unicode_exponent)
    x_, y_ = unitless.(x), unitless.(y)
    plot = Plot(
        x_,
        y_,
        nothing,
        canvas;
        xlabel = unit_label(xlabel, ux),
        ylabel = unit_label(ylabel, uy),
        unicode_exponent,
        pkw...,
    )
    return UnicodePlots.lineplot!(plot, x_, y_; okw...)
end

UnicodePlots.lineplot!(
    plot::Plot{<:Canvas},
    x::AbstractVector{<:RealOrRealQuantity},
    y::AbstractVector{<:AbstractQuantity};
    kw...,
) = UnicodePlots.lineplot!(plot, unitless.(x), unitless.(y); kw...)

# ---------------------------------------------------------------------------- #
# scatterplot
function UnicodePlots.scatterplot(
        x::AbstractVector{<:RealOrRealQuantity},
        y::AbstractVector{<:RealOrRealQuantity};
        unicode_exponent::Bool = KEYWORDS.unicode_exponent,
        canvas::Type = KEYWORDS.canvas,
        xlabel = KEYWORDS.xlabel,
        ylabel = KEYWORDS.ylabel,
        kw...,
    )
    pkw, okw = UnicodePlots.split_plot_kw(kw)
    x, ux = number_unit(x, unicode_exponent)
    y, uy = number_unit(y, unicode_exponent)
    x_, y_ = unitless.(x), unitless.(y)
    plot = Plot(
        x_,
        y_,
        nothing,
        canvas;
        xlabel = unit_label(xlabel, ux),
        ylabel = unit_label(ylabel, uy),
        unicode_exponent,
        pkw...,
    )
    return UnicodePlots.scatterplot!(plot, x_, y_; okw...)
end

UnicodePlots.scatterplot!(
    plot::Plot{<:Canvas},
    x::AbstractVector{<:RealOrRealQuantity},
    y::AbstractVector{<:AbstractQuantity};
    kw...,
) = UnicodePlots.scatterplot!(plot, unitless.(x), unitless.(y); kw...)

end  # module

# adapted from github.com/JuliaGraphics/FreeTypeAbstraction.jl/blob/master/src/rendering.jl
# credits to the `FreeTypeAbstraction` authors (@SimonDanisch, @jkrumbiegel).

module FreeTypeExt

import UnicodePlots
import FileIO

using StaticArrays
using ColorTypes
using FreeType

const REGULAR_STYLES = "regular", "normal", "medium", "standard", "roman", "book"
const FT_LIB = FT_Library[C_NULL]
const LIB_LOCK = ReentrantLock()
const VALID_FONTPATHS = String[]

struct FontExtent{T}
    vertical_bearing::SVector{2, T}
    horizontal_bearing::SVector{2, T}
    advance::SVector{2, T}
    scale::SVector{2, T}
end

mutable struct FTFont
    ft_ptr::FT_Face
    lock::ReentrantLock  # lock this for the duration of any FT operation on ft_ptr
    function FTFont(ft_ptr::FT_Face)
        face = new(ft_ptr, ReentrantLock())
        finalizer(safe_free, face)
        return face
    end
end

function safe_free(face::FTFont)
    return @lock face.lock begin
        (face.ft_ptr != C_NULL && FT_LIB[1] != C_NULL) && FT_Done_Face(face)
    end
end

FTFont(path::String) = FTFont(new_face(path))
FTFont(::Nothing) = nothing

family_name(font::FTFont) = lowercase(ft_property(font, :family_name))
style_name(font::FTFont) = lowercase(ft_property(font, :style_name))
Base.propertynames(font::FTFont) = fieldnames(FT_FaceRec)

# c interoperability
Base.cconvert(::Type{FT_Face}, font::FTFont) = font
Base.unsafe_convert(::Type{FT_Face}, font::FTFont) = font.ft_ptr

function ft_property(face::FTFont, fieldname::Symbol)
    font_rect = @lock face.lock unsafe_load(face.ft_ptr)
    return if (field = getfield(font_rect, fieldname)) isa Ptr{FT_String}
        field == C_NULL && return ""
        unsafe_string(field)
    else
        field
    end
end

Base.show(io::IO, font::FTFont) = print(
    io,
    "FTFont (family = $(ft_property(font, :family_name)), style = $(ft_property(font, :style_name)))",
)

check_error(err, error_msg) = err == 0 || error("$error_msg with error: $err")

function new_face(name, index::Real = 0, ftlib = FT_LIB)
    face = Ref{FT_Face}()
    err = @lock LIB_LOCK FT_New_Face(ftlib[1], name, Int32(index), face)
    check_error(err, "Couldn't load font $name")
    return face[]
end

add_mono(fts...) = tuple(map(x -> x * "Mono", fts)..., fts...)

# COV_EXCL_START
# those fallback fonts are likely to fail braille characters
fallback_fonts() = if Sys.islinux()
    add_mono("DejaVu Sans ", "Ubuntu ", "Noto ", "Free", "Liberation ")  # NOTE: trailing space intended
elseif Sys.isbsd()
    ("Courier New", "Helvetica")
elseif Sys.iswindows()
    ("Courier New", "Arial")
else
    @warn "Unsupported $(Base.KERNEL)"
    ("Courier", "Helvetica")
end::Tuple
# COV_EXCL_STOP

const FT_FONTS = Dict{String, FTFont}()

"""
Match a font using the user-specified search string.
Each part of the search string is searched in the family name first,
which has to match once to include the font in the candidate list.
For fonts with a family match the style name is matched next.
For fonts with the same family and style name scores, regular fonts are preferred
(any font that is "regular", "normal", "medium", "standard" or "roman"),
and as a last tie-breaker, shorter overall font names are preferred.

Example:

If we had only four fonts:
- Helvetica Italic
- Helvetica Regular
- Helvetica Neue Regular
- Helvetica Neue Light

Then this is how this function would match different search strings:
- "helvetica"           => Helvetica Regular
- "helv"                => Helvetica Regular
- "HeLvEtIcA"           => Helvetica Regular
- "helvetica italic"    => Helvetica Italic
- "helve ita"           => Helvetica Italic
- "helvetica neue"      => Helvetica Neue Regular
- "tica eue"            => Helvetica Neue Regular
- "helvetica light"     => Helvetica Neue Light
- "light"               => Helvetica Neue Light
- "helvetica bold"      => Helvetica Regular
- "helvetica neue bold" => Helvetica Neue Regular
- "times"               => no match
- "arial"               => no match
"""
function match_font(face::FTFont, searchparts)::Tuple{Int, Int, Bool, Int}
    fname, sname = family_name(face), style_name(face)
    is_regular_style = any(occursin.(REGULAR_STYLES, Ref(sname)))

    fontlength_penalty = -length(fname) - length(sname)
    family_matches = any(occursin.(searchparts, Ref(fname)))

    # return early if family name doesn't have a match
    family_matches || return 0, 0, is_regular_style, fontlength_penalty
    family_score = sum(map(length, filter(part -> occursin(part, fname), searchparts)))

    # now enhance the score with style information
    remaining_parts = filter(part -> !occursin(part, fname), searchparts)

    isempty(remaining_parts) && return family_score, 0, is_regular_style, fontlength_penalty

    # check if any parts match the style name, otherwise return early
    any(occursin.(remaining_parts, Ref(sname))) ||
        return family_score, 0, is_regular_style, fontlength_penalty

    style_score = sum(map(length, filter(part -> occursin(part, sname), remaining_parts)))  # COV_EXCL_LINE
    return family_score, style_score, is_regular_style, fontlength_penalty  # COV_EXCL_LINE
end

function find_font(searchstring::String; additional_fonts::String = "")
    font_folders = copy(VALID_FONTPATHS)
    isempty(additional_fonts) || pushfirst!(font_folders, additional_fonts)

    # \W splits at all groups of non-word characters (like space, -, ., etc)
    searchparts = unique(split(lowercase(searchstring), r"\W+", keepempty = false))

    best_score = 0, 0, false, typemin(Int)
    best_fpath = face = nothing

    for folder in font_folders, font in readdir(folder)
        fpath = joinpath(folder, font)
        try
            face = FTFont(fpath)
        catch
            continue
        end

        score = match_font(face, searchparts)
        # we can compare all four tuple elements of the score at once in order of importance:
        # 1. number of family match characters
        # 2. number of style match characters
        # 3. is font a "regular" style variant ?
        # 4. the negative length of the font name, the shorter the better
        if (family_match_score = first(score)) > 0 && score > best_score
            best_fpath = fpath
            best_score = score
        end
        finalize(face)
    end
    return FTFont(best_fpath)
end

hadvance(ext::FontExtent) = ext.advance[1]
vadvance(ext::FontExtent) = ext.advance[2]
inkwidth(ext::FontExtent) = ext.scale[1]
inkheight(ext::FontExtent) = ext.scale[2]
hbearing_ori_to_left(ext::FontExtent) = ext.horizontal_bearing[1]
hbearing_ori_to_top(ext::FontExtent) = ext.horizontal_bearing[2]
leftinkbound(ext::FontExtent) = hbearing_ori_to_left(ext)
rightinkbound(ext::FontExtent) = leftinkbound(ext) + inkwidth(ext)
bottominkbound(ext::FontExtent) = hbearing_ori_to_top(ext) - inkheight(ext)
topinkbound(ext::FontExtent) = hbearing_ori_to_top(ext)

FontExtent(fontmetric::FT_Glyph_Metrics, scale::T = 64.0) where {T <: AbstractFloat} = FontExtent(
    SVector{2, T}(fontmetric.vertBearingX, fontmetric.vertBearingY) ./ scale,
    SVector{2, T}(fontmetric.horiBearingX, fontmetric.horiBearingY) ./ scale,
    SVector{2, T}(fontmetric.horiAdvance, fontmetric.vertAdvance) ./ scale,
    SVector{2, T}(fontmetric.width, fontmetric.height) ./ scale,
)

FontExtent(func::Function, ext::FontExtent) = FontExtent(
    func(ext.vertical_bearing),
    func(ext.horizontal_bearing),
    func(ext.advance),
    func(ext.scale),
)

function set_pixelsize(face::FTFont, size::Integer)
    @lock face.lock check_error(
        FT_Set_Pixel_Sizes(face, size, size),
        "Couldn't set pixelsize",
    )
    return size
end

glyph_index(face::FTFont, glyphname::String)::UInt64 =
    @lock face.lock FT_Get_Name_Index(face, glyphname)
glyph_index(face::FTFont, char::Char)::UInt64 =
    @lock face.lock FT_Get_Char_Index(face, char)
glyph_index(face::FTFont, idx::Integer) = UInt64(idx)

function kerning(face::FTFont, glyphspecs...)
    i1, i2 = glyph_index.(Ref(face), glyphspecs)
    kerning2d = Ref{FT_Vector}()
    err = @lock face.lock FT_Get_Kerning(face, i1, i2, FT_KERNING_DEFAULT, kerning2d)
    # can error if font has no kerning ! Since that's somewhat expected, we just return 0
    err == 0 || return SVector(0.0, 0.0)
    divisor = 64  # 64 since metrics are in 1/64 units (units to 26.6 fractional pixels)
    return SVector(kerning2d[].x / divisor, kerning2d[].y / divisor)
end

function load_glyph(face::FTFont, glyph)
    gi = glyph_index(face, glyph)
    err = @lock face.lock FT_Load_Glyph(face, gi, FT_LOAD_RENDER)
    check_error(err, "Could not load glyph $(repr(glyph)) from $face to render.")
end

function load_glyph(face::FTFont, glyph, pixelsize::Integer; set_pix = true)
    set_pix && set_pixelsize(face, pixelsize)
    load_glyph(face, glyph)
    gl = @lock face.lock unsafe_load(ft_property(face, :glyph))
    @assert gl.format == FT_GLYPH_FORMAT_BITMAP
    return gl
end

function glyph_bitmap(bitmap::FT_Bitmap)
    @assert bitmap.pixel_mode == FT_PIXEL_MODE_GRAY
    bmp = Matrix{UInt8}(undef, bitmap.width, bitmap.rows)
    row = bitmap.buffer
    bitmap.pitch < 0 && (row -= bitmap.pitch * (rbmpRec.rows - 1))
    for r in 1:(bitmap.rows)
        bmp[:, r] = unsafe_wrap(Array, row, bitmap.width)
        row += bitmap.pitch
    end
    return bmp
end

function render_face(face::FTFont, glyph, pixelsize::Integer; kw...)
    gl = load_glyph(face, glyph, pixelsize; kw...)
    return glyph_bitmap(gl.bitmap), FontExtent(gl.metrics)
end

extents(face::FTFont, glyph, pixelsize::Integer) =
    FontExtent(load_glyph(face, glyph, pixelsize).metrics)

one_or_typemax(::Type{T}) where {T <: Union{Real, Colorant}} =
    T <: Integer ? typemax(T) : oneunit(T)

"""
    render_string!(img::AbstractMatrix, str::String, face, pixelsize, y0, x0;
                   fcolor=one_or_typemax(T), bcolor=zero(T), halign=:hleft, valign=:vbaseline) -> Matrix
Render `str` into `img` using the font `face` of size `pixelsize` at coordinates `y0,x0`.
Uses the conventions of freetype.org/freetype2/docs/glyphs/glyphs-3.html
# Arguments
- `y0,x0`: origin is in upper left with positive `y` going down.
- `fcolor`: foreground color; AbstractVector{T}, typemax(T) for T<:Integer, otherwise one(T).
- `gcolor`: background color; AbstractVector{T}, typemax(T) for T<:Integer, otherwise one(T).
- `bcolor`: canvas background color; set to `nothing` for transparent.
- `halign`: :hleft, :hcenter, or :hright.
- `valign`: :vtop, :vcenter, :vbaseline, or :vbttom.
- `bbox_glyph`: glyph bounding box color (debugging).
- `bbox`: bounding box color (debugging).
- `gstr`: background string or array of chars (for background sizing).
- `incx`: extra x spacing.
"""
function UnicodePlots.render_string!(
        img::AbstractMatrix{T},
        fstr::Union{AbstractVector{Char}, String},
        face::FTFont,
        pixelsize::Int,
        y0,
        x0;
        fcolor::Union{AbstractVector{T}, T} = one_or_typemax(T),
        gcolor::Union{AbstractVector{T}, T, Nothing} = nothing,
        bcolor::Union{T, Nothing} = zero(T),
        halign::Symbol = :hleft,
        valign::Symbol = :vbaseline,
        bbox_glyph::Union{T, Nothing} = nothing,
        bbox::Union{T, Nothing} = nothing,
        gstr::Union{AbstractVector{Char}, String, Nothing} = nothing,
        off_bg::Int = 0,
        incx::Int = 0,
    ) where {T <: Union{Real, Colorant}}
    set_pixelsize(face, pixelsize)

    fstr = fstr isa AbstractVector ? fstr : collect(fstr)
    if gstr ≢ nothing
        gstr = gstr isa AbstractVector ? gstr : collect(gstr)
    end

    len = length(fstr)
    bitmaps = Vector{Matrix{UInt8}}(undef, len)
    metrics = Vector{FontExtent{Int}}(undef, len)

    y_min = y_max = sum_adv_x = 0  # y_min and y_max are w.r.t the baseline
    for (i, char) in enumerate(fstr)
        bitmap, metricf = render_face(face, char, pixelsize; set_pix = false)
        metric = FontExtent(x -> round.(Int, x), metricf)
        bitmaps[i] = bitmap
        metrics[i] = metric

        y_min = min(y_min, bottominkbound(metric))
        y_max = max(y_max, topinkbound(metric))
        sum_adv_x += hadvance(metric)
    end

    bitmap_max = bitmaps |> first |> eltype |> typemax
    imgh, imgw = size(img)

    # initial pen position
    px = x0 - (halign ≡ :hright ? sum_adv_x : halign ≡ :hcenter ? sum_adv_x >> 1 : 0)
    py =
        y0 + (
        valign ≡ :vtop ? y_max :
            valign ≡ :vbottom ? y_min :
            valign ≡ :vcenter ? (y_max - y_min) >> 1 + y_min : 0
    )

    if bcolor ≢ nothing
        img[
            clamp(py - y_max, 1, imgh):clamp(py - y_min, 1, imgh),
            clamp(px, 1, imgw):clamp(px + sum_adv_x, 1, imgw),
        ] .= bcolor
    end

    first_char = first(fstr)
    for (i, char) in enumerate(fstr)
        bitmap = bitmaps[i]
        metric = metrics[i]
        bx, by = metric.horizontal_bearing
        ax, ay = metric.advance
        sx, sy = metric.scale

        i > 1 && (px += round(Int, kerning(face, first_char, char) |> first))

        # glyph origin
        oy = py - by
        ox = px + bx

        fcol = fcolor isa AbstractVector ? fcolor[i] : fcolor
        gcol = gcolor isa AbstractVector ? gcolor[i] : gcolor

        # trim parts of glyph images that are outside the destination
        row_lo, row_hi = 1 + max(0, -oy), sy - max(0, oy + sy - imgh)
        col_lo, col_hi = 1 + max(0, -ox), sx - max(0, ox + sx - imgw)

        if gcol ≡ nothing
            for r in row_lo:row_hi, c in col_lo:col_hi
                (bm = bitmap[c, r]) == 0 && continue
                color = bm / bitmap_max * fcol
                img[oy + r, ox + c] = T <: Integer ? round(T, color) : T(color)
            end
        else
            if gstr ≢ nothing
                gexts = extents(face, gstr[i], pixelsize)
                gmetric = FontExtent(x -> round.(Int, x), gexts)
                y_min = bottominkbound(gmetric)
                y_max = topinkbound(gmetric)
            end

            # fill background
            by1, by2 = py - y_max, py - y_min
            bx1, bx2 = px, px + ax
            r1, r2 = clamp(by1, 1, imgh), clamp(by2, 1, imgh)
            c1, c2 = clamp(bx1, 1, imgw), clamp(bx2, 1, imgw)
            for r in (r1 + off_bg):(r2 - off_bg), c in (c1 + off_bg):(c2 - off_bg)
                img[r, c] = gcol
            end

            # render character by drawing the corresponding glyph
            for r in row_lo:row_hi, c in col_lo:col_hi
                (bm = bitmap[c, r]) == 0 && continue
                w1 = bm / bitmap_max
                color0 = w1 * fcol
                color1 = (1 - w1) * gcol
                img[oy + r, ox + c] =
                    T <: Integer ? round(T, color0 + color1) : T(color0 + color1)
            end

            # draw background bounding box
            if bbox ≢ nothing && r2 > r1 && c2 > c1
                img[r1, c1:c2] .= bbox
                img[r2, c1:c2] .= bbox
                img[r1:r2, c1] .= bbox
                img[r1:r2, c2] .= bbox
            end
        end

        # draw glyph bounding box
        if bbox_glyph ≢ nothing
            r1, r2 = clamp(oy + row_lo, 1, imgh), clamp(oy + row_hi, 1, imgh)
            c1, c2 = clamp(ox + col_lo, 1, imgw), clamp(ox + col_hi, 1, imgw)
            if r2 > r1 && c2 > c1
                img[r1, c1:c2] .= bbox_glyph
                img[r2, c1:c2] .= bbox_glyph
                img[r1:r2, c1] .= bbox_glyph
                img[r1:r2, c2] .= bbox_glyph
            end
        end

        px += ax + incx
    end
    return img
end

function ft_init()
    return @lock LIB_LOCK begin
        FT_LIB[1] != C_NULL &&
            error("Freetype already initialized. init() called two times ?")
        FT_Init_FreeType(FT_LIB) == 0
    end
end

function ft_done()
    return @lock LIB_LOCK begin
        FT_LIB[1] == C_NULL && error(
            "Library == CNULL. done() called before init(), or done called two times ?",
        )
        err = FT_Done_FreeType(FT_LIB[1])
        FT_LIB[1] = C_NULL
        err == 0
    end
end

add_recursive(result, path) = for p in readdir(path)
    if (pabs = joinpath(path, p)) |> isdir
        push!(result, pabs)
        add_recursive(result, pabs)
    end
end

function __init__()
    ft_init()
    atexit(ft_done)
    # this method of finding fonts might not work for exotic platforms,
    # so we supply a way to help it with an environment variable.
    font_paths = if Sys.isapple()  # COV_EXCL_LINE
        [
            "/Library/Fonts",  # additional fonts that can be used by all users: this is generally where fonts go if they are to be used by other applications
            joinpath(homedir(), "Library/Fonts"),  # fonts specific to each user
            "/Network/Library/Fonts",  # fonts shared for users on a network
            "/System/Library/Fonts",  # system specific fonts
            "/System/Library/Fonts/Supplemental",  # new location since Catalina
        ]
    elseif Sys.iswindows()  # COV_EXCL_LINE
        [
            joinpath(get(ENV, "SYSTEMROOT", "C:\\Windows"), "Fonts"),
            joinpath(homedir(), "AppData", "Local", "Microsoft", "Windows", "Fonts"),
        ]
    else
        result = String[]
        for p in (
                "/usr/share/fonts",
                joinpath(homedir(), ".fonts"),
                joinpath(homedir(), ".local/share/fonts"),
                "/usr/local/share/fonts",
            )
            if isdir(p)
                push!(result, p)
                add_recursive(result, p)
            end
        end
        result  # COV_EXCL_LINE
    end
    env_path = get(ENV, "UP_FONT_PATH", nothing)
    env_path ≡ nothing || push!(font_paths, env_path)
    append!(VALID_FONTPATHS, filter(isdir, font_paths))
    return nothing
end

function UnicodePlots.get_font_face(font = nothing, fallback = fallback_fonts())
    face = nothing
    for name in filter(!isnothing, (font, "JuliaMono", fallback...))
        if (face = get(FT_FONTS, name, nothing)) ≡ nothing
            if (ft = find_font(name)) ≢ nothing
                face = FT_FONTS[name] = ft
                break  # found new font, cache and return it
            end
        else
            break  # found in cache
        end
    end
    return face
end

UnicodePlots.save_image(fn::AbstractString, args...; kw...) =
    FileIO.save(fn, args...; kw...)

# compat for Plots
UnicodePlots.save_image(io::IO, args...; kw...) =
    FileIO.save(FileIO.Stream{FileIO.format"PNG"}(io), args...; kw...)

end  # module

translate_4x4(v) = @SMatrix(
    [
        1 0 0 v[1]
        0 1 0 v[2]
        0 0 1 v[3]
        0 0 0 1
    ]
)

scale_4x4(v) = @SMatrix(
    [
        v[1] 0 0 0
        0 v[2] 0 0
        0 0 v[3] 0
        0 0 0 1
    ]
)

rotd_x(θ) = @SMatrix(
    [
        1 0 0 0
        0 cosd(θ) -sind(θ) 0
        0 sind(θ) +cosd(θ) 0
        0 0 0 1
    ]
)

rotd_y(θ) = @SMatrix(
    [
        +cosd(θ) 0 sind(θ) 0
        0 1 0 0
        -sind(θ) 0 cosd(θ) 0
        0 0 0 1
    ]
)

rotd_z(θ) = @SMatrix(
    [
        cosd(θ) -sind(θ) 0 0
        sind(θ) +cosd(θ) 0 0
        0 0 1 0
        0 0 0 1
    ]
)

"""
    lookat(eye, target, up_vector)

# Description

Computes the scene camera (see songho.ca/opengl/gl_camera.html).

# Arguments

- `eye`: position of the camera in world space (e.g. [0, 0, 10]).
- `target`: target point to look at in world space (usually to origin = [0, 0, 0]).
- `up_vector`: up vector (usually +z = [0, 0, 1]).
"""
function lookat(eye, target = [0, 0, 0], up_vector = [0, 0, 1])
    f = normalize(eye - target)  # forward vector
    l = normalize(cross(up_vector, f))  # left vector
    u = cross(f, l)  # up vector

    return @SMatrix(
            [
                l[1] l[2] l[3] -dot(l, eye)
                u[1] u[2] u[3] -dot(u, eye)
                f[1] f[2] f[3] -dot(f, eye)
                0 0 0 1
            ]
        ),
        f
end

"""
    frustum(l, r, b, t, n, f)

# Description

Computes the perspective projection matrix (see songho.ca/opengl/gl_projectionmatrix.html#perspective).

# Arguments

- `l`: left coordinate of the vertical clipping plane.
- `r`: right coordinate of the vertical clipping plane.
- `b`: bottom coordinate of the horizontal clipping plane.
- `t`: top coordinate of the horizontal clipping plane.
- `n`: distance to the near depth clipping plane.
- `f`: distance to the far depth clipping plane.
"""
function frustum(l, r, b, t, n, f)
    @assert n > 0 && f > 0
    return *(
        @SMatrix(
            [  # scale
                2n / (r - l) 0 0 0
                0 2n / (t - b) 0 0
                0 0 1 0
                0 0 0 1
            ]
        ),
        @SMatrix(
            [  # translate
                1 0 0 (l + r) / 2n
                0 1 0 (b + t) / 2n
                0 0 1 0
                0 0 0 1
            ]
        ),
        @SMatrix(
            [  # perspective
                -1 0 0 0  # flip x
                0 -1 0 0  # flip y
                0 0 (f + n) / (f - n) -2f * n / (f - n)
                0 0 1 0
            ]
        ),
    )
end

"""
    ortho(l, r, b, t, n, f)

# Description

Computes the orthographic projection matrix (see songho.ca/opengl/gl_projectionmatrix.html#ortho).

# Arguments

- `l`: left coordinate of the vertical clipping plane.
- `r`: right coordinate of the vertical clipping plane.
- `b`: bottom coordinate of the horizontal clipping plane.
- `t`: top coordinate of the horizontal clipping plane.
- `n`: distance to the near depth clipping plane.
- `f`: distance to the far depth clipping plane.
"""
ortho(l, r, b, t, n, f) = *(
    @SMatrix(
        [  # scale
            2 / (r - l) 0 0 0
            0 2 / (t - b) 0 0
            0 0 2 / (f - n) 0
            0 0 0 1
        ]
    ),
    @SMatrix(
        [  # translate
            1 0 0 -(l + r) / 2
            0 1 0 -(b + t) / 2
            0 0 1 -(n + f) / 2
            0 0 0 1
        ]
    ),
)

"""
    ctr_len_diag(x, y, z)

# Description

Computes data center, minimum and maximum points, and cube diagonal length.
"""
function ctr_len_diag(x, y, z)
    mx, Mx = nanless_extrema(x)
    my, My = nanless_extrema(y)
    mz, Mz = nanless_extrema(z)

    lx = Mx - mx
    ly = My - my
    lz = Mz - mz

    return (
        SVector(mx + 0.5lx, my + 0.5ly, mz + 0.5lz),
        SVector(mx, my, mz),
        SVector(Mx, My, Mz),
        SVector(lx, ly, lz),
        √(lx^2 + ly^2 + lz^2),
    )
end

cube_corners(mx, Mx, my, My, mz, Mz) = [
    mx mx mx mx Mx Mx Mx Mx
    my my My My my my My My
    mx Mz mx Mz mx Mz mx Mz
]

function view_matrix(center, distance, elevation, azimuth, up)
    up_str = string(up)
    shift::Int = if (up_axis = Symbol(up_str[end])) ≡ :x
        0
    elseif up_axis ≡ :y
        1
    elseif up_axis ≡ :z
        2
    else
        throw(ArgumentError("up vector $up_str not understood"))
    end
    # we support :x -> +x, :px -> +x or :mx -> -x
    up_vector = circshift(
        [
            length(up_str) == 1 ? 1 : (p = +1, m = -1)[Symbol(up_str[1])]
            0
            0
        ],
        shift,
    )
    cam_move = circshift(
        distance .* [
            sind(elevation)
            cosd(azimuth) * cosd(elevation)
            sind(azimuth) * cosd(elevation)
        ],
        shift,
    )
    return lookat(center .+ cam_move, center, up_vector)
end

"""
    MVP(x, y, z; $(keywords(; default = (), add = (:x, :y, :z, :projection, :elevation, :azimuth, :zoom, :up))))

# Description

Build up the "Model - View - Projection" transformation matrix (see codinglabs.net/article_world_view_projection_matrix.aspx).

This is typically used to adjust how 3D plot is viewed, see also
the `projection` keyword in [`surfaceplot`](@ref), [`isosurface`](@ref).
"""
struct MVP{E, T}
    mvp_mat::SMatrix{4, 4, T}
    mvp_ortho_mat::SMatrix{4, 4, T}
    mvp_persp_mat::SMatrix{4, 4, T}
    view_dir::SVector{3, T}
    ortho::Bool
    dist::T

    function MVP()  # placeholder for 2D (disabled)
        dummy = zeros(Bool, 4, 4)
        return new{Val{false}, Bool}(dummy, dummy, dummy, zeros(Bool, 3), true, true)
    end

    function MVP(
            x,
            y,
            z;
            projection = KEYWORDS.projection,
            elevation = KEYWORDS.elevation,
            azimuth = KEYWORDS.azimuth,
            zoom = KEYWORDS.zoom,
            near = KEYWORDS.near,
            far = KEYWORDS.far,
            up = KEYWORDS.up,
        )
        @assert projection ∈ (:ortho, :orthographic, :persp, :perspective)
        @assert -180 ≤ azimuth ≤ 180
        @assert -90 ≤ elevation ≤ 90

        F = float(eltype(z))
        is_ortho = projection ∈ (:ortho, :orthographic)
        ctr, mini, maxi, len, diag = ctr_len_diag(x, y, z)

        # half the diagonal (camera distance to the center)
        disto = dist = (diag / 2) / zoom
        distp = disto / 2

        # avoid `NaN`s in `V` when `elevation` is close to ±90
        δ = 100eps(F)
        elev = clamp(elevation, -90 + δ, 90 - δ)

        # Model Matrix
        M = SMatrix{4, 4, F}(I)  # we don't scale, nor translate, nor rotate input data

        # View Matrix
        V_ortho, view_dir = view_matrix(ctr, disto, elev, azimuth, up)
        V_persp, view_dir = view_matrix(ctr, distp, elev, azimuth, up)
        V = is_ortho ? V_ortho : V_persp

        # Projection Matrix
        P_ortho = ortho(-disto, disto, -disto, disto, -disto, disto)
        P_persp = frustum(-distp, distp, -distp, distp, near, far)

        MVP_ortho = P_ortho * V_ortho * M
        MVP_persp = P_persp * V_persp * M

        return new{Val{true}, F}(
            is_ortho ? MVP_ortho : MVP_persp,
            MVP_ortho,
            MVP_persp,
            view_dir,
            is_ortho,
            dist,
        )
    end
end

create_MVP(projection::Symbol, args...; kw...) = MVP(args...; projection, kw...)
create_MVP(projection::MVP, args...; _...) = projection  # NOTE: kw are expected to be lost (see Plots)
create_MVP(::Nothing, args...; _...) = MVP()  # NOTE: kw are expected to be lost (see Plots)

@inline is_enabled(::MVP{Val{false}}) = false
@inline is_enabled(::MVP{Val{true}}) = true

@inline transform_matrix(t::MVP{Val{true}, T}, n::Symbol) where {T} = if n ≡ :user
    t.mvp_mat
elseif n ∈ (:ortho, :orthographic)
    t.mvp_ortho_mat
elseif n ∈ (:persp, :perspective)
    t.mvp_persp_mat
end::SMatrix{4, 4, T}

@inline is_ortho(t::MVP, n::Symbol) = if n ≡ :user
    t.ortho
elseif n ∈ (:ortho, :orthographic)
    true
elseif n ∈ (:persp, :perspective)
    false
end::Bool

"""
    (tr::MVP)(p::AbstractMatrix, n)

Transform a matrix of points, with allocation
"""
function (tr::MVP{Val{true}, T})(p::AbstractMatrix, n::Symbol = :user) where {T}
    o = Array{T}(undef, 4, size(p, 2))
    tr(p, o, n)
    return @view(o[1, :]), @view(o[2, :])
end

"""
    (tr::MVP)(p, o, n)

inplace transform
"""
function (tr::MVP{Val{true}, T})(
        p::AbstractMatrix,
        o::AbstractMatrix,
        n::Symbol = :user,
    ) where {T}
    mul!(o, transform_matrix(tr, n), p)
    persp = !is_ortho(tr, n)
    # homogeneous coordinates
    @inbounds for i in axes(p, 2)
        w = o[4, i]
        if abs(w) > eps(T)
            o[1, i] /= w
            o[2, i] /= w
            o[3, i] /= w
        end
        if persp
            z = o[3, i]
            if abs(z) > eps(T)
                o[1, i] /= z
                o[2, i] /= z
            end
        end
    end
    return nothing
end

"""
    (tr::MVP)(v::AbstractVector, n)

Transform a vector
"""
function (tr::MVP{Val{true}, T})(v::SVector{4}, n::Symbol = :user) where {T}
    x, y, z, w = transform_matrix(tr, n) * v
    # homogeneous coordinates
    if abs(w) > eps(T)
        x /= w
        y /= w
        z /= w
    end
    if !is_ortho(tr, n)
        x /= z
        y /= z
    end
    return (x, y)
end

(tr::MVP{Val{true}})(v::AbstractVector{T}, n::Symbol = :user) where {T} =
    tr(SVector(v[1], v[2], v[3], length(v) == 4 ? v[4] : T(1)), n)

axis_line(tr, proj, start::AbstractVector{T}, stop::AbstractVector{T}) where {T} =
    tr(
    @SMatrix(
        [
            start[1] stop[1]
            start[2] stop[2]
            start[3] stop[3]
            T(1) T(1)
        ]
    ), proj
)

"""
    draw_axes!(plot, x, y, z, scale = 0.25)

# Description

Draws (X, Y, Z) cartesian coordinates axes in (R, G, B) colors, at position `p = (x, y, z)`.
If `p = (x, y)` is given, draws at screen coordinates instead.
"""
function draw_axes!(plot, x::T, y::T, z::T, scale = T(0.25)) where {T <: AbstractFloat}
    tr = plot.projection
    # constant apparent size, independent of zoom level
    len = T(scale * tr.dist)
    start = SVector(x, y, z)

    lines!(
        plot.graphics,
        axis_line(tr, :ortho, start, SVector(x + len, y, z))...,
        color = :red,
    )
    lines!(
        plot.graphics,
        axis_line(tr, :ortho, start, SVector(x, y + len, z))...,
        color = :green,
    )
    lines!(
        plot.graphics,
        axis_line(tr, :ortho, start, SVector(x, y, z + len))...,
        color = :blue,
    )

    return plot
end

draw_axes!(plot, x::T, y::T, z::Nothing, args...) where {T <: AbstractFloat} =
let (x, y, z) = transform_matrix(plot.projection, :ortho) \ SVector(x, y, T(0), T(1))
    draw_axes!(plot, x, y, z, args...)
end

import Pkg
Pkg.precompile()
Pkg.status(; outdated = true, mode = Pkg.PKGMODE_MANIFEST)

using ImageInTerminal, FreeType, FileIO, IntervalSets, Unitful, Term  # weak deps, or @require
using UnicodePlots, Test

import UnicodePlots: lines!, points!, pixel!, nrows, ncols
import UnicodePlots: print_row, preprocess!, addrow!

import Dates: DateTime, Date, Day
import DataFrames: DataFrame
import Random: seed!
import ColorSchemes
import FileIO
import Aqua

using ReferenceTests
using LinearAlgebra
using TimerOutputs
using TestImages
using ColorTypes
using StableRNGs
using AllocCheck
using StatsBase
using Crayons
using Unitful

include("fixes.jl")

const TO = TimerOutput()
const RNG = StableRNG(1_337)
const T_SZ = (24, 80)  # default terminal size on unix

# see JuliaTesting/ReferenceTests.jl/pull/91
test_ref(reference, actual) = @test_reference(
    joinpath(@__DIR__, "..", "..", "assets", "references_$(UnicodePlots.colormode())", reference),
    actual,
    render = ReferenceTests.BeforeAfterFull(),
    format = "TXT"
)

is_ci() = Base.get_bool_env("CI", false)
is_pkgeval() = Base.get_bool_env("JULIA_PKGEVAL", false)
"""
julia> is_prerelease("DEV")
julia> is_prerelease("alpha")
julia> is_prerelease("beta")
julia> is_prerelease("rc")
"""
is_prerelease(label) =
    length(VERSION.prerelease) > 0 && startswith(first(VERSION.prerelease), label)

const STABLE = Base.get_bool_env("UP_STABLE", false) || isempty(VERSION.prerelease)
const PRE = is_prerelease("alpha") || is_prerelease("beta") || is_prerelease("rc")

# helpers

"a plot must be square"
macro check_padding(x)
    tmp = gensym()
    return quote
        $tmp = UnicodePlots.no_ansi_escape($x)
        if length.(split($tmp, '\n')) |> unique |> length == 1
            @test true
        else
            println($x)
            @test false
        end
    end |> esc
end

macro show_col(p, kv...)
    tmp = gensym()
    return quote
        $tmp = @io2str $(:(show(IOContext(::IO, :color => true, $(kv...)), $p)))
        @check_padding $tmp
        $tmp
    end |> esc
end
macro show_nocol(p, kv...)
    tmp = gensym()
    return quote
        $tmp = @io2str $(:(show(IOContext(::IO, :color => false, $(kv...)), $p)))
        @check_padding $tmp
        $tmp
    end |> esc
end
macro print_col(p, kv...)
    tmp = gensym()
    return quote
        $tmp = @io2str $(:(print(IOContext(::IO, :color => true, $(kv...)), $p)))
        @check_padding $tmp
        $tmp
    end |> esc
end
macro print_nocol(p, kv...)
    tmp = gensym()
    return quote
        $tmp = @io2str $(:(print(IOContext(::IO, :color => false, $(kv...)), $p)))
        @check_padding $tmp
        $tmp
    end |> esc
end

# return type Plot{BrailleCanvas{typeof(identity), typeof(identity)}} does not match
# inferred return type Plot{var"#s129"} where var"#s129"<:Canvas
const ID = typeof(identity)

macro binf(ex)
    return :(@inferred(Plot{BrailleCanvas{ID, ID}}, $ex)) |> esc
end

macro oinf(ex)
    return :(@inferred(Plot{OctantCanvas{ID, ID}}, $ex)) |> esc
end

macro hinf(ex)
    return :(@inferred(Plot{HeatmapCanvas{ID, ID}}, $ex)) |> esc
end

macro timeit_include(path::AbstractString)
    return :(
        @timeit TO $path @testset $path begin
            include($path)
        end
    ) |> esc
end

macro no_allocs(ex)
    f = gensym()
    return quote
        @check_allocs $f() = $ex
        $f()
    end |> esc
end

println("\n== start: testing with $(UnicodePlots.colormode())bit colormode ==\n")

#! format: off
withenv("FORCE_COLOR" => "X") do  # JuliaPlots/UnicodePlots.jl/issues/134
    @timeit_include "tst_freetype.jl"
    @timeit_include "tst_depwarn.jl"
    @timeit_include "tst_issues.jl"
    @timeit_include "tst_io.jl"
    @timeit_include "tst_common.jl"
    @timeit_include "tst_graphics.jl"
    @timeit_include "tst_canvas.jl"
    @timeit_include "tst_plot.jl"
    @timeit_include "tst_scatterplot.jl"
    @timeit_include "tst_lineplot.jl"
    @timeit_include "tst_densityplot.jl"
    @timeit_include "tst_histogram.jl"
    @timeit_include "tst_barplot.jl"
    @timeit_include "tst_spy.jl"
    @timeit_include "tst_boxplot.jl"
    @timeit_include "tst_contourplot.jl"
    @timeit_include "tst_polarplot.jl"
    @timeit_include "tst_heatmap.jl"
    @timeit_include "tst_volume.jl"
    @timeit_include "tst_surfaceplot.jl"
    @timeit_include "tst_isosurface.jl"
    @timeit_include "tst_imageplot.jl"
    @timeit_include "tst_quality.jl"
end
#! format: on

# ~ 94s & 9.88GiB on 1.11
print_timer(TO; compact = true, sortby = :firstexec)

println("\n== end: testing with $(UnicodePlots.colormode())bit colormode ==")

"""
    polarplot(θ, r; kw...)
    polarplot!(p, args...; kw...)

Draws `θ` angles and `r` radii on a polar plot.

# Usage

    polarplot(θ, r; $(keywords(; add = (:canvas,))))

# Arguments

$(
    arguments(
        (
            θ = "angles values (radians)",
            r = "radii, or `Function` evaluated as `r(θ)`",
            rlim = "plotting range for the `r` axis (`(0, 0)` stands for automatic)",
            degrees = "label angles using degrees",
            num_rad_lab = "number of radius labels",
            ang_rad_lab = "angle where the radius labels are drawn",
            scatter = "use scatter instead of lines",
        )
    )
)

# Author(s)

- T Bltg (github.com/t-bltg)

# Examples

```julia-repl
julia> polarplot(range(0, 2π; length = 20), range(0, 2; length = 20))
        ⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀90°⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
        ⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
        ⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⣀⡤⠤⠒⠒⠉⠉⠉⠉⠉⡏⠉⠉⠉⠉⠓⠒⠦⠤⣀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
        ⠀⠀⠀⠀⠀⠀⠀⢀⡤⠒⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠉⠒⠤⡀⠀⠀⠀⠀⠀⠀⠀
        ⠀⠀⠀⠀⠀⡠⠞⠓⢄⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠜2⢄⠀⠀⠀⠀⠀
        ⠀⠀⠀⣠⠊⠀⠀⠀⠀⠉⠢⣀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠊⠁⠀⠀⠀⠱⣄⠀⠀⠀
        ⠀⠀⡴⠁⠀⠀⠀⠀⠀⠀⠀⠀⠑⠤⡀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀1⠔⠁⠀⠀⠀⠀⠀⠀⠀⠈⢦⠀⠀
        ⠀⡸⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⣈⠶⢖⠒⠒⠒⠢⣇⡀⠀⠀⢀⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠈⣇⠀
        ⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠔⠁⠀⠀⠀⠉⠢⣀⠀⡇⢣⡠⠊⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢸⠀
   180° ⠀⡧⠤⠤⠤⠤⠤⠤⠤⠤⢤⠧⠤⠤⠤⠤⠤⠤⠤⠤⡵0⡭⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⢼⠀ 0°
        ⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⢸⠀⠀⠀⠀⠀⠀⢀⠔⠊⠀⡇⠈⠒⢄⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⢿⠀
        ⠀⢱⡀⠀⠀⠀⠀⠀⠀⠀⠸⡀⠀⠀⢀⡠⠊⠁⠀⠀⠀⡇⠀⠀⠀⠉⠢⣀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⢎⡏⠀
        ⠀⠀⠳⡀⠀⠀⠀⠀⠀⠀⠀⠱⡠⠔⠁⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠑⠤⡀⠀⠀⠀⠀⠀⢀⠔⢁⠞⠀⠀
        ⠀⠀⠀⠙⢄⠀⠀⠀⠀⢀⠔⠊⠈⠢⣀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠈⠒⢄⢀⡠⠔⠁⡰⠋⠀⠀⠀
        ⠀⠀⠀⠀⠀⠑⢦⡠⠊⠁⠀⠀⠀⠀⠀⠉⠒⠢⢄⣀⠀⡇⠀⠀⠀⠀⠀⢀⣀⣀⡠⠔⠊⠉⢢⡤⠊⠀⠀⠀⠀⠀
        ⠀⠀⠀⠀⠀⠀⠀⠈⠓⠤⣀⠀⠀⠀⠀⠀⠀⠀⠀⠈⠉⡏⠉⠉⠉⠉⠉⠁⠀⠀⠀⣀⠤⠒⠁⠀⠀⠀⠀⠀⠀⠀
        ⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠉⠓⠒⠤⠤⣀⣀⣀⣀⣀⣇⣀⣀⣀⣀⡤⠤⠖⠒⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
        ⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
        ⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀270°⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
```

# See also

`Plot`, `lineplot`, `BrailleCanvas`
"""
function polarplot(
        θ::AbstractVector,
        r::Union{Function, AbstractVector};
        rlim = (0, 0),
        kw...,
    )
    pkw, okw = split_plot_kw(kw)

    r = r isa Function ? r.(θ) : r
    max_r = last(is_auto(rlim) ? extrema(r) : rlim)
    lims = x = y = [-max_r, +max_r]
    plot = Plot(
        x,
        y;
        xlim = lims,
        ylim = lims,
        grid = false,
        border = :none,
        xticks = false,
        yticks = false,
        blend = false,
        pkw...,
    )
    return polarplot!(plot, θ, r; rlim, okw...)
end

@doc (@doc polarplot) function polarplot!(
        plot::Plot{<:Canvas},
        θ::AbstractVector,
        r::AbstractVector;
        rlim = (0, 0),
        degrees = true,
        num_rad_lab = 3,
        ang_rad_lab = π / 4,
        scatter = false,
        kw...,
    )
    mr, Mr = is_auto(rlim) ? extrema(r) : rlim

    # grid
    theta = range(0, 2π; length = 360)
    grid_color = BORDER_COLOR[]
    lineplot!(plot, Mr * cos.(theta), Mr * sin.(theta); color = grid_color)

    for theta in 0:(π / 4):(2π)
        lineplot!(plot, [mr, Mr] .* cos(theta), [mr, Mr] .* sin(theta); color = grid_color)
    end

    # user data
    (scatter ? scatterplot! : lineplot!)(plot, r .* cos.(θ), r .* sin.(θ); kw...)

    # labels
    row = ceil(Int, nrows(plot.graphics) / 2)
    label!(plot, :r, row, degrees ? "0°" : "0"; color = grid_color)
    label!(plot, :t, degrees ? "90°" : "π / 2"; color = grid_color)
    label!(plot, :l, row, degrees ? "180°" : "π"; color = grid_color)
    label!(plot, :b, degrees ? "270°" : "3π / 2"; color = grid_color)

    for r in range(mr, Mr; length = num_rad_lab)
        annotate!(
            plot,
            r * cos(ang_rad_lab),
            r * sin(ang_rad_lab),
            isinteger(r) ? string(round(Int, r)) : @sprintf("%.1f", r);
            color = grid_color,
        )
    end
    return plot
end

img = testimage("monarch_color_256")

if !is_ci() || UnicodePlots.colormode() == 24  # FIXME: failure on ci with 8bit mode
    @testset "blocks" begin
        let _old_enc = ImageInTerminal.ENCODER_BACKEND[]
            ImageInTerminal.ENCODER_BACKEND[] = :XTermColors
            p = imageplot(img, title = "blocks")
            test_ref("imageplot/img_blocks.txt", @show_col(p, :displaysize => T_SZ))
            @test !p.graphics.sixel[]
            ImageInTerminal.ENCODER_BACKEND[] = _old_enc
        end
    end
end

# experimental testing: see github.com/JuliaLang/Pkg.jl/pull/3186
# must be launched with `Pkg.test("UnicodePlots"; forward_stdin=true)` on `1.8`+
if !is_ci() && ImageInTerminal.Sixel.is_sixel_supported()
    @testset "sixel" begin
        let _old_enc = ImageInTerminal.ENCODER_BACKEND[]
            ImageInTerminal.ENCODER_BACKEND[] = :Sixel
            p = imageplot(img, title = "sixel")
            test_ref("imageplot/img_sixel.txt", @show_col(p, :displaysize => T_SZ))
            @test p.graphics.sixel[]
            ImageInTerminal.ENCODER_BACKEND[] = _old_enc
        end
    end
end

"""
    abstract type LookupCanvas <: Canvas

Supertype for Look-Up Table (LUT) encoded canvases.
"""
abstract type LookupCanvas <: Canvas end

function CreateLookupCanvas(
        ::Type{T},
        min_max,
        char_height::Integer,
        char_width::Integer;
        blend::Bool = KEYWORDS.blend,
        visible::Bool = KEYWORDS.visible,
        origin_y::Number = 0.0,
        origin_x::Number = 0.0,
        height::Number = 1.0,
        width::Number = 1.0,
        yflip::Bool = KEYWORDS.yflip,
        xflip::Bool = KEYWORDS.xflip,
        yscale::Union{Symbol, Function} = KEYWORDS.yscale,
        xscale::Union{Symbol, Function} = KEYWORDS.xscale,
        min_char_height::Integer = 5,
        min_char_width::Integer = 2,
    ) where {T <: LookupCanvas}
    height > 0 || throw(ArgumentError("`height` has to be positive"))
    width > 0 || throw(ArgumentError("`width` has to be positive"))
    char_height = max(char_height, min_char_height)
    char_width = max(char_width, min_char_width)
    pixel_height = char_height * y_pixel_per_char(T)
    pixel_width = char_width * x_pixel_per_char(T)
    grid = transpose(fill(grid_type(T)(0), char_width, char_height))
    colors = transpose(fill(INVALID_COLOR, char_width, char_height))
    return T(
        grid,
        colors,
        visible,
        blend,
        yflip,
        xflip,
        pixel_height,
        pixel_width,
        Float64(origin_y),
        Float64(origin_x),
        Float64(height),
        Float64(width),
        NTuple{2, UnicodeType}(min_max),
        scale_callback(yscale),
        scale_callback(xscale),
    )
end

# don't attempt to blend colors if they have been explicitly specified
@inline blend_colors(c::LookupCanvas, ::UserColorType) = false
@inline blend_colors(c::LookupCanvas, ::Symbol) = c.blend

function pixel!(
        c::LookupCanvas,
        pixel_x::Integer,
        pixel_y::Integer,
        color::ColorType,
        blend::Bool,
    )
    valid_x_pixel(c, pixel_x) || return c
    valid_y_pixel(c, pixel_y) || return c
    char_x, char_y, char_x_off, char_y_off = pixel_to_char_point_off(c, pixel_x, pixel_y)
    if checkbounds(Bool, c.grid, char_y, char_x)
        if (val = UnicodeType(c.grid[char_y, char_x])) == 0 ||
                c.min_max[1] ≤ val ≤ c.min_max[2]
            c.grid[char_y, char_x] |= lookup_encode(c)[char_y_off, char_x_off]
        end
        set_color!(c, char_x, char_y, color, blend)
    end
    return c
end

function print_row(io::IO, _, print_color, c::LookupCanvas, row::Integer)
    1 ≤ row ≤ nrows(c) || throw(ArgumentError("`row` out of bounds: $row"))
    for col in 1:ncols(c)
        print_color(io, c.colors[row, col], lookup_decode(c)[c.grid[row, col] + 1])
    end
    return nothing
end

seed!(RNG, 1_337)
x, y = randn(RNG, 4_000), randn(RNG, 4_000)

@testset "densityplot" begin
    p = @inferred Plot densityplot(x, y)
    @test densityplot!(p, x .+ 2, y .+ 2) ≡ p
    @test p isa Plot
    test_ref("densityplot/densityplot.txt", @show_col(p))
end

@testset "parameters" begin
    p = @inferred Plot densityplot(
        x,
        y,
        name = "foo",
        color = :red,
        title = "Title",
        xlabel = "x",
    )
    @test densityplot!(p, x .+ 2, y .+ 2, name = "bar") ≡ p
    @test p isa Plot
    test_ref("densityplot/densityplot_parameters.txt", @show_col(p))
end

@testset "dscale" begin
    # UnicodePlots.jl/issues/226
    # identity: only peaks appear (data is hidden)
    # sqrt: we start to see underlying data
    # x -> log(1 + x): start to see the 2D normal law profile
    # x -> x / (x + 1): peak hidden
    for (dscale, name) in (
            (identity, "identity"),
            (sqrt, "sqrt"),
            (x -> log(1 + x), "log"),
            (x -> x / (x + 1), "custom"),
        )
        x′ = copy(x)
        x′[round(Int, 0.1length(x)):round(Int, 0.6length(x))] .= 0.5maximum(x)
        p = densityplot(x′, y; dscale)
        test_ref("densityplot/densityplot_dscale_$name.txt", @show_col(p))
    end
end

"""
    contourplot(x, y, A; kw...)
    contourplot!(p, args...; kw...)

Draws a contour plot on a new canvas.

# Usage

    contourplot(x, y, A; $(keywords(; add = (Z_DESCRIPTION..., :canvas), remove = (:blend, :grid))))

# Arguments

$(
    arguments(
        (
            A = "`Matrix` of interest for which contours are extracted, or `Function` evaluated as `f(x, y)`",
            levels = "the number of contour levels",
        ); add = (Z_DESCRIPTION..., :x, :y, :canvas), remove = (:blend, :grid)
    )
)

# Author(s)

- T Bltg (github.com/t-bltg)

# Examples

```julia-repl
julia> contourplot(-1:.1:1, -1:.1:1, (x, y) -> 1000√(x^2 + y^2))
      ┌────────────────────────────────────────┐ 1_000
    1 │⠀⠀⠀⠀⠀⠀⠀⠀⣀⠤⠒⠊⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠉⠉⠒⠢⣄⡀⠀⠀⠀⠀⠀⠀⠀│ ┌──┐
      │⠀⠀⠀⠀⠀⡠⠖⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠈⠑⠤⡀⠀⠀⠀⠀│ │▄▄│
      │⠀⠀⢀⡰⠊⠀⠀⠀⠀⠀⠀⠀⢀⣀⠤⠔⠒⠒⠉⠉⠉⠉⠓⠒⠒⠤⣄⡀⠀⠀⠀⠀⠀⠀⠀⠘⠢⡀⠀⠀│ │▄▄│
      │⠀⡰⠁⠀⠀⠀⠀⠀⠀⢀⡤⠒⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠈⠑⠢⡀⠀⠀⠀⠀⠀⠀⠈⢆⠀│ │▄▄│
      │⡜⠀⠀⠀⠀⠀⠀⢀⠔⠁⠀⠀⠀⠀⠀⠀⠀⢀⣀⣀⣀⣀⡀⠀⠀⠀⠀⠀⠀⠀⠈⠢⡄⠀⠀⠀⠀⠀⠀⢣│ │▄▄│
      │⠀⠀⠀⠀⠀⠀⢠⠃⠀⠀⠀⠀⠀⠀⢀⠔⠊⠁⠀⠀⠀⠀⠈⠙⠢⢄⠀⠀⠀⠀⠀⠀⠑⡄⠀⠀⠀⠀⠀⠀│ │▄▄│
      │⠀⠀⠀⠀⠀⢠⠇⠀⠀⠀⠀⠀⠀⡜⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠈⢣⠀⠀⠀⠀⠀⠀⢘⠄⠀⠀⠀⠀⠀│ │▄▄│
      │⠀⠀⠀⠀⠀⢸⠀⠀⠀⠀⠀⠀⠠⡃⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢈⠆⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀│ │▄▄│
      │⠀⠀⠀⠀⠀⠘⡆⠀⠀⠀⠀⠀⠀⠣⡀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡜⠀⠀⠀⠀⠀⠀⢠⠃⠀⠀⠀⠀⠀│ │▄▄│
      │⠀⠀⠀⠀⠀⠀⠱⡀⠀⠀⠀⠀⠀⠀⠉⠒⣄⣀⠀⠀⠀⠀⢀⣀⠔⠉⠀⠀⠀⠀⠀⠀⢀⠎⠀⠀⠀⠀⠀⠀│ │▄▄│
      │⢇⠀⠀⠀⠀⠀⠀⠘⠦⡀⠀⠀⠀⠀⠀⠀⠀⠀⠉⠉⠉⠉⠁⠀⠀⠀⠀⠀⠀⠀⠀⡠⠃⠀⠀⠀⠀⠀⠀⡰│ │▄▄│
      │⠈⠢⡀⠀⠀⠀⠀⠀⠀⠈⠒⠤⣀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠔⠋⠀⠀⠀⠀⠀⠀⢀⠖⠁│ │▄▄│
      │⠀⠀⠈⠱⣀⠀⠀⠀⠀⠀⠀⠀⠈⠉⠒⠢⠤⢤⣀⣀⣀⣀⡠⠤⠤⠒⠊⠁⠀⠀⠀⠀⠀⠀⠀⢀⠔⠁⠀⠀│ │▄▄│
      │⠀⠀⠀⠀⠀⠑⠦⣀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠒⠁⠀⠀⠀⠀│ │▄▄│
   -1 │⠀⠀⠀⠀⠀⠀⠀⠀⠙⠒⠤⢄⣀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⣀⣀⠤⠔⠊⠁⠀⠀⠀⠀⠀⠀⠀│ └──┘
      └────────────────────────────────────────┘  0
      ⠀-1⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀1⠀
```

# See also

`Plot`, `lineplot`, `BrailleCanvas`
"""
function contourplot(
        x::AbstractVector,
        y::AbstractVector,
        A::Union{Function, AbstractMatrix};
        canvas::Type = KEYWORDS.canvas,
        colormap = KEYWORDS.colormap,
        kw...,
    )
    pkw, okw = split_plot_kw(kw)
    plot = Plot(
        extrema(x) |> collect,
        extrema(y) |> collect,
        nothing,
        canvas;
        colorbar = true,
        blend = false,
        grid = false,
        colormap,
        pkw...,
    )
    A isa Function && (A = A.(x', y))
    return contourplot!(plot, x, y, A; colormap, okw...)
end

@doc (@doc contourplot) function contourplot!(
        plot::Plot{<:Canvas},
        x::AbstractVector,
        y::AbstractVector,
        A::AbstractMatrix;
        name::AbstractString = KEYWORDS.name,
        colormap = KEYWORDS.colormap,
        zlim = KEYWORDS.zlim,
        levels::Integer = 3,
    )
    isempty(name) || label!(plot, :r, string(name))

    mA, MA = nanless_extrema(A)
    plot.cmap.lim = (mh, Mh) = is_auto(zlim) ? (mA, MA) : zlim
    plot.cmap.callback = callback = colormap_callback(colormap)

    for cl in Contour.levels(Contour.contours(y, x, A, levels))
        color = callback(Contour.level(cl), mh, Mh)
        for line in Contour.lines(cl)
            yi, xi = Contour.coordinates(line)
            lineplot!(plot, xi, yi; color)
        end
    end
    return plot
end

"""
    contourplot(A; kw...)

# Usage

Draws a contour plot of matrix `A` along axis `x` and `y` on a new canvas.

The `y` axis is flipped by default:

```
Julia matrices (images) │ UnicodePlots
                        │
           axes(A, 2)   │
           o───────→    │   ↑
           │            │   │
axes(A, 1) │            │ y │
           │            │   │
           ↓            │   o───────→
                        │       x
```
"""
contourplot(A::AbstractMatrix; kw...) =
    contourplot(axes(A, 2) |> collect, axes(A, 1) |> reverse |> collect, A; kw...)

"""
    AsciiCanvas{YS <: Function, XS <: Function} <: LookupCanvas

As the name suggests the `AsciiCanvas` only uses ASCII characters to draw its content.
Naturally, it doesn't look quite as nice as the Unicode-based ones.
However, in some situations it might yield better results.
Printing plots to a file is one of those situations.

The AsciiCanvas is best used in combination with `lineplot`.
For `scatterplot` we suggest to use the `DotCanvas` instead.
"""
struct AsciiCanvas{YS <: Function, XS <: Function} <: LookupCanvas
    grid::Transpose{UInt16, Matrix{UInt16}}
    colors::Transpose{ColorType, Matrix{ColorType}}
    visible::Bool
    blend::Bool
    yflip::Bool
    xflip::Bool
    pixel_height::Int
    pixel_width::Int
    origin_y::Float64
    origin_x::Float64
    height::Float64
    width::Float64
    min_max::NTuple{2, UnicodeType}
    yscale::YS
    xscale::XS
end

const N_ASCII = grid_type(AsciiCanvas)(512)
const ASCII_SIGNS = [
    0b100_000_000 0b010_000_000 0b001_000_000
    0b000_100_000 0b000_010_000 0b000_001_000
    0b000_000_100 0b000_000_010 0b000_000_001
]

const ASCII_LOOKUP = Dict{UInt16, Char}()
ASCII_LOOKUP[0b101_000_000] = '"'
ASCII_LOOKUP[0b111_111_111] = '@'
# ASCII_LOOKUP[0b011_110_011] = '$'
ASCII_LOOKUP[0b010_000_000] = '\''
ASCII_LOOKUP[0b010_100_010] = '('
ASCII_LOOKUP[0b010_001_010] = ')'
ASCII_LOOKUP[0b000_010_000] = '*'
ASCII_LOOKUP[0b010_111_010] = '+'
ASCII_LOOKUP[0b000_010_010] = ','
ASCII_LOOKUP[0b000_100_100] = ','
ASCII_LOOKUP[0b000_001_001] = ','
ASCII_LOOKUP[0b000_111_000] = '-'
ASCII_LOOKUP[0b000_000_010] = '.'
ASCII_LOOKUP[0b000_000_100] = '.'
ASCII_LOOKUP[0b000_000_001] = '.'
ASCII_LOOKUP[0b001_010_100] = '/'
ASCII_LOOKUP[0b010_100_000] = '/'
ASCII_LOOKUP[0b001_010_110] = '/'
ASCII_LOOKUP[0b011_010_010] = '/'
ASCII_LOOKUP[0b001_010_010] = '/'
ASCII_LOOKUP[0b110_010_111] = '1'
# ASCII_LOOKUP[0b111_010_100] = '7'
ASCII_LOOKUP[0b010_000_010] = ':'
ASCII_LOOKUP[0b111_000_111] = '='
# ASCII_LOOKUP[0b010_111_101] = 'A'
# ASCII_LOOKUP[0b011_100_011] = 'C'
# ASCII_LOOKUP[0b110_101_110] = 'D'
# ASCII_LOOKUP[0b111_110_100] = 'F'
# ASCII_LOOKUP[0b011_101_011] = 'G'
# ASCII_LOOKUP[0b101_111_101] = 'H'
ASCII_LOOKUP[0b111_010_111] = 'I'
# ASCII_LOOKUP[0b011_001_111] = 'J'
# ASCII_LOOKUP[0b101_110_101] = 'K'
ASCII_LOOKUP[0b100_100_111] = 'L'
# ASCII_LOOKUP[0b111_111_101] = 'M'
# ASCII_LOOKUP[0b101_101_101] = 'N'
# ASCII_LOOKUP[0b111_101_111] = 'O'
# ASCII_LOOKUP[0b111_111_100] = 'P'
ASCII_LOOKUP[0b111_010_010] = 'T'
# ASCII_LOOKUP[0b101_101_111] = 'U'
ASCII_LOOKUP[0b101_101_010] = 'V'
# ASCII_LOOKUP[0b101_111_111] = 'W'
ASCII_LOOKUP[0b101_010_101] = 'X'
ASCII_LOOKUP[0b101_010_010] = 'Y'
ASCII_LOOKUP[0b110_100_110] = '['
ASCII_LOOKUP[0b010_001_000] = '\\'
ASCII_LOOKUP[0b100_010_001] = '\\'
ASCII_LOOKUP[0b110_010_010] = '\\'
ASCII_LOOKUP[0b100_010_011] = '\\'
ASCII_LOOKUP[0b100_010_010] = '\\'
ASCII_LOOKUP[0b011_001_011] = ']'
ASCII_LOOKUP[0b010_101_000] = '^'
ASCII_LOOKUP[0b000_000_111] = '_'
ASCII_LOOKUP[0b100_000_000] = '`'
# ASCII_LOOKUP[0b000_111_111] = 'a'
# ASCII_LOOKUP[0b100_111_111] = 'b'
# ASCII_LOOKUP[0b001_111_111] = 'd'
# ASCII_LOOKUP[0b001_111_010] = 'f'
# ASCII_LOOKUP[0b100_111_101] = 'h'
# ASCII_LOOKUP[0b100_101_101] = 'k'
ASCII_LOOKUP[0b110_010_011] = 'l'
# ASCII_LOOKUP[0b000_111_101] = 'n'
ASCII_LOOKUP[0b000_111_100] = 'r'
# ASCII_LOOKUP[0b000_101_111] = 'u'
ASCII_LOOKUP[0b000_101_010] = 'v'
ASCII_LOOKUP[0b011_110_011] = '{'
ASCII_LOOKUP[0b010_010_010] = '|'
ASCII_LOOKUP[0b100_100_100] = '|'
ASCII_LOOKUP[0b001_001_001] = '|'
ASCII_LOOKUP[0b110_011_110] = '}'

const ASCII_DECODE = Vector{Char}(undef, typemax(N_ASCII))
ASCII_DECODE[1] = ' '
for i in 2:N_ASCII
    min_dist = typemax(Int)
    min_char = ' '
    for (k, v) in sort_by_keys(ASCII_LOOKUP)
        if (cur_dist = count_ones(xor(typeof(N_ASCII)(i - 1), k))) < min_dist
            min_dist = cur_dist
            min_char = v
        end
    end
    ASCII_DECODE[i] = min_char
end

ASCII_DECODE[(N_ASCII + 1):typemax(N_ASCII)] = UNICODE_TABLE[1:(typemax(N_ASCII) - N_ASCII)]

@inline y_pixel_per_char(::Type{<:AsciiCanvas}) = 3
@inline x_pixel_per_char(::Type{<:AsciiCanvas}) = 3

@inline lookup_encode(::AsciiCanvas) = ASCII_SIGNS
@inline lookup_decode(::AsciiCanvas) = ASCII_DECODE
@inline lookup_offset(::AsciiCanvas) = N_ASCII

AsciiCanvas(args...; kw...) =
    CreateLookupCanvas(AsciiCanvas, (0b000_000_000, 0b111_111_111), args...; kw...)

@testset "padding" begin
    x = y = -1:0.1:1
    for padding in 0:3
        p = contourplot(
            x,
            y,
            (x, y) -> 1.0e4 * √(x^2 + y^2);
            labels = false,
            margin = 0,
            padding,
        )
        test_ref("contourplot/padding_$padding.txt", @show_col(p))
    end
end

gaussian_2d(x = -3:0.01:3, y = -7:0.01:3; x₀ = 0, y₀ = -2, σx = 1, σy = 2) = begin
    g = (x, y) -> exp(-((x - x₀) / 2σx)^2 - ((y - y₀) / 2σy)^2)
    x, y, g.(x', y)
end

@testset "arbitrary colormap" begin
    colormap = :cividis
    p = @binf contourplot(gaussian_2d()...; colormap = colormap)
    test_ref("contourplot/gauss_$colormap.txt", @show_col(p))
end

@testset "number of levels" begin
    levels = 5
    p = @binf contourplot(gaussian_2d()...; levels = levels)
    test_ref("contourplot/gauss_$(levels)levels.txt", @show_col(p))
end

@testset "update contourplot" begin
    p = @binf contourplot(gaussian_2d()...; levels = 2)
    # mutate the colormap & number of levels
    contourplot!(p, gaussian_2d(; σx = 0.5, σy = 0.25)...; levels = 1, colormap = :magma)
    test_ref("contourplot/gauss_nested.txt", @show_col(p))
end

@testset "function" begin
    p = @binf contourplot(
        -3:0.01:3,
        -3:0.01:4,
        (x, y) -> (exp(-x^2 - y^2) + exp(-(x - 1)^2 - 2(y - 2)^2))^2,
    )
    test_ref("contourplot/function_contour.txt", @show_col(p))
end

@testset "consistency with `surfaceplot`" begin
    x = -2:0.2:2
    y = -3:0.2:1
    z = (x, y) -> 10x * exp(-x^2 - y^2)
    p = contourplot(x, y, z; levels = 10)
    test_ref("contourplot/consistency.txt", @show_col(p))
end

struct FiveNumberSummary
    minimum::Float64
    lower_quartile::Float64
    median::Float64
    upper_quartile::Float64
    maximum::Float64
end

"""
    BoxplotGraphics

Structure to hold box based graphics.
"""
struct BoxplotGraphics{R <: Number} <: GraphicsArea
    data::Vector{FiveNumberSummary}
    colors::Vector{ColorType}
    char_width::Int
    visible::Bool
    min_x::RefValue{R}
    max_x::RefValue{R}

    function BoxplotGraphics(
            data::AbstractVector{R},
            char_width::Integer;
            visible::Bool = KEYWORDS.visible,
            color::Union{UserColorType, AbstractVector} = :green,
            min_x::Union{Number, Nothing} = nothing,
            max_x::Union{Number, Nothing} = nothing,
        ) where {R <: Number}
        char_width = max(char_width, 10)
        mi, ma = extrema(data)
        min_x = R(something(min_x, mi))
        max_x = R(something(max_x, ma))
        if min_x == max_x
            min_x -= 1
            max_x += 1
        end
        colors = if color isa AbstractVector
            ansi_color.(color)
        else
            [ansi_color(color)]
        end
        summary = FiveNumberSummary(
            mi,
            percentile(data, 25),
            percentile(data, 50),
            percentile(data, 75),
            ma,
        )
        return new{R}([summary], colors, char_width, visible, Ref(min_x), Ref(max_x))
    end
end

@inline nrows(c::BoxplotGraphics) = 3length(c.data)
@inline ncols(c::BoxplotGraphics) = c.char_width

function addseries!(
        c::BoxplotGraphics,
        data::AbstractVector{R},
        color::UserColorType = nothing,
    ) where {R <: Number}
    mi, ma = extrema(data)
    push!(
        c.data,
        FiveNumberSummary(
            mi,
            percentile(data, 25),
            percentile(data, 50),
            percentile(data, 75),
            ma,
        ),
    )
    push!(c.colors, suitable_color(c, color))
    c.min_x[] = min(mi, c.min_x[])
    c.max_x[] = max(ma, c.max_x[])
    return c
end

transform(c::BoxplotGraphics, value) = clamp(
    round(Int, (value - c.min_x[]) / (c.max_x[] - c.min_x[]) * c.char_width),
    1,
    c.char_width,
)

function print_row(io::IO, _, print_color, c::BoxplotGraphics, row::Integer)
    1 ≤ row ≤ nrows(c) || throw(ArgumentError("`row` out of bounds: $row"))
    I = ceil(Int, row / 3)
    series = c.data[I]

    series_row = mod1(row, 3)
    min_char = ('╷', '├', '╵')[series_row]
    line_char = (' ', '─', ' ')[series_row]
    left_box_char = ('┌', '┤', '└')[series_row]
    line_box_char = ('─', ' ', '─')[series_row]
    median_char = ('┬', '│', '┴')[series_row]
    right_box_char = ('┐', '├', '┘')[series_row]
    max_char = ('╷', '┤', '╵')[series_row]

    chars = fill(' ', c.char_width)

    # draw shapes first - this is most important,
    # so they'll always be drawn even if there's not enough space
    chars[transform(c, series.minimum)] = min_char
    chars[transform(c, series.lower_quartile)] = left_box_char
    chars[transform(c, series.median)] = median_char
    chars[transform(c, series.upper_quartile)] = right_box_char
    chars[transform(c, series.maximum)] = max_char

    # Fill in gaps with lines
    for i in (transform(c, series.minimum) + 1):(transform(c, series.lower_quartile) - 1)
        chars[i] = line_char
    end
    for i in (transform(c, series.lower_quartile) + 1):(transform(c, series.median) - 1)
        chars[i] = line_box_char
    end
    for i in (transform(c, series.median) + 1):(transform(c, series.upper_quartile) - 1)
        chars[i] = line_box_char
    end
    for i in (transform(c, series.upper_quartile) + 1):(transform(c, series.maximum) - 1)
        chars[i] = line_char
    end

    print_color(io, c.colors[I], String(chars))
    return nothing
end

module TermExt

import UnicodePlots
import Term

function UnicodePlots.panel(p; kw...)
    p.margin[] = p.padding[] = 0  # make plots more compact
    p.compact_labels[] = p.compact[] = true
    return Term.Panel(string(p; color = true); style = "hidden", fit = true, kw...)
end

UnicodePlots.gridplot(plots::Union{AbstractVector, Tuple}; kw...) =
    UnicodePlots.gridplot(plots...; kw...)
UnicodePlots.gridplot(plots::UnicodePlots.Plot...; kw...) =
    Term.grid(map(UnicodePlots.panel, plots); kw...)

end  # module

abstract type Canvas <: GraphicsArea end

grid_type(T::Type{<:Canvas}) = fieldtype(T, 1) |> eltype
grid_type(c::Canvas) = grid_type(typeof(c))

# we store the grid as the transpose of an array of (w, h) => (height, width) = (nrows, ncols)
@inline nrows(c::Canvas) = size(c.grid, 1)
@inline ncols(c::Canvas) = size(c.grid, 2)

@inline lookup_offset(c::Canvas) = grid_type(c)(0)
@inline pixel_height(c::Canvas)::Int = c.pixel_height
@inline pixel_width(c::Canvas)::Int = c.pixel_width
@inline blend_colors(c::Canvas, _)::Bool = c.blend
@inline origin_y(c::Canvas)::Float64 = c.origin_y
@inline origin_x(c::Canvas)::Float64 = c.origin_x
@inline height(c::Canvas)::Float64 = c.height
@inline width(c::Canvas)::Float64 = c.width

@inline y_to_pixel(c::Canvas, y::Number) = if c.yflip
    (y - origin_y(c)) / height(c) * pixel_height(c)
else
    (1 - (y - origin_y(c)) / height(c)) * pixel_height(c)
end::Float64
@inline x_to_pixel(c::Canvas, x::Number) = if c.xflip
    (1 - (x - origin_x(c)) / width(c)) * pixel_width(c)
else
    (x - origin_x(c)) / width(c) * pixel_width(c)
end::Float64

@inline scale_y_to_pixel(c::Canvas, y::Number) = y_to_pixel(c, c.yscale(y))
@inline scale_x_to_pixel(c::Canvas, x::Number) = x_to_pixel(c, c.xscale(x))

@inline valid_y(c::Canvas, y::Number) =
    isfinite(y) && (origin_y(c) ≤ c.yscale(y) ≤ origin_y(c) + height(c))
@inline valid_x(c::Canvas, x::Number) =
    isfinite(x) && (origin_x(c) ≤ c.xscale(x) ≤ origin_x(c) + width(c))

@inline valid_y_pixel(c::Canvas, pixel_y::Integer) = 0 ≤ pixel_y ≤ pixel_height(c)  # NOTE: relaxed upper bound [ref(1)]
@inline valid_x_pixel(c::Canvas, pixel_x::Integer) = 0 ≤ pixel_x ≤ pixel_width(c)

"""
    pixel_size(c::Canvas)

Canvas pixel resolution (height, width).
"""
pixel_size(c::Canvas) = (pixel_height(c), pixel_width(c))
Base.size(c::Canvas) = (height(c), width(c))
origin(c::Canvas) = (origin_x(c), origin_y(c))

############################################################
# high-level (color conversion)
pixel!(c::Canvas, pixel_x::Integer, pixel_y::Integer; color::UserColorType = :normal) =
    pixel!(c, pixel_x, pixel_y, ansi_color(color), blend_colors(c, color))

points!(
    c::Canvas,
    x::Union{Number, AbstractVector},
    y::Union{Number, AbstractVector};
    color::UserColorType = :normal,
) = points!(c, x, y, ansi_color(color), blend_colors(c, color))

lines!(
    c::Canvas,
    x1::Number,
    y1::Number,
    x2::Number,
    y2::Number;
    color::UserColorType = :normal,
) = lines!(c, x1, y1, x2, y2, ansi_color(color), blend_colors(c, color))

lines!(c::Canvas, X::AbstractVector, Y::AbstractVector; color::UserColorType = :normal) =
    lines!(c, X, Y, ansi_color(color), blend_colors(c, color))

############################################################
# low-level (restricted types for faster loops)
points!(c::Canvas, x::Number, y::Number, color::ColorType, blend::Bool) = pixel!(
    c,
    floor(Int, scale_x_to_pixel(c, x)),
    floor(Int, scale_y_to_pixel(c, y)),
    color,
    blend,
)

# implementation of the digital differential analyser (DDA)
function lines!(
        c::Canvas,
        x1::Number,
        y1::Number,
        x2::Number,
        y2::Number,
        c_or_v1::Union{AbstractFloat, ColorType},  # either floating point values or colors
        blend::Bool,
        c_or_v2::Union{Nothing, AbstractFloat, ColorType} = nothing,
        col_cb::Union{Nothing, Function} = nothing,  # color callback (map values to colors)
    )
    (valid_x(c, x1) || valid_x(c, x2)) || return c
    (valid_y(c, y1) || valid_y(c, y2)) || return c

    Δx = scale_x_to_pixel(c, x2) - (cur_x = scale_x_to_pixel(c, x1))
    isfinite(Δx) || return c

    Δy = scale_y_to_pixel(c, y2) - (cur_y = scale_y_to_pixel(c, y1))
    isfinite(Δy) || return c

    nsteps = min(max(abs(Δx), abs(Δy)), typemax(Int32))  # hard limit
    len = min(floor(Int, nsteps), typemax(Int16))  # performance limit

    δx = Δx / nsteps
    δy = Δy / nsteps

    px, Px = x_to_pixel(c, origin_x(c)), x_to_pixel(c, origin_x(c) + width(c))
    py, Py = y_to_pixel(c, origin_y(c)), y_to_pixel(c, origin_y(c) + height(c))
    px, Px = min(px, Px), max(px, Px)
    py, Py = min(py, Py), max(py, Py)

    if c_or_v1 isa AbstractFloat && c_or_v2 isa AbstractFloat && col_cb ≢ nothing
        # color interpolation
        pixel!(c, floor(Int, cur_x), floor(Int, cur_y), col_cb(c_or_v1), blend)
        start_x, start_y = cur_x, cur_y
        iΔ = inv(√(Δx^2 + Δy^2))
        for _ in range(1, length = len)
            cur_x += δx
            cur_y += δy
            (cur_y < py || cur_y > Py) && continue
            (cur_x < px || cur_x > Px) && continue
            weight = √((cur_x - start_x)^2 + (cur_y - start_y)^2) * iΔ
            pixel!(
                c,
                floor(Int, cur_x),
                floor(Int, cur_y),
                col_cb((1 - weight) * c_or_v1 + weight * c_or_v2),
                blend,
            )
        end
    else
        pixel!(c, floor(Int, cur_x), floor(Int, cur_y), c_or_v1, blend)
        for _ in range(1, length = len)
            cur_x += δx
            cur_y += δy
            (cur_y < py || cur_y > Py) && continue
            (cur_x < px || cur_x > Px) && continue
            pixel!(c, floor(Int, cur_x), floor(Int, cur_y), c_or_v1, blend)
        end
    end
    return c
end

# low-level (vectors)
function points!(
        c::Canvas,
        X::AbstractVector,
        Y::AbstractVector,
        color::ColorType,
        blend::Bool,
    )
    @assert length(X) == length(Y)
    @inbounds for i in eachindex(X, Y)
        (x = X[i]) |> isfinite || continue
        (y = Y[i]) |> isfinite || continue
        points!(c, x, y, color, blend)
    end
    return c
end

function points!(
        c::Canvas,
        X::AbstractVector,
        Y::AbstractVector,
        color::AbstractVector{ColorType},
        blend::AbstractVector{Bool},
    )
    @assert length(X) == length(Y) == length(color) == length(blend)
    @inbounds for i in eachindex(X, Y, color, blend)
        (x = X[i]) |> isfinite || continue
        (y = Y[i]) |> isfinite || continue
        points!(c, x, y, color[i], blend[i])
    end
    return c
end

function lines!(
        c::Canvas,
        X::AbstractVector,
        Y::AbstractVector,
        color::ColorType,
        blend::Bool,
    )
    length(X) == length(Y) ||
        throw(DimensionMismatch("`X` and `Y` must be the same length"))
    @inbounds for i in 2:length(X)
        (x = X[i]) |> isfinite || continue
        (y = Y[i]) |> isfinite || continue
        (xm1 = X[i - 1]) |> isfinite || continue
        (ym1 = Y[i - 1]) |> isfinite || continue
        lines!(c, xm1, ym1, x, y, color, blend)
    end
    return c
end

############################################################
function get_canvas_dimensions_for_matrix(
        canvas::Type{T},
        nrow::Integer,
        ncol::Integer,
        max_height::Integer,
        max_width::Integer,
        height::Union{Nothing, Integer},
        width::Union{Nothing, Integer},
        margin::Integer,
        padding::Integer,
        out_stream::Union{Nothing, IO},
        fix_ar::Bool;
        extra_rows = 0,
        extra_cols = 0,
    ) where {T <: Canvas}
    canv_height = nrow / y_pixel_per_char(T)
    canv_width = ncol / x_pixel_per_char(T)
    # e.g. heatmap(collect(1:2) * collect(1:2)') with nrow = 2, ncol = 2
    # on a HeatmapCanvas, x_pixel_per_char = 1 and y_pixel_per_char = 2
    # hence the canvas aspect ratio (canv_ar) is 2
    canv_ar = canv_width / canv_height

    # min_canv_height := minimal number of y canvas characters
    # (holding y_pixel_per_char pixels) to represent the input data
    min_canv_height = ceil(Int, canv_height)
    min_canv_width = ceil(Int, canv_width)

    height_diff = extra_rows
    width_diff = margin + padding + length(string(ncol)) + extra_cols

    term_height, term_width = out_stream_size(out_stream)
    max_height = max_height > 0 ? max_height : term_height - height_diff
    max_width = max_width > 0 ? max_width : term_width - width_diff

    (nrow == 0 && ncol == 0) && return 0, 0, max_width, max_height

    # Check if the size of the plot should be derived from the matrix
    # Note: if both width and height are 0, it means that there are no
    #       constraints and the plot should resemble the structure of
    #       the matrix as close as possible
    if width ≡ nothing && height ≡ nothing
        # If the interactive code did not take care of this then try
        # to plot the matrix in the correct aspect ratio (within specified bounds)
        if min_canv_height > min_canv_width
            # long matrix (according to pixel density)
            width = min(min_canv_height * canv_ar, max_width)
            height = min(width / canv_ar, max_height)
            width = min(height * canv_ar, max_width)
        else
            # wide matrix
            height = min(min_canv_width / canv_ar, max_height)
            width = min(height * canv_ar, max_width)
            height = min(width / canv_ar, max_height)
        end
    end

    if width ≡ nothing && height > 0
        width = min(height * canv_ar, max_width)
    elseif height ≡ nothing && width > 0
        height = min(width / canv_ar, max_height)
    end

    height = round(Int, height / (fix_ar ? ASPECT_RATIO[] : 1))  # optional terminal aspect ratio (4:3) correction
    width = round(Int, width)

    # the canvas will target a (height, width) grid to represent the input data
    return height, width, max_height, max_width
end

function align_char_point(
        text::AbstractString,
        char_x::Integer,
        char_y::Integer,
        halign::Symbol,
        valign::Symbol,
    )
    nchar = length(text)
    char_x = if halign ∈ (:center, :hcenter)
        char_x - nchar ÷ 2
    elseif halign ≡ :left
        char_x
    elseif halign ≡ :right
        char_x - (nchar - 1)
    else
        throw(ArgumentError("`halign=$halign` not supported"))
    end
    char_y = if valign ∈ (:center, :vcenter)
        char_y
    elseif valign ≡ :top
        char_y + 1
    elseif valign ≡ :bottom
        char_y - 1
    else
        throw(ArgumentError("`valign=$valign` not supported"))
    end
    return char_x, char_y
end

function pixel_to_char_point(c::C, pixel_x::Number, pixel_y::Number) where {C <: Canvas}
    # when hitting boundaries with canvases capable of encoding more than 1 pixel per char (see ref(1))
    pixel_x ≥ pixel_width(c) && (pixel_x -= 1)
    pixel_y ≥ pixel_height(c) && (pixel_y -= 1)
    return (
        floor(Int, pixel_x / x_pixel_per_char(C)) + 1,
        floor(Int, pixel_y / y_pixel_per_char(C)) + 1,
    )
end

function pixel_to_char_point_off(c::C, pixel_x::Number, pixel_y::Number) where {C <: Canvas}
    pixel_x ≥ pixel_width(c) && (pixel_x -= 1)
    pixel_y ≥ pixel_height(c) && (pixel_y -= 1)
    qx, rx = divrem(pixel_x, x_pixel_per_char(C))
    qy, ry = divrem(pixel_y, y_pixel_per_char(C))
    return (Int(qx) + 1, Int(qy) + 1, Int(rx) + 1, Int(ry) + 1)
end

function annotate!(
        c::Canvas,
        x::Number,
        y::Number,
        text::AbstractString,
        color::ColorType,
        blend::Bool;
        halign::Symbol = :center,
        valign::Symbol = :center,
    )
    valid_x(c, x) || return c
    valid_y(c, y) || return c

    char_x, char_y = pixel_to_char_point(c, scale_x_to_pixel(c, x), scale_y_to_pixel(c, y))
    char_x, char_y = align_char_point(text, char_x, char_y, halign, valign)
    for char in text
        char_point!(c, char_x, char_y, char, color, blend)
        char_x += 1
    end
    return c
end

function annotate!(
        c::Canvas,
        x::Number,
        y::Number,
        text::AbstractChar,
        color::ColorType,
        blend::Bool,
    )
    valid_x(c, x) || return c
    valid_y(c, y) || return c

    char_x, char_y = pixel_to_char_point(c, scale_x_to_pixel(c, x), scale_y_to_pixel(c, y))
    char_point!(c, char_x, char_y, text, color, blend)
    return c
end

@inline function char_point!(
        c::Canvas,
        char_x::Integer,
        char_y::Integer,
        char::AbstractChar,
        color::ColorType,
        blend::Bool,
    )
    if checkbounds(Bool, c.grid, char_y, char_x)
        c.grid[char_y, char_x] = lookup_offset(c) + grid_type(c)(char)
        set_color!(c, char_x, char_y, color, blend)
    end
    return nothing
end

@inline function set_color!(
        c::Canvas,
        x::Integer,
        y::Integer,
        color::ColorType,
        blend::Bool,
    )
    col::ColorType = c.colors[y, x]
    c.colors[y, x] = if col ≡ INVALID_COLOR || !blend
        color
    else
        blend_colors(col, color)
    end::ColorType
    return nothing
end

@test Canvas <: GraphicsArea

@testset "Nan / Inf" begin
    c = BrailleCanvas(15, 40)
    lines!(c, [0, NaN], [0, 0])
    lines!(c, [0, 0], [+Inf, 0])
    lines!(c, [0, 0], [0, -Inf])
end

@testset "interface" begin
    for (T, xres, yres) in (
            (BrailleCanvas, 2, 4),
            (OctantCanvas, 2, 4),
            (DensityCanvas, 1, 2),
            (BlockCanvas, 2, 2),
            (AsciiCanvas, 3, 3),
            (DotCanvas, 1, 2),
            (HeatmapCanvas, 1, 2),
        )
        @testset "$(nameof(T))" begin
            @test T <: Canvas
            c = T(15, 30; origin_y = -1.5, origin_x = -1, height = 3, width = 2)
            @test @inferred(size(c)) ≡ (3.0, 2.0)
            @test @inferred(nrows(c)) ≡ (T == HeatmapCanvas ? 8 : 15)
            @test @inferred(ncols(c)) ≡ 30
            @test @inferred(UnicodePlots.height(c)) ≡ 3.0
            @test @inferred(UnicodePlots.width(c)) ≡ 2.0
            @test @inferred(UnicodePlots.origin_y(c)) ≡ -1.5
            @test @inferred(UnicodePlots.origin_x(c)) ≡ -1.0
            @test @inferred(UnicodePlots.origin(c)) ≡ (-1.0, -1.5)
            @test @inferred(UnicodePlots.y_pixel_per_char(T)) ≡ yres
            @test @inferred(UnicodePlots.x_pixel_per_char(T)) ≡ xres
            @test @inferred(UnicodePlots.pixel_height(c)) ≡ 15yres
            @test @inferred(UnicodePlots.pixel_width(c)) ≡ 30xres
            @test @inferred(UnicodePlots.pixel_size(c)) ≡
                (UnicodePlots.pixel_height(c), UnicodePlots.pixel_width(c))
            if T <: UnicodePlots.LookupCanvas  # coverage
                @test length(UnicodePlots.lookup_encode(c)) > 0
                @test length(UnicodePlots.lookup_decode(c)) > 0
            end
        end
    end
end

@testset "print and show" begin
    seed!(RNG, 1_337)
    x1, y1 = rand(RNG, 20), rand(RNG, 20)
    x2, y2 = rand(RNG, 50), rand(RNG, 50)
    for (T, str) in (
            (BrailleCanvas, "braille"),
            (DensityCanvas, "density"),
            (BlockCanvas, "block"),
            (AsciiCanvas, "ascii"),
            (DotCanvas, "dot"),
            (HeatmapCanvas, "heatmap"),
        )
        @testset "$T" begin
            c = T(10, 40; origin_y = 0.0, origin_x = 0.0, height = 1.0, width = 1.0)
            if T == BrailleCanvas
                test_ref("canvas/empty_braille_show.txt", @show_col(c))
            elseif T == HeatmapCanvas
                test_ref("canvas/empty_heatmap_show.txt", @show_col(c))
            else
                test_ref("canvas/empty_show.txt", @show_col(c))
            end
            @test @inferred(lines!(c, 0.0, 0.0, 1.0, 1.0; color = :blue)) ≡ c
            @test @inferred(points!(c, x1, y1; color = :white)) ≡ c
            @test @inferred(pixel!(c, 2, 4, color = :cyan)) ≡ c
            @no_allocs points!(c, x2, y2, color = :red)
            @no_allocs lines!(c, 0.0, 1.0, 0.5, 0.0; color = :green)
            @no_allocs points!(c, 0.05, 0.3, color = :cyan)
            lines!(c, [1.0, 2], [2.0, 1])
            @no_allocs lines!(c, 0.0, 0.0, 0.9, 9999.0; color = :yellow)
            @no_allocs lines!(c, 0, 0, 1, 1, color = :blue)
            @no_allocs lines!(c, 0.1, 0.7, 0.9, 0.6; color = :red)

            postprocess! = preprocess!(devnull, c)
            test_ref(
                "canvas/$(str)_print_row.txt",
                @io2str(print_row(IOContext(::IO, :color => true), c, 3))
            )
            postprocess!(c)

            test_ref("canvas/$(str)_print.txt", @print_col(c))
            test_ref("canvas/$(str)_print_nocolor.txt", @print_nocol(c))
            test_ref("canvas/$(str)_show.txt", @show_col(c))
            test_ref("canvas/$(str)_show_nocolor.txt", @show_nocol(c))
        end
    end
end

vert_line!(c, m, M, x, col) = lines!(c, x, m, x, M; color = col)
horz_line!(c, m, M, y, col) = lines!(c, m, y, M, y; color = col)

@testset "color mixing (4bit)" begin
    m, M = 0.0, 1.4
    c = BrailleCanvas(15, 40; origin_y = m, origin_x = m, height = M, width = M)

    for line in (vert_line!, horz_line!)
        line(c, m, M, 0.0, :dark_gray)
        line(c, m, M, 0.2, :light_red)
        line(c, m, M, 0.4, :light_green)
        line(c, m, M, 0.6, :light_yellow)
        line(c, m, M, 0.8, :light_blue)
        line(c, m, M, 1.0, :light_magenta)
        line(c, m, M, 1.2, :light_cyan)
        line(c, m, M, 1.4, :white)
    end

    test_ref("canvas/color_mixing_4bit.txt", @print_col(c))
end

@testset "color mixing (8bit)" begin
    m, M = 0.0, 1.4
    c = BrailleCanvas(15, 40; origin_y = m, origin_x = m, height = M, width = M)

    for line in (vert_line!, horz_line!)
        line(c, m, M, 0.0, 8)
        line(c, m, M, 0.2, 9)
        line(c, m, M, 0.4, 10)
        line(c, m, M, 0.6, 11)
        line(c, m, M, 0.8, 12)
        line(c, m, M, 1.0, 13)
        line(c, m, M, 1.2, 14)
        line(c, m, M, 1.4, 15)
    end

    test_ref("canvas/color_mixing_8bit.txt", @print_col(c))
end

@testset "color mixing (24bit)" begin
    m, M = 0.0, 1.4
    c = BrailleCanvas(15, 40; origin_y = m, origin_x = m, height = M, width = M)

    for line in (vert_line!, horz_line!)
        line(c, m, M, 0.0, (0, 0, 0))
        line(c, m, M, 0.2, (255, 0, 0))
        line(c, m, M, 0.4, (0, 255, 0))
        line(c, m, M, 0.6, (255, 255, 0))
        line(c, m, M, 0.8, (0, 0, 255))
        line(c, m, M, 1.0, (255, 0, 255))
        line(c, m, M, 1.2, (0, 255, 255))
        line(c, m, M, 1.4, (255, 255, 255))
    end

    test_ref("canvas/color_mixing_24bit.txt", @print_col(c))
end

"""
    BlockCanvas{YS <: Function, XS <: Function} <: LookupCanvas

The `BlockCanvas` is also Unicode-based.
It has half the resolution of the `BrailleCanvas`.
In contrast to BrailleCanvas, the pixels don't have visible spacing between them.
This canvas effectively turns every character into four pixels that can individually be manipulated using binary operations.
"""
struct BlockCanvas{YS <: Function, XS <: Function} <: LookupCanvas
    grid::Transpose{UInt16, Matrix{UInt16}}
    colors::Transpose{ColorType, Matrix{ColorType}}
    visible::Bool
    blend::Bool
    yflip::Bool
    xflip::Bool
    pixel_height::Int
    pixel_width::Int
    origin_y::Float64
    origin_x::Float64
    height::Float64
    width::Float64
    min_max::NTuple{2, UnicodeType}
    yscale::YS
    xscale::XS
end

const BLOCK_SIGNS = [
    0b1000 0b0100
    0b0010 0b0001
]

const N_BLOCK = grid_type(BlockCanvas)(16)
const BLOCK_DECODE = Vector{Char}(undef, typemax(N_BLOCK))

BLOCK_DECODE[1] = ' '
BLOCK_DECODE[2] = '▗'
BLOCK_DECODE[3] = '▖'
BLOCK_DECODE[4] = '▄'
BLOCK_DECODE[5] = '▝'
BLOCK_DECODE[6] = '▐'
BLOCK_DECODE[7] = '▞'
BLOCK_DECODE[8] = '▟'
BLOCK_DECODE[9] = '▘'
BLOCK_DECODE[10] = '▚'
BLOCK_DECODE[11] = '▌'
BLOCK_DECODE[12] = '▙'
BLOCK_DECODE[13] = '▀'
BLOCK_DECODE[14] = '▜'
BLOCK_DECODE[15] = '▛'
BLOCK_DECODE[16] = '█'
BLOCK_DECODE[(N_BLOCK + 1):typemax(N_BLOCK)] = UNICODE_TABLE[1:(typemax(N_BLOCK) - N_BLOCK)]

@inline x_pixel_per_char(::Type{<:BlockCanvas}) = 2
@inline y_pixel_per_char(::Type{<:BlockCanvas}) = 2

@inline lookup_encode(::BlockCanvas) = BLOCK_SIGNS
@inline lookup_decode(::BlockCanvas) = BLOCK_DECODE
@inline lookup_offset(::BlockCanvas) = N_BLOCK

BlockCanvas(args...; kw...) =
    CreateLookupCanvas(BlockCanvas, (0b0000, 0b1111), args...; kw...)

"""
    densityplot(x, y; kw...)
    densityplot!(p, args...; kw...)

# Description

Draws a density plot for the given points.

The first vector `x` should contain the horizontal positions for all the points.
The second vector `y` should contain the corresponding vertical positions respectively.
The two vectors must thus be of the same length and ordering.
One can pass an arbitrary `dscale` (`Function` or `Symbol`) for transforming density counts (e.g. peaks damping).

# Usage

    densityplot(x, y; $(keywords((; dscale = :identity); remove = (:grid,))))

# Arguments

$(arguments((; dscale = "density scale function"); add = (:x, :y), remove = (:grid,)))

# Author(s)

- Christof Stocker (github.com/Evizero)

# Examples

```julia-repl
julia> densityplot(randn(1_000), randn(1_000); title = "Density Plot")
                     Density Plot
      ┌────────────────────────────────────────┐
    4 │                                        │
      │                                        │
      │                                        │
      │                                        │
      │          ░        ░░  ░                │
      │           ░ ░░░░░░▓▒▒▒░░░░░            │
      │            ░▒▒▓▒░▒▒▓▓▓▒▒░░░░           │
      │         ░░  ░░▓▓░▓▒█▓▒░░▒░░░           │
      │            ░░░▒▒▒░▒▓▒▒▒░░░░░           │
      │          ░  ░░░░░▓░░░░░░░ ░            │
      │                 ░░░░░ ░  ░             │
      │                                        │
      │                                        │
      │                                        │
   -4 │                                        │
      └────────────────────────────────────────┘
       -4                                     4
```

# See also

[`Plot`](@ref), [`scatterplot`](@ref), [`DensityCanvas`](@ref)
"""
function densityplot(
        x::AbstractVector,
        y::AbstractVector;
        dscale::Union{Symbol, Function} = :identity,
        kw...,
    )
    pkw, okw = split_plot_kw(kw)
    plot = Plot(
        x,
        y,
        nothing,
        DensityCanvas;
        canvas_kw = (; dscale = scale_callback(dscale)),
        grid = false,
        pkw...,
    )
    return scatterplot!(plot, x, y; okw...)
end

@doc (@doc densityplot) densityplot!(
    plot::Plot{<:DensityCanvas},
    x::AbstractVector,
    y::AbstractVector;
    kw...,
) = scatterplot!(plot, x, y; kw...)

using SparseArrays
using Random

# split from `runtests.jl` for docs generating script (`gen_imgs.jl`)

# `sprand` or `sprandn` is not stable across versions (e.g. `1.0` vs `1.6`)
function _stable_sprand(rng, m::Integer, n::Integer, density::AbstractFloat)
    I = Int[]
    J = Int[]
    for li in randsubseq(rng, 1:(m * n), density)
        j, i = divrem(li - 1, m)
        push!(I, i + 1)
        push!(J, j + 1)
    end
    V = rand(rng, length(I))
    return sparse(I, J, V)
end

@testset "camera" begin
    # NOTE: the output of view_matrix uses the OpenGL convention:
    # x pointing to the east, y pointing to the north, z pointing out of the screen, towards the user
    # when our up vector = y (openGL default), V looks like I
    # up vector = :x -> cam_dir = :y
    # up vector = :y -> cam_dir = :z
    # up vector = :z -> cam_dir = :x
    V, dir = UnicodePlots.view_matrix([0, 0, 0], 1, 0, 0, :x)
    @test V ≈ [
        0 0 1 0
        1 0 0 0
        0 1 0 -1
        0 0 0 1
    ]
    @test dir == [0, 1, 0]
    V, dir = UnicodePlots.view_matrix([0, 0, 0], 1, 0, 0, :y)
    @test V ≈ [
        1 0 0 0
        0 1 0 0
        0 0 1 -1
        0 0 0 1
    ]
    @test dir == [0, 0, 1]
    V, dir = UnicodePlots.view_matrix([0, 0, 0], 1, 0, 0, :z)
    @test V ≈ [
        0 1 0 0
        0 0 1 0
        1 0 0 -1
        0 0 0 1
    ]
    @test dir == [1, 0, 0]

    @test_throws ArgumentError UnicodePlots.view_matrix([0, 0, 0], 1, 0, 0, :not_supported)

    @test UnicodePlots.scale_4x4([1, 1, 1]) ≈ I
    @test UnicodePlots.translate_4x4([0, 0, 0]) ≈ I
    @test UnicodePlots.rotd_x(0) ≈ I
    @test UnicodePlots.rotd_y(0) ≈ I
    @test UnicodePlots.rotd_z(0) ≈ I

    T = MVP([-1.0, 1.0], [-1.0, 1.0], [-1.0, 1.0])
    @test length(T([1, 2, 3], :user)) == 2
    @test length(T([1, 2, 3], :ortho)) == 2
    @test length(T([1, 2, 3], :persp)) == 2

    @test UnicodePlots.transform_matrix(T, :user) |> size == (4, 4)
    @test UnicodePlots.transform_matrix(T, :orthographic) |> size == (4, 4)
    @test UnicodePlots.transform_matrix(T, :perspective) |> size == (4, 4)

    @test UnicodePlots.is_ortho(T, :user)
    @test UnicodePlots.is_ortho(T, :orthographic)
    @test UnicodePlots.is_ortho(T, :ortho)
    @test !UnicodePlots.is_ortho(T, :perspective)
    @test !UnicodePlots.is_ortho(T, :persp)

    corners = UnicodePlots.cube_corners(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0)
    @test size(corners) == (3, 8)
    @test all(-1 .≤ corners .≤ 1)

    p = Plot([-1, 1], [-1, 1], [-1, 1]; projection = :ortho)
    @test p.projection.ortho
    p = Plot([-1, 1], [-1, 1], [-1, 1]; projection = :persp)
    @test !p.projection.ortho
end

@testset "azimuth / elevation" begin
    ellipsoid(θs = (-π / 2):(π / 10):(π / 2), ϕs = (-π):(π / 10):π, a = 2, b = 0.5, c = 1) =
        (
        [a * cos(θ) .* cos(ϕ) for (ϕ, θ) in Iterators.product(ϕs, θs)] |> vec,
        [b * cos(θ) .* sin(ϕ) for (ϕ, θ) in Iterators.product(ϕs, θs)] |> vec,
        [c * sin(θ) for (ϕ, θ) in Iterators.product(ϕs, θs)] |> vec,
    )

    x, y, z = ellipsoid()
    for (pl, azimuth, elevation) in [("yz", 0, 0), ("xz", -90, 0), ("xy", -90, 90)]
        p = Plot(x, y, z; title = "plane=$pl", projection = :ortho, elevation, azimuth)
        scatterplot!(p, x, y, z)

        test_ref("volume/ellipsoid_$pl.txt", @show_col(p))
    end
end

@testset "cube" begin
    for projection in (:ortho, :orthographic, :persp, :perspective)
        ortho = projection ∈ (:ortho, :orthographic)

        T = MVP(
            [-1, 1],
            [-1, 1],
            [-1, 1];
            projection,
            elevation = ortho ? UnicodePlots.KEYWORDS.elevation : 0,
            azimuth = ortho ? UnicodePlots.KEYWORDS.azimuth : 0,
        )
        @test T.ortho == ortho

        cube = (
            # near plane square
            [(-1, 1, 1), (1, 1, 1)],
            [(-1, -1, 1), (-1, 1, 1)],
            [(-1, -1, 1), (1, -1, 1)],
            [(1, -1, 1), (1, 1, 1)],
            # transversal edges
            [(1, 1, -1), (1, 1, 1)],
            [(-1, 1, -1), (-1, 1, 1)],
            [(-1, -1, -1), (-1, -1, 1)],
            [(1, -1, -1), (1, -1, 1)],
            # far plane square
            [(-1, 1, -1), (1, 1, -1)],
            [(-1, -1, -1), (-1, 1, -1)],
            [(-1, -1, -1), (1, -1, -1)],
            [(1, -1, -1), (1, 1, -1)],
        )

        segment2xyz(s) = [s[1][1], s[2][1]], [s[1][2], s[2][2]], [s[1][3], s[2][3]]

        p = lineplot(
            segment2xyz(first(cube))...,
            projection = T,
            title = "proj=$projection",
            axes3d = false,
        )
        for (i, s) in enumerate(cube)
            i == 1 && continue
            lineplot!(p, segment2xyz(s)...)
        end

        test_ref("volume/cube_$projection.txt", @show_col(p))
    end
end

@testset "zoom" begin
    for zoom in (0.5, 1, 2)
        T = MVP([-1, 1], [-1, 1], [-1, 1]; zoom)

        tetrahedron = (
            # 1st triangle
            [(0, 0, 0), (1, 0, 0)],
            [(1, 0, 0), (0, 0, 1)],
            [(0, 0, 1), (0, 0, 0)],
            # 2nd triangle
            [(0, 0, 0), (0, 1, 0)],
            [(0, 1, 0), (0, 0, 1)],
            [(0, 0, 1), (0, 0, 0)],
            # 3rd triangle
            [(1, 0, 0), (0, 1, 0)],
            [(0, 1, 0), (0, 0, 1)],
            [(0, 0, 1), (1, 0, 0)],
        )

        segments2xyz(segments) = (
            [p[1] for s in segments for p in s],
            [p[2] for s in segments for p in s],
            [p[3] for s in segments for p in s],
        )

        p = lineplot(
            segments2xyz(tetrahedron)...,
            projection = T,
            title = "zoom=$zoom",
            axes3d = false,
        )
        test_ref("volume/tetrahedron_$zoom.txt", @show_col(p))
    end
end

x = [-1, 1, 3, 3, -1]
y = [2, 0, -5, 2, -5]

@testset "input" begin
    @test lineplot() isa Plot
    @test_throws MethodError lineplot(sin, x, y)
    @test_throws ArgumentError lineplot(0, 3, Function[])
    @test_throws ArgumentError lineplot(x, Function[])
    @test_throws ArgumentError lineplot(Function[])
    @test_throws Union{BoundsError, DimensionMismatch} lineplot([1, 2], [1, 2, 3])
    @test_throws Union{BoundsError, DimensionMismatch} lineplot([1, 2, 3], [1, 2])
    @test_throws Union{BoundsError, DimensionMismatch} lineplot([1, 2, 3], 1:2)
    @test_throws Union{BoundsError, DimensionMismatch} lineplot(1:3, [1, 2])
    @test_throws Union{BoundsError, DimensionMismatch} lineplot(1:3, 1:2)
end

@testset "Nan / Inf" begin
    @test lineplot([0, NaN], [0, 0]) isa Plot
    @test lineplot([0, 0], [+Inf, 0]) isa Plot
    @test lineplot([0, 0], [0, -Inf]) isa Plot
end

@testset "numeric array types" begin
    for p in (
            @binf(lineplot(x, y)),
            @binf(lineplot(float.(x), y)),
            @binf(lineplot(x, float.(y))),
        )
        @test p isa Plot
        test_ref("lineplot/default.txt", @show_col(p))
    end

    for p in (@binf(lineplot(y)), @binf(lineplot(float.(y))))
        @test p isa Plot
        test_ref("lineplot/y_only.txt", @show_col(p))
    end

    p = @binf lineplot(6:10)
    @test p isa Plot
    test_ref("lineplot/range1.txt", @show_col(p))

    p = @binf lineplot(11:15, 6:10)
    @test p isa Plot
    test_ref("lineplot/range2.txt", @show_col(p))
end

@testset "axis scaling and offsets" begin
    p = @binf lineplot(x .* 1.0e3 .+ 15, y .* 1.0e-3 .- 15)
    test_ref("lineplot/scale1.txt", @show_col(p))

    p = @binf lineplot(x .* 1.0e-3 .+ 15, y .* 1.0e3 .- 15)
    test_ref("lineplot/scale2.txt", @show_col(p))
    tx = [-1.0, 2, 3, 700_000]
    ty = [1.0, 2, 9, 4_000_000]
    p = @binf lineplot(tx, ty)
    test_ref("lineplot/scale3.txt", @show_col(p))
    p = @binf lineplot(tx, ty, height = 5, width = 18)
    test_ref("lineplot/scale3_small.txt", @show_col(p))
end

@testset "dates" begin
    d = collect(Date(1999, 12, 31):Day(1):Date(2000, 1, 30))
    v = range(0, stop = 3pi, length = 31)
    p = @binf lineplot(d, sin.(v); name = "sin", height = 5, xlabel = "date")
    test_ref("lineplot/dates1.txt", @show_col(p))
    @test @binf(lineplot!(p, d, cos.(v); name = "cos")) ≡ p
    test_ref("lineplot/dates2.txt", @show_col(p))
end

@testset "dataframes" begin
    df = DataFrame(
        Time = map(x -> DateTime(2022, 09, 20, x...), [1:3, 4:6, 7:9]),
        Test = [0, 1, -1],
    )
    p = lineplot(df.Time, df.Test; xticks = false)
    test_ref("lineplot/df1.txt", @show_col(p))
    p = lineplot(df.Time, df.Test; format = "M:S:s")
    test_ref("lineplot/df2.txt", @show_col(p))
end

@testset "line with intercept and slope" begin
    p = @binf lineplot(y)
    @test @binf(lineplot!(p, -3, 1)) ≡ p
    test_ref("lineplot/slope1.txt", @show_col(p))
    @test @binf(lineplot!(p, -4, 0.5; color = :cyan, name = "foo")) ≡ p
    test_ref("lineplot/slope2.txt", @show_col(p))
end

@testset "functions" begin
    @test_throws ArgumentError lineplot(
        1:0.5:12,
        sin,
        color = :blue,
        ylim = (-1.0, 1.0, 2.0),
    )
    @test_throws ArgumentError lineplot(
        1:0.5:12,
        sin,
        color = (0, 0, 255),
        ylim = [-1.0, 1.0, 2.0],
    )
    p = @binf lineplot(sin)
    test_ref("lineplot/sin.txt", @show_col(p))
    @test @binf(lineplot!(p, cos)) ≡ p
    test_ref("lineplot/sincos.txt", @show_col(p))
    p = @binf lineplot([sin, cos])
    test_ref("lineplot/sincos.txt", @show_col(p))

    p = @binf lineplot(-0.5, 6, sin)
    test_ref("lineplot/sin2.txt", @show_col(p))
    @test @binf(lineplot!(p, cos)) ≡ p
    test_ref("lineplot/sincos2.txt", @show_col(p))
    @test @binf(lineplot!(p, 2.5, 3.5, tan)) ≡ p
    test_ref("lineplot/sincostan2.txt", @show_col(p))

    p = @binf lineplot(-0.5, 3, [sin, cos])
    test_ref("lineplot/sincos3.txt", @show_col(p))

    tmp = [-0.5, 0.6, 1.4, 2.5]
    p = @binf lineplot(tmp, sin)
    test_ref("lineplot/sin4.txt", @show_col(p))
    @test @binf(lineplot!(p, tmp, cos)) ≡ p
    test_ref("lineplot/sincos4.txt", @show_col(p))
    p = @binf lineplot(tmp, [sin, cos])
    test_ref("lineplot/sincos4.txt", @show_col(p))

    @test_throws DimensionMismatch lineplot(-0.5, 3, [sin, cos]; name = ["s", "c", "d"])
    @test_throws DimensionMismatch lineplot(-0.5, 3, [sin, cos]; color = [:red])
    for (xlim, ylim) in zip(((-0.5, 2.5), [-0.5, 2.5]), ((-0.9, 1.2), [-0.9, 1.2]))
        p = @binf lineplot(
            -0.5,
            3,
            [sin, cos],
            name = ["s", "c"],
            color = [:red, :yellow],
            title = "Funs",
            ylabel = "f",
            xlabel = "num",
            xlim = (-0.5, 2.5),
            ylim = (-0.9, 1.2),
        )
        test_ref("lineplot/sincos_parameters.txt", @show_col(p))
    end
end

@testset "keyword arguments" begin
    for (xlim, ylim) in zip(((-1.5, 3.5), [-1.5, 3.5]), ((-5.5, 2.5), [-5.5, 2.5]))
        p = @binf lineplot(x, y, xlim = (-1.5, 3.5), ylim = (-5.5, 2.5))
        test_ref("lineplot/limits.txt", @show_col(p))
    end

    p = @binf lineplot(x, y, grid = false)
    test_ref("lineplot/nogrid.txt", @show_col(p))

    p = @binf lineplot(x, y; color = 20, name = "points1")
    test_ref("lineplot/blue.txt", @show_col(p))

    p = @binf lineplot(
        x,
        y,
        name = "points1",
        title = "Scatter",
        xlabel = "x",
        ylabel = "y",
    )
    @test p isa Plot
    test_ref("lineplot/parameters1.txt", @show_col(p))

    @test @binf(lineplot!(p, [0.5, 1, 1.5]; name = "points2")) ≡ p
    test_ref("lineplot/parameters2.txt", @show_col(p))

    @test @binf(lineplot!(p, [-0.5, 0.5, 1.5], [0.5, 1, 1.5]; name = "points3")) ≡ p
    test_ref("lineplot/parameters3.txt", @show_col(p))
    test_ref("lineplot/nocolor.txt", @show_nocol(p))

    p = lineplot(x, y; title = "Scatter", canvas = DotCanvas, height = 5, width = 10)
    @test p isa Plot
    test_ref("lineplot/canvassize.txt", @show_col(p))
end

@testset "stairs" begin
    sx = [1, 2, 4, 7, 8]
    sy = [1, 3, 4, 2, 7]

    p = @binf stairs(sx, sy, style = :pre)
    test_ref("lineplot/stairs_pre.txt", @show_col(p))
    p = @binf stairs(sx, sy)
    test_ref("lineplot/stairs_post.txt", @show_col(p))
    p = @binf stairs(sx, sy, style = :post)
    test_ref("lineplot/stairs_post.txt", @show_col(p))

    p = @binf stairs(sx, sy; title = "Foo", color = :red, xlabel = "x", name = "1")
    @test @binf(stairs!(p, sx .- 0.2, sy .+ 1.5; name = "2")) ≡ p
    test_ref("lineplot/stairs_parameters.txt", @show_col(p))
    @test @binf(stairs!(p, sx, sy; name = "3", style = :pre)) ≡ p
    test_ref("lineplot/stairs_parameters2.txt", @show_col(p))
    test_ref("lineplot/stairs_parameters2_nocolor.txt", @show_nocol(p))

    # special weird case
    p = stairs(sx, [1, 3, 4, 2, 7_000])
    test_ref("lineplot/stairs_edgecase.txt", @show_col(p))

    p = stairs(sx, sy, width = 20)
    label!(p, :tl, "Hello")
    label!(p, :t, "how are")
    label!(p, :tr, "you?")
    label!(p, :bl, "Hello")
    label!(p, :b, "how are")
    label!(p, :br, "you?")
    lineplot!(p, 1, 0.5)
    test_ref("lineplot/squeeze_annotations.txt", @show_col(p))

    dx = map(i -> Date(2020, 8, i), 1:10)
    p = stairs(dx, 1:10, xlim = (Date(2020, 8, 1), Date(2020, 8, 15)))
    test_ref("lineplot/stairs_date.txt", @show_col(p))
end

@testset "scales" begin
    x = y = collect(10:10:1_000)
    tmp = tempname()
    for s in (:ln, :log2, :log10)
        fscale = UnicodePlots.FSCALES[s]

        xs = fscale.(x)
        ys = fscale.(y)

        # xscale
        savefig(lineplot(xs, y; xlim = extrema(xs), labels = false), tmp; color = true)
        test_ref(tmp, @show_col(lineplot(x, y; xscale = s, labels = false)))

        # yscale
        savefig(lineplot(x, ys; ylim = extrema(ys), labels = false), tmp; color = true)
        test_ref(tmp, @show_col(lineplot(x, y; yscale = s, labels = false)))

        # xscale & yscale
        savefig(
            lineplot(xs, ys; xlim = extrema(xs), ylim = extrema(xs), labels = false),
            tmp;
            color = true,
        )
        test_ref(tmp, @show_col(lineplot(x, y; xscale = s, yscale = s, labels = false)))

        # xscale & yscale & labels
        test_ref(
            "lineplot/$(s)_scale.txt",
            @show_col(lineplot(x, y, xscale = s, yscale = s))
        )
    end

    # arbitrary scale functions
    for (xscale, yscale, name) in (
            (x -> x^3, identity, "xscale_x^3"),
            (identity, y -> y^3, "yscale_x^3"),
            (log10, log10, "xyscale_log10"),
        )
        test_ref(
            "lineplot/custom_$(name).txt",
            @show_col(lineplot(1:10, 1:10; xscale, yscale))
        )
    end
end

@testset "arrows" begin
    p = lineplot([0.0, 1.0], [0.0, 1.0]; head_tail = :head, name = "head", color = :red)
    lineplot!(p, [0.0, 1.0], [1.0, 0.0]; head_tail = :tail, name = "tail", color = :green)
    lineplot!(p, [0.0, 1.0], [0.5, 0.5]; head_tail = :both, name = "both", color = :blue)
    test_ref("lineplot/arrows.txt", @show_col(p))

    n = 20
    x = range(1, 2; length = n)
    p = lineplot(
        x,
        fill(0, n),
        ylim = (-1, 5),
        head_tail = :head,
        head_tail_frac = 0.05,
        name = "5%",
    )
    for (i, (frac, name)) in
        enumerate(zip((0.1, 0.15, 0.2, 0.25), ("10%", "15%", "20%", "25%")))
        lineplot!(p, x, fill(i, n); name, head_tail = :head, head_tail_frac = frac)
    end
    test_ref("lineplot/arrows_fractions.txt", @show_col(p))
end

@testset "color vector" begin
    x = [[-1, 2], [2, 3], [3, 7]]
    y = [[-1, 2], [2, 9], [9, 4]]
    p = Plot([-1, 7], [-1, 9])
    lineplot!(p, x, y, color = [:red, :green, :blue])
    test_ref("lineplot/color_vector.txt", @show_col(p))
end

@testset "units" begin
    a = 1u"m/s^2"
    t = collect(Float64, 0:100) * u"s"
    x = a / 2 * t .^ 2
    v = a * t
    p = lineplot(x, v, xlabel = "position", ylabel = "speed")
    lineplot!(p, extrema(x) |> collect, [maximum(v), maximum(v)]; color = :red)
    test_ref("lineplot/units_pos_vel.txt", @show_col(p))
end

@testset "multiple series (matrix columns)" begin
    x, y1, y2 = 0:10, [-2:8 2:12 6:16], [reverse(-4:6) reverse(8:18)]

    p = lineplot(x, y1)
    lineplot!(p, x, y2)
    test_ref("lineplot/matrix_auto.txt", @show_col(p))

    for name in (["1", "2", "3"], ["1" "2" "3"])
        p = lineplot(x, y1; name, color = [:red :green :blue])
        lineplot!(p, x, y2; name = ["4" "5"], color = [:yellow :cyan])
        test_ref("lineplot/matrix_parameters.txt", @show_col(p))
    end
end

@testset "hline - vline" begin
    p = Plot([NaN], [NaN]; xlim = (0, 8), ylim = (0, 8))
    vline!(p, [2, 6], [2, 6]; color = :red)
    hline!(p, [2, 6], [2, 6]; color = :white)

    hline!(p, 7)
    vline!(p, 1)
    test_ref("lineplot/hvline.txt", @show_col(p))
end

@testset "IntervalSets" begin
    p = lineplot(0 .. 2, identity)
    lineplot!(p, 0 .. 2, sqrt)
    test_ref("lineplot/intervalsets1.txt", @show_col(p))

    p = lineplot(0 .. 1, [sqrt, cbrt])
    test_ref("lineplot/intervalsets2.txt", @show_col(p))
end

"""
    isosurface(x, y, z, V; kw...)
    isosurface!(p, args...; kw...)

Extract and plot an isosurface from volumetric data, or a given implicit function.

# Usage

    isosurface(x, y, z, V; $(keywords((isovalue = 0, centroid = true); add = (Z_DESCRIPTION..., PROJ_DESCRIPTION..., :canvas), remove = (:blend, :grid, :name, :xscale, :yscale))))

# Arguments

$(
    arguments(
        (
            V = "`Array` (volume) of interest for which a surface is extracted, or `Function` evaluated as `f(x, y, z)`",
            isovalue = "chosen surface isovalue",
            cull = "cull (hide) back faces",
            legacy = "use the legacy Marching Cubes algorithm instead of the topology enhanced algorithm",
            centroid = "display triangulation centroid instead of triangle vertices",
        ); add = (Z_DESCRIPTION..., PROJ_DESCRIPTION..., :x, :y, :z, :canvas), remove = (:blend, :grid, :xscale, :yscale)
    )
)

# Author(s)

- T Bltg (github.com/t-bltg)

# Examples

```julia-repl
julia> torus(x, y, z, r = .2, R = .5) = (√(x^2 + y^2) - R)^2 + z^2 - r^2
julia> isosurface(-1:.1:1, -1:.1:1, -1:.1:1, torus, elevation = 50, zoom = 2, cull = true)
    ┌────────────────────────────────────────┐
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⢀⢀⠠⢄⢄⠄⠄⡠⡠⠤⡀⡀⡀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⡀⠔⠌⠜⠀⠡⠠⠁⠡⠠⠁⠈⠄⠌⠈⠄⠌⠀⠪⠠⠤⡀⡀⠀⠀⠀⠀⠀⠀⠀⠀│
    │⠀⠀⠀⠀⠀⠀⡠⠔⠅⠌⠈⠄⠌⠀⡁⡀⠨⡀⠄⠠⠡⠠⡀⠥⠠⠈⠀⠡⠠⠁⠡⠱⠢⡀⠀⠀⠀⠀⠀⠀│
    │⠀⠀⠀⠀⢀⣜⠃⡁⠄⢊⠈⠄⡰⠐⡀⢂⡞⢈⡰⡨⡂⢆⡁⣱⠔⢁⠘⢀⠠⠁⡑⠠⢈⠘⣲⡀⠀⠀⠀⠀│
    │⠀⠀⠀⠀⡚⠥⠁⡀⠂⢂⠈⠄⡖⡫⠗⠋⠉⠀⠀⠀⠀⠀⠈⠉⠉⠱⢝⠱⠠⠁⡐⠐⢀⠈⢌⢧⠀⠀⠀⠀│
    │⠀⠀⠀⠀⡟⠤⠁⡀⠂⢂⢈⠄⢮⡇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢸⡿⠠⡁⡐⠐⢀⠈⢤⢚⠀⠀⠀⠀│
    │⠀⠀⠀⠀⢽⠗⠅⡀⠂⢂⢀⠂⢂⠓⡢⡄⣀⠀⠀⠀⠀⠀⢀⡀⢀⢰⠂⡑⠐⡀⡐⠐⠀⠨⢔⡟⠀⠀⠀⠀│
    │⠀⠀⠀⠀⠈⠭⠄⠌⠰⠀⡀⠂⢂⠀⡐⠐⠌⠔⠑⠅⠡⠊⠢⠡⠂⢂⠀⡐⠐⣀⠐⠠⡁⡃⡑⠁⠀⠀⠀⠀│
    │⠀⠀⠀⠀⠀⠀⠈⠨⠅⠄⠌⠀⡆⢀⠐⠐⢀⠐⠐⠀⠄⠂⠂⡀⠂⡂⡀⠂⢂⠀⡂⢐⠔⠈⠀⠀⠀⠀⠀⠀│
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠈⠢⢥⢀⡂⡃⠇⠃⡁⡡⠨⡈⡨⠈⠬⠨⠢⢈⢠⠑⠒⠈⠀⠀⠀⠀⠀⠀⠀⠀⠀│
    │⠀⠀⠀⢠⠀⠀⠀⠀⠀⠀⠀⠀⠀⠈⠈⠋⠓⠂⠊⠒⠂⠚⠘⠚⠙⠉⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
    │⠀⠀⣀⠼⢄⡀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
    │⠔⠉⠀⠀⠀⠈⠑⠄⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
    └────────────────────────────────────────┘
```

# See also

`Plot`, `MVP`, `surfaceplot`, `BrailleCanvas`
"""
function isosurface(
        x::AbstractVector,
        y::AbstractVector,
        z::AbstractVector,
        V::Union{Function, AbstractArray};
        canvas::Type = BrailleCanvas,
        kw...,
    )
    pkw, okw = split_plot_kw(kw)
    V isa Function && (V = V.(x, y', reshape(z, 1, 1, length(z))))

    plot = Plot(
        map(collect ∘ extrema, (x, y, z))...,
        canvas;
        projection = KEYWORDS.projection,
        labels = false,
        pkw...,
    )
    return isosurface!(plot, x, y, z, V; okw...)
end

@doc (@doc isosurface) function isosurface!(
        plot::Plot{<:Canvas},
        x::AbstractVector,
        y::AbstractVector,
        z::AbstractVector,
        V::AbstractArray;
        color::UserColorType = KEYWORDS.color,
        isovalue::Number = 0,
        centroid::Bool = true,
        legacy::Bool = false,
        cull::Bool = false,
    )
    F = float(promote_type(eltype(x), eltype(y), eltype(z), eltype(V)))

    mc = MarchingCubes.MC(V, Int; x = collect(F, x), y = collect(F, y), z = collect(F, z))
    if legacy
        MarchingCubes.march_legacy(mc, isovalue)
    else
        MarchingCubes.march(mc, isovalue)
    end

    ntri = length(mc.triangles)
    npts = centroid ? ntri : 3ntri
    X, Y, Z = map(_ -> sizehint!(F[], npts), 1:3)
    C = sizehint!(ColorType[], npts)

    color = ansi_color(color ≡ :auto ? next_color!(plot) : color)
    @inbounds for (i1, i2, i3) in mc.triangles
        (i1 ≤ 0 || i2 ≤ 0 || i3 ≤ 0) && continue  # invalid triangle
        back_face = (
            dot(mc.normals[i1], plot.projection.view_dir) < 0 &&
                dot(mc.normals[i2], plot.projection.view_dir) < 0 &&
                dot(mc.normals[i3], plot.projection.view_dir) < 0
        )
        (cull && back_face) && continue
        v1 = mc.vertices[i1]
        v2 = mc.vertices[i2]
        v3 = mc.vertices[i3]
        vc = back_face ? complement(color) : color
        if centroid
            push!(X, (v1[1] + v2[1] + v3[1]) / 3)
            push!(Y, (v1[2] + v2[2] + v3[2]) / 3)
            push!(Z, (v1[3] + v2[3] + v3[3]) / 3)
            push!(C, vc)
        else
            push!(X, v1[1], v2[1], v3[1])
            push!(Y, v1[2], v2[2], v3[2])
            push!(Z, v1[3], v2[3], v3[3])
            push!(C, vc, vc, vc)
        end
    end
    # triangles vertices or centroid
    return points!(plot, X, Y, Z, C, falses(length(X)))
end

@testset "simple" begin
    p = polarplot(range(0, 2π, length = 20), range(0, 2, length = 20))
    test_ref("polarplot/simple.txt", @show_col(p))
end

@testset "simple with 𝓇lim" begin
    p = polarplot(range(0, 2π, length = 20), range(0, 2, length = 20), rlim = (0, 3))
    test_ref("polarplot/simple_with_rlim.txt", @show_col(p))
end

@testset "callable" begin
    p = polarplot(range(0, 4π, length = 40), θ -> θ ./ 2π)
    test_ref("polarplot/callable.txt", @show_col(p))
end

@testset "kwargs" begin
    h, w = map(x -> round(Int, 1.5x), default_size!())
    p = polarplot(
        range(0, 2π, length = 20),
        range(0, 1, length = 20);
        scatter = true,
        border = :solid,  # override
        color = :red,
        height = h,
        width = w,
    )
    @test nrows(p.graphics) == h
    @test ncols(p.graphics) == w
    test_ref("polarplot/kwargs.txt", @show_col(p))
end

seed!(RNG, 1_337)
x = randn(RNG, 4_000)

@testset "default params" begin
    p = histogram(x)
    test_ref("histogram/default.txt", @print_col(p))
    test_ref("histogram/default_nocolor.txt", @print_nocol(p))
    p = histogram(x, closed = :left)
    test_ref("histogram/default.txt", @print_col(p))
    hist = fit(Histogram, x, closed = :left)
    p = horizontal_histogram(hist)
    test_ref("histogram/default.txt", @print_col(p))
    p = histogram(x * 100)
    test_ref("histogram/default_1e2.txt", @print_col(p))
    p = histogram(x * 0.01)
    test_ref("histogram/default_1e-2.txt", @print_col(p))
    p = histogram(x, xscale = :log10)
    test_ref("histogram/log10.txt", @print_col(p))
    p = histogram(x, xlabel = "custom label", xscale = :log10)
    test_ref("histogram/log10_label.txt", @print_col(p))
    p = histogram([0.1f0, 0.1f0, 0.0f0])
    test_ref("histogram/float32.txt", @print_col(p))
    p = horizontal_histogram(Histogram([0.0, 0.1, 1.0, 10.0, 100.0], [1, 2, 3, 4]))
    test_ref("histogram/nonuniformbins.txt", @print_col(p))
    x2 = copy(reshape(x, 1, length(x), 1, 1))
    p = histogram(x2)
    test_ref("histogram/default.txt", @print_col(p))
    p = horizontal_histogram(Histogram(1:15.0, vcat(collect(1:13), 400)))
    test_ref("histogram/fraction.txt", @print_col(p))
end

@testset "hist params" begin
    hist = fit(Histogram, x, nbins = 5, closed = :right)
    p = horizontal_histogram(hist)
    test_ref("histogram/hist_params.txt", @print_col(p))
    p = histogram(x, nbins = 5, closed = :right)
    test_ref("histogram/hist_params.txt", @print_col(p))
end

@testset "keyword arguments" begin
    p = histogram(
        x,
        title = "My Histogram",
        xlabel = "Absolute Frequency",
        color = :blue,
        margin = 7,
        padding = 3,
    )
    test_ref("histogram/parameters1.txt", @print_col(p))
    p = histogram(
        x,
        title = "My Histogram",
        xlabel = "Absolute Frequency",
        color = :blue,
        margin = 7,
        padding = 3,
        labels = false,
    )
    test_ref("histogram/parameters1_nolabels.txt", @print_col(p))

    for symbols in (["="], ['='], tuple("="), tuple('='))
        p = histogram(
            x,
            title = "My Histogram",
            xlabel = "Absolute Frequency",
            color = :yellow,
            border = :solid,
            symbols = symbols,
            width = 50,
        )
        test_ref("histogram/parameters2.txt", @print_col(p))
    end

    # colors
    p = histogram(x, title = "Gray color", color = 240)
    test_ref("histogram/col1.txt", @print_col(p))

    p = histogram(x, title = "Green color", color = (0, 135, 95))
    test_ref("histogram/col2.txt", @print_col(p))
end

@testset "vertical - normal distribution" begin
    p = histogram(x; vertical = true, nbins = 100)
    test_ref("histogram/vert1.txt", @print_col(p))
end

@testset "vertical" begin
    n = 30
    dat = Float64[]
    foreach(i -> append!(dat, repeat([i], i)), 1:n)
    p = histogram(dat; vertical = true, nbins = n)
    test_ref("histogram/vert2.txt", @print_col(p))
end

@testset "aspect ratio" begin
    seed!(RNG, 1_337)
    for i in 1:minimum(T_SZ)
        @test heatmap(rand(i, i)).graphics.grid |> size == (i, i)
    end
    p = @hinf heatmap(collect(1:30) * collect(1:30)'; fix_ar = true)
    test_ref("heatmap/fix_aspect_ratio_30x30.txt", @show_col(p, :displaysize => T_SZ))
end

@testset "integer values" begin
    x = repeat(collect(1:20), outer = (1, 20))
    p = @hinf heatmap(x)
    test_ref(
        "heatmap/integers_$(size(x, 1))x$(size(x, 2)).txt",
        @show_col(p, :displaysize => T_SZ)
    )
end

@testset "all zero values" begin
    x = zeros(20, 20)
    p = @hinf heatmap(x)
    test_ref(
        "heatmap/zeros_$(size(x, 1))x$(size(x, 2)).txt",
        @show_col(p, :displaysize => T_SZ)
    )
end

@testset "color maps" begin
    x = collect(0:30) * collect(0:30)'

    for colormap in (:viridis, :inferno, :plasma, :magma, :cividis, :grays, :jet1)
        p = @hinf heatmap(x; colormap)
        test_ref(
            "heatmap/colormap_$(size(x, 1))x$(size(x, 2))_$colormap.txt",
            @show_col(p, :displaysize => T_SZ)
        )
    end

    p = @hinf heatmap(x; colormap = reverse(UnicodePlots.ColorSchemes.jet1.colors))
    test_ref(
        "heatmap/colormap_$(size(x, 1))x$(size(x, 2))_reverse_jet.txt",
        @show_col(p, :displaysize => T_SZ)
    )

    seed!(RNG, 1_337)
    rgb = rand(RNG, 20, 20, 3)
    img = RGB.(rgb[:, :, 1], rgb[:, :, 2], rgb[:, :, 3])
    p = @hinf heatmap(img)  # RGB Matrix
    test_ref("heatmap/colormap_rgb.txt", @show_col(p, :displaysize => T_SZ))
end

@testset "squareness (aspect ratio)" begin
    seed!(RNG, 1_337)
    for m in 1:minimum(T_SZ)
        p = @hinf heatmap(randn(RNG, m, m))
        @test size(p.graphics.grid) == (m, m)
    end
    for m in minimum(T_SZ):maximum(T_SZ)
        p = @hinf heatmap(randn(RNG, m, m))
        s1, s2 = size(p.graphics.grid)
        @test s1 == s2
    end
end

@testset "array display convention" begin
    p = @hinf heatmap(collect(1:20) * collect(1:20)'; array = true, fix_ar = true)
    test_ref("heatmap/array_convention.txt", @show_col(p, :displaysize => T_SZ))
end

@testset "sizing" begin
    for dims in (
            (0, 0),
            (1, 1),
            (2, 1),
            (1, 2),
            (2, 2),
            (3, 6),
            (6, 3),
            (9, 4),
            (4, 9),
            (5, 0),
            (0, 5),
            (5, 1),
            (1, 5),
            (10, 0),
            (0, 10),
            (6, 8),
            (8, 6),
            (10, 10),
            (10, 15),
            (15, 10),
            (60, 60),
            (200, 20),
            (20, 200),
        )
        seed!(RNG, 1_337)
        p = @hinf heatmap(randn(RNG, dims); labels = false)
        @test p isa Plot
        test_ref(
            "heatmap/default_$(dims[1])x$(dims[2]).txt",
            @show_col(p, :displaysize => T_SZ)
        )
    end
end

kw2str(kw) = replace(
    replace(join(("$(k)_$(v)" for (k, v) in pairs(kw)), '_'), r"[\[\]\(\),]" => ""),
    ' ' => '_',
)

@testset "axis scaling" begin
    x = repeat(collect(0:10), outer = (1, 11))

    for kw in (
            (; xfact = 0.1),
            (; yfact = 0.1),
            (; xfact = 0.1, xoffset = -0.5),
            (; yfact = 0.1, yoffset = -0.5),
            (; xfact = 0.1, xoffset = -0.5, yfact = 10, yoffset = -50),
        )
        p = @hinf heatmap(x; kw...)
        test_ref(
            "heatmap/scaling_$(size(x, 1))x$(size(x, 2))_$(kw2str(kw)).txt",
            @show_col(p, :displaysize => T_SZ)
        )
    end
end

@testset "axis limits" begin
    x = collect(0:30) * collect(0:30)'

    for kw in (
            (; ylim = (10, 20)),
            (; ylim = (50, 50)),
            (; ylim = (1, 50)),
            (; xlim = (10, 20)),
            (; xlim = (50, 60)),
            (; xlim = (1, 50)),
            (; xlim = (10, 20), ylim = (10, 20)),
            (; xlim = (1, 50), ylim = (1, 50)),
            (; xlim = (0, 0.1), xfact = 0.01),
            (; ylim = (0, 0.1), yfact = 0.01),
            (; xlim = (0, 0.1), xfact = 0.01, ylim = (0.1, 0.2), yfact = 0.01),
            (; zlim = (0, 2maximum(x))),
        )
        p = @hinf heatmap(x; kw...)
        test_ref(
            "heatmap/limits_$(size(x, 1))x$(size(x, 2))_$(kw2str(kw)).txt",
            @show_col(p, :displaysize => T_SZ)
        )
    end
end

@testset "parameters" begin
    seed!(RNG, 1_337)
    x = randn(RNG, 60, 60)
    for kw in (
            (; colorbar = false),
            (; labels = false),
            (; title = "hmap", zlabel = "lab", colorbar_border = :ascii, colormap = :inferno),
        )
        p = @hinf heatmap(x; kw...)
        test_ref(
            "heatmap/parameters_$(size(x, 1))x$(size(x, 2))_$(kw2str(kw)).txt",
            @show_col(p, :displaysize => T_SZ)
        )
    end

    for sz in ((10, 10), (10, 11))
        seed!(RNG, 1_337)
        x = randn(RNG, sz...)
        for kw in ((; xfact = 0.1), (; yfact = 1))
            p = @hinf heatmap(x; kw...)
            test_ref(
                "heatmap/parameters_$(size(x, 1))x$(size(x, 2))_$(kw2str(kw)).txt",
                @show_col(p, :displaysize => T_SZ)
            )
        end
    end
end

"""
    lineplot(; kw...)
    lineplot(y; kw...)
    lineplot(x, y; kw...)
    lineplot!(p, args...; kw...)

# Description

Draws a path through the given points on a new canvas.

The first (optional) vector `x` should contain the horizontal positions for all the points along the path.
The second vector `y` should then contain the corresponding vertical positions respectively.
This means that the two vectors must be of the same length and ordering.

# Usage

    lineplot([x], y; $(keywords((; head_tail = nothing, head_tail_frac = 5 / 100); add = (:canvas,))))
    lineplot([start], [stop], fun; kw...)

# Arguments

$(
    arguments(
        (
            fun = "a unary function ``f: R -> R`` that should be evaluated, and drawn as a path from `start` to `stop` (numbers in the domain)",
            head_tail = "color the line head and/or tail with the complement of the chosen color (`:head`, `:tail`, `:both`)",
            head_tail_frac = "fraction of the arrow head or tail (e.g. provide `0.1` for 10%)",
            x = "horizontal position for each point (can be a real number or of type `TimeType`), if omitted, the axes of `y` will be used as `x`",
            format = "specify the ticks date format (`TimeType` only)",
            color = "`Vector` of colors, or scalar - $(DESCRIPTION[:color])",
        ); add = (:x, :y, :canvas)
    )
)

# Author(s)

- Christof Stocker (github.com/Evizero)
- Milktrader (github.com/milktrader)

# Examples

```julia-repl
julia> lineplot([1, 2, 7], [9, -6, 8]; title = "My Lineplot")
       ⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀My Lineplot⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
       ┌────────────────────────────────────────┐
    10 │⡀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⢇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠│
       │⠘⡄⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠤⠊⠁⠀│
       │⠀⢣⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⣀⠔⠊⠁⠀⠀⠀⠀│
       │⠀⠈⡆⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⣀⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⢸⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡠⠔⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⢇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠒⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠤⠤⠤⠼⡤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⢤⠤⠶⠥⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤│
       │⠀⠀⠀⠀⢣⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠤⠊⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⠀⠈⡆⠀⠀⠀⠀⠀⠀⠀⣀⠔⠊⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⠀⠀⢱⠀⠀⠀⠀⡠⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⠀⠀⠀⢇⡠⠔⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⠀⠀⠀⠈⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
   -10 │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       └────────────────────────────────────────┘
       ⠀1⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀7⠀
```

# See also

[`Plot`](@ref), [`scatterplot`](@ref), [`stairs`](@ref),
[`BrailleCanvas`](@ref), [`BlockCanvas`](@ref),
[`AsciiCanvas`](@ref), [`DotCanvas`](@ref)
"""
function lineplot(
        x::AbstractVector,
        y::AbstractVector,
        z::Union{AbstractVector, Nothing} = nothing;
        canvas::Type = KEYWORDS.canvas,
        kw...,
    )
    pkw, okw = split_plot_kw(kw)
    return lineplot!(Plot(x, y, z, canvas; pkw...), x, y, z; okw...)
end

lineplot(; kw...) = lineplot([]; kw...)
lineplot(y::AbstractVector; kw...) = lineplot(axes(y, 1), y; kw...)

@doc (@doc lineplot) function lineplot!(
        plot::Plot{<:Canvas},
        x::AbstractVector,
        y::AbstractVector,
        z::Union{AbstractVector, Nothing} = nothing;
        color::Union{UserColorType, AbstractVector} = KEYWORDS.color,
        name::AbstractString = KEYWORDS.name,
        head_tail::Union{Nothing, Symbol} = nothing,
        head_tail_frac::Number = 5 / 100,
    )
    color = color ≡ :auto ? next_color!(plot) : color
    col_vec = color isa AbstractVector
    isempty(name) || label!(plot, :r, string(name), col_vec ? first(color) : color)
    (nx = length(x)) == length(y) ||
        throw(ArgumentError("`x`, `y` must be the same length"))
    if col_vec
        nx == length(color) ||
            throw(ArgumentError("`x`, `y` and `color` must be the same length"))
        @inbounds for i in eachindex(color)
            lines!(plot, x[i], y[i], z ≡ nothing ? z : z[i]; color = color[i])
        end
    else
        lines!(plot, x, y, z; color)
    end
    (head_tail ≡ nothing || nx == 0) && return plot

    n = min(round(Int, head_tail_frac * nx, RoundToZero), nx - 1)
    callable = n > 0 ? lines! : points!
    if head_tail ∈ (:head, :both)
        callable(
            plot,
            x[(end - n):end],
            y[(end - n):end],
            z ≡ nothing ? z : z[(end - n):end];
            color = complement(col_vec ? color[(end - n):end] : color),
        )
    end
    if head_tail ∈ (:tail, :both)
        callable(
            plot,
            x[begin:(begin + n)],
            y[begin:(begin + n)],
            z ≡ nothing ? z : z[begin:(begin + n)];
            color = complement(col_vec ? color[begin:(begin + n)] : color),
        )
    end
    plot.series[] += 1
    return plot
end

lineplot!(plot::Plot{<:Canvas}, y::AbstractVector; kw...) =
    lineplot!(plot, axes(y, 1), y; kw...)

# ---------------------------------------------------------------------------- #
# multiple series
function lineplot(x::AbstractVector, y::AbstractMatrix; kw...)
    names, colors = multiple_series_defaults(y, kw, 1)
    plot = lineplot(
        x,
        y[:, begin];
        ylim = extrema(y),
        name = first(names),
        color = first(colors),
        filter(a -> a.first ∉ (:name, :color), kw)...,
    )
    for (i, (name, color, ys)) in enumerate(zip(names, colors, eachcol(y)))
        i == 1 && continue
        lineplot!(plot, x, ys; name, color)
    end
    return plot
end

function lineplot!(plot::Plot{<:Canvas}, x::AbstractVector, y::AbstractMatrix; kw...)
    names, colors = multiple_series_defaults(y, kw, plot.series[] + 1)
    for (name, color, ys) in zip(names, colors, eachcol(y))
        lineplot!(plot, x, ys; name, color)
    end
    return plot
end

# ---------------------------------------------------------------------------- #
# date time

format_date(dt, ::Nothing) = string(dt)
format_date(dt, format::AbstractString) = Dates.format(dt, format)

function lineplot(
        x::AbstractVector{D},
        y::AbstractVector;
        format::Union{Nothing, AbstractString} = nothing,
        xlim = extrema(x),
        xticks = true,
        kw...,
    ) where {D <: TimeType}
    dlim = (Dates.value ∘ D).(xlim)
    plot = lineplot(Dates.value.(x), y; xlim = dlim, xticks = xticks, kw...)
    if xticks
        label!(plot, :bl, format_date(xlim[1], format); color = BORDER_COLOR[])
        label!(plot, :br, format_date(xlim[2], format); color = BORDER_COLOR[])
    end
    return plot
end

lineplot!(plot::Plot{<:Canvas}, x::AbstractVector{<:TimeType}, y::AbstractVector; kw...) =
    lineplot!(plot, Dates.value.(x), y; kw...)

# ---------------------------------------------------------------------------- #
# slope and intercept
function lineplot!(plot::Plot{<:Canvas}, intercept::Number, slope::Number; kw...)
    xmin = origin_x(plot.graphics)
    xmax = origin_x(plot.graphics) + width(plot.graphics)
    ymin = origin_y(plot.graphics)
    ymax = origin_y(plot.graphics) + height(plot.graphics)
    return lineplot!(
        plot,
        [xmin, xmax],
        [intercept + xmin * slope, intercept + xmax * slope];
        kw...,
    )
end

# ---------------------------------------------------------------------------- #
# functions
lineplot(
    x::AbstractVector{<:Number},
    f::Function;
    name = KEYWORDS.name,
    xlabel = "x",
    ylabel = "f(x)",
    kw...,
) = lineplot(x, (float ∘ f).(x); name = function_name(f, name), xlabel, ylabel, kw...)

function lineplot(startx::Number, endx::Number, f::Function; kw...)
    _, width = plot_size(; kw...)
    x = startx:(abs(endx - startx) / 3width):endx
    return lineplot(x, f; width, kw...)
end

lineplot(f::Function; kw...) = lineplot(-10, 10, f; kw...)

lineplot!(
    plot::Plot{<:Canvas},
    x::AbstractVector{<:Number},
    f::Function;
    name = KEYWORDS.name,
    kw...,
) = lineplot!(plot, x, (float ∘ f).(x); name = function_name(f, name), kw...)

lineplot!(plot::Plot{<:Canvas}, f::Function; kw...) = lineplot!(
    plot,
    origin_x(plot.graphics),
    origin_x(plot.graphics) + width(plot.graphics),
    f;
    kw...,
)

function lineplot!(plot::Plot{<:Canvas}, startx::Number, endx::Number, f::Function; kw...)
    x = startx:(abs(endx - startx) / 3ncols(plot.graphics)):endx
    return lineplot!(plot, x, f; kw...)
end

# ---------------------------------------------------------------------------- #
# vector of functions
lineplot(F::AbstractVector{<:Function}; kw...) = lineplot(-10, 10, F; kw...)

lineplot(startx::Number, endx::Number, F::AbstractVector{<:Function}; kw...) =
    _lineplot((startx, endx), F; kw...)

lineplot(x::AbstractVector{<:Number}, F::AbstractVector{<:Function}; kw...) =
    _lineplot((x,), F; kw...)

function _lineplot(args, F::AbstractVector{<:Function}; color = :auto, name = "", kw...)
    (n = length(F)) > 0 || throw(ArgumentError("cannot plot empty array of functions"))
    color_is_vec = color isa AbstractVector
    name_is_vec = name isa AbstractVector
    if color_is_vec
        length(color) == n ||
            "`color` must be a symbol or same length as the function vector" |>
            DimensionMismatch |>
            throw
    end
    if name_is_vec
        length(name) == n ||
            "`name` must be a string or same length as the function vector" |>
            DimensionMismatch |>
            throw
    end
    tcolor = color_is_vec ? first(color) : color
    tname = name_is_vec ? first(name) : name
    plot = lineplot(args..., first(F); color = tcolor, name = tname, kw...)
    for i in eachindex(F)
        i == 1 && continue
        tcolor = color_is_vec ? color[i] : color
        tname = name_is_vec ? name[i] : name
        lineplot!(plot, args..., F[i]; color = tcolor, name = tname)
    end
    return plot
end

# ---------------------------------------------------------------------------- #
# helpers

"""
    vline!(plot::Plot{<:Canvas}, x::Number, y::Union{AbstractVector{<:Number},Nothing} = nothing; kw...)

Draws a vertical line at position `x` (and optional `y` values).
"""
function vline!(
        plot::Plot{<:Canvas},
        x::Number,
        y::Union{AbstractVector{<:Number}, Nothing} = nothing;
        kw...,
    )
    o = origin_y(plot.graphics)
    ys = something(y, range(o, o + height(plot.graphics); length = nrows(plot.graphics)))
    return lineplot!(plot, fill(x, length(ys)), ys; kw...)
end

"""
    vline!(plot::Plot{<:Canvas}, x::AbstractVector{<:Number}, y::Union{AbstractVector{<:Number},Nothing} = nothing; kw...)

Draws vertical lines at positions given in `x` (and optional `y` values).
"""
function vline!(
        plot::Plot{<:Canvas},
        x::AbstractVector{<:Number},
        y::Union{AbstractVector{<:Number}, Nothing} = nothing;
        kw...,
    )
    foreach(v -> vline!(plot, v, y; kw...), x)
    return plot
end

"""
    hline!(plot::Plot{<:Canvas}, y::Number, x::Union{AbstractVector{<:Number},Nothing} = nothing; kw...)

Draws an horizontal line at position `y` (and optional `x` values).
"""
function hline!(
        plot::Plot{<:Canvas},
        y::Number,
        x::Union{AbstractVector{<:Number}, Nothing} = nothing;
        kw...,
    )
    o = origin_x(plot.graphics)
    xs = something(x, range(o, o + width(plot.graphics); length = ncols(plot.graphics)))
    return lineplot!(plot, xs, fill(y, length(xs)); kw...)
end

"""
    hline!(plot::Plot{<:Canvas}, y::AbstractVector{<:Number}, x::Union{AbstractVector{<:Number},Nothing} = nothing; kw...)

Draws horizontal lines at positions given in `y` (and optional `x` values).
"""
function hline!(
        plot::Plot{<:Canvas},
        y::AbstractVector{<:Number},
        x::Union{AbstractVector{<:Number}, Nothing} = nothing;
        kw...,
    )
    foreach(v -> hline!(plot, v, x; kw...), y)
    return plot
end

@testset "show" begin
    io = IOContext(PipeBuffer(), :color => false)

    # test padding (NOTE: @check_padidng embedded in @show_col)
    @show_col scatterplot(1:2, labels = false)

    @show_col scatterplot(1:2, labels = false, title = "scatterplot")

    @show_col scatterplot(1:2, title = "scatterplot", xlabel = "x")

    @show_col scatterplot(1:2, title = "scatterplot", xlabel = "x", compact = true)

    A = repeat(collect(0:10)', outer = (11, 1))
    # complex right padding, with colorbar and limit labels
    for zlabel in ("zlab", ""), n in 1:10
        @show_col heatmap(A; margin = 0, title = "fancy", zlabel, zlim = (1, 10^n))
    end
end

@testset "savefig" begin
    font_found = UnicodePlots.get_font_face() ≢ nothing  # `PkgEval` can fail
    for p in (
            lineplot(-π / 2, 2π, [cos, sin, x -> 0.5, x -> -0.5], title = "fancy title"),
            barplot([:a, :b, :c, :d, :e], [20, 30, 60, 50, 40]),
        )
        for bbox in (nothing, :red), tr in (true, false)
            tmp = tempname() * ".png"

            savefig(
                p,
                tmp;
                transparent = tr,
                bounding_box_glyph = bbox,
                bounding_box = bbox,
            )

            if font_found
                @test filesize(tmp) > 1_000

                img = FileIO.load(tmp)
                @test all(size(img) .> (100, 100))
            end
        end

        @test_throws ArgumentError savefig(p, tempname() * ".jpg")
    end

    # for Plots
    if font_found
        p = lineplot(1:2)
        tmp = tempname() * ".png"
        open(tmp, "w") do io
            UnicodePlots.save_image(io, UnicodePlots.png_image(p))
        end
        @test filesize(tmp) > 1_000
    end
end

macro measure(ex, tol, versioned)
    return quote
        base_tol = is_ci() ? 2 : 1.25
        @test string($ex; color = true) isa String  # 1st pass - ttfp
        if (
                UnicodePlots.get_have_truecolor() &&
                    (STABLE || PRE) &&
                    Sys.islinux() &&
                    !is_pkgeval()
            )
            n = 10
            kb = fill(0.0, n)
            ms = fill(0.0, n)
            GC.enable(false)
            for i in 1:n
                stats = @timed string($ex; color = true)  # repeated !
                kb[i] = stats.bytes / 1_000
                ms[i] = stats.time * 1_000
                # sleep(1e-2 + rand() / i)
            end
            GC.enable(true)
            key = VersionNumber(VERSION.major, VERSION.minor)
            dct = $versioned
            if haskey(dct, key)
                kbytes, msecs = dct[key]
                avg_kb = round(Int, sum(kb) / n, RoundUp)
                avg_ms = round(sum(ms) / n; digits = 3)
                @show (VERSION, (avg_kb, avg_ms), (kbytes, msecs))
                @test avg_kb ≤ kbytes
                @test avg_ms < $tol * base_tol * msecs
            else
                @warn "missing info for $VERSION ($kb, $ms) !"
            end
        end
    end |> esc
end

sombrero(x, y) = 30sinc(√(x^2 + y^2) / π)

@testset "stringify plot - performance regression" begin
    let c = BrailleCanvas(15, 40)
        lines!(c, 0.0, 1.0, 0.5, 0.0)
        @measure c 1 Dict(
            v"1.10" => (20, 0.031),
            v"1.11" => (18, 0.025),
            v"1.12" => (19, 0.041),
        )
    end

    let c = BrailleCanvas(15, 40)
        lines!(c, 0.0, 1.0, 0.5, 0.0; color = :green)
        @measure c 1 Dict(
            v"1.10" => (28, 0.039),
            v"1.11" => (24, 0.03),
            v"1.12" => (28, 0.042),
        )
    end

    let p = lineplot(1:10)
        @measure p 1 Dict(
            v"1.10" => (50, 0.07),
            v"1.11" => (44, 0.061),
            v"1.12" => (60, 0.045),
        )
    end

    let p = heatmap(collect(1:15) * collect(1:15)')
        @measure p 1 Dict(
            v"1.10" => (153, 0.106),
            v"1.11" => (182, 0.178),
            v"1.12" => (268, 0.16),
        )
    end

    let p = surfaceplot(-8:0.5:8, -8:0.5:8, sombrero; axes3d = false)
        @measure p 1 Dict(
            v"1.10" => (152, 0.142),
            v"1.11" => (124, 0.122),
            v"1.12" => (226, 0.106),
        )
    end
end

@testset "Term extension" begin
    show(devnull, gridplot(map(i -> lineplot((-i):i), 1:5); show_placeholder = true))
    show(devnull, gridplot(map(i -> lineplot((-i):i), 1:3); layout = (2, nothing)))
    show(devnull, gridplot(map(i -> lineplot((-i):i), 1:3); layout = (nothing, 1)))
end

@testset "Aqua" begin
    # JuliaTesting/Aqua.jl/issues/77
    Aqua.test_all(
        UnicodePlots;
        ambiguities = false,
        deps_compat = false,
        stale_deps = false,
    )
    Aqua.test_ambiguities(UnicodePlots)
end

const KWARGS = Union{NamedTuple, <:AbstractDict}

const BLANK = 0x0020
const BLANK_BRAILLE = 0x2800
const FULL_BRAILLE = 0x28ff

const BORDER_SOLID = (
    tl = '┌',
    tr = '┐',
    bl = '└',
    br = '┘',
    t = '─',
    l = '│',
    b = '─',
    r = '│',
)
const BORDER_CORNERS = (
    tl = '┌',
    tr = '┐',
    bl = '└',
    br = '┘',
    t = ' ',
    l = ' ',
    b = ' ',
    r = ' ',
)
const BORDER_BARPLOT = (
    tl = '┌',
    tr = '┐',
    bl = '└',
    br = '┘',
    t = ' ',
    l = '┤',
    b = ' ',
    r = ' ',
)
const BORDER_BOLD = (
    tl = '┏',
    tr = '┓',
    bl = '┗',
    br = '┛',
    t = '━',
    l = '┃',
    b = '━',
    r = '┃',
)
const BORDER_NONE = (
    tl = ' ',
    tr = ' ',
    bl = ' ',
    br = ' ',
    t = ' ',
    l = ' ',
    b = ' ',
    r = ' ',
)
const BORDER_BNONE = (
    tl = Char(BLANK_BRAILLE),
    tr = Char(BLANK_BRAILLE),
    bl = Char(BLANK_BRAILLE),
    br = Char(BLANK_BRAILLE),
    t = Char(BLANK_BRAILLE),
    l = Char(BLANK_BRAILLE),
    b = Char(BLANK_BRAILLE),
    r = Char(BLANK_BRAILLE),
)
const BORDER_DASHED = (
    tl = '┌',
    tr = '┐',
    bl = '└',
    br = '┘',
    t = '╌',
    l = '┊',
    b = '╌',
    r = '┊',
)
const BORDER_DOTTED = (
    tl = '⡤',
    tr = '⢤',
    bl = '⠓',
    br = '⠚',
    t = '⠤',
    l = '⡇',
    b = '⠒',
    r = '⢸',
)
const BORDER_ASCII = (
    tl = '+',
    tr = '+',
    bl = '+',
    br = '+',
    t = '-',
    l = '|',
    b = '-',
    r = '|',
)
const BORDERMAP = (
    solid = BORDER_SOLID,
    corners = BORDER_CORNERS,
    barplot = BORDER_BARPLOT,
    bold = BORDER_BOLD,
    none = BORDER_NONE,
    bnone = BORDER_BNONE,
    dashed = BORDER_DASHED,
    dotted = BORDER_DOTTED,
    ascii = BORDER_ASCII,
)

const MARKERS = (
    circle = '⚬',
    rect = '▫',
    diamond = '◇',
    hexagon = '⬡',
    cross = '✚',
    xcross = '✖',
    utriangle = '△',
    dtriangle = '▽',
    rtriangle = '▷',
    ltriangle = '◁',
    pentagon = '⬠',
    star4 = '✦',
    star5 = '★',
    star6 = '✶',
    star8 = '✴',
    vline = '|',
    hline = '―',
    (+) = '+',
    (x) = '⨯',
)
const SUPERSCRIPT = Dict(
    # '.' => '‧',  # U+2027: Hyphenation Point
    # '.' => '˙',  # U+02D9: Dot Above
    # '.' => '⸳',  # U+2E33: Raised Dot
    # '.' => '⋅',  # U+22C5: Dot Operator
    # '.' => '·',  # U+00B7: Middle Dot
    '.' => '⸱',  # U+2E31: Word Separator Middle Dot
    '-' => '⁻',
    '+' => '⁺',
    '0' => '⁰',
    '1' => '¹',
    '2' => '²',
    '3' => '³',
    '4' => '⁴',
    '5' => '⁵',
    '6' => '⁶',
    '7' => '⁷',
    '8' => '⁸',
    '9' => '⁹',
    'e' => 'ᵉ',
)

############################################################################################
# define types
const MarkerType = Union{Symbol, AbstractChar, AbstractString}
const CrayonColorType = Union{Integer, Symbol, NTuple{3, Integer}, Nothing}
const UserColorType = Union{Crayon, CrayonColorType}  # allowed color type
const ColorType = UInt32  # internal UnicodePlots color type (on canvas), 8bit or 24bit

############################################################################################
# unicode table
# en.wikipedia.org/wiki/Plane_(Unicode)
const PLANE0_START = 0x00000000
const PLANE0_STOP = 0x0000ffff
const PLANE1_START = 0x00010000
const PLANE1_STOP = 0x0001ffff
const PLANE2_START = 0x00020000
const PLANE2_STOP = 0x0002ffff

# TODO: maybe later support plane 1 (SMP) and plane 2 (CJK) (needs UInt16 -> UInt32 grid change)
const UNICODE_TABLE = Array{Char}(undef, (PLANE0_STOP - PLANE0_START + 1) + length(MARKERS))
for i in PLANE0_START:PLANE0_STOP
    UNICODE_TABLE[i + 1] = Char(i)
end
for (j, i) in enumerate(PLANE1_START:(PLANE1_START + (length(MARKERS) - 1)))
    UNICODE_TABLE[i + 1] = MARKERS[j]
end

# `UInt32` is enough to hold all values of `UNICODE_TABLE`:
# common supertype for `DotCanvas`, `AsciiCanvas`, `BlockCanvas` `HeatmapCanvas` and `BrailleCanvas`.
const UnicodeType = UInt32

############################################################################################
# colors
const THRESHOLD = UInt32(256^3)  # 8bit - 24bit threshold
const COLORMODE = Ref(Crayons.COLORS_256)
const INVALID_COLOR = typemax(ColorType)
const USE_LUT = Ref(false)

const CRAYONS_FAST = Ref(true)
const CRAYONS_EMPTY_STYLES = Tuple(Crayons.ANSIStyle() for _ in 1:9)
const CRAYONS_RESET = Crayons.CSI * "0" * Crayons.END_ANSI

const COLOR_CYCLE_FAINT = :green, :blue, :red, :magenta, :yellow, :cyan
const COLOR_CYCLE_BRIGHT = map(s -> Symbol("light_", s), COLOR_CYCLE_FAINT)  # COV_EXCL_LINE
const COLOR_CYCLE = Ref(COLOR_CYCLE_FAINT)

const BORDER_COLOR = Ref(:dark_gray)

############################################################################################

const FSCALES = (identity = identity, ln = log, log2 = log2, log10 = log10)  # forward
const ISCALES = (identity = identity, ln = exp, log2 = exp2, log10 = exp10)  # inverse
const BASES = (identity = nothing, ln = "ℯ", log2 = "2", log10 = "10")

const FULL_BLOCK = '█'
const HALF_BLOCK = '▄'

# standard terminals seem to respect a 4:3 aspect ratio
# unix.stackexchange.com/questions/148569/standard-terminal-font-aspect-ratio
# retrocomputing.stackexchange.com/questions/5629/why-did-80x25-become-the-text-monitor-standard
const ASPECT_RATIO = Ref(4 / 3)

# default display size for the default BrailleCanvas (which has aspect ratio = 2) ==> (40, 15)
const DEFAULT_HEIGHT = Ref(15)
const DEFAULT_WIDTH = Ref(round(Int, DEFAULT_HEIGHT[] * 2ASPECT_RATIO[]))

colormode() = if (cm = COLORMODE[]) ≡ Crayons.COLORS_256
    8
elseif cm ≡ Crayons.COLORS_24BIT
    24
else
    throw(ArgumentError("color mode $cm is unsupported"))
end

colors256!() = COLORMODE[] = Crayons.COLORS_256
truecolors!() = COLORMODE[] = Crayons.COLORS_24BIT

function colormode!(mode)
    if mode ≡ 8
        colors256!()
    elseif mode ≡ 24
        truecolors!()
    else
        throw(ArgumentError("color mode $mode is unsupported, choose 8 or 24"))
    end
    return nothing
end

brightcolors!() = COLOR_CYCLE[] = COLOR_CYCLE_BRIGHT
faintcolors!() = COLOR_CYCLE[] = COLOR_CYCLE_FAINT

function init_24bit()
    truecolors!()
    USE_LUT[] ? brightcolors!() : faintcolors!()
    return nothing
end

function init_8bit()
    colors256!()
    faintcolors!()
    return nothing
end

get_have_truecolor() = if isdefined(Base, :get_have_truecolor)
    Base.get_have_truecolor()
else
    # see gist.github.com/XVilka/8346728#checking-for-colorterm
    lowercase(get(ENV, "COLORTERM", "")) ∈ ("24bit", "truecolor")
end

# specific to UnicodePlots
forced_24bit() = lowercase(get(ENV, "UP_COLORMODE", "")) ∈ ("24", "24bit", "truecolor")
forced_8bit() = lowercase(get(ENV, "UP_COLORMODE", "")) ∈ ("8", "8bit")

"""
    default_size!(;
        height::Union{Integer,Nothing} = nothing,
        width::Union{Integer,Nothing} = nothing,
    )

Change and return the default plot size (height, width).
"""
function default_size!(;
        height::Union{Integer, Nothing} = nothing,
        width::Union{Integer, Nothing} = nothing,
    )
    @assert height ≡ nothing || width ≡ nothing
    if height ≢ nothing
        DEFAULT_HEIGHT[] = height
        DEFAULT_WIDTH[] = round(Int, height * 2ASPECT_RATIO[])
    elseif width ≢ nothing
        DEFAULT_WIDTH[] = width
        DEFAULT_HEIGHT[] = round(Int, width / 2ASPECT_RATIO[])
    else
        default_size!(height = 15)
    end
    return DEFAULT_HEIGHT[], DEFAULT_WIDTH[]  # `displaysize` order convention
end

char_marker(marker::MarkerType)::Char = if marker isa Symbol
    get(MARKERS, marker, MARKERS[:circle])
else
    length(marker) ≡ 1 || throw(ArgumentError("`marker` keyword has a non unit length"))
    first(marker)
end

iterable(obj::AbstractVecOrMat) = obj
iterable(obj) = Iterators.repeated(obj)

function transform_name(tr, basename = "")
    name = string(tr isa Union{Symbol, Function} ? tr : typeof(tr))
    name == "identity" && return basename
    name = occursin('#', name) ? "custom" : name
    return string(basename, " [", name, "]")
end

meshgrid(x, y) = repeat(x, 1, length(y)), repeat(y', length(x), 1)

as_float(x::NTuple{_, <:AbstractFloat}) where {_} = x
as_float(x::AbstractVector{<:AbstractFloat}) = x
as_float(x) = float.(x)

roundable(x::Number) = isinteger(x) && (typemin(Int32) ≤ x ≤ typemax(Int32))
compact_repr(x::Number) = repr(x; context = :compact => true)

nice_repr(x::Number, plot) =
    nice_repr(x, plot.unicode_exponent[], plot.thousands_separator[])
nice_repr(x::Number, _::Nothing) =
    nice_repr(x, PLOT_KEYWORDS.unicode_exponent, PLOT_KEYWORDS.thousands_separator)

function nice_repr(x::Integer, ::Bool, thousands_separator::Char)::String
    thousands_separator == '\0' && return string(x)
    xs = abs(x) |> string |> reverse |> collect
    n = length(xs)
    v = sizehint!(Char[], n + 10)
    for (i, c) in enumerate(xs)
        push!(v, c)
        (i < n && mod1(i, 3) == 3) && push!(v, thousands_separator)
    end
    reverse!(v)
    return (sign(x) ≥ 0 ? "" : "-") * String(v)
end

function nice_repr(
        x::AbstractFloat,
        unicode_exponent::Bool,
        thousands_separator::Char,
    )::String
    xr = (pseudo_int = roundable(x)) ? round(Int, x, RoundNearestTiesUp) : x
    iszero(xr) && return "0"
    str = compact_repr(xr)
    if (parts = split(str, 'e')) |> length == 2  # e.g. 1.0e-17 => 1e⁻¹⁷
        left, right = parts
        str = *(
            replace(left, r"\.0$" => ""),
            'e',
            unicode_exponent ? superscript(right) : String(right),
        )
    elseif pseudo_int
        str = nice_repr(xr, unicode_exponent, thousands_separator)
    end
    return str
end

function_name(f::Function, default) = isempty(default) ? string(nameof(f), "(x)") : default

function default_formatter(kw::KWARGS)
    unicode_exponent = get(kw, :unicode_exponent, PLOT_KEYWORDS.unicode_exponent)
    thousands_separator = get(kw, :thousands_separator, PLOT_KEYWORDS.thousands_separator)
    return x -> nice_repr(x, unicode_exponent, thousands_separator)
end

# workaround for github.com/JuliaMath/NaNMath.jl/issues/26
nanless_extrema(x) = any(isnan, x) ? NaNMath.extrema(x) : extrema(x)

function ceil_neg_log10(x)
    val = -log10(x)
    isfinite(val) || return typemin(Int)
    return roundable(val) ? ceil(Int, val) : floor(Int, val)
end

round_up_subtick(x::T, m) where {T} = T(
    iszero(x) ? x : if x > 0
            +ceil(+x; digits = ceil_neg_log10(m) + 1)
    else
            -floor(-x; digits = ceil_neg_log10(m) + 1)
    end
)

round_down_subtick(x::T, m) where {T} = T(
    iszero(x) ? x : if x > 0
            floor(+x; digits = ceil_neg_log10(m) + 1)
    else
            -ceil(-x; digits = ceil_neg_log10(m) + 1)
    end
)

float_round_log10(x::Integer, m) = float_round_log10(float(x), m)
float_round_log10(x) = x > 0 ? float_round_log10(x, x) : float_round_log10(x, -x)
float_round_log10(x::T, m) where {T <: AbstractFloat} = T(
    iszero(x) ? x : if x > 0
            +round(+x; digits = ceil_neg_log10(m) + 1)
    else
            -round(-x; digits = ceil_neg_log10(m) + 1)
    end
)

floor_base(x, b) = round_base(x, b, RoundDown)
ceil_base(x, b) = round_base(x, b, RoundUp)

round_base(x::T, b, ::RoundingMode{:Down}) where {T} = T(b^floor(log(b, x)))
round_base(x::T, b, ::RoundingMode{:Up}) where {T} = T(b^ceil(log(b, x)))

function superscript(s::AbstractString)::String
    v = collect(s)
    for (i, k) in enumerate(v)
        v[i] = get(SUPERSCRIPT, k, k)
    end
    return String(v)
end

function plotting_range_narrow(xmin, xmax)
    Δ = xmax - xmin
    if iszero(Δ) || !isfinite(Δ)
        Δ = Float64(xmax) - Float64(xmin)  # NOTE: support e.g. xmin == -Inf32 | xmax == Inf32
        if iszero(Δ) || !isfinite(Δ)
            @warn "Invalid plotting range" xmin xmax
            return -Inf, +Inf
        end
    end
    return float(round_down_subtick(xmin, Δ)), float(round_up_subtick(xmax, Δ))
end

unitless(x) = x  # noop when Unitful is not loaded
is_auto(lims) = all(iszero, lims)

# NOTE: we need `SVector{2}(v)` for compiler inferrability, not `Svector(v)` !
autolims(lims) = is_auto(lims) ? SVector(-1.0, 1.0) : SVector{2}(as_float(lims))
autolims(lims, vec::AbstractVector) =
    is_auto(lims) && length(vec) > 0 ? SVector{2}(extrema(vec)) : SVector{2}(as_float(lims))

scale_callback(scale::Symbol) = FSCALES[scale]
scale_callback(scale::Function) = scale

extend_limits(vec, lims) = extend_limits(vec, lims, :identity)

function extend_limits(vec::AbstractVector, lims, scale::Union{Symbol, Function})
    scale = scale_callback(scale)
    mi, ma = as_float(extrema(lims))
    if iszero(mi) && iszero(ma)
        isempty(vec) && return is_auto(lims) ? autolims(lims) : lims
        mi, ma = as_float(extrema(vec))
    end
    if mi == ma
        mi -= 1
        ma += 1
    end
    return if scale ≡ identity
        is_auto(lims) ? plotting_range_narrow(mi, ma) : (mi, ma)
    else
        scale(mi), scale(ma)
    end
end

sort_by_keys(dict::Dict) = sort!(collect(dict), by = first)

function sorted_keys_values(dict::Dict; k2s = true)
    # check and force key type to <: AbstractString if necessary
    if k2s && !(first(eltype(dict).types) <: AbstractString)
        dict = Dict(string(k) => v for (k, v) in pairs(dict))
    end
    keys_vals = sort_by_keys(dict)
    return first.(keys_vals), last.(keys_vals)
end

crayon_color(::Union{Missing, Nothing}) = Crayons.ANSIColor()
crayon_color(color::ColorType) =
if color ≡ INVALID_COLOR
    Crayons.ANSIColor()
elseif color < THRESHOLD  # 24bit
    Crayons.ANSIColor(red(color), grn(color), blu(color), Crayons.COLORS_24BIT)
else  # 8bit
    Crayons.ANSIColor(color - THRESHOLD, Crayons.COLORS_256)
end

print_crayons(io, c, args...) =
if CRAYONS_FAST[]
    if Crayons.anyactive(c)  # bypass crayons checks (_have_color, _force_color)
        print(io, Crayons.CSI)
        Crayons._print(io, c)
        print(io, Crayons.END_ANSI, args..., CRAYONS_RESET)
    else
        print(io, args...)
    end
else
    print(io, c, args..., CRAYONS_RESET)
end

print_color(io::IO, color::Crayon, args...) = print_crayons(io, color, args...)
print_color(io::IO, color::UserColorType, args...) =
    print_color(io, ansi_color(color), args...)

function print_color(io::IO, color::ColorType, args...; bgcol = missing)
    if get(io, :color, false)
        print_crayons(
            io,
            Crayon(crayon_color(color), crayon_color(bgcol), CRAYONS_EMPTY_STYLES...),
            args...,
        )
    else
        print(io, args...)
    end
    return nothing
end

@inline r32(r::Integer)::UInt32 = (r & 0x00ffffff) << 16
@inline g32(g::Integer)::UInt32 = (g & 0x00ffffff) << 8
@inline b32(b::Integer)::UInt32 = (b & 0x00ffffff)

@inline red(c::UInt32)::UInt8 = (c >> 16) & 0xff
@inline grn(c::UInt32)::UInt8 = (c >> 8) & 0xff
@inline blu(c::UInt32)::UInt8 = c & 0xff

@inline blend_colors(a::UInt32, b::UInt32)::UInt32 = if a ≡ b
    a  # fastpath
elseif a < THRESHOLD && b < THRESHOLD  # 24bit
    # physical average (UInt32 to prevent UInt8 overflow)
    r32(floor(UInt32, √((UInt32(red(a))^2 + UInt32(red(b))^2) / 2))) +
        g32(floor(UInt32, √((UInt32(grn(a))^2 + UInt32(grn(b))^2) / 2))) +
        b32(floor(UInt32, √((UInt32(blu(a))^2 + UInt32(blu(b))^2) / 2)))
    # binary or
    # r32(red(a) | red(b)) + g32(grn(a) | grn(b)) + b32(blu(a) | blu(b))
elseif THRESHOLD ≤ a < INVALID_COLOR && THRESHOLD ≤ b < INVALID_COLOR  # 8bit
    THRESHOLD + (UInt8(a - THRESHOLD) | UInt8(b - THRESHOLD))
elseif a ≢ INVALID_COLOR && b ≢ INVALID_COLOR
    max(a, b)
else
    INVALID_COLOR
end::UInt32

ignored_color(color::Symbol) = color ≡ :normal || color ≡ :default || color ≡ :nothing
ignored_color(::Nothing) = true
ignored_color(::Any) = false

no_ansi_escape(str::AbstractString) = replace(str, r"\e\[[0-9;]*[a-zA-Z]" => "")

ansi_4bit_to_8bit(c::UInt8) =
let (q, r) = divrem(c, 0x3c)  # UInt8(60)
    UInt8(r + (q > 0x00 ? 0x08 : 0x00))
end

c256(c::AbstractFloat) = round(UInt32, 255c)
c256(c::Integer) = c

# `ColorType` conversion - colormaps
ansi_color(rgb::AbstractRGB) = ansi_color((c256(rgb.r), c256(rgb.g), c256(rgb.b)))
ansi_color(rgb::NTuple{3, AbstractFloat}) = ansi_color(c256.(rgb))

ansi_color(color::ColorType)::ColorType = color  # no-op
ansi_color(crayon::Crayon) = ansi_color(crayon.fg)  # ignore bg & styles
ansi_color(::Missing) = INVALID_COLOR  # not a CrayonColorType

function ansi_color(color::CrayonColorType)::ColorType
    ignored_color(color) && return INVALID_COLOR
    return ansi_color(Crayons._parse_color(color))
end

ansi_color(c::Crayons.ANSIColor) = if COLORMODE[] ≡ Crayons.COLORS_24BIT
    if c.style ≡ Crayons.COLORS_24BIT
        r32(c.r) + g32(c.g) + b32(c.b)
    elseif c.style ≡ Crayons.COLORS_256
        USE_LUT[] ? LUT_8BIT[c.r + 1] : THRESHOLD + c.r
    elseif c.style ≡ Crayons.COLORS_16
        c8 = ansi_4bit_to_8bit(c.r)
        USE_LUT[] ? LUT_8BIT[c8 + 1] : THRESHOLD + c8
    end::ColorType
else  # 0-255 ansi stored in a UInt32
    THRESHOLD + if c.style ≡ Crayons.COLORS_24BIT
        Crayons.to_256_colors(c).r
    elseif c.style ≡ Crayons.COLORS_256
        c.r
    elseif c.style ≡ Crayons.COLORS_16
        ansi_4bit_to_8bit(c.r)
    end::UInt8
end::ColorType

complement(color::UserColorType)::ColorType = complement(ansi_color(color))
complement(color::ColorType)::ColorType = if color ≡ INVALID_COLOR
    INVALID_COLOR
elseif color < THRESHOLD
    r32(~red(color)) + g32(~grn(color)) + b32(~blu(color))
elseif color ≢ INVALID_COLOR
    THRESHOLD + ~UInt8(color - THRESHOLD)
end::ColorType

out_stream_size(out_stream::Nothing) = displaysize()
out_stream_size(out_stream::IO) = displaysize(out_stream)

out_stream_height(out_stream::Union{Nothing, IO} = nothing) =
    out_stream |> out_stream_size |> first
out_stream_width(out_stream::Union{Nothing, IO} = nothing) =
    out_stream |> out_stream_size |> last

multiple_series_defaults(y::AbstractMatrix, kw::KWARGS, start) = map(
    iterable,
    (
        get(kw, :name, map(i -> "y$i", start:(start + size(y, 2)))),
        get(kw, :color, :auto),
        get(kw, :marker, :pixel),
    ),
)

function colormap_callback(cmap::Symbol)
    cdata = ColorSchemes.colorschemes[cmap]
    return (z, minz, maxz) -> begin
        isfinite(z) || return INVALID_COLOR
        z01 =
            minz == maxz ? zero(z) :
            (max(minz, min(z, maxz)) - minz) / (maxz - minz)
        isfinite(z01) || return INVALID_COLOR
        ansi_color(get(cdata, z01))
    end::ColorType
end

function colormap_callback(cmap::AbstractVector)
    return (z, minz, maxz) -> begin
        isfinite(z) || return INVALID_COLOR
        i = if minz == maxz || z < minz
            1
        elseif z > maxz
            length(cmap)
        else
            1 + round(Int, ((z - minz) / (maxz - minz)) * (length(cmap) - 1))
        end::Int
        ansi_color(cmap[i])
    end::ColorType
end

colormap_callback(cmap::Nothing) = x -> nothing
colormap_callback(cmap::Function) = cmap

mutable struct ColorMap
    border::Symbol
    bar::Bool
    lim::NTuple{2, Number}
    callback::Function
end

split_plot_kw(kw::KWARGS) = if isempty(kw)
    pairs((;)), pairs((;))  # avoids `filter` allocations
else
    filter(p -> p.first ∈ PLOT_KEYS, kw), filter(p -> p.first ∉ PLOT_KEYS, kw)
end

warn_on_lost_kw(kw::KWARGS) =
    (isempty(kw) || @warn "keyword(s) `$kw` will be lost"; nothing)

# TermExt
function panel end
function gridplot end

# braille dots composing the character '⣿'
const BRAILLE_SIGNS = UnicodeType.(
    [
        '⠁' '⠈'
        '⠂' '⠐'
        '⠄' '⠠'
        '⡀' '⢀'
    ]
)

"""
    BrailleCanvas{YS <: Function, XS <: Function} <: Canvas

The type of canvas with the highest resolution for Unicode-based plotting.
It uses the Unicode characters for the Braille symbols to represent individual pixel.
This effectively turns every character into eight pixels that can individually be manipulated using binary operations.
"""
struct BrailleCanvas{YS <: Function, XS <: Function} <: Canvas
    grid::Transpose{UnicodeType, Matrix{UnicodeType}}
    colors::Transpose{ColorType, Matrix{ColorType}}
    visible::Bool
    blend::Bool
    yflip::Bool
    xflip::Bool
    pixel_height::Int
    pixel_width::Int
    origin_y::Float64
    origin_x::Float64
    height::Float64
    width::Float64
    yscale::YS
    xscale::XS
end

@inline blank(c::BrailleCanvas) = Char(BLANK_BRAILLE)

@inline y_pixel_per_char(::Type{<:BrailleCanvas}) = 4
@inline x_pixel_per_char(::Type{<:BrailleCanvas}) = 2

function BrailleCanvas(
        char_height::Integer,
        char_width::Integer;
        blend::Bool = KEYWORDS.blend,
        visible::Bool = KEYWORDS.visible,
        origin_y::Number = 0.0,
        origin_x::Number = 0.0,
        height::Number = 1.0,
        width::Number = 1.0,
        yflip::Bool = KEYWORDS.xflip,
        xflip::Bool = KEYWORDS.yflip,
        yscale::Union{Symbol, Function} = :identity,
        xscale::Union{Symbol, Function} = :identity,
    )
    height > 0 || throw(ArgumentError("`height` has to be positive"))
    width > 0 || throw(ArgumentError("`width` has to be positive"))
    char_height = max(char_height, 2)
    char_width = max(char_width, 5)
    pixel_height = char_height * y_pixel_per_char(BrailleCanvas)
    pixel_width = char_width * x_pixel_per_char(BrailleCanvas)
    grid = transpose(fill(grid_type(BrailleCanvas)(BLANK_BRAILLE), char_width, char_height))
    colors = transpose(fill(INVALID_COLOR, char_width, char_height))
    return BrailleCanvas(
        grid,
        colors,
        visible,
        blend,
        yflip,
        xflip,
        pixel_height,
        pixel_width,
        Float64(origin_y),
        Float64(origin_x),
        Float64(height),
        Float64(width),
        scale_callback(yscale),
        scale_callback(xscale),
    )
end

function pixel!(
        c::BrailleCanvas,
        pixel_x::Integer,
        pixel_y::Integer,
        color::ColorType,
        blend::Bool,
    )
    valid_x_pixel(c, pixel_x) || return c
    valid_y_pixel(c, pixel_y) || return c
    char_x, char_y, char_x_off, char_y_off = pixel_to_char_point_off(c, pixel_x, pixel_y)
    if checkbounds(Bool, c.grid, char_y, char_x)
        if BLANK_BRAILLE ≤ (val = c.grid[char_y, char_x]) ≤ FULL_BRAILLE
            c.grid[char_y, char_x] = val | BRAILLE_SIGNS[char_y_off, char_x_off]
        end
        set_color!(c, char_x, char_y, color, blend)
    end
    return c
end

function print_row(io::IO, _, print_color, c::BrailleCanvas, row::Integer)
    1 ≤ row ≤ nrows(c) || throw(ArgumentError("`row` out of bounds: $row"))
    for col in 1:ncols(c)
        print_color(io, c.colors[row, col], Char(c.grid[row, col]))
    end
    return nothing
end

@testset "positional types" begin
    dct = Dict("foo" => 37, "bar" => 23)
    p = barplot(dct)
    test_ref("barplot/default.txt", @print_col(p))
    test_ref("barplot/default.txt", @show_col(p))
    test_ref("barplot/nocolor.txt", @show_nocol(p))

    dct = Dict("foo" => 37.0, :bar => 23.0, 2.1 => 10)
    p = barplot(dct)
    test_ref("barplot/default_mixed.txt", @print_col(p))

    dct = Dict(:foo => 37, :bar => 23)
    p = barplot(dct)
    test_ref("barplot/default.txt", @print_col(p))

    p = barplot([:bar, :foo], Int16[23, 37])
    test_ref("barplot/default.txt", @print_col(p))

    p = barplot(["bar", "foo"], [23, 37])
    test_ref("barplot/default.txt", @print_col(p))
    @test_throws DimensionMismatch barplot!(p, ["zoom"], [90, 80])
    @test_throws DimensionMismatch barplot!(p, ["zoom", "boom"], [90])
    @test_throws MethodError barplot!(p, ["zoom"], [90.0])
    @test_throws InexactError barplot!(p, "zoom", 90.1)
    @test barplot!(p, ["zoom"], [90]) ≡ p
    test_ref("barplot/default2.txt", @print_col(p))

    p = barplot(["bar", "foo"], [23, 37])
    @test barplot!(p, :zoom, 90.0) ≡ p
    test_ref("barplot/default2.txt", @print_col(p))

    p = barplot(["bar", "foo"], [23, 37])
    @test_throws MethodError barplot!(p, Dict("zoom" => 90.0))
    @test barplot!(p, Dict("zoom" => 90)) ≡ p
    test_ref("barplot/default2.txt", @print_col(p))

    p = barplot(["bar", "foo"], [23, 37])
    @test barplot!(p, Dict(:zoom => 90)) ≡ p
    test_ref("barplot/default2.txt", @print_col(p))

    p = barplot(2:6, 11:15)
    test_ref("barplot/ranges.txt", @print_col(p))
    @test barplot!(p, 9:10, 20:21) ≡ p
    test_ref("barplot/ranges2.txt", @print_col(p))
end

@testset "keyword arguments" begin
    p = barplot(
        [:a, :b, :c, :d, :e],
        [0, 1, 10, 100, 1_000],
        title = "Logscale Plot",
        xscale = :log10,
    )
    test_ref("barplot/log10.txt", @print_col(p))

    p = barplot(
        [:a, :b, :c, :d, :e],
        [0, 1, 10, 100, 1_000],
        title = "Logscale Plot",
        xlabel = "custom label",
        xscale = :log10,
    )
    test_ref("barplot/log10_label.txt", @print_col(p))

    p = barplot(
        ["Paris", "New York", "Moskau", "Madrid"],
        [2.244, 8.406, 11.92, 3.165],
        title = "Relative sizes of cities",
        xlabel = "population [in mil]",
        color = :blue,
        margin = 7,
        padding = 3,
    )
    test_ref("barplot/parameters1.txt", @print_col(p))

    p = barplot(
        ["Paris", "New York", "Moskau", "Madrid"],
        [2.244, 8.406, 11.92, 3.165],
        title = "Relative sizes of cities",
        xlabel = "population [in mil]",
        color = (0, 0, 255),
        margin = 7,
        padding = 3,
        labels = false,
    )
    test_ref("barplot/parameters1_nolabels.txt", @print_col(p))

    for sym in ("=", '=')
        p = barplot(
            ["Paris", "New York", "Moskau", "Madrid"],
            [2.244, 8.406, 11.92, 3.165],
            title = "Relative sizes of cities",
            xlabel = "population [in mil]",
            color = :yellow,
            border = :solid,
            symbols = [sym],
            width = 60,
        )
        test_ref("barplot/parameters2.txt", @print_col(p))
    end
end

@testset "edge cases" begin
    @test_throws ArgumentError barplot([:a, :b], [-1, 2])
    p = barplot([5, 4, 3, 2, 1], [0, 0, 0, 0, 0])
    test_ref("barplot/edgecase_zeros.txt", @print_col(p))
    p = barplot([:a, :b, :c, :d], [1, 1, 1, 1_000_000])
    test_ref("barplot/edgecase_onelarge.txt", @print_col(p))
    barplot("one", 1)
end

@testset "colors" begin
    p = barplot(["B", "A"], [2, 1], color = 9)
    test_ref("barplot/col1.txt", @print_col(p))
    p = barplot(["B", "A"], [2, 1], color = (200, 50, 0))
    test_ref("barplot/col2.txt", @print_col(p))
end

@testset "different colors" begin
    p = barplot(
        [:a, :b, :c, :d, :e],
        [20, 30, 60, 50, 40],
        color = [:red, :green, :blue, :yellow, :normal],
    )
    test_ref("barplot/colors.txt", @print_col(p))
end

@testset "maximum - labels" begin
    p = barplot(
        ["1", "2", "3"],
        [1, 2, 3],
        color = :blue,
        name = "1ˢᵗ series",
        maximum = 10,
    )
    test_ref("barplot/maximum_series1.txt", @print_col(p))
    barplot!(p, ["4", "5", "6"], [6, 1, 10], color = :red, name = "2ⁿᵈ series")
    test_ref("barplot/maximum_series2.txt", @print_col(p))
end

@test supertype(GraphicsArea) == Any

@testset "BarplotGraphics" begin
    @test BarplotGraphics <: GraphicsArea
    @test !(BarplotGraphics <: Canvas)

    @testset "basic API and display" begin
        g = BarplotGraphics(0:2:10, 30)
        @test @inferred(nrows(g)) ≡ 6
        @test @inferred(ncols(g)) ≡ 30
        @test_throws ArgumentError print_row(stdout, g, 0)
        @test_throws ArgumentError print_row(stdout, g, 7)
        postprocess! = preprocess!(devnull, g)
        test_ref(
            "graphics/bar_print_row.txt",
            @io2str(print_row(IOContext(::IO, :color => true), g, 3))
        )
        postprocess!(g)
        test_ref("graphics/bar_print.txt", @print_col(g))
        test_ref("graphics/bar_show.txt", @show_col(g))
        test_ref("graphics/bar_print_nocolor.txt", @print_nocol(g))
        test_ref("graphics/bar_show_nocolor.txt", @show_nocol(g))
        @test @inferred(addrow!(g, 3)) ≡ g
        @test @inferred(nrows(g)) ≡ 7
        @test @inferred(ncols(g)) ≡ 30
        @test_throws InexactError addrow!(g, 3.5)
        test_ref("graphics/bar_addrow_scalar.txt", @show_col(g))
        @test @inferred(addrow!(g, [50, 7])) ≡ g
        @test_throws MethodError addrow!(g, [3.5])
        @test @inferred(nrows(g)) ≡ 9
        @test @inferred(ncols(g)) ≡ 30
        test_ref("graphics/bar_addrow_vector.txt", @show_col(g))
        @test @inferred(addrow!(g, [25, 12], [:blue, :red])) ≡ g
        test_ref("graphics/bar_addrow_vector_colors.txt", @show_col(g))
        @test @inferred(nrows(g)) ≡ 11
        @test @inferred(ncols(g)) ≡ 30
    end

    @testset "Constructor parameter" begin
        @test_throws MethodError BarplotGraphics(0:2:10)
        @test_throws Union{ArgumentError, MethodError} BarplotGraphics(Int[], 20)
        @test_throws ArgumentError BarplotGraphics(0:2:10, 30; symbols = ["--"])  # invalids symbols
        g = BarplotGraphics([0, 0], 20)
        @test @inferred(nrows(g)) ≡ 2
        @test @inferred(ncols(g)) ≡ 20
        test_ref("graphics/bar_empty.txt", @show_col(g))
        g = BarplotGraphics([1, 1], 20, color = :blue)
        @test @inferred(nrows(g)) ≡ 2
        @test @inferred(ncols(g)) ≡ 20
        test_ref("graphics/bar_blue.txt", @show_col(g))
        g = BarplotGraphics([0, 1, 10, 100, 1_000], 20; xscale = log10)
        @test @inferred(nrows(g)) ≡ 5
        @test @inferred(ncols(g)) ≡ 20
        test_ref("graphics/bar_log10.txt", @show_col(g))
        g = BarplotGraphics([0, 1, 10], 20; symbols = ["#"])
        @test @inferred(nrows(g)) ≡ 3
        @test @inferred(ncols(g)) ≡ 20
        test_ref("graphics/bar_symb.txt", @show_col(g))
        g = BarplotGraphics([0, 1, 9], 1)
        @test @inferred(nrows(g)) ≡ 3
        @test @inferred(ncols(g)) ≡ 10
        test_ref("graphics/bar_short.txt", @show_col(g))
        g = BarplotGraphics([0, 1, 100_000], 1)
        @test @inferred(nrows(g)) ≡ 3
        @test @inferred(ncols(g)) ≡ 13
        test_ref("graphics/bar_short2.txt", @show_col(g))
    end
end

@testset "BoxplotGraphics" begin
    @test BoxplotGraphics <: GraphicsArea
    @test !(BoxplotGraphics <: Canvas)

    @testset "basic API and display" begin
        g = @inferred BoxplotGraphics([1, 2, 2, 4, 5, 6], 30)
        @test @inferred(nrows(g)) ≡ 3
        @test @inferred(ncols(g)) ≡ 30
        @test_throws ArgumentError print_row(stdout, g, 0)
        @test_throws ArgumentError print_row(stdout, g, 4)
        postprocess! = preprocess!(devnull, g)
        test_ref(
            "graphics/box_print_row.txt",
            @io2str(print_row(IOContext(::IO, :color => true), g, 3))
        )
        postprocess!(g)
        test_ref("graphics/box_print.txt", @print_col(g))
        test_ref("graphics/box_show.txt", @show_col(g))
        test_ref("graphics/box_print_nocolor.txt", @print_nocol(g))
        test_ref("graphics/box_show_nocolor.txt", @show_nocol(g))
        @test @inferred(UnicodePlots.addseries!(g, [3.0, 3, 2, 4, 0, 1])) ≡ g
        @test @inferred(nrows(g)) ≡ 6
        @test @inferred(ncols(g)) ≡ 30
        test_ref("graphics/box_addseries.txt", @show_col(g))
        @test @inferred(UnicodePlots.addseries!(g, [2, 2, 2])) ≡ g
        @test @inferred(nrows(g)) ≡ 9
        @test @inferred(ncols(g)) ≡ 30
        test_ref("graphics/box_addseries_small.txt", @show_col(g))
    end

    @testset "Constructor parameter" begin
        @test_throws MethodError BoxplotGraphics([1, 2, 2, 4, 5, 6])
        @test_throws Union{ArgumentError, MethodError} BoxplotGraphics(Int[], 30)
        g = @inferred BoxplotGraphics([0, 0], 20)
        @test @inferred(nrows(g)) ≡ 3
        @test @inferred(ncols(g)) ≡ 20
        test_ref("graphics/box_empty.txt", @show_col(g))
        g = @inferred BoxplotGraphics([1, 2], 20, color = :blue)
        @test @inferred(nrows(g)) ≡ 3
        @test @inferred(ncols(g)) ≡ 20
        test_ref("graphics/box_blue.txt", @show_col(g))
        g = @inferred BoxplotGraphics([0, 1, 9], 1)
        @test @inferred(nrows(g)) ≡ 3
        @test @inferred(ncols(g)) ≡ 10
        test_ref("graphics/box_short.txt", @show_col(g))
        g = @inferred BoxplotGraphics([1, 2, 2, 4, 5, 6], 30, min_x = 2, max_x = 8)
        @test @inferred(nrows(g)) ≡ 3
        @test @inferred(ncols(g)) ≡ 30
        test_ref("graphics/box_minmax1.txt", @show_col(g))
        g = @inferred BoxplotGraphics([1, 2, 2, 4, 5, 6], 30, min_x = 0, max_x = 7)
        @test @inferred(nrows(g)) ≡ 3
        @test @inferred(ncols(g)) ≡ 30
        test_ref("graphics/box_minmax2.txt", @show_col(g))
        # FIXME: boxplot breaks if `max_x` or `min_x` doesn't cover data span
    end
end

"""
    DotCanvas{YS <: Function, XS <: Function} <: LookupCanvas

Similar to the `AsciiCanvas`, the `DotCanvas` only uses ASCII characters to draw its content.
Naturally, it doesn't look quite as nice as the Unicode-based ones.
However, in some situations it might yield better results.
Printing plots to a file is one of those situations.

The DotCanvas is best used in combination with `scatterplot`.
For `lineplot` we suggest to use the `AsciiCanvas` instead.
"""
struct DotCanvas{YS <: Function, XS <: Function} <: LookupCanvas
    grid::Transpose{UInt16, Matrix{UInt16}}
    colors::Transpose{ColorType, Matrix{ColorType}}
    visible::Bool
    blend::Bool
    yflip::Bool
    xflip::Bool
    pixel_height::Int
    pixel_width::Int
    origin_y::Float64
    origin_x::Float64
    height::Float64
    width::Float64
    min_max::NTuple{2, UnicodeType}
    xscale::XS
    yscale::YS
end

const N_DOT = grid_type(DotCanvas)(4)
const DOT_SIGNS = [0b10; 0b01]
const DOT_DECODE = Array{Char}(undef, typemax(N_DOT))
DOT_DECODE[1] = ' '
DOT_DECODE[2] = '.'
DOT_DECODE[3] = '\''
DOT_DECODE[4] = ':'
DOT_DECODE[(N_DOT + 1):typemax(N_DOT)] = UNICODE_TABLE[1:(typemax(N_DOT) - N_DOT)]

@inline y_pixel_per_char(::Type{<:DotCanvas}) = 2
@inline x_pixel_per_char(::Type{<:DotCanvas}) = 1

@inline lookup_encode(::DotCanvas) = DOT_SIGNS
@inline lookup_decode(::DotCanvas) = DOT_DECODE
@inline lookup_offset(::DotCanvas) = N_DOT

DotCanvas(args...; kw...) = CreateLookupCanvas(DotCanvas, (0b00, 0b11), args...; kw...)

const HEATMAP_SIGNS = [0 1; 0 1]
const HEATMAP_DECODE = [HALF_BLOCK; HALF_BLOCK]

"""
    HeatmapCanvas{YS <: Function, XS <: Function} <: LookupCanvas

The `HeatmapCanvas` is also Unicode-based.
It has a half the resolution of the `BlockCanvas`.
This canvas effectively turns every character into two pixels (top and bottom).
"""
struct HeatmapCanvas{YS <: Function, XS <: Function} <: LookupCanvas
    grid::Transpose{UInt8, Matrix{UInt8}}
    colors::Transpose{ColorType, Matrix{ColorType}}
    visible::Bool
    blend::Bool
    yflip::Bool
    xflip::Bool
    pixel_height::Int
    pixel_width::Int
    origin_y::Float64
    origin_x::Float64
    height::Float64
    width::Float64
    min_max::NTuple{2, UnicodeType}
    yscale::YS
    xscale::XS
end

@inline nrows(c::HeatmapCanvas) = div(size(c.grid, 1) + 1, 2)

@inline y_pixel_per_char(::Type{<:HeatmapCanvas}) = 2
@inline x_pixel_per_char(::Type{<:HeatmapCanvas}) = 1

@inline lookup_encode(::HeatmapCanvas) = HEATMAP_SIGNS
@inline lookup_decode(::HeatmapCanvas) = HEATMAP_DECODE

function HeatmapCanvas(args...; kw...)
    c = CreateLookupCanvas(
        HeatmapCanvas,
        (0, 1),
        args...;
        min_char_height = 1,
        min_char_width = 1,
        kw...,
    )
    fill!(c.colors, ansi_color(:black))  # black background by default
    return c
end

function print_row(io::IO, _, print_color, c::HeatmapCanvas, row::Integer)
    1 ≤ row ≤ nrows(c) || throw(ArgumentError("`row` out of bounds: $row"))
    row *= y_pixel_per_char(HeatmapCanvas)

    # extend the plot upwards by half a row
    isodd(size(c.grid, 1)) && (row -= 1)

    for col in 1:ncols(c)
        # for odd numbers of rows, only print the foreground for the top row
        bgcol = row > 1 ? c.colors[row - 1, col] : missing
        print_color(io, c.colors[row, col], HALF_BLOCK; bgcol)
    end

    return nothing
end

"""
    boxplot(data; kw...)
    boxplot!(p, args...; kw...)

# Description

Draws a box-and-whisker plot.

The first argument specifies the data to plot.
This is a vector of vectors, with each inner vector representing a data series.
We use a vector of vectors over a matrix to allow series of different lengths.
Optionally, a list of text may be provided, with length equal to the number of series.

Alternatively, one can specify a boxplot using a dictionary.
In that case, the values, which have to be numeric, will be used as the data series,
and the keys, which have to be strings, will be used as the labels.

# Usage

    boxplot([text], data; $(keywords((border = :corners, color = :green), remove = (:ylim, :height, :grid))))
    boxplot(dict; kw...)

# Arguments

$(
    arguments(
        (
            text = "the labels/captions of the boxes (optional)",
            data = "a vector of vectors, with each inner vector representing a data series (choose a vector of vectors over a matrix to allow series of different lengths)",
            dict = "a dictionary in which the keys will be used as `text` and the values will be used as `data`",
            color = "`Vector` of colors, or scalar - $(DESCRIPTION[:color])",
        ); remove = (:ylim, :yscale, :height, :grid)
    )
)

# Author(s)

- Matthew Lake (github.com/mgtlake)

# Examples

```julia-repl
julia> boxplot([1, 2, 3, 7]; title = "Test")
                       Test
    ┌                                        ┐
     ╷   ┌────┬─────────┐                   ╷
     ├───┤    │         ├───────────────────┤
     ╵   └────┴─────────┘                   ╵
    └                                        ┘
     1                  4                   7
```

# See also

[`Plot`](@ref), [`histogram`](@ref), [`BoxplotGraphics`](@ref)
"""
function boxplot(
        text::AbstractVector{<:AbstractString},
        data::AbstractVector{<:AbstractArray{<:Number}};
        color::Union{UserColorType, AbstractVector} = :green,
        width::Union{Nothing, Integer} = nothing,
        xlim = KEYWORDS.xlim,
        kw...,
    )
    pkw, okw = split_plot_kw(kw)
    length(xlim) == 2 ||
        throw(ArgumentError("`xlim` must be a tuple or a vector of length 2"))
    length(text) == length(data) || throw(DimensionMismatch("wrong number of text"))
    min_x, max_x = extend_limits(reduce(vcat, data), xlim)
    width = max(something(width, DEFAULT_WIDTH[]), 10)

    area = BoxplotGraphics(first(data), width; color, min_x, max_x, okw...)
    foreach(i -> addseries!(area, data[i]), 2:length(data))
    plot = Plot(area; border = :corners, pkw...)

    min_x_str, mean_x_str, max_x_str =
        nice_repr.((min_x, (min_x + max_x) / 2, max_x), Ref(plot))
    label!(plot, :bl, min_x_str; color = BORDER_COLOR[])
    label!(plot, :b, mean_x_str; color = BORDER_COLOR[])
    label!(plot, :br, max_x_str; color = BORDER_COLOR[])

    for (i, name) in enumerate(text)
        # Find end of last 3-line region, then add 2 for center of current
        length(name) > 0 && label!(plot, :l, 3(i - 1) + 2, name)
    end
    return plot
end

@doc (@doc boxplot) function boxplot!(
        plot::Plot{<:BoxplotGraphics},
        data::AbstractVector{<:Number};
        name = KEYWORDS.name,
        kw...,
    )
    isempty(data) && throw(ArgumentError("can't append empty array to boxplot"))

    addseries!(plot.graphics, data)

    # Find end of last 3-line region, then add 2 for center of current
    label!(plot, :l, 3(length(plot.graphics.data) - 1) + 2, name)

    min_x = plot.graphics.min_x[]
    max_x = plot.graphics.max_x[]
    min_x_str, mean_x_str, max_x_str =
        nice_repr.((min_x, (min_x + max_x) / 2, max_x), Ref(plot))
    label!(plot, :bl, min_x_str)
    label!(plot, :b, mean_x_str)
    label!(plot, :br, max_x_str)
    return plot
end

boxplot!(plot, name, data::AbstractVector{<:Number}; kw...) =
    boxplot!(plot, data; name, kw...)
boxplot(data::AbstractVector{<:AbstractArray{<:Number}}; kw...) =
    boxplot(fill("", length(data)), data; kw...)
boxplot(text::AbstractString, data::AbstractVector{<:Number}; kw...) =
    boxplot([text], [data]; kw...)
boxplot(data::AbstractVector{<:Number}; kw...) = boxplot("", data; kw...)
boxplot(dict::AbstractDict; kw...) = boxplot(sorted_keys_values(dict)...; kw...)

@testset "empty" begin
    canvas =
        BrailleCanvas(10, 40, origin_y = 0.0, origin_x = 0.0, height = 1.0, width = 1.0)
    p = @inferred Plot(canvas)
    @test_throws ArgumentError Plot(canvas, margin = -1)
    test_ref("plot/empty.txt", @show_col(p))
    p = @inferred Plot(
        BrailleCanvas(5, 30; origin_y = 0.0, origin_x = 0.0, height = 1.0, width = 1.0),
    )
    test_ref("plot/empty_small.txt", @show_col(p))

    # empty plot ctor
    p = Plot()
    @test p isa Plot
    p = Plot([], [])
    @test p isa Plot
    p = Plot([], [], [])
    @test p isa Plot

    p = Plot([], []; xlim = (-3, 5), ylim = (-10, 2))
    test_ref("plot/empty_xylim.txt", @show_col(p))
end

@testset "invisible" begin
    p = Plot([0], [0], width = -1)
    @test !p.graphics.visible
end

@testset "width - height, :auto" begin
    p = Plot([0], [0], height = :auto, width = :auto)
    @test p isa Plot
end

@testset "x/y ticks" begin
    p = Plot([0, 1], [0, 1], xticks = false)
    test_ref("plot/noxticks.txt", @show_col(p))

    p = Plot([0, 1], [0, 1], yticks = false)
    test_ref("plot/noyticks.txt", @show_col(p))
end

function _test_canvas(; kw...)
    canvas = BrailleCanvas(
        10,
        40;
        origin_y = 0.0,
        origin_x = 0.0,
        height = 1.0,
        width = 1.0,
        kw...,
    )
    lines!(canvas, 0.0, 0.0, 1.0, 1.0; color = :blue)
    lines!(canvas, 0.2, 0.7, 1.0, 0.0; color = :red)
    lines!(canvas, 0.0, 2.0, 0.5, 0.0; color = :green)
    points!(canvas, 0.5, 0.8)
    return canvas
end

@testset "canvas / xylabel" begin
    p = @inferred Plot(_test_canvas())
    test_ref("plot/canvas_only.txt", @print_col(p))
    test_ref("plot/canvas_only.txt", @show_col(p))

    for border in (:solid, :corners, :barplot, :bold, :ascii, :none, :dashed, :dotted)
        local p = @inferred Plot(_test_canvas(); border)
        test_ref("plot/border_$(string(border)).txt", @show_col(p))
    end

    p = @inferred Plot(_test_canvas(); xlabel = "x", ylabel = "y")
    test_ref("plot/xylabel.txt", @show_col(p))

    p = @inferred Plot(_test_canvas(); xlabel = "x", ylabel = "y", compact_labels = true)
    test_ref("plot/xylabel_compact_labels.txt", @show_col(p))

    p = @inferred Plot(_test_canvas(); compact = true)
    test_ref("plot/compact.txt", @show_col(p))
end

@testset "xyflip" begin
    p = Plot(_test_canvas(; xflip = true))
    test_ref("plot/xflip.txt", @show_col(p))
    p = Plot(_test_canvas(; yflip = true))
    test_ref("plot/yflip.txt", @show_col(p))
    p = Plot(_test_canvas(; xflip = true, yflip = true))
    test_ref("plot/xyflip.txt", @show_col(p))
end

@testset "padding" begin
    p = @inferred Plot(
        _test_canvas(),
        title = "testtitle",
        xlabel = "x",
        ylabel = "y",
        margin = 4,
        padding = 5,
    )
    @test @inferred(label!(p, :l, ":l auto 1")) ≡ p
    @test @inferred(label!(p, :r, ":r auto 1", :red)) ≡ p
    test_ref("plot/padding.txt", @show_col(p))

    p = @inferred Plot(
        _test_canvas(),
        title = "testtitle",
        xlabel = "x",
        ylabel = "y",
        margin = 4,
        padding = 5,
        labels = false,
    )
    @test @inferred(label!(p, :l, ":l auto 1")) ≡ p
    @test @inferred(label!(p, :r, ":r auto 1", :red)) ≡ p
    test_ref("plot/padding_nolabels.txt", @show_col(p))
end

@testset "title / labels / full deco" begin
    p = @inferred Plot(_test_canvas(), title = "testtitle")
    test_ref("plot/title.txt", @show_col(p))
    @test @inferred(label!(p, :l, ":l auto 1")) ≡ p
    @test @inferred(label!(p, :r, ":r auto 1", :red)) ≡ p
    @test @inferred(label!(p, :l, ":l auto 2", :green)) ≡ p
    @test @inferred(label!(p, :r, ":r auto 2", :blue)) ≡ p
    test_ref("plot/title_auto.txt", @show_col(p))

    for i in 1:10
        @test @inferred(label!(p, :l, i, "$i", color = :green)) ≡ p
        @test @inferred(label!(p, :r, i, "$i", :yellow)) ≡ p
    end
    @test_throws ArgumentError label!(p, :bl, 5, ":l  5", :red)
    @test_throws ArgumentError label!(p, :d, ":l auto", :red)
    @test @inferred(label!(p, :l, 5, ":l  5", :red)) ≡ p
    @test @inferred(label!(p, :r, 5, "5  :r", color = :blue)) ≡ p
    @test @inferred(label!(p, :t, ":t", color = :yellow)) ≡ p
    @test @inferred(label!(p, :tl, ":tl", :cyan)) ≡ p
    @test @inferred(label!(p, :tr, ":tr")) ≡ p
    label!(p, :bl, ":bl", :blue)
    label!(p, :b, ":b", :green)
    label!(p, :br, ":br", :white)

    @test @inferred(lines!(p, 0.0, 1.0, 1.0, 0.0, color = (0, 0, 255))) ≡ p
    @test @inferred(pixel!(p, 10, 1, color = (255, 255, 0))) ≡ p
    @test @inferred(points!(p, 0.05, 0.75, color = (0, 255, 0))) ≡ p

    ttl = "title!(plot, text)"
    @test @inferred(title!(p, ttl)) ≡ p
    @test @inferred(title(p)) == ttl
    xlab = "xlabel!(plot, text)"
    @test @inferred(xlabel!(p, xlab)) ≡ p
    @test @inferred(xlabel(p)) == xlab
    ylab = "ylabel!(plot, text)"
    @test @inferred(ylabel!(p, ylab)) ≡ p
    @test @inferred(ylabel(p)) == ylab
    zlab = "zlabel!(plot, text)"
    @test @inferred(zlabel!(p, zlab)) ≡ p
    @test @inferred(zlabel(p)) == zlab

    test_ref("plot/full_deco.txt", @show_col(p))
    tmp = tempname()
    savefig(p, tmp; color = true)
    test_ref("plot/full_deco.txt", read(tmp, String))

    test_ref("plot/full_deco_nocolor.txt", @show_nocol(p))
    tmp = tempname()
    savefig(p, tmp; color = false)
    test_ref("plot/full_deco_nocolor.txt", read(tmp, String))
end

@testset "annotations" begin
    p = @inferred Plot(_test_canvas())
    @test @inferred(annotate!(p, 0.5, 0.5, "Origin")) ≡ p
    @test @inferred(annotate!(p, 0.5, 1.0, "North")) ≡ p
    @test @inferred(annotate!(p, 1.0, 1.0, "North East"; halign = :right)) ≡ p
    @test @inferred(annotate!(p, 1.0, 0.5, "East"; halign = :right)) ≡ p
    @test @inferred(annotate!(p, 1.0, 0.0, "South East"; halign = :right)) ≡ p
    @test @inferred(annotate!(p, 0.5, 0.0, "South")) ≡ p
    @test @inferred(annotate!(p, 0.0, 0.0, "South West"; halign = :left)) ≡ p
    @test @inferred(annotate!(p, 0.0, 0.5, "West"; halign = :left)) ≡ p
    @test @inferred(annotate!(p, 0.0, 1.0, "North West"; halign = :left)) ≡ p
    @test @inferred(annotate!(p, 0.0, 0.25, '🗹')) ≡ p  # Char
    test_ref("plot/annotations_BrailleCanvas.txt", @show_col(p))

    for sym in (:OctantCanvas, :AsciiCanvas, :DotCanvas, :BlockCanvas)
        p = lineplot([-1, 1], [-1, 1]; canvas = getproperty(UnicodePlots, sym))
        annotate!(p, +0, +0, "Origin")
        annotate!(p, +0, +1, "North")
        annotate!(p, +1, +1, "North East"; halign = :right)
        annotate!(p, +1, +0, "East"; halign = :right)
        annotate!(p, +1, -1, "South East"; halign = :right)
        annotate!(p, +0, -1, "South")
        annotate!(p, -1, -1, "South West"; halign = :left)
        annotate!(p, -1, +0, "West"; halign = :left)
        annotate!(p, -1, +1, "North West"; halign = :left)
        test_ref("plot/annotations_$sym.txt", @show_col(p))
    end

    p = lineplot([-1, 1], [-1, 1])
    for h in (:right, :left, :center, :hcenter), v in (:top, :bottom, :center, :vcenter)
        annotate!(p, 0, 0, "Origin"; halign = h, valign = v)
    end
end

@testset "mutability" begin
    pl = lineplot(1:2)
    pl.margin[] = pl.padding[] = 0
    pl.title[] = "foo"
    pl.xlabel[] = "x"
    pl.ylabel[] = "y"
    pl.zlabel[] = "z"
    @test show(devnull, pl) == (20, 45)
end

@testset "formatter" begin
    p = lineplot(1:4, 1:4; xscale = :log10, yscale = :ln, unicode_exponent = false)
    test_ref("plot/no_unicode_exponent.txt", @show_col(p))

    xlim = ylim = (1_000, 1_000_000)

    p = lineplot(1:1; xlim, ylim, thousands_separator = '\0')
    test_ref("plot/no_thousands_separator.txt", @show_col(p))

    p = lineplot(1:1; xlim, ylim, thousands_separator = '_')
    test_ref("plot/underscore_thousands_separator.txt", @show_col(p))
end

const DEN_SIGNS = Ref((' ', '░', '▒', '▓', '█'))

"""
    DensityCanvas{YS <: Function, XS <: Function, DS <: Function} <: Canvas

Unlike the `BrailleCanvas`, the density canvas does not simply mark a pixel as set.
Instead it increments a counter per character that keeps track of the frequency of pixels drawn in that character.
Together with a variable that keeps track of the maximum frequency, the canvas can thus draw the density of datapoints.
"""
struct DensityCanvas{YS <: Function, XS <: Function, DS <: Function} <: Canvas
    grid::Transpose{UInt64, Matrix{UInt64}}
    colors::Transpose{ColorType, Matrix{ColorType}}
    visible::Bool
    blend::Bool
    yflip::Bool
    xflip::Bool
    pixel_height::Int
    pixel_width::Int
    origin_y::Float64
    origin_x::Float64
    height::Float64
    width::Float64
    max_density::RefValue{Float64}
    yscale::YS
    xscale::XS
    dscale::DS
end

@inline y_pixel_per_char(::Type{<:DensityCanvas}) = 2
@inline x_pixel_per_char(::Type{<:DensityCanvas}) = 1

function DensityCanvas(
        char_height::Integer,
        char_width::Integer;
        blend::Bool = KEYWORDS.blend,
        visible::Bool = KEYWORDS.visible,
        origin_y::Number = 0.0,
        origin_x::Number = 0.0,
        height::Number = 1.0,
        width::Number = 1.0,
        yflip::Bool = KEYWORDS.yflip,
        xflip::Bool = KEYWORDS.xflip,
        yscale::Union{Symbol, Function} = KEYWORDS.yscale,
        xscale::Union{Symbol, Function} = KEYWORDS.xscale,
        dscale::Union{Symbol, Function} = :identity,
    )
    height > 0 || throw(ArgumentError("`height` has to be positive"))
    width > 0 || throw(ArgumentError("`width` has to be positive"))
    char_height = max(char_height, 5)
    char_width = max(char_width, 5)
    pixel_height = char_height * y_pixel_per_char(DensityCanvas)
    pixel_width = char_width * x_pixel_per_char(DensityCanvas)
    grid = transpose(fill(grid_type(DensityCanvas)(0), char_width, char_height))
    colors = transpose(fill(INVALID_COLOR, char_width, char_height))
    return DensityCanvas(
        grid,
        colors,
        visible,
        blend,
        yflip,
        xflip,
        pixel_height,
        pixel_width,
        Float64(origin_y),
        Float64(origin_x),
        Float64(height),
        Float64(width),
        Ref(-Inf),
        scale_callback(yscale),
        scale_callback(xscale),
        scale_callback(dscale),
    )
end

function pixel!(
        c::DensityCanvas,
        pixel_x::Integer,
        pixel_y::Integer,
        color::ColorType,
        blend::Bool,
    )
    valid_x_pixel(c, pixel_x) || return c
    valid_y_pixel(c, pixel_y) || return c
    char_x, char_y = pixel_to_char_point(c, pixel_x, pixel_y)
    if checkbounds(Bool, c.grid, char_y, char_x)
        c.grid[char_y, char_x] += 1  # count occurrences
        set_color!(c, char_x, char_y, color, blend)
    end
    return c
end

function preprocess!(::IO, c::DensityCanvas)
    c.max_density[] = max(eps(), maximum(c.dscale, c.grid))
    return c -> c.max_density[] = -Inf
end

function print_row(io::IO, _, print_color, c::DensityCanvas, row::Integer)
    1 ≤ row ≤ nrows(c) || throw(ArgumentError("`row` out of bounds: $row"))
    signs = DEN_SIGNS[]
    fact = (length(signs) - 1) / c.max_density[]
    for col in 1:ncols(c)
        val = fact * c.dscale(c.grid[row, col])
        print_color(io, c.colors[row, col], signs[round(Int, val, RoundNearestTiesUp) + 1])
    end
    return nothing
end

const WIDTH_CB = 4  # NOTE: 4 = 2border + 2gradient => colorbar width

function print_colorbar_row(
        io::IO,
        print_nocol,
        print_color,
        p::Plot,
        row::Integer,
        nr::Integer,
        zlab,
        bc,
        max_len::Integer,
        blank::AbstractChar,
    )
    lab = ""
    cmap = p.cmap
    b = BORDERMAP[cmap.border]
    if (first_r = row == 1) || row == nr
        sym = first_r ? :t : :b
        # print border and z value
        print_color(io, bc, b[Symbol(sym, :l)], b[sym], b[sym], b[Symbol(sym, :r)])
    else
        # print gradient
        print_color(io, bc, b[:l])
        if cmap.lim[1] ≈ cmap.lim[2]  # if `zmin` and `zmax` are close, single color
            fgcol = bgcol = cmap.callback(1, 1, 1)
        else  # otherwise, blend from `zmin` to `zmax`
            n = 2(nr - 2)
            r = row - 2
            fgcol = cmap.callback(n - 2r - 1, 1, n)
            bgcol = cmap.callback(n - 2r, 1, n)
        end
        print_color(io, fgcol, HALF_BLOCK, HALF_BLOCK; bgcol)
        print_color(io, bc, b[:r])
        row == div(nr, 2) + 1 && (lab = zlab)
    end
    lpad = isempty(zlab) ? 0 : p.padding[]
    rpad = max_len - lpad - WIDTH_CB - length(lab)
    print_nocol(io, blank^lpad * lab * blank^rpad)
    return nothing
end

function print_colorbar_lim(
        io::IO,
        print_nocol,
        print_color,
        p::Plot,
        lab::AbstractString,
        bc,
        max_len::Integer,
        blank::AbstractChar,
        trail,
    )
    lpad = p.padding[] + if (len = length(lab)) ≥ WIDTH_CB
        -(len - WIDTH_CB) ÷ 2  # wide label mode (left shifted)
    else
        ((c = get(lab, 1, '_')) == '-' || c == '+') ? 0 : 1  # left colorbar border or sign
    end
    lpad = max(0, lpad)
    rpad = max(0, max_len - (lpad - p.padding[]) - len)
    print_nocol(io, blank^lpad)
    print_color(io, bc, lab)
    print_nocol(io, blank^rpad * trail)
    return nothing
end

function print_title(
        io::IO,
        print_nocol,
        print_color,
        left_pad::AbstractString,
        title::AbstractString,
        right_pad::AbstractString,
        blank::AbstractChar;
        p_width::Integer = 0,
        color::UserColorType = :normal,
    )
    isempty(title) && return (0, 0)
    offset = round(Int, p_width / 2 - length(title) / 2, RoundNearestTiesUp)
    pre_pad = blank^max(0, offset)
    print_nocol(io, left_pad, pre_pad)
    print_color(io, color, title)
    post_pad = blank^(max(0, p_width - length(pre_pad) - length(title)))
    print_nocol(io, post_pad, right_pad)
    return (
        count('\n', title) + 1,
        length(strip(left_pad * pre_pad * title * post_pad * right_pad, '\n')),
    )
end

function print_border(
        io::IO,
        print_nocol::Function,
        print_color::Function,
        bl::Char,
        bd::String,
        br::Char,
        left_pad::Union{Nothing, AbstractChar, AbstractString},
        right_pad::Union{Nothing, AbstractChar, AbstractString},
        color::UserColorType,
    )
    left_pad ≡ nothing || print_nocol(io, left_pad)
    print_color(io, color, bl, bd, br)
    right_pad ≡ nothing || print_nocol(io, right_pad)
    return nothing
end

function print_labels(
        io::IO,
        print_nocol,
        print_color,
        p::Plot,
        mloc::Symbol,
        border_length,
        left_pad::AbstractString,
        right_pad::AbstractString,
        blank::AbstractChar,
    )
    p.labels[] || return 0
    bc = BORDER_COLOR[]
    lloc = Symbol(mloc, :l)
    rloc = Symbol(mloc, :r)
    left_str = get(p.decorations, lloc, "")
    mid_str = get(p.decorations, mloc, "")
    right_str = get(p.decorations, rloc, "")
    (isempty(left_str) && isempty(mid_str) && isempty(right_str)) && return 0
    left_col = get(p.colors_deco, lloc, bc)
    mid_col = get(p.colors_deco, mloc, bc)
    right_col = get(p.colors_deco, rloc, bc)
    left_len = length(left_str)
    mid_len = length(mid_str)
    right_len = length(right_str)
    print_nocol(io, left_pad)
    print_color(io, left_col, left_str)
    cnt = round(Int, border_length / 2 - mid_len / 2 - left_len, RoundNearestTiesAway)
    print_nocol(io, cnt > 0 ? blank^cnt : "")
    print_color(io, mid_col, mid_str)
    cnt = border_length - right_len - left_len - mid_len + 2 - cnt
    print_nocol(io, cnt > 0 ? blank^cnt : "")
    print_color(io, right_col, right_str)
    print_nocol(io, right_pad)
    return 1
end

Base.show(io::IO, p::Plot) = _show(io, print, print_color, p)

"""
    _show(::IO, print_nocol, print_color, p::Plot)

Display a `Plot` object to a terminal emulator.
"""
function _show(end_io::IO, print_nocol, print_color, p::Plot)
    buf = PipeBuffer()  # buffering, for performance
    io_color = get(end_io, :color, false)
    io = IOContext(buf, :color => io_color, :displaysize => displaysize(end_io))

    g = p.graphics
    🗷 = Char(BLANK)  # blank outside graphics
    🗹 = blank(g)  # blank inside graphics
    ############################################################
    # 🗷 = 'x'  # debug
    # 🗹 = Char(typeof(g) <: BrailleCanvas ? '⠿' : 'o')  # debug
    ############################################################
    xlab, ylab, zlab = axes_labels = xlabel(p), ylabel(p), zlabel(p)
    postprocess! = preprocess!(io, g)
    nr, nc = nrows(g), ncols(g)

    p_width = nc + 2  # left corner + border length (number of graphics cols) + right corner
    if p.compact_labels[]
        isempty(xlab) || label!(p, :b, xlab)
        isempty(ylab) || label!(p, :l, round(Int, nr / 2), ylab)
    end

    bmap = BORDERMAP[p.border[] ≡ :none && g isa BrailleCanvas ? :bnone : p.border[]]
    bc = BORDER_COLOR[]

    # get length of largest strings to the left and right
    max_len_l = if p.labels[] && !isempty(p.labels_left)
        maximum(length ∘ no_ansi_escape, values(p.labels_left))
    else
        0
    end
    max_len_r = if p.labels[] && !isempty(p.labels_right)
        maximum(length ∘ no_ansi_escape, values(p.labels_right))
    else
        0
    end
    max_len_a = p.labels[] ? maximum(length ∘ no_ansi_escape, axes_labels) : 0
    if !p.compact_labels[] && p.labels[] && !isempty(ylab)
        max_len_l += length(ylab) + 1
    end

    has_labels =
        max_len_l > 0 || max_len_r > 0 || max_len_a > 0 || length(p.decorations) > 0
    has_labels &= p.labels[]

    plot_offset = max_len_l + p.margin[] + p.padding[]  # offset where the plot (including border) begins
    border_left_pad = 🗷^plot_offset  # padding-string between labels and border
    plot_padding = 🗷^p.padding[]  # base padding-string (left to border and border to right)

    cbar_pad = if p.cmap.bar
        min_z_str, max_z_str =
            map(x -> nice_repr(roundable(x) ? x : float_round_log10(x), p), p.cmap.lim)
        len_z_lab = length(no_ansi_escape(zlabel(p)))
        cbar_max_len = max(
            length(min_z_str),
            length(max_z_str),
            WIDTH_CB + (len_z_lab > 0 ? p.padding[] + len_z_lab : 0),
        )
        🗷^cbar_max_len
    else
        ""
    end

    # trailing
    border_right_pad = if p.cmap.bar
        🗷^max_len_r  # colorbar labels can overlap padding
    else
        plot_padding * 🗷^max_len_r
    end
    border_right_cbar_pad = plot_padding * 🗷^max_len_r * cbar_pad

    # plot the title and the top border
    h_ttl, w_ttl = print_title(
        io,
        print_nocol,
        print_color,
        border_left_pad,
        title(p),
        border_right_cbar_pad * '\n',
        🗹;
        p_width,
        color = io_color ? Crayon(foreground = :white, bold = true) : nothing,
    )
    h_lbl = print_labels(
        io,
        print_nocol,
        print_color,
        p,
        :t,
        nc - 2,
        border_left_pad * 🗹,
        🗹 * border_right_cbar_pad * '\n',
        🗹,
    )
    g.visible && print_border(
        io,
        print_nocol,
        print_color,
        bmap[:tl],
        bmap[:t]^nc,
        bmap[:tr],
        border_left_pad,
        border_right_pad * (p.cmap.bar ? "" : "\n"),
        bc,
    )
    p.cmap.bar && print_colorbar_lim(
        io,
        print_nocol,
        print_color,
        p,
        max_z_str,
        bc,
        cbar_max_len,
        🗷,
        '\n',
    )

    # compute position of ylabel
    y_lab_row = round(nr / 2, RoundNearestTiesUp)

    # plot all rows
    for row in 1:nr
        # print left annotations
        print_nocol(io, 🗷^p.margin[])
        if has_labels
            # current labels to left and right of the row and their length
            left_str = get(p.labels_left, row, "")
            left_col = get(p.colors_left, row, bc)
            right_str = get(p.labels_right, row, "")
            right_col = get(p.colors_right, row, bc)
            left_str_ = no_ansi_escape(left_str)
            right_str_ = no_ansi_escape(right_str)
            left_len = length(left_str_)
            right_len = length(right_str_)
            if !io_color
                left_str = left_str_
                right_str = right_str_
            end
            if !p.compact_labels[] && row == y_lab_row
                # print ylabel
                print_color(io, :normal, ylab)
                print_nocol(io, 🗷^(max_len_l - length(ylab) - left_len))
            else
                # print padding to fill ylabel length
                print_nocol(io, 🗷^(max_len_l - left_len))
            end
            # print the left annotation
            print_color(io, left_col, left_str)
        end
        if g.visible
            # print left border
            print_nocol(io, plot_padding)
            print_color(io, bc, bmap[:l])
            # print canvas row
            print_row(io, print_nocol, print_color, g, row)
            if g isa ImageGraphics && g.sixel[]
                offset = plot_offset + nc + 1  # COV_EXCL_LINE
                # 1F: move cursor to the beginning of the previous line, 1 line up
                # $(offset)C: move cursor to the right by an amount of $offset columns
                print_nocol(io, "\e[1F\e[$(offset)C")  # COV_EXCL_LINE
            end
            # print right border (symmetry with left border and padding)
            print_color(io, bc, bmap[:r])
            print_nocol(io, plot_padding)
        end
        if has_labels
            print_color(io, right_col, right_str)
            print_nocol(io, 🗷^(max_len_r - right_len))
        end
        # print a colorbar element
        p.cmap.bar && print_colorbar_row(
            io,
            print_nocol,
            print_color,
            p,
            row,
            nr,
            zlab,
            bc,
            cbar_max_len,
            🗷,
        )
        row < nr && print_nocol(io, '\n')
    end
    postprocess!(g)

    (g.visible || p.cmap.bar || has_labels) && print_nocol(io, '\n')

    # draw bottom border
    g.visible && print_border(
        io,
        print_nocol,
        print_color,
        bmap[:bl],
        bmap[:b]^nc,
        bmap[:br],
        border_left_pad,
        border_right_pad,
        bc,
    )
    p.cmap.bar && print_colorbar_lim(
        io,
        print_nocol,
        print_color,
        p,
        min_z_str,
        bc,
        cbar_max_len,
        🗷,
        "",
    )

    # print bottom labels
    w_lbl = 0
    if has_labels
        h_lbl += print_labels(
            io,
            print_nocol,
            print_color,
            p,
            :b,
            nc - 2,
            '\n' * border_left_pad * 🗹,
            🗹 * border_right_cbar_pad,
            🗹,
        )
        if !p.compact_labels[]
            h_w = print_title(
                io,
                print_nocol,
                print_color,
                '\n' * border_left_pad,
                xlab,
                border_right_cbar_pad,
                🗹;
                p_width,
            )
            h_lbl += h_w[1]
            w_lbl += h_w[2]
        end
    end

    # delayed print (buffering)
    print_nocol(end_io, read(buf, String))

    # return the approximate image size
    return (
        h_ttl + 1 + nr + 1 + h_lbl,  # +1 for borders
        max(
            w_ttl,
            w_lbl,
            length(border_left_pad) + p_width + length(border_right_cbar_pad),
        ),
    )
end

# generic functions for `FreeTypeExt`
function get_font_face end
function render_string! end
function save_image end

"""
    png_image(p::Plot, font = nothing, pixelsize = 32, transparent = true, foreground = nothing, background = nothing, bounding_box = nothing, bounding_box_glyph = nothing)

Renders a `png` image.

# Arguments
- `pixelsize::Integer = 32`: controls the image size scaling.
- `font::Union{Nothing,AbstractString} = nothing`: select a font by name, or fall-back to a system font.
- `transparent::Bool = true`: use a transparent background.
- `foreground::UserColorType = nothing`: choose a foreground color for un-colored text.
- `background::UserColorType = nothing`: choose a background color for the rendered image.
- `bounding_box::UserColorType = nothing`: debugging bounding box color.
- `bounding_box_glyph::UserColorType = nothing`: debugging glyph bounding box color.
- `row_fact::Union{Nothing,Real} = nothing`: row spacing multiplier (e.g. for histogram).
"""
function png_image(
        p::Plot;
        font::Union{Nothing, AbstractString} = nothing,
        pixelsize::Integer = 32,
        transparent::Bool = true,
        foreground::UserColorType = nothing,
        background::UserColorType = nothing,
        bounding_box_glyph::UserColorType = nothing,
        bounding_box::UserColorType = nothing,
        row_fact::Union{Nothing, Real} = nothing,
    )
    canvas = p.graphics
    #####################################
    # visual fixes
    incx = if canvas isa HeatmapCanvas || canvas isa BarplotGraphics || p.cmap.bar
        -1
    else
        0
    end
    row_fact = something(
        row_fact, if canvas isa BarplotGraphics  # histogram
            1.08
        else
            1.0
        end
    )
    #####################################

    fg_color = ansi_color(something(foreground, transparent ? 244 : 252))
    bg_color = ansi_color(something(background, 235))

    rgba(color::ColorType, alpha = 1.0) = begin
        color == INVALID_COLOR && (color = fg_color)
        color < THRESHOLD || (color = LUT_8BIT[1 + (color - THRESHOLD)])
        RGBA{Float32}(convert(RGB{Float32}, reinterpret(RGB24, color)), alpha)
    end

    default_fg_color = rgba(fg_color)
    default_bg_color = rgba(bg_color, transparent ? 0.0 : 1.0)
    bbox = if bounding_box ≢ nothing
        rgba(ansi_color(bounding_box))
    else
        bounding_box
    end
    bbox_glyph = if bounding_box_glyph ≢ nothing
        rgba(ansi_color(bounding_box_glyph))
    else
        bounding_box_glyph
    end

    # compute final image size
    noop = (args...; kw...) -> nothing
    nr, nc = _show(devnull, noop, noop, p)

    # hack printing to collect chars & colors
    fchars = sizehint!(Char[], nr * nc)
    gchars = sizehint!(Char[], nr * nc)
    fcolors = sizehint!(RGBA{Float32}[], nr * nc)
    gcolors = sizehint!(RGBA{Float32}[], nr * nc)

    print_nocol(io::IO, args...) = begin
        line = string(args...)
        len = length(line)
        append!(fchars, line)
        append!(gchars, line)
        append!(fcolors, fill(default_fg_color, len))
        append!(gcolors, fill(default_bg_color, len))
        nothing
    end

    print_color(io::IO, color, args...; bgcol = missing) = begin
        fcolor = rgba(ansi_color(color))
        gcolor = if ismissing(bgcol)
            default_bg_color
        else
            rgba(ansi_color(bgcol))
        end
        line = string(args...)
        len = length(line)
        append!(fchars, line)
        append!(gchars, ismissing(bgcol) ? line : fill(FULL_BLOCK, len))  # for heatmap, colorbars - BORDER_SOLID[:l]
        append!(fcolors, fill(fcolor, len))
        append!(gcolors, fill(gcolor, len))
        nothing
    end

    # compute 1D stream of chars and colors
    _show(IOContext(devnull, :color => true), print_nocol, print_color, p)

    # compute 2D grid (image) of chars and colors
    lfchars = sizehint!([Char[]], nr)
    lgchars = sizehint!([Char[]], nr)
    lfcols = sizehint!([RGBA{Float32}[]], nr)
    lgcols = sizehint!([RGBA{Float32}[]], nr)
    r = 1
    for (fchar, gchar, fcol, gcol) in zip(fchars, gchars, fcolors, gcolors)
        if fchar ≡ '\n'
            r += 1
            push!(lfchars, Char[])
            push!(lgchars, Char[])
            push!(lfcols, RGBA{Float32}[])
            push!(lgcols, RGBA{Float32}[])
            continue
        end
        push!(lfchars[r], fchar)
        push!(lgchars[r], gchar)
        push!(lfcols[r], fcol)
        push!(lgcols[r], gcol)
    end

    if (face = get_font_face(font)) ≡ nothing
        @warn "font=$font has not been found, or missing fallback font: no `png` image has been generated."  # COV_EXCL_LINE
        return  # COV_EXCL_LINE
    end

    # render image
    kr = ASPECT_RATIO[]
    kc = kr / 2

    img = fill(
        default_bg_color,
        ceil(Int, kr * pixelsize * nr * row_fact),
        ceil(Int, kc * pixelsize * nc),
    )

    y0 = ceil(Int, (kr * pixelsize) / 2)
    x0 = ceil(Int, (kc * pixelsize * nc) / 2)

    for (r, (fchars, gchars, fcols, gcols)) in
        enumerate(zip(lfchars, lgchars, lfcols, lgcols))
        y = ceil(Int, y0 + (kr * pixelsize * row_fact) * (r - 1))
        incy = render_string!(
            img,
            fchars,
            face,
            pixelsize,
            y,
            x0;
            fcolor = fcols,
            gcolor = gcols,
            bcolor = nothing,  # not needed (initial fill, avoid overlaps)
            valign = :vcenter,
            halign = :hcenter,
            gstr = gchars,
            off_bg = 1,
            bbox_glyph,
            bbox,
            incx,
        )
    end

    return img
end

"""
    savefig(p, filename; color = false, kw...)

Save the given plot to a `txt or `png` file.

# Arguments - `txt`
- `color::Bool = false`: output the ANSI color codes to the file.

# Arguments - `png`
see help?> UnicodePlots.png_image

# Examples

```julia-repl
julia> savefig(lineplot([0, 1]), "foo.txt")
julia> savefig(lineplot([0, 1]), "foo.png"; font = "JuliaMono", pixelsize = 32, transparent = false)
```
"""
function savefig(p::Plot, filename::AbstractString; color::Bool = false, kw...)
    ext = lowercase(splitext(filename)[2])
    if ext ∈ ("", ".txt")
        open(filename, "w") do io
            show(IOContext(io, :color => color), p)
        end
    elseif ext == ".png"
        # `png_image` can fail if fonts are not found: a warning has already been
        # thrown there, so just bail out at this stage
        (img = png_image(p; kw...)) ≢ nothing && save_image(filename, img)
    else
        "extension \"$ext\" is unsupported: `savefig` only supports writing to `txt` or `png` files" |>
            ArgumentError |>
            throw
    end
    return nothing
end

function Base.string(p::Plot; color = false)
    io = PipeBuffer()
    show(IOContext(io, :color => color), p)
    return read(io, String)
end

"""
    OctantCanvas{YS <: Function, XS <: Function} <: LookupCanvas

The `OctantCanvas` is also Unicode-based.
It has the same resolution as `BrailleCanvas`.
In contrast to `BrailleCanvas`, the pixels don't have visible spacing between them.
This canvas effectively turns every character into eight pixels that can individually be manipulated using binary operations.
"""
struct OctantCanvas{YS <: Function, XS <: Function} <: LookupCanvas
    grid::Transpose{UInt16, Matrix{UInt16}}
    colors::Transpose{ColorType, Matrix{ColorType}}
    visible::Bool
    blend::Bool
    yflip::Bool
    xflip::Bool
    pixel_height::Int
    pixel_width::Int
    origin_y::Float64
    origin_x::Float64
    height::Float64
    width::Float64
    min_max::NTuple{2, UnicodeType}
    yscale::YS
    xscale::XS
end

const OCTANT_SIGNS = [
    0b00000001 0b00000010
    0b00000100 0b00001000
    0b00010000 0b00100000
    0b01000000 0b10000000
]

const N_OCTANT = grid_type(OctantCanvas)(256)
const OCTANT_DECODE = Vector{Char}(undef, typemax(N_OCTANT))

# The array is stored according to the octant bit pattern:
# 0 1
# 2 3
# 4 5
# 6 7
OCTANT_DECODE[001] = 0x000000A0  # NO-BREAK SPACE
OCTANT_DECODE[002] = 0x0001CEA8  # LEFT HALF UPPER ONE QUARTER BLOCK
OCTANT_DECODE[003] = 0x0001CEAB  # RIGHT HALF UPPER ONE QUARTER BLOCK
OCTANT_DECODE[004] = 0x0001FB82  # UPPER ONE QUARTER BLOCK
OCTANT_DECODE[005] = 0x0001CD00  # BLOCK OCTANT-3
OCTANT_DECODE[006] = 0x00002598  # QUADRANT UPPER LEFT
OCTANT_DECODE[007] = 0x0001CD01  # BLOCK OCTANT-23
OCTANT_DECODE[008] = 0x0001CD02  # BLOCK OCTANT-123
OCTANT_DECODE[009] = 0x0001CD03  # BLOCK OCTANT-4
OCTANT_DECODE[010] = 0x0001CD04  # BLOCK OCTANT-14
OCTANT_DECODE[011] = 0x0000259D  # QUADRANT UPPER RIGHT
OCTANT_DECODE[012] = 0x0001CD05  # BLOCK OCTANT-124
OCTANT_DECODE[013] = 0x0001CD06  # BLOCK OCTANT-34
OCTANT_DECODE[014] = 0x0001CD07  # BLOCK OCTANT-134
OCTANT_DECODE[015] = 0x0001CD08  # BLOCK OCTANT-234
OCTANT_DECODE[016] = 0x00002580  # UPPER HALF BLOCK
OCTANT_DECODE[017] = 0x0001CD09  # BLOCK OCTANT-5
OCTANT_DECODE[018] = 0x0001CD0A  # BLOCK OCTANT-15
OCTANT_DECODE[019] = 0x0001CD0B  # BLOCK OCTANT-25
OCTANT_DECODE[020] = 0x0001CD0C  # BLOCK OCTANT-125
OCTANT_DECODE[021] = 0x0001FBE6  # MIDDLE LEFT ONE QUARTER BLOCK
OCTANT_DECODE[022] = 0x0001CD0D  # BLOCK OCTANT-135
OCTANT_DECODE[023] = 0x0001CD0E  # BLOCK OCTANT-235
OCTANT_DECODE[024] = 0x0001CD0F  # BLOCK OCTANT-1235
OCTANT_DECODE[025] = 0x0001CD10  # BLOCK OCTANT-45
OCTANT_DECODE[026] = 0x0001CD11  # BLOCK OCTANT-145
OCTANT_DECODE[027] = 0x0001CD12  # BLOCK OCTANT-245
OCTANT_DECODE[028] = 0x0001CD13  # BLOCK OCTANT-1245
OCTANT_DECODE[029] = 0x0001CD14  # BLOCK OCTANT-345
OCTANT_DECODE[030] = 0x0001CD15  # BLOCK OCTANT-1345
OCTANT_DECODE[031] = 0x0001CD16  # BLOCK OCTANT-2345
OCTANT_DECODE[032] = 0x0001CD17  # BLOCK OCTANT-12345
OCTANT_DECODE[033] = 0x0001CD18  # BLOCK OCTANT-6
OCTANT_DECODE[034] = 0x0001CD19  # BLOCK OCTANT-16
OCTANT_DECODE[035] = 0x0001CD1A  # BLOCK OCTANT-26
OCTANT_DECODE[036] = 0x0001CD1B  # BLOCK OCTANT-126
OCTANT_DECODE[037] = 0x0001CD1C  # BLOCK OCTANT-36
OCTANT_DECODE[038] = 0x0001CD1D  # BLOCK OCTANT-136
OCTANT_DECODE[039] = 0x0001CD1E  # BLOCK OCTANT-236
OCTANT_DECODE[040] = 0x0001CD1F  # BLOCK OCTANT-1236
OCTANT_DECODE[041] = 0x0001FBE7  # MIDDLE RIGHT ONE QUARTER BLOCK
OCTANT_DECODE[042] = 0x0001CD20  # BLOCK OCTANT-146
OCTANT_DECODE[043] = 0x0001CD21  # BLOCK OCTANT-246
OCTANT_DECODE[044] = 0x0001CD22  # BLOCK OCTANT-1246
OCTANT_DECODE[045] = 0x0001CD23  # BLOCK OCTANT-346
OCTANT_DECODE[046] = 0x0001CD24  # BLOCK OCTANT-1346
OCTANT_DECODE[047] = 0x0001CD25  # BLOCK OCTANT-2346
OCTANT_DECODE[048] = 0x0001CD26  # BLOCK OCTANT-12346
OCTANT_DECODE[049] = 0x0001CD27  # BLOCK OCTANT-56
OCTANT_DECODE[050] = 0x0001CD28  # BLOCK OCTANT-156
OCTANT_DECODE[051] = 0x0001CD29  # BLOCK OCTANT-256
OCTANT_DECODE[052] = 0x0001CD2A  # BLOCK OCTANT-1256
OCTANT_DECODE[053] = 0x0001CD2B  # BLOCK OCTANT-356
OCTANT_DECODE[054] = 0x0001CD2C  # BLOCK OCTANT-1356
OCTANT_DECODE[055] = 0x0001CD2D  # BLOCK OCTANT-2356
OCTANT_DECODE[056] = 0x0001CD2E  # BLOCK OCTANT-12356
OCTANT_DECODE[057] = 0x0001CD2F  # BLOCK OCTANT-456
OCTANT_DECODE[058] = 0x0001CD30  # BLOCK OCTANT-1456
OCTANT_DECODE[059] = 0x0001CD31  # BLOCK OCTANT-2456
OCTANT_DECODE[060] = 0x0001CD32  # BLOCK OCTANT-12456
OCTANT_DECODE[061] = 0x0001CD33  # BLOCK OCTANT-3456
OCTANT_DECODE[062] = 0x0001CD34  # BLOCK OCTANT-13456
OCTANT_DECODE[063] = 0x0001CD35  # BLOCK OCTANT-23456
OCTANT_DECODE[064] = 0x0001FB85  # UPPER THREE QUARTERS BLOCK
OCTANT_DECODE[065] = 0x0001CEA3  # LEFT HALF LOWER ONE QUARTER BLOCK
OCTANT_DECODE[066] = 0x0001CD36  # BLOCK OCTANT-17
OCTANT_DECODE[067] = 0x0001CD37  # BLOCK OCTANT-27
OCTANT_DECODE[068] = 0x0001CD38  # BLOCK OCTANT-127
OCTANT_DECODE[069] = 0x0001CD39  # BLOCK OCTANT-37
OCTANT_DECODE[070] = 0x0001CD3A  # BLOCK OCTANT-137
OCTANT_DECODE[071] = 0x0001CD3B  # BLOCK OCTANT-237
OCTANT_DECODE[072] = 0x0001CD3C  # BLOCK OCTANT-1237
OCTANT_DECODE[073] = 0x0001CD3D  # BLOCK OCTANT-47
OCTANT_DECODE[074] = 0x0001CD3E  # BLOCK OCTANT-147
OCTANT_DECODE[075] = 0x0001CD3F  # BLOCK OCTANT-247
OCTANT_DECODE[076] = 0x0001CD40  # BLOCK OCTANT-1247
OCTANT_DECODE[077] = 0x0001CD41  # BLOCK OCTANT-347
OCTANT_DECODE[078] = 0x0001CD42  # BLOCK OCTANT-1347
OCTANT_DECODE[079] = 0x0001CD43  # BLOCK OCTANT-2347
OCTANT_DECODE[080] = 0x0001CD44  # BLOCK OCTANT-12347
OCTANT_DECODE[081] = 0x00002596  # QUADRANT LOWER LEFT
OCTANT_DECODE[082] = 0x0001CD45  # BLOCK OCTANT-157
OCTANT_DECODE[083] = 0x0001CD46  # BLOCK OCTANT-257
OCTANT_DECODE[084] = 0x0001CD47  # BLOCK OCTANT-1257
OCTANT_DECODE[085] = 0x0001CD48  # BLOCK OCTANT-357
OCTANT_DECODE[086] = 0x0000258C  # LEFT HALF BLOCK
OCTANT_DECODE[087] = 0x0001CD49  # BLOCK OCTANT-2357
OCTANT_DECODE[088] = 0x0001CD4A  # BLOCK OCTANT-12357
OCTANT_DECODE[089] = 0x0001CD4B  # BLOCK OCTANT-457
OCTANT_DECODE[090] = 0x0001CD4C  # BLOCK OCTANT-1457
OCTANT_DECODE[091] = 0x0000259E  # QUADRANT UPPER RIGHT AND LOWER LEFT
OCTANT_DECODE[092] = 0x0001CD4D  # BLOCK OCTANT-12457
OCTANT_DECODE[093] = 0x0001CD4E  # BLOCK OCTANT-3457
OCTANT_DECODE[094] = 0x0001CD4F  # BLOCK OCTANT-13457
OCTANT_DECODE[095] = 0x0001CD50  # BLOCK OCTANT-23457
OCTANT_DECODE[096] = 0x0000259B  # QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER LEFT
OCTANT_DECODE[097] = 0x0001CD51  # BLOCK OCTANT-67
OCTANT_DECODE[098] = 0x0001CD52  # BLOCK OCTANT-167
OCTANT_DECODE[099] = 0x0001CD53  # BLOCK OCTANT-267
OCTANT_DECODE[100] = 0x0001CD54  # BLOCK OCTANT-1267
OCTANT_DECODE[101] = 0x0001CD55  # BLOCK OCTANT-367
OCTANT_DECODE[102] = 0x0001CD56  # BLOCK OCTANT-1367
OCTANT_DECODE[103] = 0x0001CD57  # BLOCK OCTANT-2367
OCTANT_DECODE[104] = 0x0001CD58  # BLOCK OCTANT-12367
OCTANT_DECODE[105] = 0x0001CD59  # BLOCK OCTANT-467
OCTANT_DECODE[106] = 0x0001CD5A  # BLOCK OCTANT-1467
OCTANT_DECODE[107] = 0x0001CD5B  # BLOCK OCTANT-2467
OCTANT_DECODE[108] = 0x0001CD5C  # BLOCK OCTANT-12467
OCTANT_DECODE[109] = 0x0001CD5D  # BLOCK OCTANT-3467
OCTANT_DECODE[110] = 0x0001CD5E  # BLOCK OCTANT-13467
OCTANT_DECODE[111] = 0x0001CD5F  # BLOCK OCTANT-23467
OCTANT_DECODE[112] = 0x0001CD60  # BLOCK OCTANT-123467
OCTANT_DECODE[113] = 0x0001CD61  # BLOCK OCTANT-567
OCTANT_DECODE[114] = 0x0001CD62  # BLOCK OCTANT-1567
OCTANT_DECODE[115] = 0x0001CD63  # BLOCK OCTANT-2567
OCTANT_DECODE[116] = 0x0001CD64  # BLOCK OCTANT-12567
OCTANT_DECODE[117] = 0x0001CD65  # BLOCK OCTANT-3567
OCTANT_DECODE[118] = 0x0001CD66  # BLOCK OCTANT-13567
OCTANT_DECODE[119] = 0x0001CD67  # BLOCK OCTANT-23567
OCTANT_DECODE[120] = 0x0001CD68  # BLOCK OCTANT-123567
OCTANT_DECODE[121] = 0x0001CD69  # BLOCK OCTANT-4567
OCTANT_DECODE[122] = 0x0001CD6A  # BLOCK OCTANT-14567
OCTANT_DECODE[123] = 0x0001CD6B  # BLOCK OCTANT-24567
OCTANT_DECODE[124] = 0x0001CD6C  # BLOCK OCTANT-124567
OCTANT_DECODE[125] = 0x0001CD6D  # BLOCK OCTANT-34567
OCTANT_DECODE[126] = 0x0001CD6E  # BLOCK OCTANT-134567
OCTANT_DECODE[127] = 0x0001CD6F  # BLOCK OCTANT-234567
OCTANT_DECODE[128] = 0x0001CD70  # BLOCK OCTANT-1234567
OCTANT_DECODE[129] = 0x0001CEA0  # RIGHT HALF LOWER ONE QUARTER BLOCK
OCTANT_DECODE[130] = 0x0001CD71  # BLOCK OCTANT-18
OCTANT_DECODE[131] = 0x0001CD72  # BLOCK OCTANT-28
OCTANT_DECODE[132] = 0x0001CD73  # BLOCK OCTANT-128
OCTANT_DECODE[133] = 0x0001CD74  # BLOCK OCTANT-38
OCTANT_DECODE[134] = 0x0001CD75  # BLOCK OCTANT-138
OCTANT_DECODE[135] = 0x0001CD76  # BLOCK OCTANT-238
OCTANT_DECODE[136] = 0x0001CD77  # BLOCK OCTANT-1238
OCTANT_DECODE[137] = 0x0001CD78  # BLOCK OCTANT-48
OCTANT_DECODE[138] = 0x0001CD79  # BLOCK OCTANT-148
OCTANT_DECODE[139] = 0x0001CD7A  # BLOCK OCTANT-248
OCTANT_DECODE[140] = 0x0001CD7B  # BLOCK OCTANT-1248
OCTANT_DECODE[141] = 0x0001CD7C  # BLOCK OCTANT-348
OCTANT_DECODE[142] = 0x0001CD7D  # BLOCK OCTANT-1348
OCTANT_DECODE[143] = 0x0001CD7E  # BLOCK OCTANT-2348
OCTANT_DECODE[144] = 0x0001CD7F  # BLOCK OCTANT-12348
OCTANT_DECODE[145] = 0x0001CD80  # BLOCK OCTANT-58
OCTANT_DECODE[146] = 0x0001CD81  # BLOCK OCTANT-158
OCTANT_DECODE[147] = 0x0001CD82  # BLOCK OCTANT-258
OCTANT_DECODE[148] = 0x0001CD83  # BLOCK OCTANT-1258
OCTANT_DECODE[149] = 0x0001CD84  # BLOCK OCTANT-358
OCTANT_DECODE[150] = 0x0001CD85  # BLOCK OCTANT-1358
OCTANT_DECODE[151] = 0x0001CD86  # BLOCK OCTANT-2358
OCTANT_DECODE[152] = 0x0001CD87  # BLOCK OCTANT-12358
OCTANT_DECODE[153] = 0x0001CD88  # BLOCK OCTANT-458
OCTANT_DECODE[154] = 0x0001CD89  # BLOCK OCTANT-1458
OCTANT_DECODE[155] = 0x0001CD8A  # BLOCK OCTANT-2458
OCTANT_DECODE[156] = 0x0001CD8B  # BLOCK OCTANT-12458
OCTANT_DECODE[157] = 0x0001CD8C  # BLOCK OCTANT-3458
OCTANT_DECODE[158] = 0x0001CD8D  # BLOCK OCTANT-13458
OCTANT_DECODE[159] = 0x0001CD8E  # BLOCK OCTANT-23458
OCTANT_DECODE[160] = 0x0001CD8F  # BLOCK OCTANT-123458
OCTANT_DECODE[161] = 0x00002597  # QUADRANT LOWER RIGHT
OCTANT_DECODE[162] = 0x0001CD90  # BLOCK OCTANT-168
OCTANT_DECODE[163] = 0x0001CD91  # BLOCK OCTANT-268
OCTANT_DECODE[164] = 0x0001CD92  # BLOCK OCTANT-1268
OCTANT_DECODE[165] = 0x0001CD93  # BLOCK OCTANT-368
OCTANT_DECODE[166] = 0x0000259A  # QUADRANT UPPER LEFT AND LOWER RIGHT
OCTANT_DECODE[167] = 0x0001CD94  # BLOCK OCTANT-2368
OCTANT_DECODE[168] = 0x0001CD95  # BLOCK OCTANT-12368
OCTANT_DECODE[169] = 0x0001CD96  # BLOCK OCTANT-468
OCTANT_DECODE[170] = 0x0001CD97  # BLOCK OCTANT-1468
OCTANT_DECODE[171] = 0x00002590  # RIGHT HALF BLOCK
OCTANT_DECODE[172] = 0x0001CD98  # BLOCK OCTANT-12468
OCTANT_DECODE[173] = 0x0001CD99  # BLOCK OCTANT-3468
OCTANT_DECODE[174] = 0x0001CD9A  # BLOCK OCTANT-13468
OCTANT_DECODE[175] = 0x0001CD9B  # BLOCK OCTANT-23468
OCTANT_DECODE[176] = 0x0000259C  # QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER RIGHT
OCTANT_DECODE[177] = 0x0001CD9C  # BLOCK OCTANT-568
OCTANT_DECODE[178] = 0x0001CD9D  # BLOCK OCTANT-1568
OCTANT_DECODE[179] = 0x0001CD9E  # BLOCK OCTANT-2568
OCTANT_DECODE[180] = 0x0001CD9F  # BLOCK OCTANT-12568
OCTANT_DECODE[181] = 0x0001CDA0  # BLOCK OCTANT-3568
OCTANT_DECODE[182] = 0x0001CDA1  # BLOCK OCTANT-13568
OCTANT_DECODE[183] = 0x0001CDA2  # BLOCK OCTANT-23568
OCTANT_DECODE[184] = 0x0001CDA3  # BLOCK OCTANT-123568
OCTANT_DECODE[185] = 0x0001CDA4  # BLOCK OCTANT-4568
OCTANT_DECODE[186] = 0x0001CDA5  # BLOCK OCTANT-14568
OCTANT_DECODE[187] = 0x0001CDA6  # BLOCK OCTANT-24568
OCTANT_DECODE[188] = 0x0001CDA7  # BLOCK OCTANT-124568
OCTANT_DECODE[189] = 0x0001CDA8  # BLOCK OCTANT-34568
OCTANT_DECODE[190] = 0x0001CDA9  # BLOCK OCTANT-134568
OCTANT_DECODE[191] = 0x0001CDAA  # BLOCK OCTANT-234568
OCTANT_DECODE[192] = 0x0001CDAB  # BLOCK OCTANT-1234568
OCTANT_DECODE[193] = 0x00002582  # LOWER ONE QUARTER BLOCK
OCTANT_DECODE[194] = 0x0001CDAC  # BLOCK OCTANT-178
OCTANT_DECODE[195] = 0x0001CDAD  # BLOCK OCTANT-278
OCTANT_DECODE[196] = 0x0001CDAE  # BLOCK OCTANT-1278
OCTANT_DECODE[197] = 0x0001CDAF  # BLOCK OCTANT-378
OCTANT_DECODE[198] = 0x0001CDB0  # BLOCK OCTANT-1378
OCTANT_DECODE[199] = 0x0001CDB1  # BLOCK OCTANT-2378
OCTANT_DECODE[200] = 0x0001CDB2  # BLOCK OCTANT-12378
OCTANT_DECODE[201] = 0x0001CDB3  # BLOCK OCTANT-478
OCTANT_DECODE[202] = 0x0001CDB4  # BLOCK OCTANT-1478
OCTANT_DECODE[203] = 0x0001CDB5  # BLOCK OCTANT-2478
OCTANT_DECODE[204] = 0x0001CDB6  # BLOCK OCTANT-12478
OCTANT_DECODE[205] = 0x0001CDB7  # BLOCK OCTANT-3478
OCTANT_DECODE[206] = 0x0001CDB8  # BLOCK OCTANT-13478
OCTANT_DECODE[207] = 0x0001CDB9  # BLOCK OCTANT-23478
OCTANT_DECODE[208] = 0x0001CDBA  # BLOCK OCTANT-123478
OCTANT_DECODE[209] = 0x0001CDBB  # BLOCK OCTANT-578
OCTANT_DECODE[210] = 0x0001CDBC  # BLOCK OCTANT-1578
OCTANT_DECODE[211] = 0x0001CDBD  # BLOCK OCTANT-2578
OCTANT_DECODE[212] = 0x0001CDBE  # BLOCK OCTANT-12578
OCTANT_DECODE[213] = 0x0001CDBF  # BLOCK OCTANT-3578
OCTANT_DECODE[214] = 0x0001CDC0  # BLOCK OCTANT-13578
OCTANT_DECODE[215] = 0x0001CDC1  # BLOCK OCTANT-23578
OCTANT_DECODE[216] = 0x0001CDC2  # BLOCK OCTANT-123578
OCTANT_DECODE[217] = 0x0001CDC3  # BLOCK OCTANT-4578
OCTANT_DECODE[218] = 0x0001CDC4  # BLOCK OCTANT-14578
OCTANT_DECODE[219] = 0x0001CDC5  # BLOCK OCTANT-24578
OCTANT_DECODE[220] = 0x0001CDC6  # BLOCK OCTANT-124578
OCTANT_DECODE[221] = 0x0001CDC7  # BLOCK OCTANT-34578
OCTANT_DECODE[222] = 0x0001CDC8  # BLOCK OCTANT-134578
OCTANT_DECODE[223] = 0x0001CDC9  # BLOCK OCTANT-234578
OCTANT_DECODE[224] = 0x0001CDCA  # BLOCK OCTANT-1234578
OCTANT_DECODE[225] = 0x0001CDCB  # BLOCK OCTANT-678
OCTANT_DECODE[226] = 0x0001CDCC  # BLOCK OCTANT-1678
OCTANT_DECODE[227] = 0x0001CDCD  # BLOCK OCTANT-2678
OCTANT_DECODE[228] = 0x0001CDCE  # BLOCK OCTANT-12678
OCTANT_DECODE[229] = 0x0001CDCF  # BLOCK OCTANT-3678
OCTANT_DECODE[230] = 0x0001CDD0  # BLOCK OCTANT-13678
OCTANT_DECODE[231] = 0x0001CDD1  # BLOCK OCTANT-23678
OCTANT_DECODE[232] = 0x0001CDD2  # BLOCK OCTANT-123678
OCTANT_DECODE[233] = 0x0001CDD3  # BLOCK OCTANT-4678
OCTANT_DECODE[234] = 0x0001CDD4  # BLOCK OCTANT-14678
OCTANT_DECODE[235] = 0x0001CDD5  # BLOCK OCTANT-24678
OCTANT_DECODE[236] = 0x0001CDD6  # BLOCK OCTANT-124678
OCTANT_DECODE[237] = 0x0001CDD7  # BLOCK OCTANT-34678
OCTANT_DECODE[238] = 0x0001CDD8  # BLOCK OCTANT-134678
OCTANT_DECODE[239] = 0x0001CDD9  # BLOCK OCTANT-234678
OCTANT_DECODE[240] = 0x0001CDDA  # BLOCK OCTANT-1234678
OCTANT_DECODE[241] = 0x00002584  # LOWER HALF BLOCK
OCTANT_DECODE[242] = 0x0001CDDB  # BLOCK OCTANT-15678
OCTANT_DECODE[243] = 0x0001CDDC  # BLOCK OCTANT-25678
OCTANT_DECODE[244] = 0x0001CDDD  # BLOCK OCTANT-125678
OCTANT_DECODE[245] = 0x0001CDDE  # BLOCK OCTANT-35678
OCTANT_DECODE[246] = 0x00002599  # QUADRANT UPPER LEFT AND LOWER LEFT AND LOWER RIGHT
OCTANT_DECODE[247] = 0x0001CDDF  # BLOCK OCTANT-235678
OCTANT_DECODE[248] = 0x0001CDE0  # BLOCK OCTANT-1235678
OCTANT_DECODE[249] = 0x0001CDE1  # BLOCK OCTANT-45678
OCTANT_DECODE[250] = 0x0001CDE2  # BLOCK OCTANT-145678
OCTANT_DECODE[251] = 0x0000259F  # QUADRANT UPPER RIGHT AND LOWER LEFT AND LOWER RIGHT
OCTANT_DECODE[252] = 0x0001CDE3  # BLOCK OCTANT-1245678
OCTANT_DECODE[253] = 0x00002586  # LOWER THREE QUARTERS BLOCK
OCTANT_DECODE[254] = 0x0001CDE4  # BLOCK OCTANT-1345678
OCTANT_DECODE[255] = 0x0001CDE5  # BLOCK OCTANT-2345678
OCTANT_DECODE[256] = 0x00002588  # FULL BLOCK
OCTANT_DECODE[(N_OCTANT + 1):typemax(N_OCTANT)] = UNICODE_TABLE[1:(typemax(N_OCTANT) - N_OCTANT)]

@inline x_pixel_per_char(::Type{<:OctantCanvas}) = 2
@inline y_pixel_per_char(::Type{<:OctantCanvas}) = 4

@inline lookup_encode(::OctantCanvas) = OCTANT_SIGNS
@inline lookup_decode(::OctantCanvas) = OCTANT_DECODE
@inline lookup_offset(::OctantCanvas) = N_OCTANT

OctantCanvas(args...; kw...) =
    CreateLookupCanvas(OctantCanvas, (0b00000000, 0b11111111), args...; kw...)

const FTE = if isdefined(Base, :get_extension)
    Base.get_extension(UnicodePlots, :FreeTypeExt)
else
    UnicodePlots.FreeTypeExt
end
const FT_DIR = joinpath(@__DIR__, "..", "..", "assets", "fonts")
push!(FTE.VALID_FONTPATHS, FT_DIR)

@testset "init and done" begin
    @test_throws ErrorException FTE.ft_init()
    @test FTE.ft_done()
    @test_throws ErrorException FTE.ft_done()
    @test FTE.ft_init()
end

face = FTE.find_font("hack")  # must occur after `ft_init` and `ft_done` !

@testset "basics" begin
    @test face ≢ nothing
    @test :size in propertynames(face)
    @test repr(face) == "FTFont (family = Hack, style = Regular)"

    FTE.set_pixelsize(face, 64)  # should be the default
    img, extent = FTE.render_face(face, 'C', 64)
    @test size(img) == (30, 49)
    @test typeof(img) == Array{UInt8, 2}

    @test FTE.hadvance(extent) == 39
    @test FTE.vadvance(extent) == 62
    @test FTE.inkheight(extent) == 49
    @test FTE.hbearing_ori_to_left(extent) == 4
    @test FTE.hbearing_ori_to_top(extent) == 48
    @test FTE.leftinkbound(extent) == 4
    @test FTE.rightinkbound(extent) == 34
    @test FTE.bottominkbound(extent) == -1
    @test FTE.topinkbound(extent) == 48

    a = UnicodePlots.render_string!(zeros(UInt8, 20, 100), "helgo", face, 10, 10, 10)

    @test any(a[3:12, :] .≠ 0)
    @test all(a[vcat(1:2, 13:20), :] .== 0)
    @test any(a[:, 11:40] .≠ 0)
    @test all(a[:, vcat(1:10, 41:100)] .== 0)
    a = UnicodePlots.render_string!(zeros(UInt8, 20, 100), "helgo", face, 10, 15, 70)
    @test any(a[8:17, :] .≠ 0)
    @test all(a[vcat(1:7, 18:20), :] .== 0)
    @test any(a[:, 71:100] .≠ 0)
    @test all(a[:, 1:70] .== 0)

    a = UnicodePlots.render_string!(zeros(Float32, 20, 100), "helgo", face, 10, 10, 50)
    @test maximum(a) ≤ 1.0
    a = UnicodePlots.render_string!(zeros(Float64, 20, 100), "helgo", face, 10, 10, 50)
    @test maximum(a) ≤ 1.0

    @test UnicodePlots.render_string!(zeros(UInt8, 20, 100), "helgo", face, 10, 25, 80) isa
        Matrix
end

@testset "ways to access glyphs" begin
    i = FTE.glyph_index(face, 'A')
    @test FTE.glyph_index(face, i) == i
    @test FTE.glyph_index(face, "A") == i
end

@testset "alignments" begin
    a = UnicodePlots.render_string!(
        zeros(UInt8, 20, 100),
        "helgo",
        face,
        10,
        10,
        50,
        valign = :vtop,
    )

    @test all(a[1:10, :] .== 0)
    @test any(a[11:20, :] .≠ 0)
    a = UnicodePlots.render_string!(
        zeros(UInt8, 20, 100),
        "helgo",
        face,
        10,
        10,
        50,
        valign = :vcenter,
    )
    @test all(a[vcat(1:5, 16:end), :] .== 0)
    @test any(a[6:15, :] .≠ 0)
    a = UnicodePlots.render_string!(
        zeros(UInt8, 20, 100),
        "helgo",
        face,
        10,
        10,
        50,
        valign = :vbaseline,
    )
    @test all(a[vcat(1:2, 13:end), :] .== 0)
    @test any(a[3:12, :] .≠ 0)
    a = UnicodePlots.render_string!(
        zeros(UInt8, 20, 100),
        "helgo",
        face,
        10,
        10,
        50,
        valign = :vbottom,
    )
    @test any(a[1:10, :] .≠ 0)
    @test all(a[11:20, :] .== 0)
    a = UnicodePlots.render_string!(
        zeros(UInt8, 20, 100),
        "helgo",
        face,
        10,
        10,
        50,
        halign = :hleft,
    )
    @test all(a[:, 1:50] .== 0)
    @test any(a[:, 51:100] .≠ 0)
    a = UnicodePlots.render_string!(
        zeros(UInt8, 20, 100),
        "helgo",
        face,
        10,
        10,
        50,
        halign = :hcenter,
    )
    @test all(a[:, vcat(1:35, 66:end)] .== 0)
    @test any(a[:, 36:65] .≠ 0)
    a = UnicodePlots.render_string!(
        zeros(UInt8, 20, 100),
        "helgo",
        face,
        10,
        10,
        50,
        halign = :hright,
    )
    @test any(a[:, 1:50] .≠ 0)
    @test all(a[:, 51:100] .== 0)

    UnicodePlots.render_string!(
        zeros(UInt8, 20, 100),
        "helgo",
        face,
        10,
        1,
        1,
        halign = :hcenter,
        valign = :vcenter,
    )
end

@testset "foreground / background colors" begin
    a = UnicodePlots.render_string!(
        zeros(UInt8, 20, 100),
        "helgo",
        face,
        10,
        10,
        50,
        fcolor = 0x80,
    )
    @test maximum(a) ≤ 0x80
    a = UnicodePlots.render_string!(
        zeros(UInt8, 20, 100),
        "helgo",
        face,
        10,
        10,
        50,
        fcolor = 0x80,
        bcolor = 0x40,
    )
    @test any(a .== 0x40)
    a = UnicodePlots.render_string!(
        fill(0x01, 20, 100),
        "helgo",
        face,
        10,
        10,
        50,
        bcolor = nothing,
    )
    @test !any(a .== 0x00)
end

@testset "array of grays" begin
    @test UnicodePlots.render_string!(zeros(Gray, 20, 100), "helgo", face, 10, 10, 50) isa
        Matrix
    @test UnicodePlots.render_string!(
        zeros(Gray{Float64}, 20, 100),
        "helgo",
        face,
        10,
        10,
        50,
        fcolor = Gray(0.5),
    ) isa Matrix
end

@testset "per char background / colors" begin
    for str in ("helgo", collect("helgo"))
        fcolor = [RGB{Float32}(rand(3)...) for _ in 1:length(str)]
        @test UnicodePlots.render_string!(
            zeros(RGB{Float32}, 20, 100),
            str,
            face,
            10,
            1,
            1;
            fcolor = fcolor,
        ) isa Matrix
        gcolor = [RGB{Float32}(rand(3)...) for _ in 1:length(str)]
        gstr = fill('█', length(str))
        @test UnicodePlots.render_string!(
            zeros(RGB{Float32}, 20, 100),
            str,
            face,
            10,
            1,
            1;
            fcolor = fcolor,
            gcolor = gcolor,
            gstr = gstr,
        ) isa Matrix
    end
end

@testset "draw bounding boxes" begin
    @test UnicodePlots.render_string!(
        zeros(RGB{Float32}, 20, 100),
        "helgo",
        face,
        10,
        1,
        1;
        gcolor = RGB{Float32}(0.0, 1.0, 0.0),
        bbox = RGB{Float32}(1.0, 0.0, 0.0),
        bbox_glyph = RGB{Float32}(0.0, 0.0, 1.0),
    ) isa Matrix
end

@testset "misc" begin
    @test FTE.fallback_fonts() isa Tuple
end

@testset "thread safety" begin
    mktempdir() do dir
        n = 100
        fontfiles = map(1:n) do i
            cp(joinpath(FT_DIR, "hack_regular.ttf"), joinpath(dir, "hack_regular_$i.ttf"))
        end
        Threads.@threads for f in fontfiles
            fo = FTE.FTFont(f)
            Threads.@threads for i in 1:n
                FTE.load_glyph(fo, i)
                FTE.load_glyph(fo, i, 64)
                FTE.render_face(fo, i, 16)
            end
        end
    end
end

pop!(FTE.VALID_FONTPATHS)

"""
    horizontal_histogram(hist; kw...)

# Description

Draws a horizontal histogram of the given `StatsBase.Histogram`.

Note internally that `horizontal_histogram` is a simply wrapper for
[`barplot`](@ref), which means that it supports the same keyword arguments.

# Usage

    horizontal_histogram(hist; $(keywords((border = :barplot, color = :green), remove = (:ylim, :yscale, :height, :grid), add = (:symbols,))))

# Arguments

$(arguments((hist = "a fitted `StatsBase.Histogram` that should be plotted",); add = (:symbols,)))
"""
function horizontal_histogram(
        hist::Histogram;
        symbols = ('▏', '▎', '▍', '▌', '▋', '▊', '▉', '█'),
        xscale = KEYWORDS.xscale,
        info::AbstractString = "",  # unused in horizontal version
        kw...,
    )
    edges, counts = hist.edges[1], hist.weights
    labels = Vector{String}(undef, length(counts))
    binwidths = diff(edges)
    # compute label padding based on all labels.
    # this is done to make all decimal points align.
    pad_left, pad_right = 0, 0
    io = PipeBuffer()
    for i in eachindex(counts)
        binwidth = binwidths[i]
        val1 = float_round_log10(edges[i], binwidth)
        val2 = float_round_log10(val1 + binwidth, binwidth)
        a1 = Base.alignment(io, val1)
        a2 = Base.alignment(io, val2)
        pad_left = max(pad_left, a1[1], a2[1])
        pad_right = max(pad_right, a1[2], a2[2])
    end
    # compute the labels using the computed padding
    l_chr = hist.closed ≡ :right ? '(' : '['
    r_chr = hist.closed ≡ :right ? ']' : ')'
    for i in eachindex(counts)
        binwidth = binwidths[i]
        val1 = float_round_log10(edges[i], binwidth)
        val2 = float_round_log10(val1 + binwidth, binwidth)
        a1 = Base.alignment(io, val1)
        a2 = Base.alignment(io, val2)
        labels[i] = string(
            l_chr,
            ' '^(pad_left - a1[1]),
            compact_repr(val1),
            ' '^(pad_right - a1[2]),
            ", ",
            ' '^(pad_left - a2[1]),
            compact_repr(val2),
            ' '^(pad_right - a2[2]),
            r_chr,
        )
    end
    plot = barplot(
        labels,
        counts;
        symbols,
        xscale,
        xlabel = transform_name(xscale, "Frequency"),
        kw...,
    )
    return plot
end

"""
    vertical_histogram(hist; kw...)

# Description

Draws a vertical histogram of the given `StatsBase.Histogram`.

# Usage

    vertical_histogram(hist; $(keywords((border = :barplot, color = :green), remove = (:xlim, :ylim, :xscale, :yscale, :width, :height, :grid), add = (:symbols,))))

# Arguments

$(arguments((hist = "a fitted `StatsBase.Histogram` that should be plotted",); add = (:symbols,)))
"""
function vertical_histogram(
        hist::Histogram;
        symbols = ('▁', '▂', '▃', '▄', '▅', '▆', '▇', '█'),
        info::AbstractString = "",
        color::UserColorType = :green,
        canvas::Type{<:Canvas} = BlockCanvas,
        kw...,
    )
    edges, counts = first(hist.edges), hist.weights
    centers = (edges[begin:(end - 1)] + edges[(begin + 1):end]) / 2
    plot = Plot(
        float.(centers),
        float.(counts),
        nothing,
        canvas;
        grid = false,
        border = :corners,
        xlim = extrema(edges),
        ylim = (0, maximum(counts)),
        width = length(centers),
        xlabel = info,
        kw...,
    )
    max_val = maximum(counts)
    nsyms = length(symbols)
    nr = nrows(plot.graphics)
    for (x, y) in zip(centers, counts)
        frac = float(max_val > 0 ? max(y, zero(y)) / max_val : 0)
        n_full = (nsyms > 1 ? floor : round)(Int, frac * nr)
        δ = max_val / nr
        for r in 1:n_full
            annotate!(plot, x, (r - 0.5) * δ, symbols[nsyms]; color)
        end
        if nsyms > 1 && (rem = frac * nr - n_full) > 0
            if 1 ≤ (I = round(Int, rem * nsyms)) ≤ nsyms
                annotate!(plot, x, (n_full + 0.5) * δ, symbols[I]; color)
            end
        end
    end
    return plot
end

"""
    histogram(data; kw...)

# Description

Draws a horizontal or vertical histogram of the given `data`, fitted to an `Histogram`.

# Usage

    histogram(x; nbins, closed = :left, vertical = false, stats = true, $(keywords((border = :barplot, color = :green), remove = (:xlim, :ylim, :xscale, :yscale, :width, :height, :grid), add = (:symbols,))))

# Arguments

$(
    arguments(
        (
            x = "array of numbers for which the histogram should be computed",
            nbins = "approximate number of bins that should be used",
            closed = "if `:left` (default), the bin intervals are left-closed ``[a, b)``; if `:right`, intervals are right-closed ``(a, b]``",
            vertical = "vertical histogram instead of the default horizontal one",
            stats = "display statistics (vertical only)",
        ); add = (:symbols,)
    )
)

# Author(s)

- Iain Dunning (github.com/IainNZ)
- Christof Stocker (github.com/Evizero)
- Kenta Sato (github.com/bicycle1885)

# Examples

```julia-repl
julia> histogram(randn(1_000) * .1, closed=:right, nbins=15)
                  ┌                                        ┐
   (-0.35, -0.3 ] ┤▍ 2
   (-0.3 , -0.25] ┤▌ 3
   (-0.25, -0.2 ] ┤██▌ 15
   (-0.2 , -0.15] ┤██████▌ 39
   (-0.15, -0.1 ] ┤████████████▍ 75
   (-0.1 , -0.05] ┤█████████████████████▋ 131
   (-0.05, -0.0 ] ┤███████████████████████████████▍ 190
   ( 0.0 ,  0.05] ┤███████████████████████████████████  212
   ( 0.05,  0.1 ] ┤█████████████████████████▉ 157
   ( 0.1 ,  0.15] ┤████████████████▌ 100
   ( 0.15,  0.2 ] ┤███████▉ 48
   ( 0.2 ,  0.25] ┤███▉ 24
   ( 0.25,  0.3 ] ┤▌ 3
   ( 0.3 ,  0.35] ┤▎ 1
                  └                                        ┘
                                   Frequency

julia> histogram(randn(100_000) .* .1, nbins=60, vertical=true, height=10)
         ┌                                             ┐
   7 978                       ▄▇█▆
                              ▆████▆
                             ▇██████▇
                            ▅████████▄
                           ▄██████████▃
                          ▃████████████▃
                         ▂██████████████▂
                        ▃████████████████▃
                      ▁▅██████████████████▅▁
       0         ▁▁▂▄▆██████████████████████▅▃▂▁▁
         └                                             ┘
          -0.46                                    0.44
                        μ ± σ: -0.0 ± 0.1
```

# See also

[`Plot`](@ref), [`barplot`](@ref), [`BarplotGraphics`](@ref)
"""
function histogram(x::AbstractArray; closed = :left, vertical = false, stats = true, kw...)
    x_plot = dropdims(x, dims = Tuple(filter(d -> size(x, d) == 1, 1:ndims(x))))
    len = length(x_plot)
    nbins = get(kw, :nbins, sturges(len))
    hist = fit(Histogram, x_plot; closed, nbins)
    info = if vertical && stats
        digits = 2
        mx, Mx = extrema(x_plot)
        μ = sum(x_plot) / len
        σ = √(sum((x_plot .- μ) .^ 2) / len)
        (
            "μ ± σ: " *
                lpad(round(μ; digits), digits + 1) * " ± " *
                lpad(round(σ; digits), digits + 1)
        )
    else
        ""
    end
    callable = vertical ? vertical_histogram : horizontal_histogram
    return callable(hist; info, filter(p -> p.first ≢ :nbins, kw)...)
end

"""
    Plot(graphics; kw...)

# Description

Decoration for objects that are `GraphicsArea` (or `Canvas`).
It is used to surround the inner `GraphicsArea` object with
additional information such as a title, border, and axis labels.

# Usage

    Plot(graphics; $(keywords(; default = (), add = (:title, :xlabel, :ylabel, :zlabel, :border, :margin, :padding, :compact, :labels))))

    Plot(x, y, z, canvas; $(keywords()))

# Arguments

$(
    arguments(
        (; graphics = "the `GraphicsArea` (e.g. a subtype of `Canvas`) that the plot should decorate");
        add = (:x, :y, :z, :canvas)
    )
)

# Methods

- `title!(plot::Plot, title::String)`

- `xlabel!(plot::Plot, xlabel::String)`

- `ylabel!(plot::Plot, xlabel::String)`

- `zlabel!(plot::Plot, zlabel::String)`

- `label!(plot::Plot, where::Symbol, value::String)`

- `label!(plot::Plot, where::Symbol, row::Integer, value::String)`

Author(s)

- Christof Stocker (github.com/Evizero)

# See also

[`scatterplot`](@ref), [`lineplot`](@ref),
[`BarplotGraphics`](@ref), [`BrailleCanvas`](@ref),
[`BlockCanvas`](@ref), [`AsciiCanvas`](@ref)
"""
struct Plot{T <: GraphicsArea, E, F}
    graphics::T
    projection::MVP{E, F}
    autocolor::RefValue{Int}
    series::RefValue{Int}
    title::RefValue{String}
    xlabel::RefValue{String}
    ylabel::RefValue{String}
    zlabel::RefValue{String}
    margin::RefValue{Int}
    padding::RefValue{Int}
    unicode_exponent::RefValue{Bool}
    thousands_separator::RefValue{Char}
    border::RefValue{Symbol}
    compact_labels::RefValue{Bool}
    compact::RefValue{Bool}
    labels::RefValue{Bool}
    labels_left::Dict{Int, String}
    labels_right::Dict{Int, String}
    colors_left::Dict{Int, ColorType}
    colors_right::Dict{Int, ColorType}
    decorations::Dict{Symbol, String}
    colors_deco::Dict{Symbol, ColorType}
    cmap::ColorMap
end

function Plot(
        graphics::T;
        title::AbstractString = PLOT_KEYWORDS.title,
        xlabel::AbstractString = PLOT_KEYWORDS.xlabel,
        ylabel::AbstractString = PLOT_KEYWORDS.ylabel,
        zlabel::AbstractString = PLOT_KEYWORDS.zlabel,
        unicode_exponent::Bool = PLOT_KEYWORDS.unicode_exponent,
        thousands_separator::Char = PLOT_KEYWORDS.thousands_separator,
        border::Symbol = PLOT_KEYWORDS.border,
        compact_labels::Bool = PLOT_KEYWORDS.compact_labels,
        compact::Bool = PLOT_KEYWORDS.compact,
        margin::Integer = PLOT_KEYWORDS.margin,
        padding::Integer = PLOT_KEYWORDS.padding,
        labels::Bool = PLOT_KEYWORDS.labels,
        colorbar::Bool = PLOT_KEYWORDS.colorbar,
        colorbar_border::Symbol = PLOT_KEYWORDS.colorbar_border,
        colorbar_lim = PLOT_KEYWORDS.colorbar_lim,
        colormap::Any = PLOT_KEYWORDS.colormap,
        projection::Union{Nothing, MVP} = nothing,
        ignored...,
    ) where {T <: GraphicsArea}
    margin < 0 && throw(ArgumentError("`margin` must be ≥ 0"))
    padding < 0 && throw(ArgumentError("`padding` must be ≥ 0"))
    if compact  # save space
        margin = padding = 0
        compact_labels = true
    end
    projection = something(projection, MVP())
    E = Val{is_enabled(projection)}
    F = typeof(projection.dist)
    return Plot{T, E, F}(
        graphics,
        projection,
        Ref(0),
        Ref(0),
        Ref(string(title)),
        Ref(string(xlabel)),
        Ref(string(ylabel)),
        Ref(string(zlabel)),
        Ref(Int(margin)),
        Ref(Int(padding)),
        Ref(unicode_exponent),
        Ref(thousands_separator),
        Ref(border),
        Ref(compact_labels),
        Ref(compact),
        Ref(labels && graphics.visible),
        Dict{Int, String}(),
        Dict{Int, String}(),
        Dict{Int, ColorType}(),
        Dict{Int, ColorType}(),
        Dict{Symbol, String}(),
        Dict{Symbol, ColorType}(),
        ColorMap(colorbar_border, colorbar, colorbar_lim, colormap_callback(colormap)),
    )
end

"""
    validate_input(x, y, z = nothing)

# Description

Check for invalid input (length) and selects only finite input data.
"""
function validate_input(x::AbstractVector, y::AbstractVector, z::AbstractVector)
    (nx = length(x)) == (ny = length(y)) == (nz = length(z)) ||
        throw(DimensionMismatch("`x`, `y` and `z` must have same length"))
    return if nx == ny == nz == 0
        x, y, z
    else
        idx =
            BitVector(map((i, j, k) -> isfinite(i) && isfinite(j) && isfinite(k), x, y, z))
        x[idx], y[idx], z[idx]
    end
end

function validate_input(x::AbstractVector, y::AbstractVector, z::Nothing)
    (nx = length(x)) == (ny = length(y)) ||
        throw(DimensionMismatch("`x` and `y` must have same length"))
    return if nx == ny == 0
        x, y, z
    else
        idx = BitVector(map((i, j) -> isfinite(i) && isfinite(j), x, y))
        x[idx], y[idx], z
    end
end

function plot_size(; max_width_ylims_labels = 0, kw...)
    height = get(kw, :height, PLOT_KEYWORDS.height)
    width = get(kw, :width, PLOT_KEYWORDS.width)
    ylabel = get(kw, :ylabel, PLOT_KEYWORDS.ylabel)
    title = get(kw, :title, PLOT_KEYWORDS.title)
    margin = get(kw, :margin, PLOT_KEYWORDS.margin)
    padding = get(kw, :padding, PLOT_KEYWORDS.padding)
    compact_labels = get(kw, :compact_labels, PLOT_KEYWORDS.compact_labels)
    borders = 2  # add spaces for 2x border
    len_ylab = length(ylabel)
    width_labels = if compact_labels
        max(len_ylab, max_width_ylims_labels)
    else
        len_ylab + (len_ylab > 0 ? 1 : 0) + max_width_ylims_labels  # one space in-between
    end
    height_offset = (
        1 +  # xticks line
            1 +  # forced newline
            1  # `julia>` prompt
    )
    return (
        something(
            height ≡ :auto ?
                displaysize(stdout)[1] - height_offset - borders - (isempty(title) ? 0 : 1) :
                height,
            DEFAULT_HEIGHT[],
        ),
        something(
            width ≡ :auto ?
                displaysize(stdout)[2] - margin - 2padding - width_labels - borders : width,
            DEFAULT_WIDTH[],
        ),
    )
end

function axis_label(mvp, dat, lim, scale, flip, unicode_exponent, thousands_separator)
    base = scale isa Symbol ? get(BASES, scale, nothing) : nothing

    min_val, max_val = if is_enabled(mvp)
        autolims(lim)
    else
        extend_limits(dat, lim, base ≡ nothing ? identity : scale)
    end

    min_lab = nice_repr(min_val, unicode_exponent, thousands_separator)
    max_lab = nice_repr(max_val, unicode_exponent, thousands_separator)

    if base ≢ nothing
        if unicode_exponent
            min_lab = superscript(min_lab)
            max_lab = superscript(max_lab)
        end
        base_str = base * (unicode_exponent ? "" : "^")
        min_lab, max_lab = base_str * min_lab, base_str * max_lab
    end

    return flip ? (max_lab, min_lab) : (min_lab, max_lab)
end

Plot(; kw...) = Plot(Float64[], Float64[]; kw...)

function Plot(
        x::AbstractVector,
        y::AbstractVector,
        z::Union{AbstractVector, Nothing} = nothing,
        canvas::Type{<:Canvas} = BrailleCanvas;
        title::AbstractString = PLOT_KEYWORDS.title,
        xlabel::AbstractString = PLOT_KEYWORDS.xlabel,
        ylabel::AbstractString = PLOT_KEYWORDS.ylabel,
        zlabel::AbstractString = PLOT_KEYWORDS.zlabel,
        unicode_exponent::Bool = PLOT_KEYWORDS.unicode_exponent,
        thousands_separator::Char = PLOT_KEYWORDS.thousands_separator,
        xscale::Union{Symbol, Function} = PLOT_KEYWORDS.xscale,
        yscale::Union{Symbol, Function} = PLOT_KEYWORDS.yscale,
        height::Union{Integer, Nothing, Symbol} = nothing,
        width::Union{Integer, Nothing, Symbol} = nothing,
        border::Symbol = PLOT_KEYWORDS.border,
        compact_labels::Bool = PLOT_KEYWORDS.compact_labels,
        compact::Bool = PLOT_KEYWORDS.compact,
        blend::Bool = PLOT_KEYWORDS.blend,
        xlim = PLOT_KEYWORDS.xlim,
        ylim = PLOT_KEYWORDS.ylim,
        margin::Integer = PLOT_KEYWORDS.margin,
        padding::Integer = PLOT_KEYWORDS.padding,
        labels::Bool = PLOT_KEYWORDS.labels,
        colorbar::Bool = PLOT_KEYWORDS.colorbar,
        colorbar_border::Symbol = PLOT_KEYWORDS.colorbar_border,
        colorbar_lim = PLOT_KEYWORDS.colorbar_lim,
        colormap::Any = PLOT_KEYWORDS.colormap,
        grid::Bool = PLOT_KEYWORDS.grid,
        yticks::Bool = PLOT_KEYWORDS.yticks,
        xticks::Bool = PLOT_KEYWORDS.xticks,
        min_height::Integer = PLOT_KEYWORDS.min_height,
        min_width::Integer = PLOT_KEYWORDS.min_width,
        yflip::Bool = PLOT_KEYWORDS.yflip,
        xflip::Bool = PLOT_KEYWORDS.xflip,
        projection::Union{Nothing, Symbol, MVP} = nothing,
        axes3d = PLOT_KEYWORDS.axes3d,
        canvas_kw = PLOT_KEYWORDS.canvas_kw,
        kw...,
    )
    length(xlim) == length(ylim) == 2 ||
        throw(ArgumentError("`xlim` and `ylim` must be tuples or vectors of length 2"))

    x, y, z = validate_input(x, y, z)

    mvp = create_MVP(projection, x, y, z; kw...)

    xlim, ylim = unitless.(xlim), unitless.(ylim)

    max_width_ylims_labels = 0
    if xticks
        lab_x_bl, lab_x_br = axis_label(mvp, x, xlim, xscale, xflip, unicode_exponent, thousands_separator)
    end
    if yticks
        lab_y_lt, lab_y_lb = axis_label(mvp, y, ylim, yscale, yflip, unicode_exponent, thousands_separator)
        max_width_ylims_labels = max(length(lab_y_lt), length(lab_y_lb))
    end

    if compact  # save space
        margin = padding = 0
        compact_labels = true
    end

    height, width = plot_size(;
        max_width_ylims_labels,
        height,
        width,
        title,
        ylabel,
        compact_labels,
        margin,
        padding,
        kw...,
    )

    (visible = width ≥ 0) && (width = max(width, min_width))
    height = max(height, min_height)

    (mx, Mx), (my, My) = if is_enabled(mvp)
        (scale_callback(xscale) ≢ identity || scale_callback(yscale) ≢ identity) &&
            throw(ArgumentError("`xscale` or `yscale` are unsupported in 3D"))
        grid = blend = false

        # normalized coordinates, but allow override (artifact for zooming):
        # using `xlim = (-0.5, 0.5)` & `ylim = (-0.5, 0.5)`
        # should be close to using `zoom = 2`.
        autolims(xlim), autolims(ylim)
    else
        extend_limits(x, xlim, xscale), extend_limits(y, ylim, yscale)
    end

    can = canvas(
        height,
        width;
        origin_y = my,
        origin_x = mx,
        height = My - my,
        width = Mx - mx,
        blend,
        visible,
        yscale,
        xscale,
        yflip,
        xflip,
        canvas_kw...,
    )
    plot = Plot(
        can;
        title,
        margin,
        padding,
        border,
        compact_labels,
        compact,
        labels,
        xlabel,
        ylabel,
        zlabel,
        colormap,
        colorbar,
        colorbar_border,
        colorbar_lim,
        unicode_exponent,
        thousands_separator,
        projection = mvp,
    )
    bc = BORDER_COLOR[]
    if xticks
        label!(plot, :bl, lab_x_bl; color = bc)
        label!(plot, :br, lab_x_br; color = bc)
    end
    if yticks
        label!(plot, :l, nrows(can), lab_y_lt; color = bc)
        label!(plot, :l, 1, lab_y_lb; color = bc)
    end
    if grid && (scale_callback(xscale) ≡ identity && scale_callback(yscale) ≡ identity)
        my < 0 < My && lines!(plot, mx, 0.0, Mx, 0.0)
        mx < 0 < Mx && lines!(plot, 0.0, my, 0.0, My)
    end

    (is_enabled(mvp) && axes3d) && draw_axes!(plot, 0.8 * mx, 0.8 * my, nothing)

    return plot
end

function next_color!(plot::Plot)
    next_idx = plot.autocolor[] + 1
    next_color = COLOR_CYCLE[][next_idx]
    plot.autocolor[] = next_idx % length(COLOR_CYCLE[])
    return next_color
end

"""
    title(plot) -> String

Returns the current title of the given plot.
Alternatively, the title can be changed with `title!`.
"""
@inline title(plot::Plot) = plot.title[]

"""
    title!(plot, newtitle)

Sets a new title for the given plot.
Alternatively, the current title can be queried using `title`.
"""
function title!(plot::Plot, title::AbstractString)
    plot.title[] = title
    return plot
end

"""
    xlabel(plot) -> String

Returns the current label for the x-axis.
Alternatively, the x-label can be changed with `xlabel!`.
"""
@inline xlabel(plot::Plot) = plot.xlabel[]

"""
    xlabel!(plot, newlabel)

Sets a new x-label for the given plot.
Alternatively, the current label can be queried using `xlabel`.
"""
function xlabel!(plot::Plot, xlabel::AbstractString)
    plot.xlabel[] = xlabel
    return plot
end

"""
    ylabel(plot) -> String

Returns the current label for the y-axis.
Alternatively, the y-label can be changed with `ylabel!`.
"""
@inline ylabel(plot::Plot) = plot.ylabel[]

"""
    ylabel!(plot, newlabel)

Sets a new y-label for the given plot.
Alternatively, the current label can be
queried using `ylabel`
"""
function ylabel!(plot::Plot, ylabel::AbstractString)
    plot.ylabel[] = ylabel
    return plot
end

"""
    zlabel(plot) -> String

Returns the current label for the z-axis (colorbar).
Alternatively, the z-label can be changed with `zlabel!`.
"""
@inline zlabel(plot::Plot) = plot.zlabel[]

"""
    zlabel!(plot, newlabel)

Sets a new z-label (colorbar label) for the given plot.
Alternatively, the current label can be queried using `zlabel`.
"""
function zlabel!(plot::Plot, zlabel::AbstractString)
    plot.zlabel[] = zlabel
    return plot
end

"""
    label!(plot, where, value, [color])

    label!(plot, where, row, value, [color])

This method is responsible for the setting all the textual decorations of a plot.

Note that `where` can be any of: `:tl` (top-left),
`:t` (top-center), `:tr` (top-right),
`:bl` (bottom-left), `:b` (bottom-center),
`:br` (bottom-right), `:l` (left), `:r` (right).

If `where` is either `:l`, or `:r`, then `row` can be between 1
and the number of character rows of the plots canvas.
"""
function label!(plot::Plot, loc::Symbol, value::AbstractString, color::UserColorType)
    loc ∈ (:t, :b, :l, :r, :tl, :tr, :bl, :br) || throw(
        ArgumentError("unknown location $loc: try one of these :tl :t :tr :bl :b :br"),
    )
    if loc ≡ :l || loc ≡ :r
        for row in 1:nrows(plot.graphics)
            if loc ≡ :l
                if !haskey(plot.labels_left, row) || isempty(plot.labels_left[row])
                    plot.labels_left[row] = value
                    plot.colors_left[row] = ansi_color(color)
                    break
                end
            elseif loc ≡ :r
                if !haskey(plot.labels_right, row) || isempty(plot.labels_right[row])
                    plot.labels_right[row] = value
                    plot.colors_right[row] = ansi_color(color)
                    break
                end
            end
        end
    else
        plot.decorations[loc] = value
        plot.colors_deco[loc] = ansi_color(color)
    end
    return plot
end

label!(plot::Plot, loc::Symbol, value::AbstractString; color::UserColorType = :normal) =
    label!(plot, loc, value, color)

function label!(
        plot::Plot,
        loc::Symbol,
        row::Integer,
        value::AbstractString,
        color::UserColorType,
    )
    if loc ≡ :l
        plot.labels_left[row] = value
        plot.colors_left[row] = ansi_color(color)
    elseif loc ≡ :r
        plot.labels_right[row] = value
        plot.colors_right[row] = ansi_color(color)
    else
        throw(ArgumentError("unknown location $loc, try `:l` or `:r` instead"))
    end
    return plot
end

label!(
    plot::Plot,
    loc::Symbol,
    row::Integer,
    value::AbstractString;
    color::UserColorType = :normal,
) = label!(plot, loc, row, value, color)

"""
    annotate!(plot, x, y, text; kw...)

# Description

Adds text to the plot at the position `(x, y)`.

# Arguments

$(arguments((; text = "a string of text"); default = (), add = (:x, :y, :color)))

# Examples

```julia-repl
julia> plt = lineplot([1, 2, 7], [9, -6, 8], title = "My Lineplot");
julia> annotate!(plt, 5, 5, "My text")
       ⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀My Lineplot⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
       ┌────────────────────────────────────────┐
    10 │⡀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⢇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠│
       │⠘⡄⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠤⠊⠁⠀│
       │⠀⢣⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀My text⠀⠀⣀⠔⠊⠁⠀⠀⠀⠀│
       │⠀⠈⡆⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⣀⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⢸⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡠⠔⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⢇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠒⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠤⠤⠤⠼⡤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⢤⠤⠶⠥⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤│
       │⠀⠀⠀⠀⢣⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠤⠊⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⠀⠈⡆⠀⠀⠀⠀⠀⠀⠀⣀⠔⠊⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⠀⠀⢱⠀⠀⠀⠀⡠⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⠀⠀⠀⢇⡠⠔⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⠀⠀⠀⠈⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
   -10 │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
       └────────────────────────────────────────┘
       ⠀1⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀7⠀
```

# See also

[`Plot`](@ref), [`lineplot`](@ref), [`scatterplot`](@ref),
[`stairs`](@ref), [`BrailleCanvas`](@ref), [`BlockCanvas`](@ref),
[`AsciiCanvas`](@ref), [`DotCanvas`](@ref)
"""
function annotate!(
        plot::Plot{<:Canvas},
        x::Number,
        y::Number,
        text::Union{AbstractChar, AbstractString};
        color = :normal,
        kw...,
    )
    color = color ≡ :auto ? next_color!(plot) : color
    annotate!(
        plot.graphics,
        x,
        y,
        text,
        ansi_color(color),
        blend_colors(plot.graphics, color);
        kw...,
    )
    return plot
end

transform(tr, args...) = args  # catch all
transform(tr::MVP{Val{false}}, x, y, args...) = (x, y, args...)
transform(tr::MVP{Val{false}}, x, y, ::Nothing, args...) = (x, y, args...)  # drop z
transform(tr::MVP{Val{true}}, x, y, z::Union{AbstractVector, Number}, args...) =
    (tr(vcat(x', y', z', ones(1, length(x))))..., args...)

function lines!(plot::Plot{<:Canvas}, args...; kw...)
    lines!(plot.graphics, transform(plot.projection, args...)...; kw...)
    return plot
end

function pixel!(plot::Plot{<:Canvas}, args...; kw...)
    pixel!(plot.graphics, transform(plot.projection, args...)...; kw...)
    return plot
end

function points!(plot::Plot{<:Canvas}, args...; kw...)
    points!(plot.graphics, transform(plot.projection, args...)...; kw...)
    return plot
end

@testset "plotting_range_narrow" begin
    @testset "types" begin
        @test @no_allocs(UnicodePlots.plotting_range_narrow(0, 1)) ≡ (0.0, 1.0)
        @test @no_allocs(UnicodePlots.plotting_range_narrow(0.0, 1)) ≡ (0.0, 1.0)
        @test @no_allocs(UnicodePlots.plotting_range_narrow(0, 1.0f0)) ≡ (0.0, 1.0f0)
        @test @no_allocs(UnicodePlots.plotting_range_narrow(0x00, 0x01)) ≡ (0.0, 1.0)
    end

    @test_logs (:warn, "Invalid plotting range") UnicodePlots.plotting_range_narrow(
        nextfloat(-Inf),
        prevfloat(+Inf),
    )
    @test @no_allocs(
        UnicodePlots.plotting_range_narrow(nextfloat(-Inf32), prevfloat(Inf32))
    ) ≡ (-Inf32, Inf32)
    @test @no_allocs(
        UnicodePlots.plotting_range_narrow(nextfloat(-Inf16), prevfloat(Inf16))
    ) ≡ (-Inf16, Inf16)
    @test @no_allocs(UnicodePlots.plotting_range_narrow(0.0001, 0.002)) ≡ (0.0, 0.002)
    @test @no_allocs(UnicodePlots.plotting_range_narrow(0.001, 0.02)) ≡ (0.0, 0.02)
    @test @no_allocs(UnicodePlots.plotting_range_narrow(0.01, 0.2)) ≡ (0.0, 0.2)
    @test @no_allocs(UnicodePlots.plotting_range_narrow(0.1, 2.0)) ≡ (0.0, 2.0)
    @test @no_allocs(UnicodePlots.plotting_range_narrow(0, 2)) ≡ (0.0, 2.0)
    @test @no_allocs(UnicodePlots.plotting_range_narrow(0, 5)) ≡ (0.0, 5.0)

    @test @no_allocs(UnicodePlots.floor_base(15.0, 10.0)) ≈ 10
    @test @no_allocs(UnicodePlots.ceil_base(15.0, 10.0)) ≈ 10^2
    @test @no_allocs(UnicodePlots.floor_base(4.2, 2.0)) ≈ 2^2
    @test @no_allocs(UnicodePlots.ceil_base(4.2, 2.0)) ≈ 2^3
    @test @no_allocs(UnicodePlots.floor_base(1.5 * ℯ, ℯ)) ≈ ℯ
    @test @no_allocs(UnicodePlots.ceil_base(1.5 * ℯ, ℯ)) ≈ ℯ^2
end

@testset "limits" begin
    @test @no_allocs(UnicodePlots.extend_limits(1:4, (0.1, 2))) ≡ (0.1, 2.0)
    @test @no_allocs(UnicodePlots.extend_limits(1:4, (0, 1.1))) ≡ (0.0, 1.1)
    @test @no_allocs(UnicodePlots.extend_limits(1:4, (2, 3))) ≡ (2.0, 3.0)
    @test @no_allocs(UnicodePlots.extend_limits(1:4, (0, 0))) ≡ (1.0, 4.0)
    @test @no_allocs(UnicodePlots.extend_limits(1:4, (1, 1))) ≡ (0.0, 2.0)

    @test UnicodePlots.extend_limits([], (-1, 2)) ≡ (-1.0, 2.0)

    @test @no_allocs UnicodePlots.is_auto((0, 0))
    @test @no_allocs !UnicodePlots.is_auto((-1, 1))
    @test UnicodePlots.is_auto([0, 0])
    @test !UnicodePlots.is_auto([-1, 1])

    # `SVector` inferrability
    @test UnicodePlots.autolims([-3, 2]) == [-3, 2]
    @test UnicodePlots.autolims([-3, 2], 1:10) == [-3, 2]
    @test UnicodePlots.autolims([0, 0], 1:10) == [1, 10]
    @test @no_allocs(UnicodePlots.autolims((-3.0, 2.0))) == [-3, 2]
    @test @no_allocs(UnicodePlots.autolims((0.0, 0.0), 1:10)) == [1, 10]
end

@testset "bordermap" begin
    bmap_keys = keys(UnicodePlots.BORDERMAP)
    @test length(bmap_keys) == 9
    @test haskey(UnicodePlots.BORDERMAP, :none)
    @test haskey(UnicodePlots.BORDERMAP, :bnone)
    @test haskey(UnicodePlots.BORDERMAP, :solid)
    @test haskey(UnicodePlots.BORDERMAP, :corners)
    @test haskey(UnicodePlots.BORDERMAP, :barplot)
    @test haskey(UnicodePlots.BORDERMAP, :bold)
    @test haskey(UnicodePlots.BORDERMAP, :dotted)
    @test haskey(UnicodePlots.BORDERMAP, :dashed)
    @test haskey(UnicodePlots.BORDERMAP, :ascii)
    for (k, v) in zip(bmap_keys, UnicodePlots.BORDERMAP)
        @test length(keys(v)) == 8
        @test haskey(v, :tl)
        @test haskey(v, :tr)
        @test haskey(v, :bl)
        @test haskey(v, :br)
        @test haskey(v, :r)
        @test haskey(v, :l)
        @test haskey(v, :t)
        @test haskey(v, :b)
    end
end

@testset "colors" begin
    @test first(UnicodePlots.COLOR_CYCLE_BRIGHT) ≡ :light_green
    @test first(UnicodePlots.COLOR_CYCLE_FAINT) ≡ :green

    _cycle = UnicodePlots.COLOR_CYCLE[]
    @test UnicodePlots.brightcolors!() == UnicodePlots.COLOR_CYCLE_BRIGHT
    @test UnicodePlots.faintcolors!() == UnicodePlots.COLOR_CYCLE_FAINT
    UnicodePlots.COLOR_CYCLE[] = _cycle

    @test @no_allocs(UnicodePlots.c256(0.0)) == 0
    @test @no_allocs(UnicodePlots.c256(1.0)) == 255
    @test @no_allocs(UnicodePlots.c256(0)) == 0
    @test @no_allocs(UnicodePlots.c256(255)) == 255

    @test_throws ArgumentError UnicodePlots.colormode!(123456789)

    _color_mode = UnicodePlots.colormode()
    UnicodePlots.COLORMODE[] = Crayons.COLORS_16  # we only support 8bit or 24bit, not 4bit (terminal dependent)
    @test_throws ArgumentError UnicodePlots.colormode()

    UnicodePlots.colors256!()
    @test @no_allocs(UnicodePlots.ansi_color(0x80)) == UnicodePlots.THRESHOLD + 0x80  # ansi 128
    @test @no_allocs(UnicodePlots.ansi_color(128)) == UnicodePlots.THRESHOLD + 0x80  # ansi 128
    @test @no_allocs(UnicodePlots.ansi_color((0.0, 0.0, 0.0))) ==
        UnicodePlots.THRESHOLD + 0x00  # float 0 - 1 range
    @test @no_allocs(UnicodePlots.ansi_color((1.0, 1.0, 1.0))) ==
        UnicodePlots.THRESHOLD + 0xe7  # float 0 - 1 range
    @test @no_allocs(UnicodePlots.ansi_color((0, 0, 0))) == UnicodePlots.THRESHOLD + 0x00
    @test @no_allocs(UnicodePlots.ansi_color((255, 255, 255))) ==
        UnicodePlots.THRESHOLD + 0xe7  # ansi 231
    @test @no_allocs(UnicodePlots.ansi_color(:red)) == UnicodePlots.THRESHOLD + 0x01
    @test @no_allocs(UnicodePlots.ansi_color(:green)) == UnicodePlots.THRESHOLD + 0x02
    @test @no_allocs(UnicodePlots.ansi_color(:blue)) == UnicodePlots.THRESHOLD + 0x04
    @test @no_allocs(UnicodePlots.ansi_color(:light_red)) == UnicodePlots.THRESHOLD + 0x09  # bright := normal + 8
    @test @no_allocs(UnicodePlots.ansi_color(:light_green)) == UnicodePlots.THRESHOLD + 0x0a
    @test @no_allocs(UnicodePlots.ansi_color(:light_blue)) == UnicodePlots.THRESHOLD + 0x0c

    UnicodePlots.truecolors!()
    _lut = UnicodePlots.USE_LUT[]
    UnicodePlots.USE_LUT[] = true
    @test @no_allocs(UnicodePlots.ansi_color(0x80)) == 0x00af00d7
    @test @no_allocs(UnicodePlots.ansi_color(128)) == 0x00af00d7
    @test @no_allocs(UnicodePlots.ansi_color((0.0, 0.0, 0.0))) == 0x00
    @test @no_allocs(UnicodePlots.ansi_color((1.0, 1.0, 1.0))) == 0x00ffffff
    @test @no_allocs(UnicodePlots.ansi_color((0, 0, 0))) == 0x00
    @test @no_allocs(UnicodePlots.ansi_color((255, 255, 255))) == 0x00ffffff
    @test @no_allocs(UnicodePlots.ansi_color(:red)) == 0x00800000
    @test @no_allocs(UnicodePlots.ansi_color(:green)) == 0x00008000
    @test @no_allocs(UnicodePlots.ansi_color(:blue)) == 0x00000080
    @test @no_allocs(UnicodePlots.ansi_color(:light_red)) == 0x00ff0000
    @test @no_allocs(UnicodePlots.ansi_color(:light_green)) == 0x0000ff00
    @test @no_allocs(UnicodePlots.ansi_color(:light_blue)) == 0x000000ff
    UnicodePlots.USE_LUT[] = false
    @test @no_allocs(UnicodePlots.ansi_color(0x80)) == UnicodePlots.THRESHOLD + 0x80
    @test @no_allocs(UnicodePlots.ansi_color(128)) == UnicodePlots.THRESHOLD + 0x80
    @test @no_allocs(UnicodePlots.ansi_color((0, 0, 0))) == 0x00
    @test @no_allocs(UnicodePlots.ansi_color((255, 255, 255))) == 0x00ffffff
    @test @no_allocs(UnicodePlots.ansi_color(:red)) == UnicodePlots.THRESHOLD + 0x01
    @test @no_allocs(UnicodePlots.ansi_color(:green)) == UnicodePlots.THRESHOLD + 0x02
    @test @no_allocs(UnicodePlots.ansi_color(:blue)) == UnicodePlots.THRESHOLD + 0x04
    @test @no_allocs(UnicodePlots.ansi_color(:light_red)) == UnicodePlots.THRESHOLD + 0x09
    @test @no_allocs(UnicodePlots.ansi_color(:light_green)) == UnicodePlots.THRESHOLD + 0x0a
    @test @no_allocs(UnicodePlots.ansi_color(:light_blue)) == UnicodePlots.THRESHOLD + 0x0c
    UnicodePlots.USE_LUT[] = _lut

    UnicodePlots.colormode!(_color_mode)

    @static if true  # physical average
        @test @no_allocs(UnicodePlots.blend_colors(UInt32(0), UInt32(255))) == UInt32(180)
        @test @no_allocs(UnicodePlots.blend_colors(0x00ff0000, 0x0000ff00)) == 0x00b4b400  # red & green -> yellow
        @test @no_allocs(UnicodePlots.blend_colors(0x0000ff00, 0x000000ff)) == 0x0000b4b4  # green & blue -> cyan
        @test @no_allocs(UnicodePlots.blend_colors(0x00ff0000, 0x000000ff)) == 0x00b400b4  # red & blue -> magenta
    else  # binary or
        @test @no_allocs(UnicodePlots.blend_colors(UInt32(0), UInt32(255))) == UInt32(255)
        @test @no_allocs(UnicodePlots.blend_colors(0x00ff0000, 0x0000ff00)) == 0x00ffff00
        @test @no_allocs(UnicodePlots.blend_colors(0x0000ff00, 0x000000ff)) == 0x0000ffff
        @test @no_allocs(UnicodePlots.blend_colors(0x00ff0000, 0x000000ff)) == 0x00ff00ff
    end

    @test @no_allocs(UnicodePlots.complement(UnicodePlots.INVALID_COLOR)) ==
        UnicodePlots.INVALID_COLOR
    @test @no_allocs(UnicodePlots.complement(0x003ae1c3)) == 0x00c51e3c

    io = PipeBuffer()
    _cfast = UnicodePlots.CRAYONS_FAST[]
    for fast in (false, true)
        UnicodePlots.CRAYONS_FAST[] = fast
        UnicodePlots.print_crayons(io, Crayon(foreground = :red), 123)
        UnicodePlots.print_crayons(io, Crayon(), 123)
    end
    UnicodePlots.CRAYONS_FAST[] = _cfast

    @test @no_allocs(UnicodePlots.ignored_color(nothing))
    @test @no_allocs(UnicodePlots.crayon_color(missing)) isa Crayons.ANSIColor
    @test @no_allocs(UnicodePlots.crayon_color(nothing)) isa Crayons.ANSIColor
end

@testset "colormaps" begin
    @test UnicodePlots.colormap_callback(:inferno) isa Function
    @test UnicodePlots.colormap_callback([1, 2, 3]) isa Function
    @test @no_allocs(UnicodePlots.colormap_callback(() -> nothing)) isa Function
    @test @no_allocs(UnicodePlots.colormap_callback(nothing)) isa Function
end

@testset "ColorSchemes: custom registered cmap" begin
    ColorSchemes.loadcolorscheme(
        :test_unicodeplots,
        map(i -> RGB{Float64}(i, i, i), 0.0:0.1:1.0),
        "general",
        "test colorscheme (grays)",
    )
    callback = UnicodePlots.colormap_callback(:test_unicodeplots)
    lft = callback(0.5, 0.0, 2.0)
    rgt = callback(1.5, 0.0, 2.0)
    if UnicodePlots.colormode() == 8
        @test lft == UnicodePlots.THRESHOLD + 0x3b
        @test rgt == UnicodePlots.THRESHOLD + 0x91
    elseif UnicodePlots.colormode() == 24
        @test @no_allocs(UnicodePlots.red(lft)) ==
            @no_allocs(UnicodePlots.grn(lft)) ==
            @no_allocs(UnicodePlots.blu(lft)) ==
            @no_allocs(UnicodePlots.c256(0.25))
        @test @no_allocs(UnicodePlots.red(rgt)) ==
            @no_allocs(UnicodePlots.grn(rgt)) ==
            @no_allocs(UnicodePlots.blu(rgt)) ==
            @no_allocs(UnicodePlots.c256(0.75))
    else
        @test false
    end
end

@testset "clamp colors values within smaller range" begin
    values = collect(-10:0.5:10)
    left, right = 15, length(values) - 10
    mini, maxi = values[left], values[right]

    callback = UnicodePlots.colormap_callback(collect(1:10))
    colors = map(v -> callback(v, mini, maxi), values)

    # smaller interval, must hit colormap extrema
    @test all(x -> x == first(colors), colors[1:left])
    @test all(x -> x == last(colors), colors[right:end])
end

@testset "miscellaneous" begin
    @test UnicodePlots.split_plot_kw(pairs((width = 1, height = 2))) |> last |> isempty  # only plot keywords
    @test UnicodePlots.split_plot_kw(pairs((foo = 1, bar = 2))) |> first |> isempty  # only other keywords

    @test_logs (:warn, r".*will be lost") UnicodePlots.warn_on_lost_kw(pairs((; a = 1)))
    @test UnicodePlots.warn_on_lost_kw(pairs((;))) ≡ nothing

    @test @no_allocs(UnicodePlots.char_marker('a')) ≡ 'a'
    @test @no_allocs(UnicodePlots.char_marker("a")) ≡ 'a'
    @test @no_allocs(UnicodePlots.char_marker(:+)) ≡ '+'

    @test UnicodePlots.iterable([1, 2]) == [1, 2]
    @test collect(Iterators.take(UnicodePlots.iterable(:abc), 2)) == [:abc, :abc]

    @test UnicodePlots.scale_callback(:identity)(1) ≡ 1
    @test UnicodePlots.scale_callback(:log10)(10) ≈ 1
    @test UnicodePlots.scale_callback(:log2)(2) ≈ 1
    @test UnicodePlots.scale_callback(:ln)(ℯ) ≈ 1
    @test UnicodePlots.scale_callback(x -> x)(1) ≡ 1
    @test UnicodePlots.scale_callback(x -> sin(x))(0) ≈ 0

    h, w = ds = displaysize()
    @test UnicodePlots.out_stream_height() == h
    @test UnicodePlots.out_stream_width() == w
    @test UnicodePlots.out_stream_size(nothing) == ds
    @test UnicodePlots.out_stream_size(stdout) == displaysize(stdout)

    @test UnicodePlots.superscript("-10") == "⁻¹⁰"
    @test UnicodePlots.superscript("+2") == "⁺²"

    @test_throws AssertionError default_size!(width = 8, height = 8)

    @test default_size!(height = 30) == (30, 80)
    @test default_size!(width = 64) == (24, 64)
    @test default_size!() == (15, 40)

    @test UnicodePlots.nice_repr(2.1e-9, true, ' ') == "2.1e⁻⁹"
    @test UnicodePlots.nice_repr(1.0e20, false, ' ') == "1e20"
    @test UnicodePlots.nice_repr(1.0e20, true, ' ') == "1e²⁰"
    @test UnicodePlots.nice_repr(1.0, true, ' ') == "1"
    @test UnicodePlots.nice_repr(10, true, ' ') == "10"
    @test UnicodePlots.nice_repr(1 + 0.1eps(), true, ' ') == "1"

    s = UnicodePlots.KEYWORDS.thousands_separator
    @test UnicodePlots.nice_repr(-1_000_000_000, nothing) == "-1$(s)000$(s)000$(s)000"
    @test UnicodePlots.nice_repr(-100_000_000, nothing) == "-100$(s)000$(s)000"
    @test UnicodePlots.nice_repr(-10_000_000, nothing) == "-10$(s)000$(s)000"
    @test UnicodePlots.nice_repr(-1_000_000, nothing) == "-1$(s)000$(s)000"
    @test UnicodePlots.nice_repr(-100_000, nothing) == "-100$(s)000"
    @test UnicodePlots.nice_repr(-10_000, nothing) == "-10$(s)000"
    @test UnicodePlots.nice_repr(-1_000, nothing) == "-1$(s)000"
    @test UnicodePlots.nice_repr(-100, nothing) == "-100"
    @test UnicodePlots.nice_repr(-10, nothing) == "-10"
    @test UnicodePlots.nice_repr(-1, nothing) == "-1"
    @test UnicodePlots.nice_repr(0, nothing) == "0"
    @test UnicodePlots.nice_repr(+1, nothing) == "1"
    @test UnicodePlots.nice_repr(+10, nothing) == "10"
    @test UnicodePlots.nice_repr(+100, nothing) == "100"
    @test UnicodePlots.nice_repr(+1_000, nothing) == "1$(s)000"
    @test UnicodePlots.nice_repr(+10_000, nothing) == "10$(s)000"
    @test UnicodePlots.nice_repr(+100_000, nothing) == "100$(s)000"
    @test UnicodePlots.nice_repr(+1_000_000, nothing) == "1$(s)000$(s)000"
    @test UnicodePlots.nice_repr(+10_000_000, nothing) == "10$(s)000$(s)000"
    @test UnicodePlots.nice_repr(+100_000_000, nothing) == "100$(s)000$(s)000"
    @test UnicodePlots.nice_repr(+1_000_000_000, nothing) == "1$(s)000$(s)000$(s)000"
end

@testset "docs coverage" begin
    @test UnicodePlots.default_with_type(:foo_bar) isa String
    @test UnicodePlots.arguments() isa String
    @test UnicodePlots.keywords() isa String
end

const UE = if isdefined(Base, :get_extension)
    Base.get_extension(UnicodePlots, :UnitfulExt)
else
    UnicodePlots.UnitfulExt
end

@testset "units" begin
    x = [1.0, 2.0, 3.0]
    @test UE.number_unit(x) == (x, nothing)
    @test UE.number_unit(1) == (1, nothing)
    @test UE.number_unit(x * u"°C") == (x, "°C")
    @test UE.number_unit(1u"°C") == (1, "°C")

    @test UE.unit_label("  fancy label  ", "Hz") == "  fancy label (Hz)"
    @test UE.unit_label("  ", "dB") == "dB"
    @test UE.unit_label("  no units  ", nothing) == "  no units"
end

abstract type GraphicsArea end

@inline blank(c::GraphicsArea) = Char(BLANK)

suitable_color(c::GraphicsArea, color::Union{UserColorType, AbstractVector}) = ansi_color(
    color ≡ nothing && length(c.colors) > 0 ? c.colors[end] :
        (color isa AbstractVector ? first(color) : color),
)

Base.print(io::IO, c::GraphicsArea) = _print(io, print, print_color, c)

function _print(io::IO, print_nocol, print_color, c::GraphicsArea)
    postprocess! = preprocess!(io, c)
    for row in 1:nrows(c)
        print_row(io, print_nocol, print_color, c, row)
        row < nrows(c) && print_nocol(io, '\n')
    end
    postprocess!(c)
    return nothing
end

Base.show(io::IO, c::GraphicsArea) = _show(io, print, print_color, c)

function _show(io::IO, print_nocol, print_color, c::GraphicsArea)
    bd = BORDER_SOLID
    bc = BORDER_COLOR[]
    bd_len = ncols(c)
    print_border(
        io,
        print_nocol,
        print_color,
        bd[:tl],
        bd[:t]^bd_len,
        bd[:tr],
        nothing,
        '\n',
        bc,
    )
    postprocess! = preprocess!(io, c)
    bl::Char, br::Char = bd[:l], bd[:r]
    for row in 1:nrows(c)
        print_color(io, bc, bl)
        print_row(io, print_nocol, print_color, c, row)
        print_color(io, bc, br)
        row < nrows(c) && print_nocol(io, '\n')
    end
    postprocess!(c)
    print_border(
        io,
        print_nocol,
        print_color,
        bd[:bl],
        bd[:b]^bd_len,
        bd[:br],
        '\n',
        nothing,
        bc,
    )
    return nothing
end

print_row(io::IO, c::GraphicsArea, row::Integer) = print_row(io, print, print_color, c, row)

"""
    preprocess!(c::GraphicsArea)

Optional step: pre-process canvas before printing rows (e.g. for costly computations).
Returns a callback for optional cleanup after printing.
"""
preprocess!(::IO, c::GraphicsArea) = c -> nothing

function Base.string(c::GraphicsArea; color = false)
    io = PipeBuffer()
    show(IOContext(io, :color => color), c)
    return read(io, String)
end

module IntervalSetsExt

import UnicodePlots
import IntervalSets

function interval_range(x::IntervalSets.AbstractInterval, length, step)
    if length ≡ nothing && step ≡ nothing
        length = UnicodePlots.DEFAULT_WIDTH[]
    end
    return range(x; length, step)
end

UnicodePlots.lineplot(
    x::IntervalSets.AbstractInterval,
    f::Function;
    length = nothing,
    step = nothing,
    kw...,
) = UnicodePlots.lineplot(interval_range(x, length, step), f; kw...)

UnicodePlots.lineplot!(
    plot::UnicodePlots.Plot{<:UnicodePlots.Canvas},
    x::IntervalSets.AbstractInterval,
    f::Function;
    length = nothing,
    step = nothing,
    kw...,
) = UnicodePlots.lineplot!(plot, interval_range(x, length, step), f; kw...)

UnicodePlots.lineplot(
    x::IntervalSets.AbstractInterval,
    F::AbstractVector{<:Function};
    length = nothing,
    step = nothing,
    kw...,
) = UnicodePlots.lineplot(interval_range(x, length, step), F; kw...)

end  # module

module UnicodePlots

using PrecompileTools
using LinearAlgebra
using StaticArrays
using ColorTypes
using Crayons
using Printf
using Dates

import StatsBase: Histogram, fit, percentile, sturges
import SparseArrays: AbstractSparseMatrix, findnz
import Base: RefValue

import MarchingCubes
import ColorSchemes
import NaNMath
import Contour

# composite types
export Plot,
    BarplotGraphics,
    BoxplotGraphics,
    GraphicsArea,
    BrailleCanvas,
    OctantCanvas,
    DensityCanvas,
    HeatmapCanvas,
    BlockCanvas,
    AsciiCanvas,
    DotCanvas,
    Canvas,
    MVP

# helpers
export default_size!,
    annotate!,
    title!,
    title,
    label!,
    xlabel!,
    xlabel,
    ylabel!,
    ylabel,
    zlabel!,
    zlabel,
    vline!,
    hline!,
    savefig,
    gridplot

# methods with mutating variants
export scatterplot!,
    scatterplot,
    lineplot!,
    lineplot,
    densityplot!,
    densityplot,
    contourplot!,
    contourplot,
    surfaceplot!,
    surfaceplot,
    isosurface!,
    isosurface,
    polarplot!,
    polarplot,
    barplot!,
    barplot,
    boxplot!,
    boxplot,
    stairs!,
    stairs

# methods without mutating variants
export horizontal_histogram, vertical_histogram, histogram, heatmap, spy, imageplot

include("common.jl")
include("lut.jl")

include("graphics.jl")
include("graphics/bargraphics.jl")
include("graphics/boxgraphics.jl")
include("graphics/imagegraphics.jl")

include("canvas.jl")
include("canvas/lookupcanvas.jl")
include("canvas/braillecanvas.jl")
include("canvas/octantcanvas.jl")
include("canvas/densitycanvas.jl")
include("canvas/blockcanvas.jl")
include("canvas/asciicanvas.jl")
include("canvas/dotcanvas.jl")
include("canvas/heatmapcanvas.jl")

include("description.jl")
include("volume.jl")

include("plot.jl")
include("show.jl")

include("interface/barplot.jl")
include("interface/histogram.jl")
include("interface/scatterplot.jl")
include("interface/contourplot.jl")
include("interface/surfaceplot.jl")
include("interface/isosurface.jl")
include("interface/lineplot.jl")
include("interface/stairs.jl")
include("interface/densityplot.jl")
include("interface/heatmap.jl")
include("interface/spy.jl")
include("interface/boxplot.jl")
include("interface/polarplot.jl")
include("interface/imageplot.jl")

function __init__()
    forced_24bit() && return init_24bit()
    forced_8bit() && return init_8bit()
    get_have_truecolor() ? init_24bit() : init_8bit()
    return nothing
end

# COV_EXCL_START
function precompile_workload(io::IO = IOContext(devnull, :color => Base.get_have_color()))
    __init__()
    surf(x, y) = sinc(√(x^2 + y^2))
    for T in (  # most common types
            Float64,
            Int,
        )
        I = one(T)
        plots = (
            lineplot(I:2),
            lineplot(I:2, I:2),
            lineplot(-I, I, sin),
            lineplot((-I):I, sin),
            lineplot(-I, I, [sin, cos]),
            lineplot((-I):I, [sin, cos]),
            lineplot(I:2, T[0:1 2:3]),
            lineplot(I:2, I:2; xscale = :ln, yscale = :log10),
            lineplot([Date(2020), Date(2021)], I:2),
            scatterplot(I:2),
            scatterplot(I:2, I:2),
            scatterplot(I:2, T[0:1 2:3]),
            stairs(T[1, 2, 4], T[1, 3, 4]),
            barplot(["Paris", "New York"], T[2, 8]),
            boxplot(T[1, 2, 3]),
            boxplot(["one", "two"], [collect(I:3), collect(I:4)]),
            histogram(T[1, 2, 3]),
            histogram(T[1, 2, 3]; vertical = true),
            polarplot(0:(π / 4):π, I:5),
            densityplot(T[1, 2], T[3, 4]; dscale = x -> log(1 + x)),
            heatmap(repeat(collect(T, 0:4)'; outer = (5, 1))),
            spy(T[1 -1 0; -1 2 1; 0 -1 1]),
            contourplot(surf.(meshgrid((-I):I, (-2I):(2I))...)),
            contourplot((-I):I, (-2I):(2I), surf),
            surfaceplot((-I):I, (-2I):(2I), surf; lines = true),
            surfaceplot((-I):I, (-2I):(2I), surf.(meshgrid((-I):I, (-2I):(2I))...)),
            isosurface((-I):4, I:2, I:3, (x, y, z) -> float(x^2 + y^2 - z^2 - 1)),
        )
        foreach(p -> show(io, p), plots)
    end
    return
end

@compile_workload begin
    precompile_workload()
end
# COV_EXCL_STOP

end

"""
    scatterplot(; kw...)
    scatterplot(y; kw...)
    scatterplot(x, y; kw...)
    scatterplot!(p, args...; kw...)

# Description

Draws the given points on a new canvas.

The first (optional) vector `x` should contain the horizontal positions for all the points.
The second vector `y` should then contain the corresponding vertical positions respectively.
This means that the two vectors must be of same length and ordering.

# Usage

    scatterplot([x], y; $(keywords(; add = (:canvas,))))

# Arguments

$(
    arguments(
        (
            marker = "choose a marker from $(keys(MARKERS)), a `Char`, a unit length `String` or a `Vector` of these",
            color = "`Vector` of colors, or scalar - $(DESCRIPTION[:color])",
        ); add = (:x, :y, :canvas)
    )
)

Author(s)

- Christof Stocker (github.com/Evizero)

# Examples

```julia-repl
julia> scatterplot(randn(50), randn(50), title = "My Scatterplot")
      ⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀My Scatterplot⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
      ┌────────────────────────────────────────┐
    3 │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
      │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
      │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠄⠀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠈⠀⠀⠠⠀⠀⠀│
      │⠀⠀⠀⠀⠀⠀⠀⠀⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠠⠀⠀⠂⡀⠀⠀⠀⠀⠀⠄⠀⠀⠀⠀⠀⠀│
      │⠈⠀⠀⠀⠀⠠⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠌⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
      │⠀⠀⠠⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠄⠀⠀⠀⠀⠀⠀⡇⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠠⠀⡀⠀⠀⠀⠀│
      │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡀⠀⠀⠀⠀⠀⠀⠀⠀⡀⡏⠀⠉⠀⠀⠂⠀⠠⠀⠄⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
      │⠤⠤⠤⠤⠤⠤⠤⠴⠤⢤⠤⠤⠤⠤⠤⠤⠬⠤⢤⠤⡧⠤⢤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤⠤│
      │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠠⠀⠀⠀⠀⠀⠂⠀⠀⡇⠀⠀⠀⠂⠠⡀⠀⡀⠀⠀⠀⡀⠀⠀⠀⠀⠀⠀⠀│
      │⠀⠀⠀⠀⠀⠀⠄⠀⠀⠀⠀⠀⠀⠄⠀⠀⠀⠈⠀⠀⡇⠀⠀⠀⠀⠈⠀⠀⠀⠁⠀⠀⠀⠀⠐⠀⠀⠀⠀⠀│
      │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠐⠀⠀⠀⠀⠀⠀⠀⠀⠀│
      │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡀⠀⠀⠀⡇⠀⠠⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠐⠀⠀⠀⠀⠀│
      │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
      │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
   -3 │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡇⠀⠀⠀⠀⠀⠀⠀⠀⠐⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
      └────────────────────────────────────────┘
      ⠀-2⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀2⠀
```

# See also

[`Plot`](@ref), [`lineplot`](@ref), [`stairs`](@ref),
[`BrailleCanvas`](@ref), [`BlockCanvas`](@ref),
[`AsciiCanvas`](@ref), [`DotCanvas`](@ref)
"""
function scatterplot(
        x::AbstractVector,
        y::AbstractVector,
        z::Union{AbstractVector, Nothing} = nothing;
        canvas::Type = KEYWORDS.canvas,
        kw...,
    )
    pkw, okw = split_plot_kw(kw)
    return scatterplot!(Plot(x, y, z, canvas; pkw...), x, y, z; okw...)
end

scatterplot(; kw...) = lineplot([]; kw...)
scatterplot(y::AbstractVector; kw...) = scatterplot(axes(y, 1), y; kw...)

@doc (@doc scatterplot) function scatterplot!(
        plot::Plot{<:Canvas},
        x::AbstractVector,
        y::AbstractVector,
        z::Union{AbstractVector, Nothing} = nothing;
        color::Union{UserColorType, AbstractVector} = KEYWORDS.color,
        marker::Union{MarkerType, AbstractVector} = :pixel,
        name = KEYWORDS.name,
        kw...,
    )
    color = color ≡ :auto ? next_color!(plot) : color
    col_vec = color isa AbstractVector
    isempty(name) || label!(plot, :r, string(name), col_vec ? first(color) : color)
    if marker ∈ (:pixel, :auto)
        if col_vec
            @inbounds for i in eachindex(color)
                points!(plot, x[i], y[i], z ≡ nothing ? z : z[i]; color = color[i])
            end
        else
            points!(plot, x, y, z; color)
        end
    else
        z ≡ nothing || throw(ArgumentError("unsupported scatter with 3D data"))
        for (xi, yi, mi, ci) in zip(x, y, iterable(marker), iterable(color))
            annotate!(plot, xi, yi, char_marker(mi); color = ci, kw...)
        end
    end
    plot.series[] += 1
    return plot
end

scatterplot!(plot::Plot{<:Canvas}, y::AbstractVector; kw...) =
    scatterplot!(plot, axes(y, 1), y; kw...)

# ---------------------------------------------------------------------------- #
# multiple series
function scatterplot(x::AbstractVector, y::AbstractMatrix; kw...)
    names, colors, markers = multiple_series_defaults(y, kw, 1)
    plot = scatterplot(
        x,
        y[:, begin];
        ylim = extrema(y),
        name = first(names),
        color = first(colors),
        marker = first(markers),
        filter(k -> k.first ∉ (:name, :color, :marker), kw)...,
    )
    for (i, (name, color, marker, ys)) in enumerate(zip(names, colors, markers, eachcol(y)))
        i == 1 && continue
        scatterplot!(plot, x, ys; name, color, marker)
    end
    return plot
end

function scatterplot!(plot::Plot{<:Canvas}, x::AbstractVector, y::AbstractMatrix; kw...)
    names, colors, markers = multiple_series_defaults(y, kw, plot.series[] + 1)
    for (name, color, marker, ys) in zip(names, colors, markers, eachcol(y))
        scatterplot!(plot, x, ys; name, color, marker)
    end
    return plot
end

let canvases = (HeatmapCanvas, BlockCanvas, AsciiCanvas, DotCanvas, BrailleCanvas)
    @assert typemax(UnicodeType) ≥ maximum((typemax ∘ grid_type).(canvases))
end

const PLOT_KEYWORDS = (  # intercepted by `split_plot_kw`
    canvas = BrailleCanvas,  # positional argument, but left here
    title = "",
    xlabel = "",
    ylabel = "",
    zlabel = "",
    xscale = :identity,
    yscale = :identity,
    height = DEFAULT_HEIGHT[],
    width = DEFAULT_WIDTH[],
    border = :solid,
    compact_labels = false,
    compact = false,
    blend = true,
    xlim = (0, 0),
    ylim = (0, 0),
    margin = 3,
    padding = 1,
    labels = true,
    unicode_exponent = true,
    thousands_separator = ' ',
    colorbar = false,
    colorbar_border = :solid,
    colorbar_lim = (0, 1),
    colormap = :viridis,
    grid = true,
    yticks = true,
    xticks = true,
    min_height = 2,
    min_width = 5,
    yflip = false,
    xflip = false,
    projection = :orthographic,
    elevation = √2 |> inv |> atand,
    azimuth = 45.0,
    axes3d = true,
    near = 1.0,
    far = 100.0,
    zoom = 1.0,
    up = :z,
    canvas_kw = (;),
)

const PLOT_KEYS = keys(PLOT_KEYWORDS)

const KEYWORDS = (
    PLOT_KEYWORDS...,
    # propagated keywords (canvas, interface, ...)
    symbols = ['■'],
    name = "",
    zscale = :aspect,
    zlim = (0, 0),
    color = :auto,
    # internals
    visible = true,
    fix_ar = false,
)

const DESCRIPTION = (
    # NOTE: this named tuple has to stay ordered (for `README.md`)
    x = "horizontal position for each point",
    y = "vertical position for each point",
    z = "depth position for each point",
    symbols = "collection of characters used to render the bars",
    title = "text displayed on top of the plot",
    name = "current drawing annotation displayed on the right",
    xlabel = "text displayed on the `x` axis of the plot",
    ylabel = "text displayed on the `y` axis of the plot",
    zlabel = "text displayed on the `z` axis (colorbar) of the plot",
    xscale = "`x`-axis scale (`:identity`, `:ln`, `:log2`, `:log10`), or scale function e.g. `x -> log10(x)`",
    yscale = "`y`-axis scale",
    labels = "show plot labels",
    border = "plot bounding box style (`:corners`, `:solid`, `:bold`, `:dashed`, `:dotted`, `:ascii`, `:none`)",
    margin = "number of empty characters to the left of the whole plot",
    padding = "left and right space between the labels and the canvas",
    color = "choose from (`:green`, `:blue`, `:red`, `:yellow`, `:cyan`, `:magenta`, `:white`, `:normal`, `:auto`), use an integer in `[0-255]`, or provide `3` integers as `RGB` components",
    height = "number of canvas rows, or `:auto`",
    width = "number of characters per canvas row, or `:auto`",
    xlim = "plotting range for the `x` axis (`(0, 0)` stands for automatic)",
    ylim = "plotting range for the `y` axis",
    zlim = "colormap scaled data range",
    xticks = "set `false` to disable ticks (labels) on `x`-axis",
    yticks = "set `false` to disable ticks (labels) on `y`-axis",
    xflip = "set `true` to flip the `x` axis",
    yflip = "set `true` to flip the `y` axis",
    colorbar = "toggle the colorbar",
    colormap = "choose a symbol from `ColorSchemes.jl` e.g. `:viridis`, or supply a function `f: (z, zmin, zmax) -> Int(0-255)`, or a vector of RGB tuples",
    colorbar_lim = "colorbar limit",
    colorbar_border = "color bar bounding box style (`:solid`, `:bold`, `:dashed`, `:dotted`, `:ascii`, `:none`)",
    canvas = "type of canvas used for drawing",
    grid = "draws grid-lines at the origin",
    compact_labels = "compact plot labels",
    compact = "compress the plot (compact labels, removes margins and padding)",
    unicode_exponent = "use `Unicode` symbols for exponents: e.g. `10²⸱¹` instead of `10^2.1`",
    thousands_separator = "thousands separator character (use `Char(0)` to disable grouping digits)",
    projection = "projection for 3D plots (`:ortho(graphic)`, `:persp(ective)`, or `Model-View-Projection` (MVP) matrix)",
    axes3d = "draw 3d axes (`x -> :red`, `y -> :green`, `z -> :blue`)",
    elevation = "elevation angle above or below the `floor` plane (`-90 ≤ θ ≤ 90`)",
    azimuth = "azimutal angle around the `up` vector (`-180° ≤ φ ≤ 180°`)",
    zoom = "zooming factor in 3D",
    up = "up vector (`:x`, `:y` or `:z`), prefix with `m -> -` or `p -> +` to change the sign e.g. `:mz` for `-z` axis pointing upwards",
    near = "distance to the near clipping plane (`:perspective` projection only)",
    far = "distance to the far clipping plane (`:perspective` projection only)",
    canvas_kw = "extra canvas keywords",
    blend = "blend colors on the underlying canvas",
    fix_ar = "fix terminal aspect ratio (experimental)",
    visible = "visible canvas",
)

const Z_DESCRIPTION =
    (:zlabel, :zlim, :colorbar, :colormap, :colorbar_lim, :colorbar_border)

const PROJ_DESCRIPTION = (:projection, :azimuth, :elevation, :up, :zoom, :axes3d)

const DEFAULT_KW = (
    # does not have to stay ordered
    :name,
    :title,
    :xlabel,
    :ylabel,
    :zlabel,
    :xscale,
    :yscale,
    :labels,
    :border,
    :height,
    :width,
    :xlim,
    :ylim,
    :zlim,
    :xflip,
    :yflip,
    :unicode_exponent,
    :compact,
    :blend,
    :grid,
    :padding,
    :margin,
)

const DEFAULT_EXCLUDED = (
    :visible,  # internals
    :fix_ar,  # experimental
    Z_DESCRIPTION...,  # by default for 2D data
    PROJ_DESCRIPTION...,  # 3D plots
)

base_type(x) = replace(string(typeof(x).name.name), "64" => "")

default_with_type(s::Symbol) = if s ∈ keys(KEYWORDS)
    "$s::$(base_type(KEYWORDS[s])) = $(KEYWORDS[s] |> repr)"
else
    s |> string
end

"""
    keywords([extra]; default = DEFAULT_KW, add = (), exclude = DEFAULT_EXCLUDED, remove = ())

Adds default keywords to a function signature, in a docstring.

# Arguments

- `extra::NamedTuple`: add extra keywords in the form `keyword = value`.
- `default::Tuple`: default `UnicodePlots` keywords.
- `add::Tuple`: add extra symbols, not listed in `default` but present in `KEYWORDS`.
- `remove::Tuple`: remove symbols from `default`.
"""
function keywords(
        extra::NamedTuple = NamedTuple();
        default::Tuple = DEFAULT_KW,
        add::Tuple = (),
        exclude::Tuple = DEFAULT_EXCLUDED,
        remove::Tuple = (),
    )
    all_kw = (; KEYWORDS..., extra...)
    candidates = keys(extra) ∪ filter(x -> x ∈ add ∪ default, keys(KEYWORDS))  # extra goes first !
    kw = filter(x -> x ∉ setdiff(exclude ∪ remove, add), candidates)
    @assert allunique(kw)  # extra check
    return join((k isa Symbol ? "$k = $(all_kw[k] |> repr)" : k for k in kw), ", ")
end

"""
    arguments([desc]; default = DEFAULT_KW, add = (), exclude = DEFAULT_EXCLUDED, remove = ())

Defines arguments for docstring genreration.

# Arguments

- `desc::NamedTuple`: add argument description in the form `arg = desc`.
- `default::Tuple`: default `UnicodePlots` keywords.
- `add::Tuple`: add extra symbols, not listed in `default` but present in `DESCRIPTION`.
- `remove::Tuple`: remove symbols from `default`.
"""
function arguments(
        desc::NamedTuple = NamedTuple();
        default::Tuple = DEFAULT_KW,
        add::Tuple = (),
        exclude::Tuple = DEFAULT_EXCLUDED,
        remove::Tuple = (),
    )
    get_description(n, d) = begin
        str = d[n]
        @assert first(str) ≡ '`' || islowercase(first(str))  # description starts with a lowercase string, or `something`
        @assert last(str) ≢ '.'  # trailing dot will be added later
        str
    end
    all_desc = (; DESCRIPTION..., desc...)  # desc preempts defaults !
    candidates = keys(desc) ∪ filter(x -> x ∈ add ∪ default, keys(DESCRIPTION))  # desc goes first !
    kw = filter(x -> x ∉ setdiff(exclude ∪ remove, add), candidates)
    @assert allunique(kw)  # extra check
    return join(
        ("- **`$(default_with_type(k))`** : $(get_description(k, all_desc))." for k in kw),
        '\n',
    )
end

module ImageInTerminalExt

import ImageInTerminal
import UnicodePlots

using ColorTypes

UnicodePlots.sixel_encode(args...; kw...) = ImageInTerminal.sixel_encode(args...; kw...)  # COV_EXCL_LINE
UnicodePlots.imshow(args...; kw...) = ImageInTerminal.imshow(args...; kw...)

function UnicodePlots.terminal_specs(img)
    char_h = char_w = nothing
    # COV_EXCL_START
    if ImageInTerminal.choose_sixel(img)
        ans = ImageInTerminal.Sixel.TerminalTools.query_terminal("\e[16t", stdout)
        if ans isa String && (m = match(r"\e\[6;(\d+);(\d+)t", ans)) ≢ nothing
            char_h, char_w = tryparse.(Int, m.captures)
        end
    end
    # COV_EXCL_STOP
    return char_h ≢ nothing && char_w ≢ nothing, char_h, char_w
end

UnicodePlots.imageplot(img::AbstractArray{<:Colorant}; kw...) =
    UnicodePlots.Plot(UnicodePlots.ImageGraphics(img); border = :corners, kw...)

end  # module

"""
    heatmap(A; kw...)

# Description

Draws a heatmap for the given points.
It uses the `Matrix` `A` as the values of the heatmap, with the column and row indices
of the matrix as `x` and `y` coordinates respectively.

# Usage

    heatmap(A::AbstractMatrix; $(keywords((height = 0, width = 0, yfact = nothing, xfact = nothing, array = false); add = (Z_DESCRIPTION..., :fix_ar))))

# Arguments

$(
    arguments(
        (
            A = "input matrix (color values)",
            yfact = "scale for the `y` coordinate labels (defaults to 0 - i.e. each row in `A` maps to one unit, `y` origin starting at 1). If set to anything else, the y origin will start at 0",
            xfact = "scale for the `x` coordinate (defaults to 0 - i.e. each column in `A` maps to one unit, `x` origin starting at 1). If set to anything else, the x origin will start at 0",
            yoffset = "plotting offset for the `y` coordinate (after scaling)",
            xoffset = "plotting offset for the `x` coordinate (after scaling)",
            array = "use array display convention (origin at the North-West corner of the plot, hence flipping `y` versus regular plots)",
        ); add = (Z_DESCRIPTION..., :fix_ar)
    )
)

# Author(s)

- Rowan Katekar (github.com/rjkat)

# Examples

```julia-repl
julia> heatmap(repeat(collect(0:10)', outer=(11, 1)), zlabel="z")
      ┌───────────┐  10
   11 │▄▄▄▄▄▄▄▄▄▄▄│ ┌──┐
      │▄▄▄▄▄▄▄▄▄▄▄│ │▄▄│
      │▄▄▄▄▄▄▄▄▄▄▄│ │▄▄│
      │▄▄▄▄▄▄▄▄▄▄▄│ │▄▄│ z
      │▄▄▄▄▄▄▄▄▄▄▄│ │▄▄│
    1 │▄▄▄▄▄▄▄▄▄▄▄│ └──┘
      └───────────┘  0
       1        11
```

# See also

`Plot`, `HeatmapCanvas`
"""
function heatmap(
        A::AbstractMatrix{T};
        xlim = KEYWORDS.xlim,
        ylim = KEYWORDS.ylim,
        zlim = KEYWORDS.zlim,
        yoffset::Number = 0.0,
        xoffset::Number = 0.0,
        out_stream::Union{Nothing, IO} = nothing,
        height::Union{Nothing, Integer} = nothing,
        width::Union{Nothing, Integer} = nothing,
        margin::Integer = KEYWORDS.margin,
        padding::Integer = KEYWORDS.padding,
        colormap = KEYWORDS.colormap,
        yfact::Union{Nothing, Number} = nothing,
        xfact::Union{Nothing, Number} = nothing,
        fix_ar::Bool = KEYWORDS.fix_ar,
        labels::Bool = KEYWORDS.labels,
        array::Bool = false,
        kw...,
    ) where {T}
    pkw, okw = split_plot_kw(kw)
    warn_on_lost_kw(okw)

    nrows, ncols = size(A)

    # if scale is auto, use the matrix indices as axis labels
    # otherwise, start axis labels at zero
    Y = if yfact ≡ nothing
        collect(1:nrows)
    else
        collect(0:(nrows - 1)) .* yfact
    end .+ yoffset
    X = if xfact ≡ nothing
        collect(1:ncols)
    else
        collect(0:(ncols - 1)) .* xfact
    end .+ xoffset

    # set the axis limits automatically
    ylim = autolims(ylim, Y)
    xlim = autolims(xlim, X)

    # select a subset of A based on the supplied limits
    subset(lims, vec) = begin
        first = findfirst(x -> x ≥ lims[1], vec)
        last = findlast(x -> x ≤ lims[2], vec)
        (first ≡ nothing || last ≡ nothing) ? (1:0) : (first:last)
    end

    yrange = subset(ylim, Y)
    xrange = subset(xlim, X)
    Y = Y[yrange]
    X = X[xrange]
    A = A[yrange, xrange]

    nrows = ceil(Int, (ylim[2] - ylim[1]) / something(yfact, 1)) + 1
    ncols = ceil(Int, (xlim[2] - xlim[1]) / something(xfact, 1)) + 1

    # allow A to be an array over which min and max is not defined,
    # e.g. an array of RGB color values
    mi, ma = (0, 0)
    has_extrema = false
    try
        mi, ma = nanless_extrema(A)
        has_extrema = true
    catch
    end
    if !is_auto(zlim)
        has_extrema ||
            throw(ArgumentError("`zlim` cannot be set when the element type is $T"))
        mi, ma = zlim
    end

    # if A is an rgb image, translate the colors directly to the terminal
    callback =
    if length(A) > 0 && isconcretetype(T) && all(x -> x ∈ fieldnames(T), (:r, :g, :b))
        (A, mi, ma) -> ansi_color(c256.((A.r, A.g, A.b)))
    else
        colormap_callback(colormap)
    end

    data_ar = ncols / nrows  # data aspect ratio

    max_width = if width ≡ nothing
        height ≡ nothing ? 0 : ceil(Int, height * data_ar)
    else
        width
    end
    max_height = if height ≡ nothing
        width ≡ nothing ? 0 : ceil(Int, width / data_ar)
    else
        height
    end

    # `2nrows`: compensate nrows(c::HeatmapCanvas) = div(size(c.grid, 1) + 1, 2)
    height, width, max_height, max_width = get_canvas_dimensions_for_matrix(
        HeatmapCanvas,
        2nrows,
        ncols,
        max_height,
        max_width,
        height,
        width,
        margin,
        padding,
        out_stream,
        fix_ar,
    )

    colorbar = has_extrema && if height < 7
        # for small plots, don't show colorbar by default
        get(pkw, :colorbar, false)
    else
        # show colorbar by default, unless set to false, or `labels = false`
        get(pkw, :colorbar, labels)
    end

    xs = length(X) > 0 ? [first(X), last(X)] : zeros(2)
    ys = length(Y) > 0 ? [first(Y), last(Y)] : zeros(2)

    plot = Plot(
        xs,
        ys,
        nothing,
        HeatmapCanvas;
        colorbar,
        ylim,
        xlim,
        labels,
        height,
        width,
        margin,
        colorbar_lim = (mi, ma),
        colormap = callback,
        min_height = 1,
        min_width = 1,
        yflip = array,
        grid = false,
        filter(x -> x.first ≢ :colorbar, pairs(pkw))...,
    )

    for row in eachindex(Y)
        color = ColorType[ansi_color(callback(x, mi, ma)) for x in view(A, row, :)]
        blend = blend_colors.(Ref(plot.graphics), color)
        points!(plot, X, fill(Y[row], length(X)), color, blend)
    end
    return plot
end

x = [-1, 1, 3, 3, -1]
y = [2, 0, -5, 2, -5]

@testset "input" begin
    @test scatterplot() isa Plot
    @test_throws MethodError scatterplot(sin, x)
    @test_throws DimensionMismatch scatterplot([sin], x)
    @test_throws DimensionMismatch scatterplot([1, 2], [1, 2, 3])
    @test_throws DimensionMismatch scatterplot([1, 2, 3], [1, 2])
    @test_throws DimensionMismatch scatterplot([1, 2, 3], 1:2)
    @test_throws DimensionMismatch scatterplot(1:3, [1, 2])
    @test_throws DimensionMismatch scatterplot(1:3, 1:2)
end

@testset "boundaries" begin
    # tests that the two points are drawn correctly on the canvas
    for canvas in (BrailleCanvas, OctantCanvas, DotCanvas, AsciiCanvas)
        for width in (20:10:60), height in (10:5:30)
            p = scatterplot(1:2, reverse(1:2); height, width, canvas)
            @test first(p.graphics.grid) != UnicodePlots.blank(p.graphics)
            @test last(p.graphics.grid) != UnicodePlots.blank(p.graphics)
        end
    end
end

@testset "positional types" begin
    for p in (
            @binf(scatterplot(x, y)),
            @binf(scatterplot(float.(x), y)),
            @binf(scatterplot(x, float.(y))),
        )
        @test p isa Plot
        test_ref("scatterplot/default.txt", @show_col(p))
    end

    for p in (@binf(scatterplot(y)), @binf(scatterplot(float.(y))))
        @test p isa Plot
        test_ref("scatterplot/y_only.txt", @show_col(p))
    end

    p = @binf scatterplot(6:10)
    @test p isa Plot
    test_ref("scatterplot/range1.txt", @show_col(p))

    p = @binf scatterplot(11:15, 6:10)
    @test p isa Plot
    test_ref("scatterplot/range2.txt", @show_col(p))

    p = @binf scatterplot(x .* 1.0e3 .+ 15, y .* 1.0e-3 .- 15)
    test_ref("scatterplot/scale1.txt", @show_col(p))
    p = @binf scatterplot(x .* 1.0e-3 .+ 15, y .* 1.0e3 .- 15)
    test_ref("scatterplot/scale2.txt", @show_col(p))
    miny = -1.2796649117521434e218
    maxy = -miny
    p = @binf scatterplot([1], [miny]; xlim = (1, 1), ylim = (miny, maxy))
    test_ref("scatterplot/scale3.txt", @show_col(p))
    p = @binf scatterplot([1], [miny]; xlim = [1, 1], ylim = [miny, maxy])
    test_ref("scatterplot/scale3.txt", @show_col(p))
end

@testset "keyword arguments" begin
    p = @binf scatterplot(x, y; xlim = (-1.5, 3.5), ylim = (-5.5, 2.5))
    test_ref("scatterplot/limits.txt", @show_col(p))
    p = @binf scatterplot(x, y; xlim = [-1.5, 3.5], ylim = [-5.5, 2.5])
    test_ref("scatterplot/limits.txt", @show_col(p))

    p = @binf scatterplot(x, y; grid = false)
    test_ref("scatterplot/nogrid.txt", @show_col(p))

    p = @binf scatterplot(x, y; color = :blue, name = "points1")
    test_ref("scatterplot/blue.txt", @show_col(p))

    p = @binf scatterplot(
        x,
        y;
        name = "points1",
        title = "Scatter",
        xlabel = "x",
        ylabel = "y",
    )
    @test p isa Plot
    test_ref("scatterplot/parameters1.txt", @show_col(p))

    @test @binf(scatterplot!(p, [0.5, 1, 1.5]; name = "points2")) ≡ p
    test_ref("scatterplot/parameters2.txt", @show_col(p))

    @test @binf(scatterplot!(p, [-0.5, 0.5, 1.5], [0.5, 1, 1.5]; name = "points3")) ≡ p
    test_ref("scatterplot/parameters3.txt", @show_col(p))
    test_ref("scatterplot/nocolor.txt", @show_nocol(p))

    p = scatterplot(x, y, title = "Scatter"; canvas = DotCanvas, height = 5, width = 10)
    @test p isa Plot
    test_ref("scatterplot/canvassize.txt", @show_col(p))
end

@testset "markers" begin
    p = scatterplot(
        x,
        y;
        title = "Vector of markers",
        marker = [:circle, "!", '.', :star5, :vline],
        color = [:red, :green, :yellow, :blue, :cyan],
    )
    test_ref("scatterplot/markers_vector.txt", @show_col(p))

    scatterplot(x, y, marker = :circle)

    n = collect(1:length(UnicodePlots.MARKERS))
    m = collect(keys(UnicodePlots.MARKERS))
    for canvas in (BrailleCanvas, OctantCanvas, DotCanvas, AsciiCanvas)
        p = scatterplot(n, n, title = "Supported markers", marker = m)
        test_ref("scatterplot/markers_$(canvas).txt", @show_col(p))
    end
end

@testset "units" begin
    y1 = [22.0, 23.0, 24.0] * u"°C"
    p = scatterplot(y1; marker = :circle)
    y2 = [23.5, 22.5, 23.0] * u"°C"
    p = scatterplot!(p, y2; marker = :cross, color = :red)
    test_ref("scatterplot/units_temp.txt", @show_col(p))
end

@testset "multiple series (matrix columns)" begin
    n = 3
    x = 1:n
    y1, y2 = [0:2:4 4:2:8], [fill(3, n) fill(5, n)]

    p = scatterplot(x, y1)
    scatterplot!(p, x, y2, marker = :pentagon)
    test_ref("scatterplot/matrix_auto.txt", @show_col(p))

    for name in (["1", "2"], ["1" "2"])
        p = scatterplot(x, y1; name, color = [:red :green], marker = [:utriangle :rect])
        scatterplot!(
            p,
            x,
            y2;
            name = ["3", "4"],
            color = [:yellow :cyan],
            marker = [:circle :cross],
        )

        test_ref("scatterplot/matrix_parameters.txt", @show_col(p))
    end
end

"""
    surfaceplot(x, y, A; kw...)
    surfaceplot!(p, args...; kw...)

Draws a 3D surface plot on a new canvas (masking values using `NaN`s is supported).
To plot a slice one can pass an anonymous function which maps to a constant height: `zscale = z -> a_constant`.
By default, `zscale = :aspect` normalizes heights (`z` axis) to the `x` or `y` axes.
The `x`, `y` and `z` axes of the 3D cartesian frame are mapped respectively to the `:red`, `:green` and `:blue` colors.

# Usage

    surfaceplot(x, y, A; $(keywords((; lines = false); add = (Z_DESCRIPTION..., PROJ_DESCRIPTION..., :canvas), remove = (:blend, :grid, :xscale, :yscale))))

# Arguments

$(
    arguments(
        (
            A = "`Matrix` of surface heights, or `Function` evaluated as `f(x, y)`",
            lines = "use `lineplot` instead of `scatterplot` (for regular increasing data)",
            zscale = "scale heights (`:identity`, `:aspect`, tuple of (min, max) values, or arbitrary scale function)",
        ); add = (Z_DESCRIPTION..., PROJ_DESCRIPTION..., :x, :y, :canvas), remove = (:blend, :grid, :name, :xscale, :yscale)
    )
)

# Author(s)

- T Bltg (github.com/t-bltg)

# Examples

```julia-repl
julia> sombrero(x, y) = 15sinc(√(x^2 + y^2) / π)
julia> surfaceplot(-8:.5:8, -8:.5:8, sombrero)
    ┌────────────────────────────────────────┐  15
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ ┌──┐
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ │▄▄│
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ │▄▄│
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ │▄▄│
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡰⡃⢝⢆⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ │▄▄│
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢠⠭⠂⠒⠭⡄⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ │▄▄│
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⣀⣀⣠⣤⣴⣥⡅⣭⣬⣦⣤⣄⣀⣀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ │▄▄│
    │⠀⠀⠀⠀⠀⠀⠀⠀⠀⣀⣤⣖⡻⠝⡪⢒⢵⣥⡫⠇⠼⢝⣬⡮⡒⢕⠫⢟⣲⣤⣀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ │▄▄│
    │⠀⠀⠀⠀⠀⠀⠀⣠⣾⣿⢗⣒⣊⡩⠔⢁⢎⣐⡱⡁⢏⢎⣂⡱⡈⠢⢍⣑⣒⡺⣿⣷⣄⠀⠀⠀⠀⠀⠀⠀│ │▄▄│
    │⠀⠀⠀⠀⠀⣠⣾⡿⠿⣿⣿⣕⣒⣒⣊⣽⣯⡾⠵⠅⠮⠮⢷⣽⣯⣑⣒⣒⣪⣿⣿⠿⢿⣷⣄⠀⠀⠀⠀⠀│ │▄▄│
    │⠀⠀⠀⠐⠻⠿⠛⠛⠛⠛⠽⢿⣶⣶⡾⠓⠉⠢⠈⡀⢁⠁⠔⠉⠚⢷⣶⣶⡿⠯⠛⠛⠛⠛⠿⠟⠂⠀⠀⠀│ │▄▄│
    │⠀⠀⠀⢀⠀⠀⠀⠀⠀⠀⠀⠀⠘⠿⣯⣯⣓⢶⣷⡆⣶⣾⡶⣚⣽⣽⠿⠃⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ │▄▄│
    │⠀⠀⠀⢸⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠉⠻⡳⡻⡃⢟⢟⢞⠟⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ │▄▄│
    │⠀⢀⡠⠜⠤⣀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠈⠪⠆⡵⠕⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ │▄▄│
    │⠊⠁⠀⠀⠀⠀⠉⠂⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│ └──┘
    └────────────────────────────────────────┘ -3
```

# See also

`Plot`, `MVP`, `lineplot`, `scatterplot`, `BrailleCanvas`
"""
function surfaceplot(
        x::AbstractVecOrMat,
        y::AbstractVecOrMat,
        A::Union{Function, AbstractVecOrMat};
        zscale::Union{Symbol, Function, NTuple} = KEYWORDS.zscale,
        canvas::Type = KEYWORDS.canvas,
        colormap = KEYWORDS.colormap,
        kw...,
    )
    pkw, okw = split_plot_kw(kw)
    X, Y = if x isa AbstractVector && y isa AbstractVector && !(A isa AbstractVector)
        meshgrid(x, y)
    else
        x, y
    end
    H = A isa Function ? A.(X, Y) : A

    ex, ey = map(collect ∘ extrema, (x, y))
    eh = collect(nanless_extrema(H))

    if (aspect = zscale ≡ :aspect) || zscale isa NTuple
        mh, Mh = eh
        mz, Mz = ez = if aspect
            only(diff(ex)) > only(diff(ey)) ? ex : ey
        else
            zscale
        end
        Z = @. (H - mh) * ((Mz - mz) / (Mh - mh)) + mz
    elseif zscale isa Function
        ez = zscale.(eh)
        Z = zscale.(H)
    elseif zscale ≡ :identity
        ez = eh
        Z = H
    else
        throw(ArgumentError("zscale=$zscale not understood"))
    end

    plot = Plot(
        ex,
        ey,
        ez,
        canvas;
        projection = KEYWORDS.projection,
        labels = false,
        colormap,
        pkw...,
    )
    return surfaceplot!(plot, X, Y, Z, H; colormap, okw...)
end

@doc (@doc surfaceplot) function surfaceplot!(
        plot::Plot{<:Canvas},
        X::AbstractVecOrMat,  # support AbstractVector for `Plots.jl`
        Y::AbstractVecOrMat,
        Z::AbstractVecOrMat,
        H::Union{AbstractVecOrMat, Nothing} = nothing;
        color::UserColorType = nothing,  # NOTE: `nothing` as default (uses a colormap), but allow a single color
        colormap = KEYWORDS.colormap,
        lines::Bool = false,
        zlim = KEYWORDS.zlim,
        kw...,
    )
    H = something(H, Z)
    length(X) == length(Y) == length(Z) == length(H) ||
        throw(DimensionMismatch("`X`, `Y`, `Z` and `H` must have same length"))

    cmapped = color ≡ nothing
    color = ansi_color(color ≡ :auto ? next_color!(plot) : color)

    plot.cmap.lim = (mh, Mh) = is_auto(zlim) ? nanless_extrema(H) : zlim
    plot.cmap.callback = callback = colormap_callback(colormap)
    plot.cmap.bar |= cmapped

    F = float(promote_type(eltype(X), eltype(Y), eltype(Z)))
    if (
            lines &&
                cmapped &&
                X isa AbstractMatrix &&
                Y isa AbstractMatrix &&
                Z isa AbstractMatrix &&
                H isa AbstractMatrix
        )
        m, n = size(X)
        col_cb = h -> callback(h, mh, Mh)
        buf = MMatrix{4, 2, F}(undef)
        incs = (0, 0, 1, 0), (0, 0, 0, 1), (0, 0, 1, 1), (1, 0, 0, 1)
        @inbounds for j in axes(X, 2), i in axes(X, 1)
            for inc in incs
                (i1 = i + inc[1]) > m && continue
                (j1 = j + inc[2]) > n && continue
                (i2 = i + inc[3]) > m && continue
                (j2 = j + inc[4]) > n && continue
                plot.projection(
                    @SMatrix(
                        [
                            X[i1, j1] X[i2, j2]
                            Y[i1, j1] Y[i2, j2]
                            Z[i1, j1] Z[i2, j2]
                            1 1
                        ]
                    ),
                    buf,
                )
                lines!(
                    plot.graphics,
                    buf[1, 1],
                    buf[2, 1],
                    buf[1, 2],
                    buf[2, 2],
                    H[i1, j1],
                    false,
                    H[i2, j2],
                    col_cb,
                )
            end
            (i == m || j == n) && points!(
                plot,
                X[i, j],
                Y[i, j],
                Z[i, j];
                color = cmapped ? col_cb(H[i, j]) : color,
            )
        end
    else
        npts = length(H)
        colors = if cmapped
            map(h -> callback(h, mh, Mh), vec(H))
        else
            fill(color, npts)
        end
        points!(plot, vec(X), vec(Y), vec(Z), colors, falses(npts))
    end
    return plot
end

"""
    surfaceplot(A; kw...)

# Usage

Draws a surface plot of matrix `A` along axis `x` and `y` on a new canvas.
"""
surfaceplot(A::AbstractMatrix; kw...) = surfaceplot(axes(A, 1), axes(A, 2), A; kw...)

"""
    spy(A; kw...)

# Description

Plots the sparsity pattern for the given matrix `A`.
This means that a scatterplot that resembles the matrix is drawn,
in which only the pixel for non-zero elements of the matrix are set.

If the parameters `width` and `height` are not explicitly specified,
then the function will attempt to preserve the aspect ratio of the matrix,
while also attempting to fit the resulting plot within the bounding box
specified by `maxwidth` and `maxheight`.

# Usage

    spy(A; $(keywords((maxwidth = 0, maxheight = 0, zeros = false); add = (:fix_ar, :canvas))))

# Arguments

$(
    arguments(
        (
            A = "matrix of interest for which non-zero elements should be drawn",
            maxheight = "maximum number of character rows that should be used for plotting",
            maxwidth = "maximum number of characters per row that should be used for plotting",
            height = "exact number of character rows that should be used for plotting (`0` stands for automatic)",
            width = "exact number of characters per row that should be used for plotting (`0` stands for automatic)",
            show_zeros = "show zeros pattern instead of default nonzeros",
        ); add = (:fix_ar, :canvas),
    )
)

# Author(s)

- Dominique Orban (github.com/dpo)
- Christof Stocker (github.com/Evizero)
- Jake Bolewski (github.com/jakebolewski)

# Examples

```julia-repl
julia> using SparseArrays
julia> spy(sprandn(50, 120, .05))
      ┌────────────────────────────────────────────────────────────┐
    1 │⡀⠨⠂⠀⠠⠀⠠⠀⠀⠀⠂⠀⡀⠂⠀⠀⠰⠈⠈⠂⡀⠀⠀⠀⠀⠐⠀⡀⡀⠀⠀⢄⡀⠀⠀⠠⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢄⠀⠀⠀⠁⠀⠀⠀⠀⠀⠀⠐⠴⠄│ > 0
      │⠀⠀⠀⢀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠄⠠⠄⠉⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠐⢀⠀⡀⠀⠄⠘⠀⠀⡀⠀⠀⠀⠂⠠⠀⠀⠀⠀⠀⠈⠀⠀⠀⠀⠀⠀⠀⠀│ < 0
      │⠂⠀⠀⠀⠐⠐⠀⠂⠀⡀⠐⢀⠀⠀⠀⠀⡀⠀⠈⠀⠄⠀⠀⠨⠀⠀⠀⠀⠀⠠⠀⢀⠀⠀⠉⠐⠄⠄⠀⠔⠀⠀⠂⠀⢐⠀⠀⠀⡀⠘⢀⠀⠁⠄⠀⠠⠀⠄⠀⠄│
      │⠀⢀⠀⠀⠀⠀⠀⠠⠀⠂⠀⠄⠀⠘⠈⠌⢀⠀⠀⠀⠐⠀⠁⠀⠀⠀⢀⠀⠀⠠⠀⠁⠄⠀⠀⠀⠂⢀⠀⠀⠀⠀⢀⡁⠀⠀⠂⠠⠀⠀⠀⠀⠀⠊⠁⠀⠀⠀⠀⠄│
      │⠀⠅⠀⠀⠀⠀⢄⠈⠄⠠⠈⠀⠀⠀⠀⡀⠀⢀⠠⠀⠀⠀⠁⠀⠀⡀⠃⠀⠀⠈⠈⠁⠀⠁⠠⢀⠀⢁⠀⠀⢀⠀⠀⠀⢀⠀⠠⠂⠀⠁⢁⠀⠂⠀⠀⠆⠌⠀⠀⠀│
      │⠀⠀⠔⠀⠀⠀⠀⢀⠀⠁⢀⠀⠀⠀⠀⠀⡀⠀⠀⠀⠀⡀⠀⠀⠀⡀⠀⠈⠀⠀⠀⡁⠁⠀⠀⠀⠠⠀⠀⠀⠄⡀⠀⠀⠀⠊⠀⠀⠄⠀⠀⠀⠀⠀⠀⠠⠀⠀⠄⠀│
      │⠀⠀⠀⠀⠐⠀⠀⠀⠀⠀⠁⠀⠀⠀⠀⠅⠄⡀⠀⠀⢂⠂⠄⠑⠀⠀⠀⢄⠀⠀⠠⠂⠁⡀⠀⢠⠈⠀⠂⠀⠀⠄⠀⠀⠀⠄⠀⠀⠃⠂⠀⠄⢀⠀⠀⠀⠀⠀⠀⠀│
      │⠀⠐⠀⠀⠂⠀⢀⠀⠀⠀⠀⠀⠀⠀⠀⠌⠀⠂⠀⠀⠀⠀⡀⢁⠁⠨⠀⠀⠀⠂⠀⠀⠨⠀⠁⠀⠀⠀⠀⠀⠊⠀⠄⠀⠀⠁⠐⠠⠀⢀⠀⠀⠀⠈⠀⠀⠁⠐⠄⠄│
      │⢉⠀⢀⠁⠀⠀⠀⠀⠈⠀⠀⠀⠀⠁⠀⠠⠀⠀⠁⠀⠀⠀⡠⠁⠀⠀⠀⠀⠉⠠⡀⠀⠀⠀⢀⡀⠄⠀⠀⠀⠄⠀⠀⠈⠄⠀⠑⠀⠀⠀⠀⠀⠀⠠⠀⡀⡀⠀⠀⠀│
      │⠅⠈⠈⠀⠀⠀⠀⠄⠀⠀⠀⠀⠀⠀⠀⠂⠀⠀⡄⠀⠀⠄⠀⠀⠠⠀⠀⠠⠈⠀⠂⠢⠈⠀⠀⠀⠄⠀⠀⠐⠀⠀⠀⠀⠀⠀⠀⠠⠀⠀⠀⠀⠀⠀⢀⠤⠀⠀⠀⠀│
      │⠀⠀⠀⠂⠁⠀⠀⠀⠀⠁⠀⠘⠀⠂⢠⠀⠀⠀⠀⠀⢃⠀⠐⠈⠄⠐⠀⠀⠀⢀⠀⠀⠁⠀⠀⠀⠀⠀⠀⠀⠄⠀⠀⠀⠀⡀⠀⡀⠀⠀⠁⠀⠁⠀⠁⠠⠔⠀⢁⡀│
   50 │⠀⠀⠀⠀⠀⠀⡀⠀⠀⠀⠐⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠀⠀⠈⠀⠂⠠⠀⠀⠀⠖⠀⠀⠀⠈⠀⠀⠀⠀⠀⡀⠠⠀⢀⠀⠅⠀⠀⠐⠀⠀⠀⠀⠠⠀⠠⠀⠀⢀⠀│
      └────────────────────────────────────────────────────────────┘
      ⠀1⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀120⠀
      ⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀315 ≠ 0⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
```

# See also

[`Plot`](@ref), [`scatterplot`](@ref),
[`BrailleCanvas`](@ref), [`BlockCanvas`](@ref),
[`AsciiCanvas`](@ref), [`DotCanvas`](@ref)
"""
function spy(A::AbstractMatrix; kw...)
    rows, cols, vals = _strict_non_zeros(_findnz(A)...)
    if get(kw, :show_zeros, false)
        I = CartesianIndex.(zip(rows, cols))  # non zeros
        mask = trues(size(A))
        mask[I] .= false
        Z = CartesianIndices(axes(A))[mask]  # zeros
        rows, cols = getindex.(Z, 1), getindex.(Z, 2)
        vals = zeros(eltype(vals), length(rows))
    end
    return spy(size(A)..., rows, cols, vals; kw...)
end

_strict_non_zeros(rows, cols, vals) =
let I = findall(!iszero, vals)  # findnz(A) returns stored zeros, ignore those
    rows[I], cols[I], vals[I]
end

_findnz(A::AbstractMatrix) =
let I = findall(!iszero, A)
    getindex.(I, 1), getindex.(I, 2), A[I]
end

_findnz(A::AbstractSparseMatrix) = findnz(A)

function spy(
        nrow::Integer,
        ncol::Integer,
        rows::AbstractArray{<:Integer},
        cols::AbstractArray{<:Integer},
        vals::AbstractArray;
        maxwidth::Integer = 0,
        maxheight::Integer = 0,
        out_stream::Union{Nothing, IO} = nothing,
        height::Union{Nothing, Integer} = nothing,
        width::Union{Nothing, Integer} = nothing,
        margin::Integer = KEYWORDS.margin,
        padding::Integer = KEYWORDS.padding,
        color::UserColorType = KEYWORDS.color,
        canvas::Type{<:Canvas} = KEYWORDS.canvas,
        fix_ar::Bool = KEYWORDS.fix_ar,
        show_zeros::Bool = false,
        xflip::Bool = false,
        yflip::Bool = true,
        kw...,
    )
    pkw, okw = split_plot_kw(kw)
    warn_on_lost_kw(okw)

    height, width = get_canvas_dimensions_for_matrix(
        canvas,
        nrow,
        ncol,
        maxheight,
        maxwidth,
        height,
        width,
        margin,
        padding,
        out_stream,
        fix_ar;
        extra_rows = 9,
        extra_cols = 6,
    )

    ylim = [1, nrow]
    xlim = [1, ncol]

    plot = Plot(
        xlim,
        ylim,
        nothing,
        canvas;
        ylim,
        xlim,
        yflip,
        xflip,
        height,
        width,
        margin,
        padding,
        grid = false,
        canvas_kw = (; height = 1.0 + nrow, width = 1.0 + ncol),
        pkw...,
    )

    if color ≢ :auto
        points!(plot, cols, rows; color)
        label!(plot, :r, 1, show_zeros ? "⩵ 0" : "≠ 0", color)
    else
        if show_zeros
            points!(plot, cols, rows; color = :green)
            label!(plot, :r, 1, "⩵ 0", :green)
        else
            pos_idx = vals .> 0
            neg_idx = (!).(pos_idx)
            pos_cols = cols[pos_idx]
            pos_rows = rows[pos_idx]
            neg_cols = cols[neg_idx]
            neg_rows = rows[neg_idx]
            points!(plot, pos_cols, pos_rows; color = :red)
            points!(plot, neg_cols, neg_rows; color = :blue)
            label!(plot, :r, 1, "> 0", :red)
            label!(plot, :r, 2, "< 0", :blue)
        end
    end
    isempty(xlabel(plot)) &&
        xlabel!(plot, nice_repr(length(vals), plot) * (show_zeros ? " ⩵ 0" : " ≠ 0"))
    return plot
end

@testset "default" begin
    p = boxplot([1, 2, 3, 4, 5])
    test_ref("boxplot/default.txt", @show_col(p))
    p = boxplot("series1", [1, 2, 3, 4, 5])
    test_ref("boxplot/default_name.txt", @show_col(p))
    for xlim in ([-1, 8], (-1, 8))
        p = boxplot(
            "series1",
            [1, 2, 3, 4, 5];
            xlim,
            title = "Test",
            color = :blue,
            width = 50,
            border = :solid,
            xlabel = "foo",
        )
        test_ref("boxplot/default_parameters.txt", @show_col(p))
        test_ref("boxplot/default_parameters_nocolor.txt", @show_nocol(p))
    end
end

@testset "scaling" begin
    for (i, max_x) in enumerate([5, 6, 10, 20, 40])
        for xlim in ((0, max_x), [0, max_x])
            p = boxplot([1, 2, 3, 4, 5]; xlim)
            test_ref("boxplot/scale$i.txt", @show_col(p))
        end
    end
end

@testset "multi-series" begin
    p = boxplot(
        ["one", "two"],
        [[1, 2, 3, 4, 5], [2, 3, 4, 5, 6, 7, 8, 9]],
        title = "Multi-series",
        xlabel = "foo",
        color = :yellow,
    )
    test_ref("boxplot/multi1.txt", @show_col(p))
    @test @inferred(boxplot!(p, "one more", [-1, 2, 3, 4, 11])) ≡ p
    test_ref("boxplot/multi2.txt", @show_col(p))
    @test @inferred(boxplot!(p, [4, 2, 2.5, 4, 14], name = "last one")) ≡ p
    test_ref("boxplot/multi3.txt", @show_col(p))
    p = boxplot([[1, 2, 3, 4, 5], [2, 3, 4, 5, 6, 7, 8, 9]])
    test_ref("boxplot/multi4.txt", @show_col(p))
end

@testset "colors" begin
    p = boxplot(["one", "two"], [[1, 2, 3], [4, 5, 6]], color = 214)
    test_ref("boxplot/col1.txt", @show_col(p))

    p = boxplot(["one", "two"], [[1, 2, 3], [4, 5, 6]], color = (187, 0, 187))
    test_ref("boxplot/col2.txt", @show_col(p))
end

@testset "different colors" begin
    p = boxplot(["one", "two"], [[1, 2, 3], [4, 5, 6]], color = [:red, :green])
    test_ref("boxplot/colors.txt", @show_col(p))
end

"""
    barplot(text, heights; kw...)
    barplot!(p, args...; kw...)

# Description

Draws a horizontal barplot.
It uses the first parameter (`text`) to denote the names for the bars,
and the second parameter (`heights`) as their values.
This means that the two vectors have to have the same length.
Alternatively, one can specify a barplot using a dictionary `dict`.
In that case, the keys will be used as the names and the values,
which have to be numeric, will be used as the heights of the bars.

# Usage

    barplot(text, heights; $(keywords((border = :barplot, color = :green, maximum = nothing), remove = (:xlim, :ylim, :yscale, :height, :grid), add = (:symbols,))))
    barplot(dict; kw...)

# Arguments

$(
    arguments(
        (
            text = "the labels / captions of the bars",
            heights = "the values / heights of the bars",
            dict = "a dictionary in which the keys will be used as `text` and the values will be used as `heights`",
            xscale = "`Function` or `Symbol` to transform the bar length before plotting: this effectively scales the `x`-axis without influencing the captions of the individual bars (use `xscale = :log10` for logscale)",
            color = "`Vector` of colors, or scalar - $(DESCRIPTION[:color])",
            maximum = "optional maximal height",
        ); remove = (:xlim, :ylim, :yscale, :height, :grid), add = (:symbols,),
    )
)

# Author(s)

- Christof Stocker (github.com/Evizero)

# Examples

```julia-repl
julia> barplot(["Paris", "New York", "Madrid"],
               [2.244, 8.406, 3.165],
               xlabel = "population [in mil]")
            ┌                                        ┐
      Paris ┤■■■■■■■■■ 2.244
   New York ┤■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■ 8.406
     Madrid ┤■■■■■■■■■■■■ 3.165
            └                                        ┘
                        population [in mil]
```

# See also

[`Plot`](@ref), [`histogram`](@ref), [`BarplotGraphics`](@ref)
"""
function barplot(
        text::AbstractVector{<:AbstractString},
        heights::AbstractVector{<:Number};
        color::Union{UserColorType, AbstractVector} = :green,
        width::Union{Nothing, Integer} = nothing,
        xscale = KEYWORDS.xscale,
        name::AbstractString = KEYWORDS.name,
        kw...,
    )
    pkw, okw = split_plot_kw(kw)
    length(text) == length(heights) ||
        throw(DimensionMismatch("the given vectors must be of the same length"))
    minimum(heights) ≥ 0 || throw(ArgumentError("all values have to be ≥ 0"))

    if any(map(t -> occursin('\n', t), text))
        _text = eltype(text)[]
        _heights = eltype(heights)[]
        for (t, h) in zip(text, heights)
            lines = split(t, '\n')
            if (n = length(lines)) > 1
                append!(_text, lines)
                for i in eachindex(lines)
                    push!(_heights, i == n ? h : -1)
                end
            else
                push!(_text, t)
                push!(_heights, h)
            end
        end
        text, heights = _text, _heights
    end

    area = BarplotGraphics(
        heights,
        something(width, DEFAULT_WIDTH[]);
        formatter = default_formatter(pkw),
        symbols = KEYWORDS.symbols,
        maximum = nothing,
        xscale,
        color,
        okw...,
    )
    plot = Plot(area; border = :barplot, xlabel = transform_name(xscale), pkw...)

    isempty(name) || label!(plot, :r, string(name), suitable_color(plot.graphics, color))
    for i in eachindex(text)
        label!(plot, :l, i, text[i])
    end

    return plot
end

barplot(label, height::Number; kw...) = barplot([string(label)], [height]; kw...)
barplot(dict::AbstractDict{<:Any, <:Number}; kw...) =
    barplot(sorted_keys_values(dict)...; kw...)
barplot(text::AbstractVector, heights::AbstractVector{<:Number}; kw...) =
    barplot(map(string, text), heights; kw...)

@doc (@doc barplot) function barplot!(
        plot::Plot{<:BarplotGraphics},
        text::AbstractVector{<:AbstractString},
        heights::AbstractVector{<:Number};
        color::Union{UserColorType, AbstractVector} = nothing,
        name::AbstractString = KEYWORDS.name,
    )
    length(text) == length(heights) ||
        throw(DimensionMismatch("the given vectors must be of the same length"))
    isempty(text) && throw(ArgumentError("can't append empty array to barplot"))
    curidx = nrows(plot.graphics)
    addrow!(plot.graphics, heights, color)
    for i in eachindex(heights)
        label!(plot, :l, curidx + i, text[i])
    end
    isempty(name) || label!(plot, :r, string(name), suitable_color(plot.graphics, color))
    return plot
end

barplot!(plot::Plot{<:BarplotGraphics}, dict::AbstractDict{<:Any, <:Number}; kw...) =
    barplot!(plot, sorted_keys_values(dict)...; kw...)

barplot!(
    plot::Plot{<:BarplotGraphics},
    text::AbstractVector,
    heights::AbstractVector{<:Number};
    kw...,
) = barplot!(plot, map(string, text), heights; kw...)

function barplot!(
        plot::Plot{<:BarplotGraphics},
        label,
        heights::Number;
        color::UserColorType = nothing,
        name::AbstractString = KEYWORDS.name,
    )
    curidx = nrows(plot.graphics)
    addrow!(plot.graphics, heights, color)
    label!(plot, :l, curidx + 1, string(label))
    isempty(name) || label!(plot, :r, string(name), suitable_color(plot.graphics))
    return plot
end

# NOTE: use `axes3d = false` on stability of \ issues w.r.t azimuth and elevation

@testset "zscale" begin
    sombrero(x, y) = 50sinc(√(x^2 + y^2) / π)

    p = surfaceplot(-8:0.5:8, -8:0.5:8, sombrero; axes3d = false)
    test_ref("surfaceplot/sombrero_aspect.txt", @show_col(p))

    p = surfaceplot(-8:0.5:8, -8:0.5:8, sombrero; axes3d = false, zscale = :identity)
    test_ref("surfaceplot/sombrero_identity.txt", @show_col(p))

    p = surfaceplot(-8:0.5:8, -8:0.5:8, sombrero; axes3d = false, zscale = h -> h / 2)
    test_ref("surfaceplot/sombrero_zscale.txt", @show_col(p))

    @test_throws ArgumentError surfaceplot([1 2; 3 4]; zscale = :not_supported)
end

@testset "single color - no colormap" begin
    f = (x, y) -> sin(x) + cos(y)
    x, y = 0:0.5:(2π), 0:0.5:(2π)
    p = surfaceplot(x, y, f, color = :cyan)
    test_ref("surfaceplot/single_color.txt", @show_col(p))

    x, y = 0:π, π:(2π)
    X, Y = UnicodePlots.meshgrid(x, y)
    surfaceplot!(p, X, Y, zero(X), nothing; color = :white, lines = true)
    @test !p.cmap.bar  # since we gave the `color` keyword twice
    test_ref("surfaceplot/mutate.txt", @show_col(p))
end

@testset "matrix" begin
    A = collect(1:10) * collect(0.1:0.1:1)'

    p = surfaceplot(A)
    test_ref("surfaceplot/matrix.txt", @show_col(p))

    p = surfaceplot(A; compact = true)
    test_ref("surfaceplot/matrix_compact.txt", @show_col(p))
end

@testset "masking values using `NaN`s" begin
    x = y = -4:4

    z = 1 ./ sin.(x' .* y)  # produce data with `Inf` values
    z[isinf.(z)] .= NaN  # mask infinite values (quite common scenario)

    p = surfaceplot(x, y, z)
    test_ref("surfaceplot/masked_values_points.txt", @show_col(p))

    p = surfaceplot(x, y, z; lines = true)
    test_ref("surfaceplot/masked_values_lines.txt", @show_col(p))
end

@testset "color interpolation" begin
    p = surfaceplot(
        -2:2,
        -2:2,
        (x, y) -> 15sinc(√(x^2 + y^2) / π),
        colormap = :jet,
        elevation = 60,
        lines = true,
        height = 30,
        width = 80,
    )
    test_ref("surfaceplot/interpolation.txt", @show_col(p))
end

@testset "slice" begin
    data = zeros(40, 20, 20)
    x, y, z = (axes(data, d) for d in 1:ndims(data))
    xc, yc, zc = 30, 8, 8  # centers
    xr, yr, zr = 10, 6, 3  # radii

    for k in z, j in y, i in x  # ellipsoid
        data[i, j, k] = ((i - xc) / xr)^2 + ((j - yc) / yr)^2 + ((k - zc) / zr)^2
    end

    kw = (; zscale = z -> zc, colormap = :jet, azimuth = -90, elevation = 90)

    slice = data[:, :, zc]

    p = surfaceplot(x, y, slice; kw...)
    test_ref("surfaceplot/slice_scatter.txt", @show_col(p))

    p = surfaceplot(x, y, slice; kw..., lines = true)
    test_ref("surfaceplot/slice_lines.txt", @show_col(p))
end

@testset "consistency with `contourplot`" begin
    x = -2:0.2:2
    y = -3:0.2:1
    z = (x, y) -> 10x * exp(-x^2 - y^2)
    p = surfaceplot(x, y, z)
    test_ref("surfaceplot/consistency.txt", @show_col(p))
end

"""
    ImageGraphics

Structure to hold an image.
"""
struct ImageGraphics{C <: Colorant} <: GraphicsArea
    img::Matrix{C}
    sixel::RefValue{Bool}
    visible::Bool
    encoded_size::Vector{Int}
    chars::Vector{Vector{Char}}  # nested vector structure chars[row][col] is more suited for this context
    fgcols::Vector{Vector{ColorType}}  # only used in no-sixel context
    bgcols::Vector{Vector{ColorType}}  # only used in no-sixel context
end

function ImageGraphics(img::AbstractArray{<:Colorant})
    h = size(img, 1)
    return ImageGraphics(
        img,
        Ref(false),
        true,
        [0, 0],
        sizehint!(Vector{Char}[], h),
        sizehint!(Vector{ColorType}[], h),
        sizehint!(Vector{ColorType}[], h),
    )
end

@inline nrows(c::ImageGraphics) = first(c.encoded_size)
@inline ncols(c::ImageGraphics) = last(c.encoded_size)

# # generic functions for `ImageInTerminalExt`
function terminal_specs end
function sixel_encode end
function imshow end

function preprocess!(io::IO, c::ImageGraphics)
    ctx = IOContext(PipeBuffer(), :displaysize => displaysize(io))
    c.sixel[], char_h, char_w = terminal_specs(c.img)
    postprocess = c -> begin
        c.encoded_size .= (0, 0)
        empty!(c.chars)
        empty!(c.fgcols)
        empty!(c.bgcols)
        nothing
    end
    img_h, img_w = size(c.img)
    c.encoded_size .= if c.sixel[]
        # COV_EXCL_START
        # it is better to encode the whole image in a single pass
        # otherwise, issues with the last line (see previous implementation)
        sixel_encode(ctx, c.img)
        push!(c.chars, read(ctx, String) |> collect)
        length(1:char_h:img_h), ceil(Int, img_w / char_w)
        # COV_EXCL_STOP
    else
        callback(I, fgcol, bgcol, chars...) = begin
            if (row = first(I)) > length(c.chars)
                push!(c.chars, sizehint!(Char[], img_w))
                push!(c.fgcols, sizehint!(ColorType[], img_w))
                push!(c.bgcols, sizehint!(ColorType[], img_w))
            end
            append!(c.chars[row], chars)
            _fgcol = ansi_color(fgcol)
            _bgcol = ansi_color(bgcol)
            for _ in eachindex(chars)
                push!(c.fgcols[row], _fgcol)
                push!(c.bgcols[row], _bgcol)
            end
            nothing
        end
        imshow(ctx, c.img; callback)
        length(c.chars), length(c.chars |> first)
    end
    return postprocess
end

function print_row(io::IO, print_nocol, print_color, c::ImageGraphics, row::Integer)
    1 ≤ row ≤ nrows(c) || throw(ArgumentError("`row` out of bounds: $row"))
    if c.sixel[]  # encoded in a pass => row == 1
        row == 1 && print_nocol(io, String(c.chars[row]))  # COV_EXCL_LINE
    else
        bgcols = c.bgcols[row]
        fgcols = c.fgcols[row]
        chars = c.chars[row]
        for col in 1:ncols(c)
            # NOTE: the last row can be hidden (only the upper pixel colored)
            # see XTermColors.jl/src/ascii.jl - SmallBlocks encoder
            bgcol = (bgcol = bgcols[col]) == INVALID_COLOR ? missing : bgcol
            print_color(io, fgcols[col], chars[col]; bgcol)
        end
    end
    return nothing
end
